// CellsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "io.h"
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "CellsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CVobBlankerApp theApp;
extern CString FormatDuration(DWORD duration);
extern DWORD AddDuration(DWORD dwDuration1, DWORD dwDuration2);
extern void MyInfoBox(LPCTSTR text);
extern void MyErrorBox(LPCTSTR text);
extern int readbuffer(uchar* caracter, FILE *in);
extern bool IsNav(uchar* buffer);
extern bool IsVideo(uchar* buffer);
extern CString Size_MBytes(__int64 i64size);


/////////////////////////////////////////////////////////////////////////////
// CCellsDlg dialog


CCellsDlg::CCellsDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CCellsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCellsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CCellsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCellsDlg)
	DDX_Control(pDX, IDC_PROGRESS1, m_ProgCell);
	DDX_Control(pDX, IDC_LISTCELLS, m_CList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCellsDlg, CDialog)
	//{{AFX_MSG_MAP(CCellsDlg)
	ON_NOTIFY(NM_RCLICK, IDC_LISTCELLS, OnRclickList)
	ON_BN_CLICKED(IDC_BUTTONEXTRACT, OnButtonextract)
	ON_NOTIFY(NM_CLICK, IDC_LISTCELLS, OnClickList)
	ON_BN_CLICKED(IDC_BUTTONEXTRACTALL, OnButtonextractall)
	ON_BN_CLICKED(IDC_BUTTONBLANK, OnButtonblank)
	ON_BN_CLICKED(IDC_BUTTONKEEP, OnButtonkeep)
	ON_BN_CLICKED(IDC_BUTTONSUBS, OnButtonsubs)
	ON_BN_CLICKED(IDC_BUTTONKEEPALL, OnButtonkeepall)
	ON_BN_CLICKED(IDC_BUTTONBLANKALL, OnButtonblankall)
	ON_BN_CLICKED(IDC_BUTTONEXTRACTALL2, OnButtonextractall2)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID__CELLEXTRACT, On__extract)
	ON_COMMAND(ID__CELLEXTRACTALL, On__extractall)
	ON_COMMAND(ID__CELLEXTRACTALL2, On__extractall2)
	ON_COMMAND(ID__CELLKEEP, On__keep)
	ON_COMMAND(ID__CELLBLANK, On__blank)
	ON_COMMAND(ID__CELLSUBS, On__subs)
	ON_COMMAND(ID__CELLBLANKALL, On__blankall)
	ON_COMMAND(ID__CELLKEEPALL, On__keepall)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCellsDlg message handlers
BOOL CCellsDlg::OnInitDialog()
{
	int i,j;
	int n;
	CString csAux,csAux2;
	int nCell,nCells,nButtons;
	int VobId, CellId;
	__int64 i64Size;
	DWORD dwDuration, dwTotalDuration;
	bool bReused;
	uchar CellCat0, mychar;
	int nPrg,nChap;



	CDialog::OnInitDialog();

	//CLISTCTRL HEADERS
	i=0;

	m_CList.SetExtendedStyle( LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES );

	m_CList.InsertColumn( i, "#");
	m_CList.SetColumnWidth( i, 35); 
	i++;

	m_CList.InsertColumn( i, "Prg");
	m_CList.SetColumnWidth( i, 35); 
	i++;

	if (m_iDomain==TITLES)
	{
		m_CList.InsertColumn( i, "Cha");
		m_CList.SetColumnWidth( i, 35); 
		i++;
	}
	m_CList.InsertColumn( i, "VID");
	m_CList.SetColumnWidth( i, 30); 
	i++;
	m_CList.InsertColumn( i, "CID");
	m_CList.SetColumnWidth( i, 30); 
	i++;
	if (m_iDomain==MENUS)
	{
		m_CList.InsertColumn( i, "Buttons");
		m_CList.SetColumnWidth( i, 30); 
		i++;
	}
	m_CList.InsertColumn( i, "Size");
	m_CList.SetColumnWidth( i, 60); 
	i++;
	m_CList.InsertColumn( i, "Duration");
	m_CList.SetColumnWidth( i, 80); 
	i++;
	m_CList.InsertColumn( i, "Total Duration");
	m_CList.SetColumnWidth( i, 80); 
	i++;
	m_CList.InsertColumn( i, "Reused");
	m_CList.SetColumnWidth( i, 40); 
	i++;
	m_CList.InsertColumn( i, "ILV");
	m_CList.SetColumnWidth( i, 30); 
	i++;
	m_CList.InsertColumn( i, "Cat");
	m_CList.SetColumnWidth( i, 30); 
	i++;
	m_CList.InsertColumn( i, "Action");
	m_CList.SetColumnWidth( i, 60); 
	i++;
	m_CList.InsertColumn( i, "Replacing Cell");
	m_CList.SetColumnWidth( i, 160); 
	i++;

	if (m_iDomain==TITLES)
		nCells=theApp.m_nCells[m_nVTS][m_nT];
	else
		nCells=theApp.m_nMCells[m_nVTS][m_nT];

	dwTotalDuration=0;
	for (nCell=0;nCell<nCells;nCell++)
	{
		theApp.GetCellInfo(m_iDomain, m_nVTS,m_nT,nCell, &VobId, &CellId, &dwDuration, &i64Size, &bReused, &CellCat0, &nButtons);
		dwTotalDuration=AddDuration(dwTotalDuration, dwDuration);

		// Cell number
		csAux.Format(_T("%d"),nCell+1);
		m_CList.InsertItem(nCell, csAux);
		j=1;

		nPrg=theApp.GetProgram(m_iDomain,m_nVTS,m_nT,nCell);
		if (nPrg<=0)
			csAux="";
		else
			csAux.Format(_T("%d"),nPrg);
		m_CList.SetItemText(nCell,j, csAux);
		j++;

		if (m_iDomain==TITLES)
		{
			nChap=theApp.GetChapter(m_nVTS,m_nT,nCell);
			if (nChap<=0)
				csAux="";
			else
				csAux.Format(_T("%d"),nChap);
			m_CList.SetItemText(nCell,j, csAux);
			j++;
		}
		// VobID
		csAux.Format(_T("%d"),VobId);
		m_CList.SetItemText(nCell,j, csAux);
		j++;
		// CellID
		csAux.Format(_T("%d"),CellId);
		m_CList.SetItemText(nCell,j, csAux);
		j++;
		if (m_iDomain==MENUS)
		{
			csAux.Format(_T("%d"),nButtons);
			m_CList.SetItemText(nCell,j, csAux);
			j++;
		}
		// Size
		csAux=Size_MBytes(i64Size);
		m_CList.SetItemText(nCell,j, csAux);
		j++;
		// Duration
		csAux=FormatDuration(dwDuration);
		m_CList.SetItemText(nCell,j, csAux);
		j++;
		// TotalDuration
		csAux=FormatDuration(dwTotalDuration);
		m_CList.SetItemText(nCell,j, csAux);
		j++;
		// Reused
		if (bReused)
			csAux="Yes";
		else
			csAux="No";
		m_CList.SetItemText(nCell,j, csAux);
		j++;
		// ILV
		if (CellCat0 & 0x04)
			csAux="Yes";
		else
			csAux="No";
		m_CList.SetItemText(nCell,j, csAux);
		j++;
		// CellCat
		csAux.Format(_T("%02X"),CellCat0);
		m_CList.SetItemText(nCell,j, csAux);
		j++;

		// Action
		csAux2="";
		if (m_iDomain==TITLES)
			mychar=theApp.m_csCellBased[m_nVTS][m_nT][nCell];
		else
			mychar=theApp.m_csMCellBased[m_nVTS][m_nT][nCell];
		switch (mychar)
		{
		case 'K':
			csAux="Keep";
			break;
		case 'B':
			csAux="Blank";
			break;
		case 'R':
			csAux="Replace";
			csAux2.Empty();
			for (n=0; n<theApp.m_ACell_replace.GetSize(); n++)
			{
				if (theApp.m_ACell_replace[n].VID==VobId &&
					theApp.m_ACell_replace[n].CID==CellId &&
					theApp.m_ACell_replace[n].nVTS==m_nVTS &&
					theApp.m_ACell_replace[n].iDomain==m_iDomain)
					csAux2=theApp.m_ACell_replace[n].csPath;
			}
			break;
		default:
			csAux="Unknown";
			break;

		}
		m_CList.SetItemText(nCell,j, csAux);
		m_indexAction=j;
		j++;

//Replacing 
		m_CList.SetItemText(nCell,j, csAux2);
		m_indexReplace=j;
		j++;

	}

	// TOOLTIPS
	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);

	m_wndToolTip.AddTool(GetDlgItem(IDCANCEL), "Quit" );
	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Apply changes" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONEXTRACT),    "Extracts selected Cell" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONEXTRACTALL), "Extracts all Cells in only one file" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONEXTRACTALL2), "Extracts all Cells: One file per cell" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONKEEP), "Keeps the cell as it is" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONBLANKALL), "Marks all the cells for blanking. If there is a reused one, creates a blank cell with a new VID/CID" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONKEEPALL), "Keeps all cells as they are" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONBLANK), "Blanks the selected cell. If it is a reused one, creates a blank cell with a new VID/CID" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONSUBS),  "Replaces the selected cell. If it is a reused one, uses a new VID/CID" );

	m_ProgCell.SetRange( 0, 100 );
	m_ProgCell.SetPos(0);

	UpdateData(FALSE);
	
	CheckEnableButtons();

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CCellsDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CCellsDlg::OnOK() 
{
	// TODO: Add extra validation here

	CDialog::OnOK();

}

void CCellsDlg::OnRclickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
		// TODO: Add your control notification handler code here
	CPoint point;
	CMenu menu;

	GetCursorPos(&point);

    VERIFY(menu.LoadMenu(IDR_MENUCELLS));
    CMenu* pPopup = menu.GetSubMenu(0);
    ASSERT(pPopup != NULL);

	CheckEnableMenu(pPopup);
    pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x,point.y , this);

	*pResult = 0;
}

void CCellsDlg::On__extract() 
{
	// TODO: Add your control notification handler code here
	OnButtonextract();
}
void CCellsDlg::On__keep() 
{
	// TODO: Add your control notification handler code here
	OnButtonkeep();
}
void CCellsDlg::On__extractall() 
{
	// TODO: Add your control notification handler code here
	OnButtonextractall();
}
void CCellsDlg::On__extractall2() 
{
	// TODO: Add your control notification handler code here
	OnButtonextractall2();
}
void CCellsDlg::On__blank() 
{
	// TODO: Add your control notification handler code here
	OnButtonblank();
}
void CCellsDlg::On__subs() 
{
	// TODO: Add your control notification handler code here
	OnButtonsubs();
}
void CCellsDlg::On__keepall() 
{
	// TODO: Add your control notification handler code here
	OnButtonkeepall();
}
void CCellsDlg::On__blankall() 
{
	// TODO: Add your control notification handler code here
	OnButtonblankall();
}
void CCellsDlg::OnButtonextract() 
{
	// TODO: Add your control notification handler code here
//	int m_nT,m_nVTS;
	
	int nCell;
	POSITION posCell;
	CString csAux;
	CString csFiltro,csTitulo;
	CString csSavePath;
	CWnd* pWnd;
	int iRet;

	posCell=m_CList.GetFirstSelectedItemPosition();
	pWnd = GetDlgItem(IDC_STATICINFO);

	if (posCell != NULL )
	{
		csFiltro = "VOB files";
		csFiltro += " (*.VOB)|*.VOB||";
		csTitulo = "Select Output File *.VOB";
	// OpenFile Dlg construction 
		CFileDialog dlgAbrir(FALSE,"VOB","VTS_01_1.VOB",OFN_EXPLORER ,(const char*)csFiltro);

		dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;
//		dlgAbrir.m_ofn.Flags=OFN_NODEREFERENCELINKS|OFN_EXPLORER;
		dlgAbrir.m_ofn.Flags=OFN_EXPLORER;

		if (dlgAbrir.DoModal() == IDOK)
		{
			csSavePath = dlgAbrir.GetPathName(); 
			if( (_access( csSavePath , 0 )) != -1 )
			{
				iRet=AfxMessageBox ("The selected file already exists. Overwrite?", MB_YESNO|MB_ICONQUESTION );
				if (iRet!=IDYES) 
				{
					pWnd->SetWindowText("");
					CheckEnableButtons();	
					return;
				}
			}

			if ((theApp.m_Fout=fopen (csSavePath,"wb"))==NULL)
			{
				MessageBox( "Error opening file", "Error",  MB_OK | MB_ICONEXCLAMATION );
				pWnd->SetWindowText("");
				return;
			}
		}
		else return;
	}

	while (posCell )
	{
		nCell=m_CList.GetNextSelectedItem(posCell);	
		if (m_iDomain==TITLES)
			csAux.Format(_T("Extracting VTS=%d  PGC=%d  Cell=%d..."), m_nVTS, m_nT+1, nCell+1);
		else
			csAux.Format(_T("Extracting VTS=%d  LU=%d  PGC=%d  Cell=%d..."),
			          m_nVTS, m_nLU+1, m_nT-theApp.m_nIniPGCinLU[m_nVTS][m_nLU]+1, nCell+1);

		pWnd->SetWindowText(csAux);

		theApp.ExtractCell(m_iDomain,m_nVTS,m_nT, nCell, this );
		
	}
	if (theApp.m_Fout!=NULL) fclose (theApp.m_Fout);
	
	theApp.m_Fout=NULL;
	pWnd->SetWindowText("Done");

	CheckEnableButtons();
	
}

void CCellsDlg::UpdateProgress(int nPerc)
{
	if (nPerc <0 ) nPerc=0;
	if (nPerc >100 ) nPerc=100;
	m_ProgCell.SetPos(nPerc);
//	m_csPcProgress.Format(_T("%d %%"),nPerc);

	UpdateData(FALSE);
}


void CCellsDlg::CheckEnableButtons()
{
	CWnd* pWnd;
	POSITION posCell;
	UINT nSelected;
	int iAction;
//	int nCell;

	UpdateData(TRUE);

	if (m_iDomain==TITLES)
		iAction=theApp.m_iAction[m_nVTS][m_nT];
	else
		iAction=theApp.m_iMAction[m_nVTS][m_nT];
	if (theApp.m_bInProcess==true)
	{
		pWnd = GetDlgItem(IDC_BUTTONEXTRACT);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONEXTRACTALL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONEXTRACTALL2);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONBLANK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONKEEP);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONBLANKALL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONKEEPALL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONSUBS);
		pWnd->EnableWindow(FALSE);

		return;
	}

	pWnd = GetDlgItem(IDC_BUTTONEXTRACTALL);
	pWnd->EnableWindow(TRUE);
	pWnd = GetDlgItem(IDC_BUTTONEXTRACTALL2);
	pWnd->EnableWindow(TRUE);
	if (iAction==SKIP)
	{
		pWnd = GetDlgItem(IDC_BUTTONBLANKALL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONKEEPALL);
		pWnd->EnableWindow(FALSE);
	}
	else
	{
		pWnd = GetDlgItem(IDC_BUTTONBLANKALL);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_BUTTONKEEPALL);
		pWnd->EnableWindow(TRUE);
	}
	posCell=m_CList.GetFirstSelectedItemPosition();
	nSelected=m_CList.GetSelectedCount();

	if (posCell != NULL)
	{
//		nCell=m_CList.GetNextSelectedItem(posCell);
		pWnd = GetDlgItem(IDC_BUTTONEXTRACT);
		pWnd->EnableWindow(TRUE);
	}
	else
	{
		pWnd = GetDlgItem(IDC_BUTTONEXTRACT);
		pWnd->EnableWindow(FALSE);
	}

	if (posCell != NULL && iAction!=SKIP)
	{//Enable
		pWnd = GetDlgItem(IDC_BUTTONBLANK);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_BUTTONKEEP);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_BUTTONSUBS);
		pWnd->EnableWindow(TRUE);
	}
	else
	{
		pWnd = GetDlgItem(IDC_BUTTONBLANK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONKEEP);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONSUBS);
		pWnd->EnableWindow(FALSE);
	}

}

void CCellsDlg::CheckEnableMenu(CMenu* pPopup)
{
	POSITION posCell;
	int iAction;

	UpdateData(TRUE);
	if (m_iDomain==TITLES)
		iAction=theApp.m_iAction[m_nVTS][m_nT];
	else
		iAction=theApp.m_iMAction[m_nVTS][m_nT];
	if (theApp.m_bInProcess==true)
	{
		pPopup->EnableMenuItem(ID__CELLEXTRACT, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLEXTRACTALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLEXTRACTALL2, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLKEEP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLBLANK, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLKEEPALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLBLANKALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLSUBS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		return;
	}

	pPopup->EnableMenuItem(ID__CELLEXTRACTALL, MF_BYCOMMAND | MF_ENABLED );	
	pPopup->EnableMenuItem(ID__CELLEXTRACTALL2, MF_BYCOMMAND | MF_ENABLED );	
	if (iAction==SKIP)
	{
		pPopup->EnableMenuItem(ID__CELLKEEPALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLBLANKALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
	}
	else
	{
		pPopup->EnableMenuItem(ID__CELLKEEPALL, MF_BYCOMMAND | MF_ENABLED );	
		pPopup->EnableMenuItem(ID__CELLBLANKALL, MF_BYCOMMAND | MF_ENABLED );	
	}

	posCell=m_CList.GetFirstSelectedItemPosition();
	if (posCell != NULL)
		pPopup->EnableMenuItem(ID__CELLEXTRACT, MF_BYCOMMAND | MF_ENABLED );	
	else
		pPopup->EnableMenuItem(ID__CELLEXTRACT, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );

	if (posCell != NULL && iAction!=SKIP)
	{
		pPopup->EnableMenuItem(ID__CELLKEEP, MF_BYCOMMAND | MF_ENABLED );	
		pPopup->EnableMenuItem(ID__CELLBLANK, MF_BYCOMMAND | MF_ENABLED );	
		pPopup->EnableMenuItem(ID__CELLSUBS, MF_BYCOMMAND | MF_ENABLED );	
	}
	else
	{
		pPopup->EnableMenuItem(ID__CELLKEEP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLBLANK, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLSUBS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
	}
}

void CCellsDlg::OnClickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	CheckEnableButtons();
	*pResult = 0;
}

void CCellsDlg::OnButtonextractall() 
{
	// TODO: Add your control notification handler code here

	int nCell,nCells;
	CString csAux;
	CString csFiltro,csTitulo;
	CString csSavePath;
	bool bReused;
	CWnd* pWnd;
	int iRet;

	pWnd = GetDlgItem(IDC_STATICINFO);
	
	csFiltro = "VOB files";
	csFiltro += " (*.VOB)|*.VOB||";
	csTitulo = "Select Output File *.VOB";
	// OpenFile Dlg construction 
	CFileDialog dlgAbrir(FALSE,"VOB","VTS_01_1.VOB",OFN_EXPLORER ,(const char*)csFiltro);

	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;
//	dlgAbrir.m_ofn.Flags=OFN_NODEREFERENCELINKS|OFN_EXPLORER;
	dlgAbrir.m_ofn.Flags=OFN_EXPLORER;

	if (dlgAbrir.DoModal() == IDOK)
	{
		csSavePath = dlgAbrir.GetPathName(); 
		if( (_access( csSavePath , 0 )) != -1 )
		{
			iRet=AfxMessageBox ("The selected file already exists. Overwrite?", MB_YESNO|MB_ICONQUESTION );
			if (iRet!=IDYES) 
			{
				CheckEnableButtons();	
				return;
			}
		}

		if ((theApp.m_Fout=fopen (csSavePath,"wb"))==NULL)
		{
			MessageBox( "Error opening file", "Error",  MB_OK | MB_ICONEXCLAMATION );
			CheckEnableButtons();	
			return;
		}
		
		if (m_iDomain==TITLES)
			nCells=theApp.m_nCells[m_nVTS][m_nT];
		else
			nCells=theApp.m_nMCells[m_nVTS][m_nT];

			
		for (nCell=0,bReused=false;nCell<nCells && bReused==false ;nCell++)
				bReused=theApp.IsReused(m_iDomain,m_nVTS,m_nT,nCell);

		iRet=IDNO;
		if (bReused)
			iRet=AfxMessageBox ("There are some reused cells.\nDo you want to include them in the extracted VOB?", MB_YESNO|MB_ICONQUESTION );
			
		for (nCell=0;nCell<nCells;nCell++)
		{
			if (iRet ==IDYES || bReused==false ) // Extract all cells
			{
				if (m_iDomain==TITLES)
					csAux.Format(_T("Extracting VTS=%d  PGC=%d  Cell=%d..."), m_nVTS, m_nT+1, nCell+1);
				else
					csAux.Format(_T("Extracting VTS=%d  LU=%d  PGC=%d  Cell=%d..."),
						m_nVTS, m_nLU+1, m_nT-theApp.m_nIniPGCinLU[m_nVTS][m_nLU]+1, nCell+1);
				pWnd->SetWindowText(csAux);
				theApp.ExtractCell(m_iDomain,m_nVTS,m_nT, nCell, this );
				pWnd->SetWindowText("Done.");
			}
		}
		if (theApp.m_Fout!=NULL) fclose (theApp.m_Fout);
		theApp.m_Fout=NULL;
	}

	CheckEnableButtons();	
}


void CCellsDlg::OnButtonextractall2() 
{
	// TODO: Add your control notification handler code here

	int nCell,nCells;
	CString csAux;
	CString csFiltro,csTitulo;
	CString csSavePath;
	bool bReused;
	CWnd* pWnd;
	int iRet;

	pWnd = GetDlgItem(IDC_STATICINFO);
	
	csFiltro = "VOB files";
	csFiltro += " (*.VOB)|*.VOB||";
	csTitulo = "Select Output File *.VOB";
	// OpenFile Dlg construction 
	CFileDialog dlgAbrir(FALSE,"VOB","VTS_01_001.VOB",OFN_EXPLORER ,(const char*)csFiltro);

	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;
//	dlgAbrir.m_ofn.Flags=OFN_NODEREFERENCELINKS|OFN_EXPLORER;
	dlgAbrir.m_ofn.Flags=OFN_EXPLORER;

	if (dlgAbrir.DoModal() == IDOK)
	{
		csSavePath = dlgAbrir.GetPathName(); 
		csSavePath = csSavePath.Left(csSavePath.GetLength()-7)+"001.VOB";

		if( (_access( csSavePath , 0 )) != -1 )
		{
			iRet=AfxMessageBox ("The selected file already exists. Overwrite?\n"+csSavePath, MB_YESNO|MB_ICONQUESTION );
			if (iRet!=IDYES) 
			{
				CheckEnableButtons();	
				return;
			}
		}

	
		if (m_iDomain==TITLES)
			nCells=theApp.m_nCells[m_nVTS][m_nT];
		else
			nCells=theApp.m_nMCells[m_nVTS][m_nT];

			
		for (nCell=0,bReused=false;nCell<nCells && bReused==false ;nCell++)
				bReused=theApp.IsReused(m_iDomain,m_nVTS,m_nT,nCell);

		iRet=IDNO;
		if (bReused)
			iRet=AfxMessageBox ("There are some reused cells.\nDo you want to include them in the extracted VOB?", MB_YESNO|MB_ICONQUESTION );
			

		for (nCell=0;nCell<nCells;nCell++)
		{
			csAux.Format(_T("%03d.VOB"),nCell+1);
			csSavePath = csSavePath.Left(csSavePath.GetLength()-7)+csAux;
			if ((theApp.m_Fout=fopen (csSavePath,"wb"))==NULL)
			{
				MessageBox( "Error opening file. Aborting\n" + csSavePath, "Error",  MB_OK | MB_ICONEXCLAMATION );
				CheckEnableButtons();	
				return;
			}
			if (iRet ==IDYES || bReused==false ) // Extract all cells
			{
				if (m_iDomain==TITLES)
					csAux.Format(_T("Extracting VTS=%d  PGC=%d  Cell=%d..."), m_nVTS, m_nT+1, nCell+1);
				else
					csAux.Format(_T("Extracting VTS=%d  LU=%d  PGC=%d  Cell=%d..."),
						m_nVTS, m_nLU+1, m_nT-theApp.m_nIniPGCinLU[m_nVTS][m_nLU]+1, nCell+1);
				pWnd->SetWindowText(csAux);
				theApp.ExtractCell(m_iDomain,m_nVTS,m_nT, nCell, this );
				pWnd->SetWindowText("Done.");
			}
			if (theApp.m_Fout!=NULL) fclose (theApp.m_Fout);
			theApp.m_Fout=NULL;
		}
	}

	CheckEnableButtons();	
}

void CCellsDlg::OnButtonblank() 
{
	// TODO: Add your control notification handler code here
	int nCell,n;
	POSITION posCell;
	CWnd* pWnd;
	CString csAux,csAux2;

	posCell=m_CList.GetFirstSelectedItemPosition();
	pWnd = GetDlgItem(IDC_STATICINFO);

//	if (posCell != NULL )
	while (posCell)
	{	
		nCell=m_CList.GetNextSelectedItem(posCell);	
		csAux2="";
		if (m_iDomain==TITLES)
			theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,'B');
		else
			theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,'B');
		csAux="Blank";

		for(n=theApp.m_ACell_replace.GetSize()-1; n>=0;n--)
		{
			if (m_iDomain==TITLES)
			{
				if (theApp.m_ACell_replace[n].VID== theApp.CellVID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].CID== theApp.CellCID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].nVTS==m_nVTS &&
					theApp.m_ACell_replace[n].iDomain==m_iDomain)
						theApp.m_ACell_replace.RemoveAt(n,1);
			}
			else
			{
				if (theApp.m_ACell_replace[n].VID== theApp.CellMVID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].CID== theApp.CellMCID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].nVTS==m_nVTS &&
					theApp.m_ACell_replace[n].iDomain==m_iDomain)
						theApp.m_ACell_replace.RemoveAt(n,1);
			}
		}

		if (theApp.IsReused(m_iDomain,m_nVTS,m_nT,nCell))
			MyInfoBox("You have selected a Cell already used in other/s PGC/s.\nA new VobId/CellId will be used in this cell, so this will be a completely new cell");

		m_CList.SetItemText(nCell,m_indexAction, csAux);
		m_CList.SetItemText(nCell,m_indexReplace, csAux2);
	}
}

void CCellsDlg::OnButtonkeep() 
{
	// TODO: Add your control notification handler code here
	int nCell,n;
	POSITION posCell;
	CWnd* pWnd;
	CString csAux,csAux2;

	posCell=m_CList.GetFirstSelectedItemPosition();
	pWnd = GetDlgItem(IDC_STATICINFO);

//	if (posCell != NULL )
	while (posCell)
	{	
		nCell=m_CList.GetNextSelectedItem(posCell);	
		csAux2="";
		if (m_iDomain==TITLES)
			theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,'K');
		else
			theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,'K');
		csAux="Keep";

		for(n=theApp.m_ACell_replace.GetSize()-1; n>=0;n--)
		{
			if (m_iDomain==TITLES)
			{
				if (theApp.m_ACell_replace[n].VID== theApp.CellVID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].CID== theApp.CellCID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].nVTS==m_nVTS &&
					theApp.m_ACell_replace[n].iDomain==m_iDomain)
						theApp.m_ACell_replace.RemoveAt(n,1);
			}
			else
			{
				if (theApp.m_ACell_replace[n].VID== theApp.CellMVID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].CID== theApp.CellMCID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].nVTS==m_nVTS &&
					theApp.m_ACell_replace[n].iDomain==m_iDomain)
						theApp.m_ACell_replace.RemoveAt(n,1);
			}
		}

		m_CList.SetItemText(nCell,m_indexAction, csAux);
		m_CList.SetItemText(nCell,m_indexReplace, csAux2);
	}	
}

void CCellsDlg::OnButtonsubs() 
{
	// TODO: Add your control notification handler code here
	int nCell;
	int n;
	POSITION posCell;
	CWnd* pWnd;
	CString csAux,csAux2,csPath;
	CString csFiltro,csTitulo;
	int VobId,CellId;
	bool bAlready;
	CELL_REPLACE myCell_replace;
	FILE *in;
	uchar buffer[2048];

	posCell=m_CList.GetFirstSelectedItemPosition();
	pWnd = GetDlgItem(IDC_STATICINFO);

	csAux="VTS_01_1.VOB";

//	if (posCell != NULL )
	while (posCell)
	{	
		nCell=m_CList.GetNextSelectedItem(posCell);	
		if (m_iDomain==TITLES)
		{
			VobId=theApp.CellVID(m_nVTS,m_nT,nCell);
			CellId=theApp.CellCID(m_nVTS,m_nT,nCell);
		}
	
		else
		{
			VobId=theApp.CellMVID(m_nVTS,m_nT,nCell);
			CellId=theApp.CellMCID(m_nVTS,m_nT,nCell);
		}
		csFiltro = "VOB files";
		csFiltro += " (*.VOB)|*.VOB||";
		csTitulo = "Select Replacing Cell File *.VOB";
	// OpenFile Dlg construction 
//		CFileDialog dlgAbrir(TRUE,"VOB",csAux,OFN_NODEREFERENCELINKS|OFN_EXPLORER|OFN_FILEMUSTEXIST ,(const char*)csFiltro);
		CFileDialog dlgAbrir(TRUE,"VOB",csAux,OFN_EXPLORER|OFN_FILEMUSTEXIST ,(const char*)csFiltro);
		dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;
//		dlgAbrir.m_ofn.Flags=OFN_NODEREFERENCELINKS|OFN_EXPLORER|OFN_FILEMUSTEXIST;
		dlgAbrir.m_ofn.Flags=OFN_EXPLORER|OFN_FILEMUSTEXIST;

// Check name: Must end in 1.VOB
		if (dlgAbrir.DoModal() == IDOK)
			csPath = dlgAbrir.GetPathName();
		else
		{
			csPath="";
			return;
		}
// Check name: Must end in .VOB
//		csPath.MakeUpper();
		csAux=csPath.Right(4);
		csAux.MakeUpper();

		if (csAux != ".VOB")
		{
			MyErrorBox("Please select a VOB: Filename must end in .VOB");
			return;
		}

		in=fopen(csPath,"rb");
		if (in==NULL)
		{
			MyErrorBox("Unable to open selected file");
			return;
		}
		if (readbuffer(buffer,in) == 2048)
		{
			if (!IsNav(buffer))
			{
				MyErrorBox("Replacing Cell does not start with a Nav Pack");
				return;
			}
			while (readbuffer(buffer,in) == 2048 && !IsVideo(buffer));
			if (!IsVideo(buffer))
			{
				MyErrorBox("Unable to find a Video Pack in selected file");
				return;
			}
		}
		if (in !=NULL) fclose(in);



		for(n=0, bAlready=false; n< theApp.m_ACell_replace.GetSize(); n++)
		{
			if (theApp.m_ACell_replace[n].VID== VobId &&
				theApp.m_ACell_replace[n].CID== CellId &&
				theApp.m_ACell_replace[n].nVTS==m_nVTS &&
				theApp.m_ACell_replace[n].iDomain==m_iDomain)
			{
				bAlready=true;
				theApp.m_ACell_replace[n].csPath=csPath;
			}

		}
		if (bAlready==false)
		{
			myCell_replace.VID=VobId;
			myCell_replace.CID=CellId;
			myCell_replace.iDomain=m_iDomain;
			myCell_replace.nVTS=m_nVTS;
			myCell_replace.csPath=csPath;
			theApp.m_ACell_replace.SetAtGrow(theApp.m_ACell_replace.GetSize(),myCell_replace);
		}
		csAux2=csPath;
		if (m_iDomain==TITLES)
			theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,'R');
		else
			theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,'R');
		csAux="Replace";

		if (theApp.IsReused(m_iDomain,m_nVTS,m_nT,nCell))
			MyInfoBox("You have selected a Cell already used in other/s PGC/s.\nA new VobId/CellId will be used in this cell, so this will be a completely new cell");

		m_CList.SetItemText(nCell,m_indexAction, csAux);
		m_CList.SetItemText(nCell,m_indexReplace, csAux2);

		csAux=csPath.Right(csPath.GetLength()-csPath.ReverseFind('\\')-1);
	}	
}

void CCellsDlg::OnButtonkeepall() 
{
// TODO: Add your control notification handler code here
	int nCell,n,nCells;
	CString csAux,csAux2;

	if (m_iDomain==TITLES)
		nCells=theApp.m_nCells[m_nVTS][m_nT];
	else
		nCells=theApp.m_nMCells[m_nVTS][m_nT];

	for (nCell=0; nCell<nCells; nCell++)
	{	
		csAux2="";
		if (m_iDomain==TITLES)
			theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,'K');
		else
			theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,'K');
		csAux="Keep";

		for(n=theApp.m_ACell_replace.GetSize()-1; n>=0;n--)
		{
			if (m_iDomain==TITLES)
			{
				if (theApp.m_ACell_replace[n].VID== theApp.CellVID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].CID== theApp.CellCID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].nVTS==m_nVTS &&
					theApp.m_ACell_replace[n].iDomain==m_iDomain)
						theApp.m_ACell_replace.RemoveAt(n,1);
			}
			else
			{
				if (theApp.m_ACell_replace[n].VID== theApp.CellMVID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].CID== theApp.CellMCID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].nVTS==m_nVTS &&
					theApp.m_ACell_replace[n].iDomain==m_iDomain)
						theApp.m_ACell_replace.RemoveAt(n,1);
			}
		}

		m_CList.SetItemText(nCell,m_indexAction, csAux);
		m_CList.SetItemText(nCell,m_indexReplace, csAux2);
	}		
}

void CCellsDlg::OnButtonblankall() 
{
// TODO: Add your control notification handler code here
	CString csAux,csAux2;
	bool bWarning;
	int nCells,nCell,n;

	if (m_iDomain==TITLES)
		nCells=theApp.m_nCells[m_nVTS][m_nT];
	else
		nCells=theApp.m_nMCells[m_nVTS][m_nT];

	for (nCell=0,bWarning=false; nCell<nCells; nCell++)
	{	
		csAux2="";
		if (m_iDomain==TITLES)
			theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,'B');
		else
			theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,'B');
		csAux="Blank";

		for(n=theApp.m_ACell_replace.GetSize()-1; n>=0;n--)
		{
			if (m_iDomain==TITLES)
			{
				if (theApp.m_ACell_replace[n].VID== theApp.CellVID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].CID== theApp.CellCID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].nVTS==m_nVTS &&
					theApp.m_ACell_replace[n].iDomain==m_iDomain)
						theApp.m_ACell_replace.RemoveAt(n,1);
			}
			else
			{
				if (theApp.m_ACell_replace[n].VID== theApp.CellMVID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].CID== theApp.CellMCID(m_nVTS,m_nT,nCell) &&
					theApp.m_ACell_replace[n].nVTS==m_nVTS &&
					theApp.m_ACell_replace[n].iDomain==m_iDomain)
						theApp.m_ACell_replace.RemoveAt(n,1);
			}
		}

		if (theApp.IsReused(m_iDomain,m_nVTS,m_nT,nCell)) bWarning=true;

		m_CList.SetItemText(nCell,m_indexAction, csAux);
		m_CList.SetItemText(nCell,m_indexReplace, csAux2);
	}	

	if (bWarning)
		MyInfoBox("There is at least one Cell already used in other/s PGC/s.\nA new VobId/CellId will be used in these cells, so they will be completely new cells");

}



