// PreviewDlg.cpp : implementation file
//

#include "stdafx.h"
#include "direct.h"
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "PreviewDlg.h"

#define TRACK_HEIGHT	30

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CVobBlankerApp theApp;
extern void MyInfoBox(LPCTSTR text);
extern "C" int Coded_Picture_Width, Coded_Picture_Height;	// Size of DVD picture.


#define TIMEOUT   150

#define ID_USERPOSITION   0
#define ID_USERINISECTOR  1
#define ID_USERENDSECTOR  2

#define ID_LEFT_BUTTON                  1
#define ID_LEFT_ARROW                   2
#define ID_RIGHT_ARROW                  3
#define ID_RIGHT_BUTTON                 4
#define ID_TRACKBAR                     5

#define IDM_PREVIEW                     32775
#define IDM_PAUSE                       32777
#define IDM_STOP                        32778
#define IDM_PLAY                        32862
#define IDM_INFO                        32786



/////////////////////////////////////////////////////////////////////////////
// CPreviewDlg dialog


CPreviewDlg::CPreviewDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CPreviewDlg::IDD, pParent)


{
	//{{AFX_DATA_INIT(CPreviewDlg)
	m_iSlider = 0;
	m_csSector = _T("");
	m_csIniSector = _T("");
	m_csIniCell = _T("");
	m_csEndSector = _T("");
	m_csEndCell = _T("");
	m_bCheckDar = TRUE;
	m_bCheckFps = TRUE;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDI_MYMOVIE);

}


void CPreviewDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPreviewDlg)
	DDX_Control(pDX, IDC_COMBOCELL, m_ComboCell);
	DDX_Slider(pDX, IDC_SLIDER1, m_iSlider);
	DDX_Text(pDX, IDC_SECTOR, m_csSector);
	DDX_Text(pDX, IDC_INISECTOR, m_csIniSector);
	DDX_Text(pDX, IDC_INICELL, m_csIniCell);
	DDX_Text(pDX, IDC_ENDSECTOR, m_csEndSector);
	DDX_Text(pDX, IDC_ENDCELL, m_csEndCell);
	DDX_Radio(pDX, IDC_RADIO1, m_iRadio);
	DDX_Check(pDX, IDC_CHECKDAR, m_bCheckDar);
	DDX_Check(pDX, IDC_CHECKFPS, m_bCheckFps);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPreviewDlg, CDialog)
	//{{AFX_MSG_MAP(CPreviewDlg)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER1, OnCustomdrawSlider1)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_PREV, OnPrev)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_INIMARK, OnInimark)
	ON_BN_CLICKED(IDC_ENDMARK, OnEndmark)
	ON_BN_CLICKED(IDC_INICLEAR, OnIniclear)
	ON_BN_CLICKED(IDC_ENDCLEAR, OnEndclear)
	ON_CBN_SELENDOK(IDC_COMBOCELL, OnSelendokCombocell)
	ON_BN_CLICKED(IDC_BUTTONINFO, OnInfo)
	ON_BN_CLICKED(IDC_CHECKDAR, OnCheckdar)
	ON_WM_SIZE()
	ON_WM_MOVE()
	ON_MESSAGE(WM_USER,OnUser)
	ON_BN_CLICKED(IDC_CHECKFPS, OnCheckfps)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CPreviewDlg::OnInitDialog()
{
	CString csPar,csPath,csError,csAux;
	int i;
	CRect myRect;
	int iOFFX;
	int iOFFY;
	char szFile[1024];
	bool bLoadMany;
	CWnd *pWnd;


	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	if (m_iDomain==TITLES)
	{
		for (i=0; i<theApp.m_nCells[m_nVTS][m_nT] ; i++)
		{
			csAux.Format(_T("%d"),i+1);
			m_ComboCell.AddString(csAux);
		}
	}
	else
	{
		for (i=0; i<theApp.m_nMCells[m_nVTS][m_nT] ; i++)
		{
			csAux.Format(_T("%d"),i+1);
			m_ComboCell.AddString(csAux);
		}
	}

	m_ComboCell.SetCurSel(0);

	m_nCell=m_ComboCell.GetCurSel();
	m_nCellSectors= (int) theApp.PR_CellSectors(m_iDomain, m_nVTS,m_nT,m_nCell);
	iSector=0;
	m_csSector="0";

	m_bIsPlaying=false;

	if (m_iDomain==TITLES)
	{
		iIniCell=	theApp.m_CutInfo[m_nVTS][m_nT].iIniCell;
		iIniSector= theApp.m_CutInfo[m_nVTS][m_nT].iIniLba;
		iEndCell=	theApp.m_CutInfo[m_nVTS][m_nT].iEndCell;
		iEndSector=	theApp.m_CutInfo[m_nVTS][m_nT].iEndLba;
		m_iRadio=	theApp.m_CutInfo[m_nVTS][m_nT].iAction;
	}

	UpdateData(FALSE);


	// TOOLTIPS
	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);

	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Exit" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_SLIDER1), "Move cursor inside the Cell" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_COMBOCELL), "Change Cell" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_NEXT), "Move cursor to next VOBU" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_PREV), "Move cursor to previous VOBU" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_INIMARK), "Mark for cut PGC: Initial point" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_ENDMARK), "Mark for cut PGC: End point" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_INICLEAR), "Clear cutting mark" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_ENDCLEAR), "Clear cutting mark" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_PLAY), "Play the selected Cell." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_STOP), "Stop playing." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_INICELL), "Mark for cut PGC: Initial point" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_ENDCELL), "Mark for cut PGC: End point" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_INISECTOR), "Mark for cut PGC: Initial point" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_ENDSECTOR), "Mark for cut PGC: End point" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONINFO), "Toggle DVD2AVI info window" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_RADIO1), "Keep movie between marks. Discard before initial mark and after end mark" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_RADIO2), "Discard movie between marks. Keep before initial mark and after end mark" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKDAR), "Keep Display Aspect Ratio when resizing. If not checked, fill the window completely" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKFPS), "Insert delays between frames to get the actual frame rate." );

	UpdateCsEdit();

	UpdateData(FALSE);


	GetClientRect(&m_RectDlg);
	GetWindowRect(&myRect);
	iOFFX=(myRect.Width()-m_RectDlg.Width())/2;    // OFFX=Border
	iOFFY=myRect.Height()-m_RectDlg.Height()-iOFFX; // OFFY=Top border+Caption+Menu. 

	pWnd=GetDlgItem(IDC_STATICPREV);
	pWnd->GetWindowRect(&m_RectPrev);

	m_RectPrev.OffsetRect(-myRect.left-iOFFX,-myRect.top-iOFFY);

	m_PreviewHWnd = m_VideoPreview.InitPreview(m_hWnd,.5,.5,
		              m_RectPrev.left,m_RectPrev.top,SW_SHOW,0,WS_CHILD|WS_DLGFRAME);

	if (m_iDomain==TITLES)
	{
		sprintf( szFile,"%s\\VTS_%02d_1.VOB",theApp.m_csInputPath, m_nVTS);
		bLoadMany=true;
	}
	else
	{
		bLoadMany=false;
		if (m_nVTS ==0 )
			sprintf( szFile,"%s\\VIDEO_TS.VOB",theApp.m_csInputPath);
		else
			sprintf( szFile,"%s\\VTS_%02d_0.VOB",theApp.m_csInputPath, m_nVTS);
	}

	m_VideoPreview.LoadFile(szFile,bLoadMany, true);
	m_VideoPreview.WaitForThread();
	m_VideoPreview.PlaybackActualRate(m_bCheckFps);

	ReSize(m_RectDlg.Width(),m_RectDlg.Height());

	EnableButtons();
	OnSelendokCombocell();

	return TRUE;  // return TRUE  unless you set the focus to a control

}
/////////////////////////////////////////////////////////////////////////////
// CPreviewDlg message handlers

void CPreviewDlg::OnCustomdrawSlider1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here

	int i, iVID,iCID;
	__int64	i64DestSector;
	int iSector_old;

	UpdateData(TRUE);

	iSector_old=iSector;
	i= m_iSlider;
	iSector=((m_nCellSectors-1)*i)/100;

	if (m_iDomain==TITLES)
	{
		iVID=theApp.CellVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellCID(m_nVTS,m_nT,m_nCell);
	}
	else
	{
		iVID=theApp.CellMVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellMCID(m_nVTS,m_nT,m_nCell);
	}

	i64DestSector= theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell) + iSector;
	i64DestSector=theApp.PR_LocateNavSector(m_iDomain,m_nVTS, iVID, iCID, i64DestSector, true);
	if (i64DestSector >= 0 ) 
		i64DestSector-=theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell);
	else
		i64DestSector=iSector_old;
	iSector= (int) i64DestSector;
	m_csSector.Format(_T("%d"),iSector);

	if ( iSector > 1700)

	UpdateData(FALSE);

	else
			UpdateData(FALSE);


	SendPosition( ID_USERPOSITION, true );
	*pResult = 0;
}


void CPreviewDlg::OnOK() 
{
	// TODO: Add extra cleanup here

	UpdateData(TRUE);

	if (m_iDomain==TITLES)
	{
		theApp.m_CutInfo[m_nVTS][m_nT].iIniCell=iIniCell;
		theApp.m_CutInfo[m_nVTS][m_nT].iIniLba=iIniSector;
		theApp.m_CutInfo[m_nVTS][m_nT].iEndCell=iEndCell;
		theApp.m_CutInfo[m_nVTS][m_nT].iEndLba=iEndSector;
		theApp.m_CutInfo[m_nVTS][m_nT].iAction=m_iRadio;
	}
	if (m_bIsPlaying)  OnStop();

	CDialog::OnOK();
}


void CPreviewDlg::OnCancel() 
{
	if (m_bIsPlaying)  OnStop();

	CDialog::OnCancel();
}

void CPreviewDlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	
	m_VideoPreview.Stop();
	m_VideoPreview.WaitForThread();

	m_VideoPreview.SetStopSector(-1);
	m_VideoPreview.WaitForThread();

	m_bIsPlaying=false;
	EnableButtons();
	SendPosition( ID_USERPOSITION, false );

}

void CPreviewDlg::OnPlay() 
{
	// TODO: Add your control notification handler code here
	int iVobId, iCellId;
	DWORD dwDuration;
	__int64 i64Size;
	int nButtons;
	bool bReused;
	uchar CellCat0;
	int iDestSector;

	if (m_bIsPlaying) return;

	theApp.GetCellInfo(m_iDomain, m_nVTS,m_nT,m_nCell, 
		&iVobId, &iCellId, &dwDuration, &i64Size, &bReused, &CellCat0 , &nButtons);

	if (CellCat0 & 0x04)
	{
		MyInfoBox("This cell is a interleaved one.\nPlayback will not be correct.");
	}
	m_bIsPlaying=true;
	EnableButtons();

	iDestSector=(int) (theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell)+
		               theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell))-1;

	m_VideoPreview.SetStopSector(iDestSector);
	m_VideoPreview.WaitForThread();

	m_VideoPreview.Play();

}

void CPreviewDlg::OnPrev() 
{
	// TODO: Add your control notification handler code here
	__int64 i64DestSector;
	int iVID,iCID;
	bool bDecrCell;

	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	i64DestSector= theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell) + iSector;
	if (m_iDomain==TITLES)
	{
		iVID=theApp.CellVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellCID(m_nVTS,m_nT,m_nCell);
	}
	else
	{
		iVID=theApp.CellMVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellMCID(m_nVTS,m_nT,m_nCell);
	}

	bDecrCell=false;
	if (iSector > 0)
	{
		i64DestSector=theApp.PR_LocateNavSector(m_iDomain, m_nVTS, iVID, iCID, i64DestSector-1, false);
		if (i64DestSector >= 0 )
		{
			i64DestSector-=theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell);
			iSector= (int) i64DestSector;
		}
		else bDecrCell=true;
	}
	else bDecrCell=true;

	if (bDecrCell)
	{
		if (m_nCell >0)
		{
			m_nCell--;
			m_ComboCell.SetCurSel(m_nCell);
			if (m_iDomain==TITLES)
			{
				iVID=theApp.CellVID(m_nVTS,m_nT,m_nCell);
				iCID=theApp.CellCID(m_nVTS,m_nT,m_nCell);
			}
			else
			{
				iVID=theApp.CellMVID(m_nVTS,m_nT,m_nCell);
				iCID=theApp.CellMCID(m_nVTS,m_nT,m_nCell);
			}
			m_nCellSectors= (int) theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell);
			iSector=m_nCellSectors;

			i64DestSector= theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell) + iSector;
			i64DestSector= theApp.PR_LocateNavSector(m_iDomain, m_nVTS,iVID, iCID, i64DestSector-1, false);
			if (i64DestSector >= 0 )
				i64DestSector-=theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell);
			iSector= (int) i64DestSector;

		}
		
	}

	m_csSector.Format(_T("%d"),iSector);
	m_iSlider=(iSector*100)/m_nCellSectors;

	UpdateData(FALSE);

	SendPosition( ID_USERPOSITION, true );

}

void CPreviewDlg::OnNext() 
{

	__int64 i64DestSector;
	int iCID,iVID,nCells;

	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	i64DestSector= theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell) + iSector;
	if (m_iDomain==TITLES)
	{
		iVID=theApp.CellVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellCID(m_nVTS,m_nT,m_nCell);
		nCells=theApp.m_nCells[m_nVTS][m_nT] ;
	}
	else
	{
		iVID=theApp.CellMVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellMCID(m_nVTS,m_nT,m_nCell);
		nCells=theApp.m_nMCells[m_nVTS][m_nT] ;
	}

	if (iSector < m_nCellSectors-1)
	{
		i64DestSector=theApp.PR_LocateNavSector(m_iDomain, m_nVTS,iVID, iCID,i64DestSector+1, true);
		if (i64DestSector >= 0)
		{
			i64DestSector-=theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell);
			iSector= (int) i64DestSector;
		}
		else 
		{
			if (m_nCell < nCells-1)
			{
				iSector=0;
				m_nCell++;
				m_ComboCell.SetCurSel(m_nCell);
				m_nCellSectors= (int) theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell);
			}
		}
	}
	else
	{
		if (m_nCell < nCells -1)
		{
			iSector=0;
			m_nCell++;
			m_ComboCell.SetCurSel(m_nCell);
			m_nCellSectors= (int) theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell);
		}
	}

	m_csSector.Format(_T("%d"),iSector);
	m_iSlider=(iSector*100)/m_nCellSectors;

	UpdateData(FALSE);

	SendPosition( ID_USERPOSITION, true );

}

void CPreviewDlg::EnableButtons() 
{

	CWnd *pWnd;

	if (m_bIsPlaying)
	{
		pWnd = GetDlgItem(IDC_SLIDER1);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_COMBOCELL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_NEXT);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_PREV);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_INIMARK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_ENDMARK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_INICLEAR);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_ENDCLEAR);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_PLAY);
		pWnd->EnableWindow(FALSE);

	}
	else
	{
		pWnd = GetDlgItem(IDC_SLIDER1);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_COMBOCELL);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_NEXT);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_PREV);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_PLAY);
		pWnd->EnableWindow(TRUE);


		if (m_iDomain==TITLES)
		{
			pWnd = GetDlgItem(IDC_INIMARK);
			pWnd->EnableWindow(m_BEnableCut);
			pWnd = GetDlgItem(IDC_ENDMARK);
			pWnd->EnableWindow(m_BEnableCut);
			pWnd = GetDlgItem(IDC_INICLEAR);
			pWnd->EnableWindow(m_BEnableCut);
			pWnd = GetDlgItem(IDC_ENDCLEAR);
			pWnd->EnableWindow(m_BEnableCut);
		}
		else
		{
			pWnd = GetDlgItem(IDC_INIMARK);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_ENDMARK);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_INICLEAR);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_ENDCLEAR);
			pWnd->EnableWindow(FALSE);
		}
	}
	if (m_iDomain==TITLES)
	{
		pWnd = GetDlgItem(IDC_STATIC1);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC2);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC3);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC4);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC5);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC6);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC7);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_RADIO1);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_RADIO2);
		pWnd->EnableWindow(TRUE);

	}
	else
	{
		pWnd = GetDlgItem(IDC_STATIC1);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC2);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC3);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC4);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC5);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC6);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC7);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_RADIO1);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_RADIO2);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_ENDCELL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_ENDSECTOR);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_INICELL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_INISECTOR);
		pWnd->EnableWindow(FALSE);

	}

}

void CPreviewDlg::OnIniclear() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	iIniSector=-1;
	iIniCell=-1;

	m_csIniCell="Start";
	m_csIniSector="Start";

	UpdateData(FALSE);

}

void CPreviewDlg::OnEndclear() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	iEndSector=-1;
	iEndCell=-1;

	m_csEndCell="Last";
	m_csEndSector="Last";

	UpdateData(FALSE);

}

void CPreviewDlg::OnInimark() 
{
	// TODO: Add your control notification handler code here
	int iret;

	UpdateData(TRUE);

	if (theApp.PR_IsClosedGOP(m_nVTS,m_nT,m_nCell, iSector) == false)
	{
		iret=AfxMessageBox ("The selected GOP is not a closed one,\nso if this mark is the init of the playback,\nthe first picture can not be properly decoded.\nDo you want to continue?", MB_YESNO|MB_ICONQUESTION );
		if (iret!=IDYES) return;
	}

	iIniSector=iSector;
	iIniCell=m_nCell;

	m_csIniCell.Format(_T("%d"),iIniCell+1);
	m_csIniSector.Format(_T("%d"),iIniSector);


	if (iEndSector >=0 )
		if (iEndCell < iIniCell || 
			 ( iEndCell==iIniCell && iEndSector < iIniSector))
		{
			iEndSector=iIniSector;
			iEndCell=iIniCell;

			m_csEndCell=m_csIniCell;
			m_csEndSector=m_csIniSector;

		}

	UpdateData(FALSE);

}
void CPreviewDlg::UpdateCsEdit()
{ 
	if (iIniCell ==-1)
		m_csIniCell="Start";
	else
		m_csIniCell.Format(_T("%d"),iIniCell+1);
	if (iIniSector ==-1)
		m_csIniSector="Start";
	else
		m_csIniSector.Format(_T("%d"),iIniSector);
	if (iEndCell ==-1)
		m_csEndCell="Last";
	else
		m_csEndCell.Format(_T("%d"),iEndCell+1);
	if (iEndSector ==-1)
		m_csEndSector="Last";
	else
		m_csEndSector.Format(_T("%d"),iEndSector);

}

void CPreviewDlg::OnEndmark() 
{
	// TODO: Add your control notification handler code here
	int iret;

	UpdateData(TRUE);

	if (theApp.PR_IsClosedGOP(m_nVTS,m_nT,m_nCell, iSector) == false)
	{
		iret=AfxMessageBox ("The selected GOP is not a closed one,\nso if this mark is the init of the playback,\nthe first picture can not be properly decoded.\nDo you want to continue?", MB_YESNO|MB_ICONQUESTION );
		if (iret!=IDYES) return;
	}

	iEndSector=iSector;
	iEndCell=m_nCell;

	m_csEndCell.Format(_T("%d"),iEndCell+1);
	m_csEndSector.Format(_T("%d"),iEndSector);


	if (iEndCell < iIniCell || 
		 ( iEndCell==iIniCell && iEndSector < iIniSector))
	{
		iEndSector=iIniSector;
		iEndCell=iIniCell;
		m_csEndCell=m_csIniCell;
		m_csEndSector=m_csIniSector;

	}
	UpdateData(FALSE);	
}

void CPreviewDlg::OnSelendokCombocell() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_nCell=m_ComboCell.GetCurSel();
	m_nCellSectors= (int) theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell);
	iSector=0;
	m_csSector="0";
	m_iSlider=0;
	UpdateData(FALSE);

	SendPosition( ID_USERENDSECTOR, true );
	SendPosition( ID_USERINISECTOR, true );
	SendPosition( ID_USERPOSITION, true );
}

void CPreviewDlg::SendPosition(LONG wParam, bool bCheck) 
{
	static int iDestSector_old=-1;
	int iDestSector;

	switch (wParam)
	{
		case ID_USERPOSITION:
			iDestSector=(int) theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell) + iSector;
			if (bCheck && iDestSector==iDestSector_old) return;
			iDestSector_old=iDestSector;

			m_VideoPreview.GoToSector(iDestSector,1);
			m_VideoPreview.WaitForThread();

		break;

		case ID_USERINISECTOR:
			iDestSector=(int) theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell);

			m_VideoPreview.HandleMessage(WM_USER,ID_USERINISECTOR,iDestSector);
			m_VideoPreview.WaitForThread();
//			m_VideoPreview.HandleMessage(WM_COMMAND,ID_LEFT_ARROW,0);
//			m_VideoPreview.WaitForThread();
			m_VideoPreview.HandleMessage(WM_COMMAND,ID_LEFT_BUTTON,0);
			m_VideoPreview.WaitForThread();
		break;

		case ID_USERENDSECTOR:
			iDestSector=(int) (theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell)+
			               theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell))-1;

			m_VideoPreview.HandleMessage(WM_USER,ID_USERINISECTOR,0);
			m_VideoPreview.WaitForThread();
			m_VideoPreview.HandleMessage(WM_COMMAND,ID_LEFT_BUTTON,0);
			m_VideoPreview.WaitForThread();
			m_VideoPreview.HandleMessage(WM_USER,ID_USERENDSECTOR,iDestSector);
			m_VideoPreview.WaitForThread();
//			m_VideoPreview.HandleMessage(WM_COMMAND,ID_RIGHT_ARROW,0);
//			m_VideoPreview.WaitForThread();
			m_VideoPreview.HandleMessage(WM_COMMAND,ID_RIGHT_BUTTON,0);
			m_VideoPreview.WaitForThread();
		break;
	}
}


void CPreviewDlg::OnInfo() 
{
	static bool ShowIt = false;

	ShowIt = !ShowIt;
	m_VideoPreview.ShowInfo(ShowIt);
}


void CPreviewDlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);
	// This is necessary, so when you move the preview window, the video moves with it!
	// Only necessary when using the video overlay mixer.
	m_VideoPreview.HandleMessage(WM_MOVE,0,0);
}


void CPreviewDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
/*	if (nType==SIZE_RESTORED  )
	{
		if (cx < m_RectDlg.right)
		{
			cx=m_RectDlg.right-m_RectDlg.left;
		}
		if (cy < m_RectDlg.bottom)
		{
			cy=m_RectDlg.bottom-m_RectDlg.top;
		}

	}
*/
	ReSize(cx, cy);
}

void CPreviewDlg::ReSize(int cx, int cy) 
{

	// TODO: Add your message handler code here
	float fscale_x, fscale_y;
	int iDar,iVideoAttr;
	int iIniX,iIniY;

	CRect myRect;
	int imaxhoriz,imaxvert;
	int iResHoriz,iResVert;
	int ihorizDar,ivertDar;
	
	if (m_iDomain==TITLES)
		iVideoAttr=theApp.m_iVideoAttr[m_nVTS];
	else
		iVideoAttr=theApp.m_pIFO[m_nVTS][0x100]*256+theApp.m_pIFO[m_nVTS][0x101];

	iDar=0;
	if ((iVideoAttr & 0x0C00) != 0)  
		iDar=1;
	
	iResHoriz=Coded_Picture_Width;
	iResVert=Coded_Picture_Height;

	if (iResHoriz==0 || iResVert==0) return;

	imaxhoriz=cx-(m_RectDlg.Width()-m_RectPrev.Width());
	imaxvert=cy-(m_RectDlg.Height()-m_RectPrev.Height())-TRACK_HEIGHT;

	iIniX=m_RectPrev.left;
	iIniY=m_RectPrev.top;

	if (!m_bCheckDar)
	{
		fscale_x=(float)imaxhoriz/(float)iResHoriz;
		fscale_y=(float)imaxvert/(float)iResVert;
	}
	else
	{
		if (iDar==0)
		{
			ihorizDar=imaxvert*4/3;
			ivertDar=imaxhoriz*3/4;
		}
		else
		{
			ihorizDar=imaxvert*16/9;
			ivertDar=imaxhoriz*9/16;
		}
		if (ihorizDar > imaxhoriz)
		{
			ihorizDar = imaxhoriz;
			fscale_x=(float)imaxhoriz/(float)iResHoriz;
			fscale_y=(float)ivertDar/(float)iResVert;
			iIniY+=((imaxvert-ivertDar)/2);
		}
		else
		{
			ivertDar=imaxvert;
			fscale_x=(float)ihorizDar/(float)iResHoriz;
			fscale_y=(float)imaxvert/(float)iResVert;
			iIniX+=((imaxhoriz-ihorizDar)/2);

		}


	}
	m_VideoPreview.SetVideoScaling(fscale_x,fscale_y);
	::SetWindowPos(m_PreviewHWnd,HWND_TOP,iIniX,iIniY,0,0,SWP_NOSIZE|SWP_NOZORDER);
	m_VideoPreview.SetVideoPosition(iIniX,iIniY);
}

void CPreviewDlg::OnCheckdar() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	CRect myRect;

	GetClientRect(&myRect);

	ReSize(myRect.Width(),myRect.Height());

}

void CPreviewDlg::OnUser(WPARAM wParam, LPARAM lParam)
{
	// Here, we handle messages sent by DVD2AVI.
	if(wParam == ID_THREAD_STOPPED)
	{
	}
	else if(wParam == ID_SECTOR_HIT)
	{
	// We're here because playback hit a sector limit.
		m_bIsPlaying=false;
		EnableButtons();
		m_VideoPreview.SetStopSector(-1);
		m_VideoPreview.WaitForThread();

	}
}

void CPreviewDlg::OnCheckfps() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_VideoPreview.PlaybackActualRate(m_bCheckFps);
	
}
