// VobBlankerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "sys/types.h"
#include "sys/stat.h"
#include "io.h"
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "VobBlankerDlg.h"
#include "CreditsDlg.h"
#include "ContactDlg.h"
#include "PreviewDlg.h"
#include "StripDlg.h"
#include "VideoAttrDlg.h"
#include "LogDlg.h"
#include "CellsDlg.h"
#include "MenusDlg.h"


extern CVobBlankerApp theApp;
extern CString Size_MBytes(__int64 i64size);
extern CString FormatDuration(DWORD duration);
extern void MyErrorBox(LPCTSTR text);
extern void MyInfoBox(LPCTSTR text);
extern CString SelectFolder (CString csTitulo, CString csStartFolder);
extern int readbuffer(uchar* caracter, FILE *in);
extern bool IsNav(uchar* buffer);
extern bool IsSynch(uchar* buffer);
extern bool IsVideo(uchar* buffer);
extern int GetNbytes(int nNumber,uchar* address);
extern bool MyDeleteFile(const char *szFilename);



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


CLogDlg dlgLog;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVobBlankerDlg dialog

CVobBlankerDlg::CVobBlankerDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CVobBlankerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVobBlankerDlg)
	m_csProgress = _T("");
	m_csOutput = _T("");
	m_csInput = _T("");
	m_bCheckIfof = TRUE;
	m_bCheckMenu = TRUE;
	m_bCheckVobPuops = TRUE;
	m_bCheckTitle = TRUE;
	m_csPcProgress = _T("");
	m_bCheckIfoPuops = TRUE;
	m_csEditEnd = _T("");
	m_csEditIni = _T("");
	m_bCheckFixVobs = TRUE;
	m_csPcProgressTot = _T("");
	m_bCheckPostPre = TRUE;
	m_bCheckElapsed = FALSE;
	m_bCheckPostPreForced = FALSE;
	m_bCheckFolder = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVobBlankerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVobBlankerDlg)
	DDX_Control(pDX, IDC_PROGRESSTOT, m_CProgressTot);
	DDX_Control(pDX, IDC_LISTT, m_CListT);
	DDX_Control(pDX, IDC_LISTVTS, m_CListVTS);
	DDX_Control(pDX, IDC_PROGRESS0, m_CProgress);
	DDX_Text(pDX, IDC_STATICPROGRESS, m_csProgress);
	DDX_Text(pDX, IDC_EDITOUTPUT, m_csOutput);
	DDX_Text(pDX, IDC_EDITINPUT, m_csInput);
	DDX_Check(pDX, IDC_CHECKIFOF, m_bCheckIfof);
	DDX_Check(pDX, IDC_CHECKMENU, m_bCheckMenu);
	DDX_Check(pDX, IDC_CHECKVOBPUOPS, m_bCheckVobPuops);
	DDX_Check(pDX, IDC_CHECKTITLE, m_bCheckTitle);
	DDX_Text(pDX, IDC_PCPROGRESS, m_csPcProgress);
	DDX_Check(pDX, IDC_CHECKIFOPUOPS, m_bCheckIfoPuops);
	DDX_Text(pDX, IDC_EDITEND, m_csEditEnd);
	DDX_Text(pDX, IDC_EDITINI, m_csEditIni);
	DDX_Check(pDX, IDC_CHECKFIXVOBS, m_bCheckFixVobs);
	DDX_Text(pDX, IDC_PCPROGRESSTOT, m_csPcProgressTot);
	DDX_Check(pDX, IDC_CHECKPOSTPRE, m_bCheckPostPre);
	DDX_Check(pDX, IDC_CHECKELAPSED, m_bCheckElapsed);
	DDX_Check(pDX, IDC_CHECKPOSTPREFORCED, m_bCheckPostPreForced);
	DDX_Check(pDX, IDC_CHECKFOLDER, m_bCheckFolder);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVobBlankerDlg, CDialog)
	//{{AFX_MSG_MAP(CVobBlankerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_HELP_CONTACT, OnHelpContact)
	ON_COMMAND(ID_HELP_CONTENTS, OnHelpContents)
	ON_COMMAND(ID_HELP_CREDITS, OnHelpCredits)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_QUIT, OnFileQuit)
	ON_COMMAND(ID_FILE_EXECUTE, OnFileExecute)
	ON_COMMAND(ID_BLANK_ALL, OnBlankAll)
	ON_COMMAND(ID_BLANK_AUTO, OnBlankAuto)
	ON_BN_CLICKED(IDC_BUTTONBLANK, OnButtonblank)
	ON_BN_CLICKED(IDC_BUTTONINPUT, OnButtoninput)
	ON_BN_CLICKED(IDC_BUTTONKEEP, OnButtonkeep)
	ON_BN_CLICKED(IDC_BUTTONOUTPUT, OnButtonoutput)
	ON_BN_CLICKED(IDC_BUTTONPREV, OnButtonprev)
	ON_BN_CLICKED(IDC_BUTTONSUBS, OnButtonsubs)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LISTVTS, OnItemchangedListvts)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LISTT, OnItemchangedListt)
	ON_BN_CLICKED(IDC_BUTTONSKIP, OnButtonskip)
	ON_BN_CLICKED(IDC_BUTTONPROC, OnButtonproc)
	ON_BN_CLICKED(IDC_BUTTONSKIPALL, OnButtonskipall)
	ON_BN_CLICKED(IDC_BUTTONPROCALL, OnButtonprocall)
	ON_BN_CLICKED(IDC_BUTTONABORT, OnButtonabort)
	ON_BN_CLICKED(IDC_CHECKMENU, OnCheckmenu)
	ON_BN_CLICKED(IDC_BUTTONSTRIP, OnButtonstrip)
	ON_BN_CLICKED(IDC_BUTTONCELLS, OnButtoncells)
	ON_WM_SIZE()
	ON_NOTIFY(NM_RCLICK, IDC_LISTT, OnRclickListt)
	ON_NOTIFY(NM_DBLCLK, IDC_LISTT, OnDblclkListt)
	ON_NOTIFY(NM_RCLICK, IDC_LISTVTS, OnRclickListvts)
	ON_NOTIFY(NM_DBLCLK, IDC_LISTVTS, OnDblclkListvts)
	ON_BN_CLICKED(IDC_BUTTONMENU, OnButtonmenu)
	ON_BN_CLICKED(IDC_CHECKPOSTPREFORCED, OnCheckpostpreforced)
	ON_BN_CLICKED(IDC_CHECKPOSTPRE, OnCheckpostpre)
	ON_EN_KILLFOCUS(IDC_EDITINPUT, OnKillfocusEditinput)
	ON_BN_CLICKED(IDC_CHECKFOLDER, OnCheckfolder)
	//}}AFX_MSG_MAP
    ON_WM_DROPFILES()

	ON_COMMAND(ID__REPLACE, On__replace)
	ON_COMMAND(ID__KEEP, On__keep)
	ON_COMMAND(ID__BLANK, On__blank)
	ON_COMMAND(ID__STRIP, On__strip)
	ON_COMMAND(ID__PREVIEW, On__preview)
	ON_COMMAND(ID__CELLS, On__cells)
	ON_COMMAND(ID__AUDINFO, On__audinfo)


	ON_COMMAND(ID__PROCALL, On__procall)
	ON_COMMAND(ID__SKIPALL, On__skipall)
	ON_COMMAND(ID__PROC, On__process)
	ON_COMMAND(ID__SKIP, On__skip)
	ON_COMMAND(ID__BLANKVTS, On__blankVTS)
	ON_COMMAND(ID__VIDEOATTR, On__videoattr)
	ON_COMMAND(ID__AUDIOATTR, On__audioattr)
	ON_COMMAND(ID__MENUS, On__menus)


END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVobBlankerDlg message handlers

BOOL CVobBlankerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_csProgress= "Waiting...";
	//CLISTCTRL HEADERS
	m_CListVTS.SetExtendedStyle( LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES );
	m_CListVTS.SetItemCount(110);
	m_CListVTS.InsertColumn( 0, "TitleSet");
	m_CListVTS.SetColumnWidth( 0, 90); 
	m_CListVTS.InsertColumn( 1, "# Titles");
	m_CListVTS.SetColumnWidth( 1, 50); 
	m_CListVTS.InsertColumn( 2, "Ini Size");
	m_CListVTS.SetColumnWidth( 2, 60); 
	m_CListVTS.InsertColumn( 3, "Menu Size");
	m_CListVTS.SetColumnWidth( 3, 60); 
	m_CListVTS.InsertColumn( 4, "Final Size");
	m_CListVTS.SetColumnWidth( 4, 60); 
	m_CListVTS.InsertColumn( 5, "Video Format");
	m_CListVTS.SetColumnWidth( 5, 110); 
	m_CListVTS.InsertColumn( 6, "# Aud");
	m_CListVTS.SetColumnWidth( 6, 50); 
	m_CListVTS.InsertColumn( 7, "Action");
	m_CListVTS.SetColumnWidth( 7, 60); 
	

	m_CListT.SetExtendedStyle( LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES );
	m_CListT.SetItemCount(100);
	m_CListT.InsertColumn( 0, "PGC #");
	m_CListT.SetColumnWidth( 0, 60); 
	m_CListT.InsertColumn( 1, "TTN");
	m_CListT.SetColumnWidth( 1, 40); 
	m_CListT.InsertColumn( 2, "T in VMG");
	m_CListT.SetColumnWidth( 2, 57); 
	m_CListT.InsertColumn( 3, "1st Vid");
	m_CListT.SetColumnWidth( 3, 45); 
	m_CListT.InsertColumn( 4, "# Cells");
	m_CListT.SetColumnWidth( 4, 45); 
	m_CListT.InsertColumn( 5, "Duration");
	m_CListT.SetColumnWidth( 5, 80); 
	m_CListT.InsertColumn( 6, "Size");
	m_CListT.SetColumnWidth( 6, 60); 
	m_CListT.InsertColumn( 7, "Action");
	m_CListT.SetColumnWidth( 7, 60); 
	m_CListT.InsertColumn( 8, "Reuse cells");
	m_CListT.SetColumnWidth( 8, 40); 
	m_CListT.InsertColumn( 9, "ILV");
	m_CListT.SetColumnWidth( 9, 40); 
	m_CListT.InsertColumn( 10, "Angles");
	m_CListT.SetColumnWidth( 10, 50); 
	m_CListT.InsertColumn( 11, "Commands");
	m_CListT.SetColumnWidth( 11, 110); 
	m_CListT.InsertColumn( 12, "Replacing Title");
	m_CListT.SetColumnWidth( 12, 160); 

	m_indexReplacing=12;
	m_indexAction=7;

	m_CProgress.SetRange( 0, 100 );

	UpdateData(FALSE);

	bAlreadyRun=false;

	// TOOLTIPS
	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);

	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Use this to generate the file");
	m_wndToolTip.AddTool(GetDlgItem(IDCANCEL), "Use this for...quitting" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKTITLE), "Process Titles (VOBs)" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKVOBPUOPS), "Remove PUOPs in VOBs and Menus" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKIFOPUOPS), "Remove PUOPs in IFOs (Title and Menu PGCs)" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKMENU), "Process Menus (VTS_XX_0.VOB)" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKIFOF), "Process VTS IFO files tables" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKFIXVOBS), "Correct DSI pointers in VOBs (also audio/subs pointers), but only in the affected cells. Do not correct if not checked" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKPOSTPRE), "Change postcommands into precommands in Blanked PGCs (Titles and Menus) but only if there are not cell commands." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKPOSTPREFORCED), "Change unconditionally postcommands into precommands in Blanked PGC (Titles and Menus)." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKELAPSED), "Recalculate elapsed time in replacing cells (Cellbased mode) Nav Packs. Reset to zero the first elapsed time and substract it as an offset in the following ones." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONBLANK ), "Blanks selected Title" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONSUBS ), "Replaces a title by a VOB with one and only one title with the SAME number of cells" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONSTRIP ),"Removes one or more audio tracks" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONCELLS ),"Cell based selection" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONKEEP ), "Keeps original Title. De-interleave cells" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONPREV ), "Preview title" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONSKIP ), "Skips processing the whole VTS. Nothing will be generated in output dir" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONPROC ), "Process the VTS as selected" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONSKIPALL ), "Skips all VTS (Do nothing at all)" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONPROCALL ), "Process all VTS" );


	CheckEnableButtons();

	GetInitialCoord();

	DragAcceptFiles(TRUE);

	m_bCLIMode=m_bCLIRun= m_bCLIExit=m_bFirstLoad=false;

	CString csParam,csAux;
	char *p;

	// Check CLI mode
	if ( __argc > 1 )
	{
		m_bCLIMode=m_bFirstLoad=true;
		m_bCLIRun= m_bCLIExit=theApp.m_bLog=false;

		m_csCLIFile = __argv [(__argc)-1];
//		m_csCLIFile.MakeLower();

		csAux=m_csCLIFile.Right(12);
		csAux.MakeUpper();

		if (__argc==2 && csAux=="VIDEO_TS.IFO")
		{
			m_csInput =  m_csCLIFile; 
//			m_csInput.MakeUpper();
			UpdateData (FALSE);

			OnNewInputfile();
		}
		else
		{
			for ( int i = 1; i < (__argc); i++ )
			{
				p = __argv[i];
				csParam = p;
				csParam.MakeLower();

				if (csParam == "-log" )
				{
					theApp.m_bLog=true;
					if ( __argc == 2 ) 
						m_bCLIMode=m_bCLIRun= m_bCLIExit=m_bFirstLoad=false;

				}
				if (csParam == "-run" ) m_bCLIRun=true;
				if (csParam == "-exit" ) m_bCLIExit=true;
			}

			if (m_bCLIMode)
				PostMessage(WM_COMMAND, ID_FILE_OPEN, NULL);
		}
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CVobBlankerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVobBlankerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVobBlankerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/////////////////////////////////////////////////////////////////////////////
// MENU Commands

void CVobBlankerDlg::OnHelpAbout() 
{
	// TODO: Add your command handler code here
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();	
}

void CVobBlankerDlg::OnHelpContact() 
{
	// TODO: Add your command handler code here
		CContactDlg dlgContact;
		dlgContact.DoModal();	
}

void CVobBlankerDlg::OnHelpCredits() 
{
	// TODO: Add your command handler code here
		CCreditsDlg dlgCredits;
		dlgCredits.DoModal();
}

void CVobBlankerDlg::OnHelpContents() 
{
	// TODO: Add your command handler code here
/*	int iRet;
	CString csError;

	iRet = (int) ShellExecute (NULL, "open", "VobBlanker.hlp","",theApp.csPath,SW_SHOW) ;
	if (iRet <=32)
	{
		csError.Format(_T("Error in ShellExecute. Return value= %d\nPlease check if VobBlanker.hlp is located in the same folder"),iRet);
		MessageBox(csError, "ERROR", MB_OK);
	}
*/
	AfxGetApp()->WinHelp(0,HELP_FINDER);

	return;
}

void CVobBlankerDlg::OnFileQuit() 
{
	// TODO: Add your command handler code here
	OnCancel();
}

void CVobBlankerDlg::OnFileExecute() 
{
	// TODO: Add your command handler code here
	OnOK();
}


bool CVobBlankerDlg::LoadProject(CString csFileName) 
{
	CMenu * mmenu;
	FILE *in;
	bool bRet;

	mmenu=GetMenu();

	if ((in=fopen (csFileName,"r"))==NULL)
	{
		MessageBox( "Error opening file", "Error",  MB_OK | MB_ICONEXCLAMATION );
		mmenu->EnableMenuItem(ID_FILE_SAVE_AS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
	return false;
	}
	fclose (in);

	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));

	if ( theApp.LoadProject(csFileName) == false)
	{
		MessageBox( "Error loading project", "Error",  MB_OK | MB_ICONEXCLAMATION );
		mmenu->EnableMenuItem(ID_FILE_SAVE_AS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		bRet=false;
	}
	else
	{
		mmenu->EnableMenuItem(ID_FILE_SAVE_AS, MF_BYCOMMAND | MF_ENABLED );

		m_csInput=theApp.m_csInputPath+"\\"+"VIDEO_TS.IFO";
		m_csOutput=theApp.m_csOutputPath;
		m_bCheckIfof=		theApp.m_bCheckIfof;
		m_bCheckMenu=		theApp.m_bCheckMenu;
		m_bCheckVobPuops=	theApp.m_bCheckVobPuops;
		m_bCheckTitle=		theApp.m_bCheckTitle;
		m_bCheckIfoPuops=	theApp.m_bCheckIfoPuops;
		m_bCheckFixVobs=	theApp.m_bCheckFixVobs;
		m_bCheckPostPre=	theApp.m_bCheckPostPre;
		m_bCheckPostPreForced=	theApp.m_bCheckPostPreForced;
		m_bCheckElapsed=	theApp.m_bCheckElapsed;
		m_bCheckFolder=		theApp.m_bCheckFolder;
		bAlreadyRun=false;
		UpdateData(FALSE);
		PintaVTS();
		PintaT();
		bRet=true;
	}

	OnCheckfolder();

	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
	return bRet;
}	

void CVobBlankerDlg::OnFileOpen() 
{
// TODO: Add your command handler code here
//Open Project

	CString csFiltro,csTitulo;
	CString csSavePath,csAux;

	csAux=m_csCLIFile;
	csAux.MakeUpper();

	if (csAux.Right(4)==".IFO")
	{
		MessageBox( "Unable to open a single VTS IFO: Please select the VIDEO_TS.IFO", "Error",  MB_OK | MB_ICONEXCLAMATION );
		return;
	}

	if (m_bCLIMode && m_bFirstLoad)
	{
		if (LoadProject(m_csCLIFile))
		{
			if (m_bCLIRun)
				PostMessage(WM_COMMAND, IDOK, NULL);
			else if (m_bCLIExit)
				PostMessage(WM_COMMAND, IDCANCEL, NULL);
		}
		m_bFirstLoad=false;
	}
	else
	{
		csFiltro = "All files";
		csFiltro += " (*.*)|*.*||";
		csTitulo = "Select file Project File *.ini";
	// OpenFile Dlg construction 
//		CFileDialog dlgAbrir(TRUE,"ini","VobBlanker.ini",OFN_NODEREFERENCELINKS|OFN_EXPLORER|OFN_FILEMUSTEXIST ,(const char*)csFiltro);
		CFileDialog dlgAbrir(TRUE,"ini","VobBlanker.ini",OFN_EXPLORER|OFN_FILEMUSTEXIST ,(const char*)csFiltro);

		dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;
//		dlgAbrir.m_ofn.Flags=OFN_NODEREFERENCELINKS|OFN_EXPLORER|OFN_FILEMUSTEXIST;
		dlgAbrir.m_ofn.Flags=OFN_EXPLORER|OFN_FILEMUSTEXIST;

		if (dlgAbrir.DoModal() == IDOK)
		{
			csSavePath = dlgAbrir.GetPathName(); 
			LoadProject(csSavePath);
		}
	}
}


void CVobBlankerDlg::OnFileSaveAs() 
{
	// TODO: Add your command handler code here
	CString csSavePath,csFiltro,csTitulo;
	FILE *in;

	csFiltro = "All files";
	csFiltro += " (*.*)|*.*||";
	csTitulo = "Save Project as *.ini";
	// OpenFile Dlg construction 
	CFileDialog dlgAbrir(FALSE,"ini","VobBlanker.ini",OFN_EXPLORER ,(const char*)csFiltro);

	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;
//	dlgAbrir.m_ofn.Flags=OFN_NODEREFERENCELINKS|OFN_EXPLORER;
	dlgAbrir.m_ofn.Flags=OFN_EXPLORER;

	if (dlgAbrir.DoModal() == IDOK)
	{
		csSavePath = dlgAbrir.GetPathName(); 
		if ((in=fopen (csSavePath,"w"))==NULL)
		{
			MessageBox( "Error opening file", "Error",  MB_OK | MB_ICONEXCLAMATION );
		}
		else
		{
			SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
			fclose(in);
			UpdateData(TRUE);
			theApp.m_csOutputPath=		m_csOutput;
			theApp.m_bCheckIfof=		m_bCheckIfof;
			theApp.m_bCheckMenu=		m_bCheckMenu;
			theApp.m_bCheckVobPuops=	m_bCheckVobPuops;
			theApp.m_bCheckTitle=		m_bCheckTitle;
			theApp.m_bCheckIfoPuops=	m_bCheckIfoPuops;
			theApp.m_bCheckFixVobs=		m_bCheckFixVobs;
			theApp.m_bCheckPostPre=		m_bCheckPostPre;
			theApp.m_bCheckPostPreForced=m_bCheckPostPreForced;
			theApp.m_bCheckElapsed=		m_bCheckElapsed;
			theApp.m_bCheckFolder=		m_bCheckFolder;
			if ( theApp.SaveProject(csSavePath) ==false)
				MessageBox( "Error Saving Project", "Error",  MB_OK | MB_ICONERROR );
			else
				MessageBox( "Project Saved", "Info",  MB_OK | MB_ICONEXCLAMATION );

			SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));

		}	
	}
}

void CVobBlankerDlg::OnBlankAll() 
{
	int nVTS;

	if (m_csInput.IsEmpty()) return;

	for (nVTS=1; nVTS< theApp.m_nIFOs+1; nVTS++)
		ButtonblankVTS(nVTS); 

	PintaVTS();
	PintaT();
	UpdateSize();
	UpdateData(FALSE);

}

void CVobBlankerDlg::OnBlankAuto() 
{
	int nVTS,nT;
	int SelectedVTS,SelectedT;
	DWORD dwMaxDuration;

	if (m_csInput.IsEmpty()) return;

	OnBlankAll();

	SelectedVTS=1;
	SelectedT=0;
	dwMaxDuration=0;

	for (nVTS=1; nVTS< theApp.m_nIFOs+1; nVTS++)
	{
		for (nT=0; nT< theApp.m_nPGCs[nVTS]; nT++)
		{
			if (theApp.m_dwDuration[nVTS][nT] > dwMaxDuration)
			{
				SelectedVTS=nVTS;
				SelectedT=nT;
				dwMaxDuration=theApp.m_dwDuration[nVTS][nT];
			}
		}
	}


	theApp.m_iAction[SelectedVTS][SelectedT]=KEEP;
	CleanCellBased(SelectedVTS,SelectedT);

	PintaVTS();
	PintaT();
	UpdateSize();
	UpdateData(FALSE);

}

/////////////////////////////////////////////////////////////////////////////
// Buttons


void CVobBlankerDlg::OnButtoninput() 
{
	// TODO: Add your control notification handler code here
	CString	csFiltro,csTitulo;
	CString csAux;

	// String del filtro de ficheros y del titulo
	UpdateData (TRUE);

	csFiltro = "IFO VGM files";
	csFiltro += " (VIDEO_TS.IFO)|VIDEO_TS.IFO||";
	csTitulo = "Select file VIDEO_TS.IFO";
	// OpenFile Dlg construction 
//	CFileDialog dlgAbrir(TRUE,"IFO","VIDEO_TS.IFO",OFN_NODEREFERENCELINKS|OFN_EXPLORER|OFN_FILEMUSTEXIST ,(const char*)csFiltro);
	CFileDialog dlgAbrir(TRUE,"IFO","VIDEO_TS.IFO",OFN_EXPLORER|OFN_FILEMUSTEXIST ,(const char*)csFiltro);

	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;
//	dlgAbrir.m_ofn.Flags=OFN_NODEREFERENCELINKS|OFN_EXPLORER|OFN_FILEMUSTEXIST;
	dlgAbrir.m_ofn.Flags=OFN_EXPLORER|OFN_FILEMUSTEXIST;

	if (dlgAbrir.DoModal() == IDOK)
	{
		m_csInput = dlgAbrir.GetPathName(); 
		//TODO: Check name
		csAux=m_csInput.Right(12);
		csAux.MakeUpper();

		if (csAux!="VIDEO_TS.IFO")
		{
			MyErrorBox("Invalid input File. Please select the video manager: VIDEO_TS.IFO");
			m_csInput="";
			if (m_bCheckFolder)
				m_csOutput="";
			UpdateData (FALSE);
			return;
		}
		UpdateData (FALSE);
		OnNewInputfile();
		if (m_bCheckFolder)
			m_csOutput=theApp.m_csInputPath;
		UpdateData (FALSE);

	}		
}

void CVobBlankerDlg::OnNewInputfile() 
{
	CMenu * mmenu;

	mmenu=GetMenu();

	if ( theApp.ReadIFOs(m_csInput) <=0)
	{
		m_csInput="";
		m_CListVTS.DeleteAllItems();
		m_CListT.DeleteAllItems();
		UpdateData (FALSE);
		return;
	}
	else
	{
		mmenu->EnableMenuItem(ID_FILE_SAVE_AS, MF_BYCOMMAND | MF_ENABLED );
		bAlreadyRun=false;
		CheckEnableButtons();
		PintaVTS();
	}
	if (theApp.m_bAngleAll)
			MyInfoBox("There are at least one multiangle (UNSUPPORTED) Cell.\nThe VTSs containing these cells have been marked as SKIP.");
	if (theApp.m_bAngleAll || theApp.m_bILVAll )
			MyInfoBox("There are at least one ILV Cell.\nThe VTSs containing these cells have been marked as SKIP.\nYou can process them, but playback problems can appear\nin all PGCs originally containing ILV cells except the first one.");

}

void CVobBlankerDlg::OnButtonoutput() 
{
	// TODO: Add your control notification handler code here

	CString	csPath;
	
	UpdateData (TRUE);
	if (m_csOutput.IsEmpty())
	{
		if (theApp.m_csInputPath.IsEmpty())
			csPath=SelectFolder ("Select destination Folder","C:\\");
		else
			csPath=SelectFolder ("Select destination Folder",theApp.m_csInputPath);
	}
	else
		csPath=SelectFolder ("Select destination Folder",m_csOutput);
	if (! csPath.IsEmpty())
	{
		m_csOutput= csPath;
//		m_csOutput.MakeUpper();
	}
	UpdateData (FALSE);

}

///////////////////////////////////////////////////////////////
///////////////////////////TITLE SECTION BUTTONS //////////////
///////////////////////////////////////////////////////////////

void CVobBlankerDlg::OnButtonprev() 
{
	// TODO: Add your control notification handler code here
	int nItemT,nItemVTS;
	POSITION posT, posVTS;
	CPreviewDlg dlgPreview;


	posT=m_CListT.GetFirstSelectedItemPosition();
	posVTS=m_CListVTS.GetFirstSelectedItemPosition();


	if (posT != NULL && posVTS !=NULL)
	{
		nItemT=m_CListT.GetNextSelectedItem(posT);	
		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);

		dlgPreview.m_BEnableCut=FALSE;
		if (theApp.m_iAction[nItemVTS][nItemT]==KEEP ||
		    theApp.m_iAction[nItemVTS][nItemT]==CUT)
			dlgPreview.m_BEnableCut=TRUE;

		dlgPreview.m_nT=nItemT;
		dlgPreview.m_nVTS=nItemVTS;
		dlgPreview.m_iDomain=TITLES;

		if (dlgPreview.DoModal()== IDOK)
		{

			if (theApp.m_CutInfo[nItemVTS][nItemT].iIniCell !=-1 || 
				theApp.m_CutInfo[nItemVTS][nItemT].iEndCell !=-1) 
			{
				theApp.m_iAction[nItemVTS][nItemT]=CUT;
				theApp.CalculateCutSize(nItemVTS,nItemT);
				m_CListT.SetItemText(nItemT,m_indexAction, "Cut");
				m_CListT.SetItemText(nItemT,m_indexReplacing, "");
				CleanCellBased(nItemVTS,nItemT);
			}
			else if (theApp.m_iAction[nItemVTS][nItemT]==CUT)
			{
				theApp.m_iAction[nItemVTS][nItemT]=KEEP;
				theApp.m_i64Rsize[nItemVTS][nItemT]=0;
				m_CListT.SetItemText(nItemT,m_indexAction, "Keep");
				m_CListT.SetItemText(nItemT,m_indexReplacing, "");

			}
		}

	}

	UpdateSize();
	UpdateData(FALSE);
}

void CVobBlankerDlg::OnButtonsubs() 
{
	// TODO: Add your control notification handler code here
	int nItemT,nItemVTS;
	POSITION posT, posVTS;
	CString csTitulo, csFiltro;
	CString csFile,csAux,csAux1;
	int k;
	struct  _stati64 statbuf;
	__int64 i64oldRsize;
	FILE *in;
	uchar buffer[2050];
	int iVTSAttr, iVTSdar, iVTSres, iRepdar, iRepres;
	int ret;
	int ihoriz,ivert;
	__int64 MPEGAttr;
	char szAux1[30],szAux2[30],szAux3[30],szAux4[30];


	
	csFiltro = "VOB file";
	csFiltro += " (*.VOB)|*.VOB||";
	csTitulo = "Select VOB file";
	// OpenFile Dlg construction 
//	CFileDialog dlgAbrir(TRUE,"VOB","VTS_01_1.VOB",OFN_NODEREFERENCELINKS|OFN_EXPLORER|OFN_FILEMUSTEXIST ,(const char*)csFiltro);
	CFileDialog dlgAbrir(TRUE,"VOB","VTS_01_1.VOB",OFN_EXPLORER|OFN_FILEMUSTEXIST ,(const char*)csFiltro);

	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;
//	dlgAbrir.m_ofn.Flags=OFN_NODEREFERENCELINKS|OFN_EXPLORER|OFN_FILEMUSTEXIST;
	dlgAbrir.m_ofn.Flags=OFN_EXPLORER|OFN_FILEMUSTEXIST;

	if (dlgAbrir.DoModal() == IDOK)
		csFile = dlgAbrir.GetPathName();
	else
	{
		csFile="";
		return;
	}
// Check name: Must end in 1.VOB
//	csFile.MakeUpper();
	csAux=csFile.Right(5);
	csAux.MakeUpper();
	if (csAux != "1.VOB")
	{
		MyErrorBox("Please select first VOB: Filename must end in _1.VOB");
		return;
	}

	in=fopen(csFile,"rb");
	if (in==NULL)
	{
		MyErrorBox("Unable to open selected file");
		return;
	}
	if (readbuffer(buffer,in) == 2048)
	{
		if (!IsNav(buffer))
		{
			MyErrorBox("Replacing title does not start with a Nav Pack");
			return;
		}
		while (readbuffer(buffer,in) == 2048 && !IsVideo(buffer));
		if (!IsVideo(buffer))
		{
			MyErrorBox("Unable to find a Video Pack in selected file");
			return;
		}
	}
	if (in !=NULL) fclose(in);

	posT=m_CListT.GetFirstSelectedItemPosition();
	posVTS=m_CListVTS.GetFirstSelectedItemPosition();

	if (posT != NULL && posVTS !=NULL)
	{
		nItemT=m_CListT.GetNextSelectedItem(posT);	
		nItemVTS=m_CListT.GetNextSelectedItem(posVTS);

// Calculate m_i64Rsize;
		i64oldRsize=theApp.m_i64Rsize[nItemVTS][nItemT];
		theApp.m_i64Rsize[nItemVTS][nItemT]=0;

		for (k=1; k<10; k++)
		{
			csAux1.Format(_T("%d.VOB"),k);
			csAux=csFile.Left(csFile.GetLength()-5)+csAux1;
			if (_stati64 ( csAux, &statbuf)==0)
				theApp.m_i64Rsize[nItemVTS][nItemT]+= statbuf.st_size;
			else 
				if (k!=0) k=20;
		}

		theApp.m_iAction[nItemVTS][nItemT]=REPLACE;
		theApp.m_csReplace[nItemVTS][nItemT]=csFile;
		
		m_CListT.SetItemText(nItemT,m_indexAction, "Replace");
		m_CListT.SetItemText(nItemT,m_indexReplacing, csFile);
		CleanCellBased(nItemVTS,nItemT);


// Check MPEG headers. See AR & Resolution. If different ask
// for changing IFOs
		iVTSAttr=theApp.m_iVideoAttr[nItemVTS];

		iVTSdar =(iVTSAttr & 0x0C00) >> 10;
		iVTSres =(iVTSAttr & 0x000C) >> 2;

		if (GetNbytes(4,&buffer[0x17+buffer[0x16]]) == 0x000001b3 )
		{
			MPEGAttr=GetNbytes(4,&buffer[0x17+buffer[0x16]+4]);
			ihoriz= (int) (MPEGAttr & 0xFFF00000) >> 20;
			ivert= (int) (MPEGAttr & 0x000FFF00) >>8;
			if (ihoriz==720 && (ivert==480 || ivert==576)) iRepres=0;
			else if (ihoriz==720 && (ivert==480 || ivert==576)) iRepres=0;
			else if (ihoriz==704 && (ivert==480 || ivert==576)) iRepres=1;
			else if (ihoriz==352 && (ivert==480 || ivert==576)) iRepres=2;
			else if (ihoriz==352 && (ivert==240 || ivert==288)) iRepres=3;
			else  iRepres=4;

			if ( ((int) (MPEGAttr & 0x0F0) >> 4) == 2)  iRepdar=0; // 4:3
			else if ( ((int) (MPEGAttr & 0x0F0) >> 4) == 3)  iRepdar=3; // 16:9
			else  iRepdar=4;
		}

		if (iRepdar!=iVTSdar || iVTSres!= iRepres)
		{
			if (iVTSdar == 0 ) strcpy (szAux1,"4:3");
			else if (iVTSdar == 3 ) strcpy (szAux1,"16:9");
			else strcpy (szAux1,"Illegal");
			if (iRepdar == 0 ) strcpy (szAux2,"4:3");
			else if (iRepdar == 3 ) strcpy (szAux2,"16:9");
			else strcpy (szAux2,"Illegal");

			if (iVTSres == 0) strcpy (szAux3,"720x480/576");
			else if (iVTSres == 1) strcpy (szAux3,"704x480/576");
			else if (iVTSres == 2) strcpy (szAux3,"352x480/576");
			else if (iVTSres == 3) strcpy (szAux3,"352x240/288");
			else strcpy(szAux3,"Illegal");
			if (iRepres == 0) strcpy (szAux4,"720x480/576");
			else if (iRepres == 1) strcpy (szAux4,"704x480/576");
			else if (iRepres == 2) strcpy (szAux4,"352x480/576");
			else if (iRepres == 3) strcpy (szAux4,"352x240/288");
			else strcpy(szAux4,"Illegal");


			csAux.Format(_T("There are some video attribute differences.\n"));
			csAux1.Format(_T("\nVTS DAR= %s; Replacing Title DAR= %s"),szAux1,szAux2); 
			if (iRepdar != iVTSdar )
				csAux+=csAux1;
			csAux1.Format(_T("\nVTS Res= %s; Replacing Title Res= %s"),szAux3,szAux4); 
			if (iRepres != iVTSres )
				csAux+=csAux1;
			csAux1.Format(_T("\n\nDo you want to correct destination IFOs?"));
				csAux+=csAux1;

			ret=AfxMessageBox (csAux, MB_YESNO|MB_ICONQUESTION );

			if (ret==IDYES)
			{
				iVTSAttr=theApp.m_iVideoAttr[nItemVTS];
				iVTSAttr = iVTSAttr & 0xF3F3;
				iVTSAttr+= ((iRepdar & 0x3 ) << 10 );
				iVTSAttr+= ((iRepres & 0x3 ) << 2 );

				theApp.m_iVideoAttr[nItemVTS]=iVTSAttr;

				theApp.UpdateVideoAttr(nItemVTS);
				csAux=DisplayVideoAttr(nItemVTS);
				m_CListVTS.SetItemText(nItemVTS,5, csAux);
			}
//			if (ret==IDNO)
		}
	}	
	CheckEnableButtons();
	UpdateSize();
	UpdateData(FALSE);

}

void CVobBlankerDlg::OnButtonblank() 
{
	// TODO: Add your control notification handler code here
	int nItemT,nItemVTS;
	POSITION posT, posVTS;
	CString csAux;

	posT=m_CListT.GetFirstSelectedItemPosition();
	posVTS=m_CListVTS.GetFirstSelectedItemPosition();
	if (posVTS != NULL) nItemVTS=m_CListT.GetNextSelectedItem(posVTS);
	else return;

	while (posT)
	{
		nItemT=m_CListT.GetNextSelectedItem(posT);	

		theApp.m_i64Rsize[nItemVTS][nItemT]=0;
		theApp.m_iAction[nItemVTS][nItemT]=BLANK;
		m_CListT.SetItemText(nItemT,m_indexAction, "Blank");
		m_CListT.SetItemText(nItemT,m_indexReplacing, "");
		CleanCellBased(nItemVTS,nItemT);
	}

	CheckEnableButtons();
	UpdateSize();
	UpdateData(FALSE);

}

void CVobBlankerDlg::OnButtonkeep() 
{
	// TODO: Add your control notification handler code here
	int nItemT,nItemVTS, ret;
	POSITION posT, posVTS;
	CString csAux;

	posT=m_CListT.GetFirstSelectedItemPosition();
	posVTS=m_CListVTS.GetFirstSelectedItemPosition();
	if (posVTS != NULL) nItemVTS=m_CListT.GetNextSelectedItem(posVTS);
	else return;

	while (posT)
	{
		nItemT=m_CListT.GetNextSelectedItem(posT);	
		
		theApp.m_i64Rsize[nItemVTS][nItemT]=0;
		theApp.m_iAction[nItemVTS][nItemT]=KEEP;
		m_CListT.SetItemText(nItemT,m_indexAction, "Keep");
		m_CListT.SetItemText(nItemT,m_indexReplacing, "");

		CleanCellBased(nItemVTS,nItemT);

		if (theApp.m_iVideoAttr[nItemVTS]!=theApp.m_iVideoAttrBK[nItemVTS])
		{
			csAux.Format(_T("VTS Video Attributes are different from the initial ones in PGC # %d\n"),nItemT+1);
			ret=AfxMessageBox (csAux + "Do you want to recover the originals?", MB_YESNO|MB_ICONQUESTION );

			if (ret==IDYES)
			{
				theApp.m_iVideoAttr[nItemVTS]=theApp.m_iVideoAttrBK[nItemVTS];
				theApp.UpdateVideoAttr(nItemVTS);
				csAux=DisplayVideoAttr(nItemVTS);
				m_CListVTS.SetItemText(nItemVTS,5, csAux);
			}
		}
		UpdateData(FALSE);
	}	
	CheckEnableButtons();
	UpdateSize();
	UpdateData(FALSE);

}

void CVobBlankerDlg::OnButtonstrip() 
{
	// TODO: Add your control notification handler code here
	int nItemT,nItemVTS;
	POSITION posT, posVTS;
	CString csAux;
	CStripDlg dlg;
	int nResponse;
	__int64 i64Rsizeold;



	posT=m_CListT.GetFirstSelectedItemPosition();
	posVTS=m_CListVTS.GetFirstSelectedItemPosition();

	if (posT != NULL && posVTS !=NULL)
	{
		nItemT=m_CListT.GetNextSelectedItem(posT);	
		nItemVTS=m_CListT.GetNextSelectedItem(posVTS);

		i64Rsizeold=theApp.m_i64Rsize[nItemVTS][nItemT];

		dlg.m_nVTS=nItemVTS;
		dlg.m_nT=nItemT;
		dlg.m_mode=STRIP;

		theApp.m_i64Rsize[nItemVTS][nItemT]=0;
		nResponse = dlg.DoModal();

		if (nResponse == IDOK)
		{
			theApp.m_iAction[nItemVTS][nItemT]=STRIP;
			m_CListT.SetItemText(nItemT,m_indexAction, "Strip");
			m_CListT.SetItemText(nItemT,m_indexReplacing, "");
			UpdateData(FALSE);
			CleanCellBased(nItemVTS,nItemT);
		}
		else 
		{
			theApp.m_i64Rsize[nItemVTS][nItemT]=i64Rsizeold;
		}
	}
	UpdateSize();
	UpdateData(FALSE);

}

void CVobBlankerDlg::OnButtoncells() 
{
	// TODO: Add your control notification handler code here
	POSITION posT,posVTS;
	int nItemT, nItemVTS,nCells;
	CString csAux;
	CCellsDlg dlg;
	int nResponse;
	int nCell;
	bool bAllCellsKeep;


	posVTS=m_CListVTS.GetFirstSelectedItemPosition();
	posT=m_CListT.GetFirstSelectedItemPosition();

	if (posVTS !=NULL && posT !=NULL)
	{
		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);
		nItemT=m_CListT.GetNextSelectedItem(posT);

//		i64Rsizeold=theApp.m_i64Rsize[nItemVTS][nItemT];

		dlg.m_nVTS=nItemVTS;
		dlg.m_nT=nItemT;
		dlg.m_iDomain=TITLES;

		nResponse = dlg.DoModal();

		if (nResponse == IDOK)
		{
			nCells=theApp.m_nCells[nItemVTS][nItemT];

			for (nCell=0, bAllCellsKeep=true; nCell<nCells &&  bAllCellsKeep ;nCell++)
			{
				if (theApp.m_csCellBased[nItemVTS][nItemT][nCell] != 'K' ) bAllCellsKeep=false;
			}
			if (bAllCellsKeep) 
			{
				OnButtonkeep();
				return;
			}

			theApp.m_i64Rsize[nItemVTS][nItemT]=theApp.CalculateCellBasedSize(nItemVTS,nItemT);
			theApp.m_iAction[nItemVTS][nItemT]=CELLBASED;
			m_CListT.SetItemText(nItemT,m_indexAction, "Cells");
			m_CListT.SetItemText(nItemT,m_indexReplacing, "");
			UpdateData(FALSE);
		}
	
	UpdateSize();
	UpdateData(FALSE);
	}
}

void CVobBlankerDlg::CleanCellBased(int nVTS, int nT)
{
	int nCell,nCells;
	int nCellR,nReplacingCells;
	char mychar;

	nCells=theApp.m_nCells[nVTS][nT];

	mychar='K';

	for (nCell=0; nCell<nCells ;nCell++)
	   theApp.m_csCellBased[nVTS][nT].SetAt(nCell,mychar);


// REMOVE ONLY CELLS OF MY TITLE ....
	nReplacingCells=theApp.m_ACell_replace.GetSize();
	for (nCellR=nReplacingCells-1; nCellR>=0 ;nCellR--)
	{
		for (nCell=0;nCell<nCells;nCell++)
		{
			if (theApp.CellVID(nVTS,nT,nCell)== theApp.m_ACell_replace[nCellR].VID &&
			    theApp.CellCID(nVTS,nT,nCell)== theApp.m_ACell_replace[nCellR].CID &&
			    theApp.m_ACell_replace[nCellR].nVTS==nVTS &&
				theApp.m_ACell_replace[nCellR].iDomain==TITLES)
			{
				theApp.m_ACell_replace.RemoveAt(nCellR,1);
				nCell=nCells;  //exit loop
			}
		}
	}

}

///////////////////////////////////////////////////////////////
///////////////////////////VTS SECTION BUTTONS ////////////////
///////////////////////////////////////////////////////////////


void CVobBlankerDlg::OnButtonmenu() 
{
	// TODO: Add your control notification handler code here
	int nItemVTS;
	POSITION posVTS;
	CString csAux;

	CMenusDlg dlgMenus;

	posVTS=m_CListVTS.GetFirstSelectedItemPosition();

	if (posVTS !=NULL)
	{
		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);
		dlgMenus.m_nVTS=nItemVTS;
		dlgMenus.DoModal();	
		UpdateSize();
		UpdateData(FALSE);
	}
}

void CVobBlankerDlg::OnButtonskip() 
{
// TODO: Add your control notification handler code here
	int nItemVTS;
	POSITION posVTS;
	CString csAux;

	posVTS=m_CListVTS.GetFirstSelectedItemPosition();

	while (posVTS)
	{
		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);
		Buttonskip(nItemVTS);
		UpdateSize();
		UpdateData(FALSE);
	}
	CheckEnableButtons();
}

void CVobBlankerDlg::OnButtonproc() 
{
	// TODO: Add your control notification handler code here
	int nItemVTS;
	POSITION posVTS;
	CString csAux;

	posVTS=m_CListVTS.GetFirstSelectedItemPosition();

	while (posVTS )
	{
		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);
		Buttonproc(nItemVTS);
		UpdateSize();
		UpdateData(FALSE);
	}	
	CheckEnableButtons();
}
void CVobBlankerDlg::OnButtonblankVTS() 
{
	int nItemVTS;
	POSITION posVTS;

	posVTS=m_CListVTS.GetFirstSelectedItemPosition();

	while (posVTS)
	{
		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);
		ButtonblankVTS(nItemVTS);
		UpdateSize();
		UpdateData(FALSE);
	}	
	CheckEnableButtons();
}
void CVobBlankerDlg::OnButtonskipall() 
{
	// TODO: Add your control notification handler code here
	int i;

	for (i=0;i<theApp.m_nIFOs+1;i++)
		Buttonskip(i);
	UpdateSize();
	UpdateData(FALSE);
	CheckEnableButtons();
}

void CVobBlankerDlg::OnButtonprocall() 
{
	// TODO: Add your control notification handler code here
	int i;

	for (i=0;i<theApp.m_nIFOs+1;i++)
		Buttonproc(i);

	UpdateSize();
	UpdateData(FALSE);
	CheckEnableButtons();	
}

void CVobBlankerDlg::Buttonskip(int nItemVTS) 
{
// TODO: Add your control notification handler code here
	int i;
	CString csAux;

	if (theApp.m_iActionVTS[nItemVTS]==PROCESS)
	{	
		for (i=0;i<theApp.m_nPGCs[nItemVTS];i++)
		{
			theApp.m_iAction[nItemVTS][i]=SKIP;
			m_CListT.SetItemText(i,m_indexAction, "Skip");
		}
	}
	theApp.m_iActionVTS[nItemVTS]=SKIP;
	m_CListVTS.SetItemText(nItemVTS,7, "Skip");
	theApp.m_i64VTSfsize[nItemVTS]=0;
	csAux=Size_MBytes(theApp.m_i64VTSfsize[nItemVTS]);
	m_CListVTS.SetItemText(nItemVTS,4, csAux);
}

void CVobBlankerDlg::Buttonproc(int nItemVTS) 
{
	// TODO: Add your control notification handler code here
	int i;
	CString csAux;

	if (theApp.m_iActionVTS[nItemVTS]==SKIP)
	{	
		for (i=0;i<theApp.m_nPGCs[nItemVTS];i++)
		{
			theApp.m_iAction[nItemVTS][i]=KEEP;
			m_CListT.SetItemText(i,m_indexAction, "Keep");
			theApp.m_CutInfo[nItemVTS][i].iIniCell=-1;
			theApp.m_CutInfo[nItemVTS][i].iEndCell=-1;
			theApp.m_CutInfo[nItemVTS][i].iIniLba=-1;
			theApp.m_CutInfo[nItemVTS][i].iEndLba=-1;

		}
	}
	theApp.m_iActionVTS[nItemVTS]=PROCESS;
	m_CListVTS.SetItemText(nItemVTS,7, "Process");	
	theApp.m_i64VTSfsize[nItemVTS]=theApp.m_i64VTSisize[nItemVTS];
	csAux=Size_MBytes(theApp.m_i64VTSfsize[nItemVTS]);
	m_CListVTS.SetItemText(nItemVTS,4, csAux);
}

void CVobBlankerDlg::ButtonblankVTS(int nItemVTS) 
{
	// TODO: Add your control notification handler code here
	int i;
	CString csAux;

	if (nItemVTS == 0) return;

	for (i=0;i<theApp.m_nPGCs[nItemVTS];i++)
	{
		theApp.m_iAction[nItemVTS][i]=BLANK;
		m_CListT.SetItemText(i,m_indexAction, "Blank");
	}
	theApp.m_iActionVTS[nItemVTS]=PROCESS;
	m_CListVTS.SetItemText(nItemVTS,7, "Process");	
}

void CVobBlankerDlg::OnButtonabort() 
{
	// TODO: Add your control notification handler code here
	if (theApp.m_bInProcess==true)
		theApp.m_bInProcess=false;
	m_CProgress.SetPos(0);
	m_csPcProgress.Format(_T(""));
	m_CProgressTot.SetPos(0);
	m_csPcProgressTot.Format(_T(""));
	UpdateData(FALSE);

	CheckEnableButtons();

}

void CVobBlankerDlg::OnOK() 
{
	// TODO: Add extra validation here
	int i,j,iRet;
	CString csAux,csAux1,csAux2,csAuxIn;
	struct  _stati64 statbuf;


	if (m_csInput.IsEmpty())
	{
		MessageBox( "Fill input file!", "Error",  MB_OK | MB_ICONEXCLAMATION );
		return;
	}

	UpdateData(TRUE);
	if (m_csOutput.IsEmpty())
	{
		MessageBox( "Fill output Folder!", "Error",  MB_OK | MB_ICONEXCLAMATION );
		return;
	}

	theApp.m_csOutputPath=m_csOutput;

	if (m_bCheckFolder) 
	{
		theApp.m_csOutputPath=theApp.m_csInputPath+"\\VobBlanker_backup";
		if ( _access(theApp.m_csOutputPath + "\\" , 0 ) ==0)
		{
			iRet=AfxMessageBox ("VobBlanker_backup folder already exists\nIts video contents will be overwritten. Do you want to continue?", MB_YESNO|MB_ICONQUESTION );
			if (iRet !=IDYES) return;
			MyDeleteFile(theApp.m_csOutputPath+"\\*.IFO");
			MyDeleteFile(theApp.m_csOutputPath+"\\*.BUP");
			MyDeleteFile(theApp.m_csOutputPath+"\\*.VOB");
		}
		else
			CreateDirectory(theApp.m_csOutputPath,NULL);
	}
// Check if folder exists
	if ( _access(theApp.m_csOutputPath + "\\" , 06 ) !=0)
	{
		MessageBox( "Check output Folder!", "Error",  MB_OK | MB_ICONEXCLAMATION );
		return;
	}

//	m_csOutput.MakeUpper();

	csAux1=theApp.m_csInputPath;
	csAux2=theApp.m_csOutputPath;
	csAux1.MakeUpper();
	csAux2.MakeUpper();
	if (csAux2.Right(1)=="\\")
		csAux2=csAux2.Left(csAux2.GetLength()-1);
	if (csAux1.Right(1)=="\\")
		csAux1=csAux1.Left(csAux1.GetLength()-1);


	if (csAux1==csAux2)
	{
		MessageBox( "Output Folder must be different from input one!", "Error",  MB_OK | MB_ICONEXCLAMATION );
		return;
	}

	theApp.m_bCheckIfof=		m_bCheckIfof;
	theApp.m_bCheckMenu=		m_bCheckMenu;
	theApp.m_bCheckVobPuops=	m_bCheckVobPuops;
	theApp.m_bCheckTitle=		m_bCheckTitle;
	theApp.m_bCheckIfoPuops=	m_bCheckIfoPuops;
	theApp.m_bCheckFixVobs=		m_bCheckFixVobs;
	theApp.m_bCheckPostPre=		m_bCheckPostPre;
	theApp.m_bCheckPostPreForced=m_bCheckPostPreForced;
	theApp.m_bCheckElapsed=		m_bCheckElapsed;
	theApp.m_bCheckFolder=		m_bCheckFolder;

	theApp.m_i64GranTotalCurr=0;
	theApp.m_nPostPre=theApp.m_nActualPostPre=0;

	theApp.m_nWarnings=theApp.m_nErrors=0;
	theApp.m_bInProcess=true;
	bAlreadyRun=true;
	CheckEnableButtons();

	if (theApp.m_pLog==NULL)
	{
		dlgLog.Create(IDD_LOG, NULL);
		theApp.m_pLog=&dlgLog;
	}
	dlgLog.m_csEditLog="";
	dlgLog.m_nlin=0;

	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));

	for (i=1; i< theApp.m_nIFOs+1 ; i++)
	{
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
		csAux.Format(_T("VTS_%02d"),i);
		if (theApp.m_iActionVTS[i] == PROCESS)
		{
			if (m_bCheckIfof) 	theApp.ProcessIfoVTSPrepare (i,this);

			if (m_bCheckMenu)
			{
				SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
				m_csProgress= "Processing Menu " + csAux;
				m_csPcProgress="";
				m_CProgress.SetPos(0);
				UpdateData(FALSE);
				theApp.ProcessMenu (i,this);
				m_csProgress= "Waiting..";
				m_csPcProgress="";
				m_CProgress.SetPos(0);
				UpdateData(FALSE);

				if(theApp.m_bInProcess==false) 
				{
					m_CProgressTot.SetPos(0);
					m_csPcProgressTot="";
					break;
				}
				if (m_bCheckIfof) 
				{
					SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
					m_csProgress= "Processing IFO (Menu part) " + csAux;
					m_CProgress.SetPos(0);
					m_csPcProgress="";
					UpdateData(FALSE);
					theApp.ProcessIfoVTSMenu (i,this);
					m_csProgress= "Waiting..";
					m_csPcProgress="";
					m_CProgress.SetPos(0);
					UpdateData(FALSE);
					if(theApp.m_bInProcess==false) 
					{
						m_CProgressTot.SetPos(0);
						m_csPcProgressTot="";
						break;
					}
				}
			}

			if (m_bCheckTitle)
			{
				SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));

				m_csProgress= "Processing VOB " + csAux;
				m_CProgress.SetPos(0);
				m_csPcProgress="";
				UpdateData(FALSE);
				theApp.ProcessVob (i,this);
				m_csProgress= "Waiting..";
				m_csPcProgress="";
				m_CProgress.SetPos(0);
				UpdateData(FALSE);
				if(theApp.m_bInProcess==false)
				{
					m_CProgressTot.SetPos(0);
					m_csPcProgressTot="";
					break;
				}

//// Fix Vob if needed
				if (theApp.m_bFixVobs && theApp.m_bCheckFixVobs)
				{
					SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
					m_csProgress= "Fixing VOB pointers " + csAux;
					m_CProgress.SetPos(0);
					m_csPcProgress="";
					UpdateData(FALSE);
					theApp.FV_FixVob (i,this);
					m_csProgress= "Waiting..";
					m_csPcProgress="";
					m_CProgress.SetPos(0);
					UpdateData(FALSE);
					if(theApp.m_bInProcess==false)
					{
						m_CProgressTot.SetPos(0);
						m_csPcProgressTot="";
						break;
					}
				}
				if (m_bCheckIfof)
					{
					SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
					m_csProgress= "Processing IFO " + csAux;
					m_CProgress.SetPos(0);
					m_csPcProgress="";
					UpdateData(FALSE);
					theApp.ProcessIfoVTSTitle (i,this);
					m_csProgress= "Waiting..";
					m_csPcProgress="";
					m_CProgress.SetPos(0);
					UpdateData(FALSE);
					if(theApp.m_bInProcess==false) 
					{
						m_CProgressTot.SetPos(0);
						m_csPcProgressTot="";
						break;
					}
				}
			}

			if (m_bCheckIfof)
			{
				SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
				m_csProgress= "Writting IFO " + csAux;
				m_CProgress.SetPos(0);
				m_csPcProgress="";
				UpdateData(FALSE);
				theApp.ProcessIfoVTSEnd (i,this);
				m_csProgress= "Waiting..";
				m_csPcProgress="";
				m_CProgress.SetPos(0);
				UpdateData(FALSE);
				if(theApp.m_bInProcess==false) 
				{
					m_CProgressTot.SetPos(0);
					m_csPcProgressTot="";
					break;
				}
			}
		}
	}

	if(theApp.m_bInProcess==false)
	{
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
		theApp.LogEnd();
		return;
	}
// Process VMG
// Always process VIDEO_TS.IFO if any IFO is processed
	if(theApp.m_bInProcess==true && m_bCheckIfof) 
		theApp.ProcessIfoVTSPrepare (0,this);

	if (theApp.m_iActionVTS[0] == PROCESS)
	{
		if (m_bCheckMenu)
		{
			SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
			m_csProgress= "Processing Menu " + csAux;
			m_csPcProgress="";
			m_CProgress.SetPos(0);
			UpdateData(FALSE);
			theApp.ProcessMenu (0,this);
			m_csProgress= "Waiting..";
			m_csPcProgress="";
			m_CProgress.SetPos(0);
			UpdateData(FALSE);
			if(theApp.m_bInProcess==false) 
			{
				m_CProgressTot.SetPos(0);
				m_csPcProgressTot="";
				SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
				theApp.LogEnd();
				return;
			}
			if (m_bCheckIfof) 
			{
				SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
				m_csProgress= "Processing IFO VMG (Menu part)";
				m_CProgress.SetPos(0);
				m_csPcProgress="";
				UpdateData(FALSE);
				theApp.ProcessIfoVTSMenu (0,this);
				m_csProgress= "Waiting..";
				m_csPcProgress="";
				m_CProgress.SetPos(0);
				UpdateData(FALSE);
				if(theApp.m_bInProcess==false) 
				{
					m_CProgressTot.SetPos(0);
					m_csPcProgressTot="";
				}
			}
		}
	}

	// Always process VIDEO_TS.IFO if any IFO is processed
	if(theApp.m_bInProcess==true && m_bCheckIfof) 
	{
		m_csProgress= "Processing IFO VIDEO_TS";
		m_CProgress.SetPos(0);
		m_csPcProgress="";
		UpdateData(FALSE);
		theApp.ProcessIfoMGR (this);
		m_csProgress= "Waiting..";
		m_csPcProgress="";
		m_CProgress.SetPos(0);
		UpdateData(FALSE);
	}


// Move Files if Same Folder
	if (m_bCheckFolder) 
	{
		theApp.MyLog("");
		theApp.MyLog("Moving Files start");

		for (i=1; i< theApp.m_nIFOs+1 ; i++)
		{
			if (theApp.m_iActionVTS[i] == SKIP)
			{// Check 0 bytes Menus
				csAux.Format(_T("VTS_%02d_0.VOB"),i);
				csAuxIn=theApp.m_csInputPath+'\\'+csAux;
				if (_stati64 ( csAuxIn, &statbuf)==0)
				{
					if (statbuf.st_size ==0)
					{
						theApp.MyLog("     Moving 0 bytes menu: "+ csAux);
						MoveFile (csAuxIn,theApp.m_csOutputPath+'\\'+csAux);
					}
				}

				csAux.Format(_T("VTS_%02d_0.IFO"),i);
				csAuxIn=theApp.m_csInputPath+'\\'+csAux;
				theApp.MyLog("     Saving IFO: "+ csAux);
				CopyFile (csAuxIn,theApp.m_csOutputPath+'\\'+csAux, FALSE);

				csAux.Format(_T("VTS_%02d_0.BUP"),i);
				csAuxIn=theApp.m_csInputPath+'\\'+csAux;
				theApp.MyLog("     Saving BUP: "+ csAux);
				CopyFile (csAuxIn,theApp.m_csOutputPath+'\\'+csAux, FALSE);

			}
			if (theApp.m_iActionVTS[i] == PROCESS)
			{
				if (m_bCheckIfof) 
				{
					csAux.Format(_T("VTS_%02d_0.IFO"),i);
					theApp.MyLog("     Moving File: "+ csAux);
					iRet=MoveBckFile(csAux, true);
					if (iRet!=0)
					{
						csAux.Format(_T("VTS_%02d_0.BUP"),i);
						theApp.MyLog("     Moving File: "+ csAux);
						iRet=MoveBckFile(csAux, true);
					}
					if (iRet==0)
					{
						MessageBox( "Error Moving Files!", "Error",  MB_OK | MB_ICONEXCLAMATION );
						theApp.m_bInProcess=false;
						return;
					}
				}
				if (m_bCheckMenu)
				{
					csAux.Format(_T("VTS_%02d_0.VOB"),i);
					csAuxIn=theApp.m_csInputPath+'\\'+csAux;
					if (_stati64 ( csAuxIn, &statbuf)==0)
					{
						theApp.MyLog("     Moving File: "+ csAux);
						iRet=MoveBckFile(csAux, false);
						if (iRet==0)
						{
							MessageBox( "Error Moving Files!", "Error",  MB_OK | MB_ICONEXCLAMATION );
							theApp.m_bInProcess=false;
							return;
						}
					}
				}
				if (m_bCheckTitle)
				{
					for(j=1,iRet=1; j<10 && iRet!=0;j++)
					{
						csAux.Format(_T("VTS_%02d_%1d.VOB"),i,j);
						if (_access(theApp.m_csOutputPath + "\\" + csAux, 0) == -1 &&
							_access(m_csOutput + "\\" + csAux, 0) == -1 ) j=11;
						else
						{
							iRet=MoveBckFile(csAux, false);
							theApp.MyLog("     Moving File: "+ csAux);
						}
					}
					if (iRet==0)
					{
						MessageBox( "Error Moving Files!", "Error",  MB_OK | MB_ICONEXCLAMATION );
						theApp.m_bInProcess=false;
						return;
					}
			
				}
			}
		}
		if (theApp.m_iActionVTS[0] == SKIP)
		{// Check 0 bytes Menu
		// VIDEO_TS.IFO always is processed, so it must be there, no need to save..
			csAux.Format(_T("VIDEO_TS.VOB"));
			csAuxIn=theApp.m_csInputPath+'\\'+csAux;
			if (_stati64 ( csAuxIn, &statbuf)==0)
			{
				if (statbuf.st_size==0)
				{
					theApp.MyLog("     Moving 0 bytes menu: "+ csAux);
					MoveFile (csAuxIn,theApp.m_csOutputPath+'\\'+csAux);
				}
			}
		}
		if (m_bCheckMenu && theApp.m_iActionVTS[0] == PROCESS)
		{
			csAux.Format(_T("VIDEO_TS.VOB"));
			csAuxIn=theApp.m_csInputPath+'\\'+csAux;
			if (_stati64 ( csAuxIn, &statbuf)==0)
			{
				theApp.MyLog("     Moving File: "+ csAux);
				iRet=MoveBckFile(csAux, false);
				if (iRet==0)
				{
					MessageBox( "Error Moving Files!", "Error",  MB_OK | MB_ICONEXCLAMATION );
					theApp.m_bInProcess=false;
					return;
				}
			}
		}

// VIDEO_TS.IFO always is processed, so it must be there..
		csAux.Format(_T("VIDEO_TS.IFO"));
		theApp.MyLog("     Moving File: "+ csAux);
		iRet=MoveBckFile(csAux, true);
		if (iRet!=0)
		{
			csAux.Format(_T("VIDEO_TS.BUP"));
			theApp.MyLog("     Moving File: "+ csAux);
			iRet=MoveBckFile(csAux, true);
		}
		if (iRet==0)
		{
			MessageBox( "Error Moving Files!", "Error",  MB_OK | MB_ICONEXCLAMATION );
			theApp.m_bInProcess=false;
			return;
		}
	}


// Adjust Sectors again if Same Folder
	if (m_bCheckFolder) 
	{
		theApp.MyLog("");
		theApp.MyLog("Adjusting sectors");
		iRet=theApp.AdjustSectors(theApp.m_csInputPath);
		if (iRet)
			theApp.MyLog("   Done OK");
		else
			theApp.MyLog("   Ooops. Something went wrong");

	}


	theApp.m_bInProcess=false;
	m_CProgressTot.SetPos(0);
	m_csPcProgressTot="";
	UpdateData(FALSE);
	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));

	CheckEnableButtons();

	if (m_bCLIMode && m_bCLIExit) 
	{
		PostMessage(WM_COMMAND, IDCANCEL, NULL);
		return;
	}

	theApp.LogEnd();
	return;

	CDialog::OnOK();
}

void CVobBlankerDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CVobBlankerDlg::PintaVTS()
{
	int i;
	CString csAux;

	m_CListVTS.DeleteAllItems();
	m_CListT.DeleteAllItems();
	m_nSelectedItemVTS=-1;

	for (i=0; i<theApp.m_nIFOs+1; i++)
	{
		m_CListVTS.InsertItem( i, theApp.m_csVTSname[i]);
		csAux.Format(_T("%02d"),theApp.m_nPGCs[i]);
		m_CListVTS.SetItemText(i,1, csAux);
		csAux=Size_MBytes(theApp.m_i64VTSisize[i]);
		m_CListVTS.SetItemText(i,2, csAux);
		csAux=Size_MBytes(theApp.m_i64Misize[i]);
		m_CListVTS.SetItemText(i,3, csAux);
		csAux=Size_MBytes(theApp.m_i64VTSfsize[i]);
		m_CListVTS.SetItemText(i,4, csAux);
		if (theApp.m_iActionVTS[i]==PROCESS)
			m_CListVTS.SetItemText(i,7, "Process");
		if (theApp.m_iActionVTS[i]==SKIP)
			m_CListVTS.SetItemText(i,7, "Skip");		
		if (i!=0)
		{
			csAux=DisplayVideoAttr(i);
			m_CListVTS.SetItemText(i,5, csAux);
			csAux.Format(_T("%d"),theApp.m_nAudio[i]);
			m_CListVTS.SetItemText(i,6, csAux);
		}
		//	m_CListT.SetItemText(j,i, "subitem "+csAux);
	}
	UpdateSize();
	UpdateData(FALSE);
}


void CVobBlankerDlg::OnItemchangedListvts(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here

	int nItem;
	CString csNum;
	POSITION pos;

	UpdateData(TRUE);
	pos=m_CListVTS.GetFirstSelectedItemPosition();
	if (pos != NULL)
	{
		nItem=m_CListVTS.GetNextSelectedItem(pos);
		if (nItem!= m_nSelectedItemVTS)
		{
			m_nSelectedItemVTS=nItem;
			PintaT();
		}
	}		
	CheckEnableButtons();
	*pResult = 0;
}


void CVobBlankerDlg::PintaT()
{
	int i,j;
	CString csAux;

	j=m_nSelectedItemVTS;

	m_CListT.DeleteAllItems();

	for (i=0; i<theApp.m_nPGCs[j]; i++)
	{
		csAux.Format(_T("%02d"),i+1);
		if (theApp.m_bEntry[j][i]==true) csAux+= " Entry";
		m_CListT.InsertItem( i, csAux);

		csAux.Format(_T("%02d"),theApp.m_nTitleInVTS[j][i]);
		m_CListT.SetItemText( i,1, csAux);

		csAux.Format(_T("%02d"),theApp.m_nTitle[j][i]);
		m_CListT.SetItemText( i,2, csAux);

		csAux.Format(_T("%02d"),theApp.m_nFirstVID[j][i]);
		m_CListT.SetItemText( i,3, csAux);

		csAux.Format(_T("%02d"),theApp.m_nCells[j][i]);
		m_CListT.SetItemText( i,4, csAux);

		csAux=FormatDuration(theApp.m_dwDuration[j][i]);
		m_CListT.SetItemText(i,5, csAux);

		csAux=Size_MBytes(theApp.m_i64Tisize[j][i]);
		m_CListT.SetItemText(i,6, csAux);

		if (theApp.m_iAction[j][i]==KEEP) csAux="Keep";
		if (theApp.m_iAction[j][i]==BLANK) csAux="Blank";
		if (theApp.m_iAction[j][i]==REPLACE) csAux="Replace";
		if (theApp.m_iAction[j][i]==SKIP) csAux="Skip";
		if (theApp.m_iAction[j][i]==STRIP) csAux="Strip";
		if (theApp.m_iAction[j][i]==CUT) csAux="Cut";
		if (theApp.m_iAction[j][i]==CELLBASED) csAux="Cells";
		m_CListT.SetItemText(i,m_indexAction, csAux);

		if (theApp.m_bCellReUsed[j][i])
			m_CListT.SetItemText(i,8, "Yes");
		else
			m_CListT.SetItemText(i,8, "No");

		if (theApp.m_bILVU[j][i])
			m_CListT.SetItemText(i,9, "Yes");
		else
			m_CListT.SetItemText(i,9, "No");

		csAux.Format(_T("%d"),theApp.m_nAngles[j][i]);
		m_CListT.SetItemText( i,10, csAux);

		csAux.Format(_T("Pr=%02d Po=%02d Ce=%02d"),
			theApp.m_i8PreComm[j][i],theApp.m_i8PostComm[j][i],theApp.m_i8CellComm[j][i]);
		m_CListT.SetItemText( i,11, csAux);
		
		if (theApp.m_iAction[j][i]==REPLACE)
			m_CListT.SetItemText(i,m_indexReplacing, theApp.m_csReplace[j][i]);
		else
			m_CListT.SetItemText(i,m_indexReplacing, "");
	}
	UpdateSize();
	UpdateData(FALSE);
}

void CVobBlankerDlg::CheckEnableButtons()
{
	CWnd* pWnd;
	POSITION posT,posVTS;
	int nItemT, nItemVTS;
	int nSelected;

	UpdateData(TRUE);

	if (theApp.m_bInProcess==true)
	{
		pWnd = GetDlgItem(IDC_BUTTONSUBS);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONKEEP);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONPREV);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONBLANK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONSTRIP);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONCELLS);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONMENU);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONSKIP);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONPROC);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONSKIPALL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONPROCALL);
		pWnd->EnableWindow(FALSE);

		pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDCANCEL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONABORT);
		pWnd->EnableWindow(TRUE);
	return;
	}
	else
	{
		pWnd = GetDlgItem(IDOK);
		if (bAlreadyRun)
			pWnd->EnableWindow(FALSE);
		else
			pWnd->EnableWindow(TRUE);

		pWnd = GetDlgItem(IDCANCEL);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_BUTTONABORT);
		pWnd->EnableWindow(FALSE);
	}

//VTS List
	nSelected=m_CListVTS.GetSelectedCount();
	posVTS=m_CListVTS.GetFirstSelectedItemPosition();
	if (posVTS != NULL)
	{//Enable
		pWnd = GetDlgItem(IDC_BUTTONMENU);
		if (nSelected==1)
			pWnd->EnableWindow(TRUE);
		else
			pWnd->EnableWindow(FALSE);

		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);
		if (theApp.m_iActionVTS[nItemVTS]==PROCESS)
		{
			pWnd = GetDlgItem(IDC_BUTTONSKIP);
			pWnd->EnableWindow(TRUE);
			pWnd = GetDlgItem(IDC_BUTTONPROC);
			pWnd->EnableWindow(FALSE);
		}
		else
		{
			pWnd = GetDlgItem(IDC_BUTTONSKIP);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONPROC);
			pWnd->EnableWindow(TRUE);
		}
	}
	else
	{
		pWnd = GetDlgItem(IDC_BUTTONSKIP);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONPROC);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONMENU);
		pWnd->EnableWindow(FALSE);
	}


	if (theApp.m_pIFO[0]==NULL)
	{//Disable
		pWnd = GetDlgItem(IDC_BUTTONSKIPALL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONPROCALL);
		pWnd->EnableWindow(FALSE);
	}
	else
	{//Enable
		pWnd = GetDlgItem(IDC_BUTTONSKIPALL);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_BUTTONPROCALL);
		pWnd->EnableWindow(TRUE);
	}

// Title List	
	posT=m_CListT.GetFirstSelectedItemPosition();
	posVTS=m_CListVTS.GetFirstSelectedItemPosition();
	nSelected=m_CListT.GetSelectedCount();

	if (posT != NULL && posVTS !=NULL)
	{//Enable
		pWnd = GetDlgItem(IDC_BUTTONPREV);
		if (nSelected==1)
			pWnd->EnableWindow(TRUE);
		else
			pWnd->EnableWindow(FALSE);

		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);
		nItemT=m_CListT.GetNextSelectedItem(posT);
		if (theApp.m_iAction[nItemVTS][nItemT]==SKIP)
		{
			pWnd = GetDlgItem(IDC_BUTTONSUBS);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONKEEP);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONBLANK);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONSTRIP);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONCELLS);
			pWnd->EnableWindow(TRUE);
		}
		else
		{
			if (nSelected==1)
			{
				pWnd = GetDlgItem(IDC_BUTTONSUBS);
				pWnd->EnableWindow(TRUE);
				pWnd = GetDlgItem(IDC_BUTTONKEEP);
				pWnd->EnableWindow(TRUE);
				pWnd = GetDlgItem(IDC_BUTTONBLANK);
				pWnd->EnableWindow(TRUE);
				pWnd = GetDlgItem(IDC_BUTTONSTRIP);
				pWnd->EnableWindow(TRUE);
				pWnd = GetDlgItem(IDC_BUTTONCELLS);
				pWnd->EnableWindow(TRUE);
			}
			else
			{
				pWnd = GetDlgItem(IDC_BUTTONSUBS);
				pWnd->EnableWindow(FALSE);
				pWnd = GetDlgItem(IDC_BUTTONKEEP);
				pWnd->EnableWindow(TRUE);
				pWnd = GetDlgItem(IDC_BUTTONBLANK);
				pWnd->EnableWindow(TRUE);
				pWnd = GetDlgItem(IDC_BUTTONSTRIP);
				pWnd->EnableWindow(FALSE);
				pWnd = GetDlgItem(IDC_BUTTONCELLS);
				pWnd->EnableWindow(FALSE);

			}

		}
	}
	else
	{// Disable
		pWnd = GetDlgItem(IDC_BUTTONSUBS);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONKEEP);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONPREV);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONSTRIP);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONCELLS);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONBLANK);
		pWnd->EnableWindow(FALSE);

	}
	UpdateSize();
	UpdateData(FALSE);
}

void CVobBlankerDlg::OnItemchangedListt(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	CheckEnableButtons();
	*pResult = 0;
}

void CVobBlankerDlg::UpdateProgress(int nPerc)
{
	if (nPerc <0 ) nPerc=0;
	if (nPerc >100 ) nPerc=100;
	m_CProgress.SetPos(nPerc);
	m_csPcProgress.Format(_T("%d %%"),nPerc);
// Global progress
	nPerc=(int) (theApp.m_i64GranTotalCurr*100/theApp.m_i64GranTotalMax);
	if (nPerc <0 ) nPerc=0;
	if (nPerc >100 ) nPerc=100;
	m_CProgressTot.SetPos(nPerc);
	m_csPcProgressTot.Format(_T("%d %%"),nPerc);
	UpdateData(FALSE);
}

void CVobBlankerDlg::UpdateSize()
{
	int nVTS,nT;
	__int64 i64isize, i64fsize, i64fssize;
	CString csAux;

	i64isize=i64fsize=i64fssize=0;

	for (nVTS=0 ; nVTS< theApp.m_nIFOs+1 ; nVTS++)
	{
		// Calculate VTS final Size
		if (theApp.m_iActionVTS[nVTS]==PROCESS)
		{
			theApp.m_i64VTSfsize[nVTS]=0;
			if (m_bCheckMenu || m_bCheckFolder)
				theApp.m_i64VTSfsize[nVTS]=theApp.m_i64Mfsize[nVTS];
			for (nT=0 ; nT< theApp.m_nPGCs[nVTS] ; nT++)
			{
				if (theApp.m_iAction[nVTS][nT]==KEEP)
					theApp.m_i64VTSfsize[nVTS]+=theApp.m_i64Tisize[nVTS][nT];
				if (theApp.m_iAction[nVTS][nT]==CUT)
					theApp.m_i64VTSfsize[nVTS]+=theApp.m_i64Rsize[nVTS][nT];
				if (theApp.m_iAction[nVTS][nT]==REPLACE)
					theApp.m_i64VTSfsize[nVTS]+=theApp.m_i64Rsize[nVTS][nT];
				if (theApp.m_iAction[nVTS][nT]==STRIP)
					theApp.m_i64VTSfsize[nVTS]+=theApp.m_i64Rsize[nVTS][nT];
				if (theApp.m_iAction[nVTS][nT]==CELLBASED)
					theApp.m_i64VTSfsize[nVTS]+=theApp.m_i64Rsize[nVTS][nT];
				if (theApp.m_iAction[nVTS][nT]==BLANK)
					theApp.m_i64VTSfsize[nVTS]+=5*2048*theApp.m_nCells[nVTS][nT];
			}
			i64fsize+=theApp.m_i64VTSfsize[nVTS];
			i64fssize+=theApp.m_i64VTSfsize[nVTS];
		}
		else if (theApp.m_iActionVTS[nVTS]==SKIP && m_bCheckFolder)

			i64fsize+=theApp.m_i64VTSisize[nVTS];

		i64isize+=theApp.m_i64VTSisize[nVTS];
		csAux=Size_MBytes(theApp.m_i64VTSfsize[nVTS]);
		m_CListVTS.SetItemText(nVTS,4, csAux);
	}

	m_csEditIni.Format(_T("%I64d"), i64isize/1024/1024);
	m_csEditEnd.Format(_T("%I64d"), i64fsize/1024/1024);

	theApp.m_i64GranTotalMax=i64fssize/2048;

}


void CVobBlankerDlg::OnCheckmenu() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	UpdateSize();
	UpdateData(FALSE);
}

void CVobBlankerDlg::GetInitialCoord() 
{
	CWnd* pWnd;
	CRect myRect;
	int OFFX;
	int OFFY;

	GetClientRect(&m_RectApp);
	GetWindowRect(&myRect);
	OFFX=(myRect.Width()-m_RectApp.Width())/2;    // OFFX=Border
	OFFY=myRect.Height()-m_RectApp.Height()-OFFX; // OFFY=Top border+Caption+Menu. 

	pWnd=GetDlgItem(IDC_STATIC_VTS);
	pWnd->GetWindowRect(&m_RectVTS);
	m_RectVTS.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_STATIC_PGC);
	pWnd->GetWindowRect(&m_RectPGC);
	m_RectPGC.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_LISTVTS);
	pWnd->GetWindowRect(&m_RectLISTVTS);
	m_RectLISTVTS.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_LISTT);
	pWnd->GetWindowRect(&m_RectLISTT);
	m_RectLISTT.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONMENU);
	pWnd->GetWindowRect(&m_RectBMENU);
	m_RectBMENU.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONSKIP);
	pWnd->GetWindowRect(&m_RectBSKIP);
	m_RectBSKIP.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONPROC);
	pWnd->GetWindowRect(&m_RectBPROC);
	m_RectBPROC.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONSKIPALL);
	pWnd->GetWindowRect(&m_RectBSKIPALL);
	m_RectBSKIPALL.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONPROCALL);
	pWnd->GetWindowRect(&m_RectBPROCALL);
	m_RectBPROCALL.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONPREV);
	pWnd->GetWindowRect(&m_RectBPREV);
	m_RectBPREV.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONSUBS);
	pWnd->GetWindowRect(&m_RectBSUBS);
	m_RectBSUBS.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONKEEP);
	pWnd->GetWindowRect(&m_RectBKEEP);
	m_RectBKEEP.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONBLANK);
	pWnd->GetWindowRect(&m_RectBBLANK);
	m_RectBBLANK.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONSTRIP);
	pWnd->GetWindowRect(&m_RectBSTRIP);
	m_RectBSTRIP.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONCELLS);
	pWnd->GetWindowRect(&m_RectBCELLS);
	m_RectBCELLS.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_PCPROGRESSTOT);
	pWnd->GetWindowRect(&m_RectEPRGT);
	m_RectEPRGT.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_PROGRESSTOT);
	pWnd->GetWindowRect(&m_RectPRGT);
	m_RectPRGT.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONABORT);
	pWnd->GetWindowRect(&m_RectBABOR);
	m_RectBABOR.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDOK);
	pWnd->GetWindowRect(&m_RectOK);
	m_RectOK.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

	pWnd=GetDlgItem(IDCANCEL);
	pWnd->GetWindowRect(&m_RectCANCEL);
	m_RectCANCEL.OffsetRect(myRect.left-OFFX,myRect.top-OFFY);

}

void CVobBlankerDlg::ReSizeVTS(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=cx-m_RectApp.right;
		ancho+=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(cy-m_RectApp.bottom)/2;
		alto+=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left,myRect.top,ancho,alto);
	}
}

void CVobBlankerDlg::ReSizeBVTS(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left+cx-m_RectApp.right,myRect.top,ancho,alto);
	}
}

void CVobBlankerDlg::ReSizePGC(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=cx-m_RectApp.right;
		ancho+=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(cy-m_RectApp.bottom)/2;
		alto+=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left,myRect.top+(cy-m_RectApp.bottom)/2,ancho,alto);
	}
}

void CVobBlankerDlg::ReSizeBPGC(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;

	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left+cx-m_RectApp.right,myRect.top+(cy-m_RectApp.bottom)/2,ancho,alto);
	}
}


void CVobBlankerDlg::ReSizeBottom(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left+(cx-m_RectApp.right)/2,myRect.top+(cy-m_RectApp.bottom),ancho,alto);
	}
}


void CVobBlankerDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	// TODO: Add your message handler code here

	CRect myRect;


	if (nType==SIZE_RESTORED  )
	{
		if (cx < m_RectApp.right)
		{
			cx=m_RectApp.right-m_RectApp.left;
		}
		if (cy < m_RectApp.bottom)
		{
			cy=m_RectApp.bottom-m_RectApp.top;
		}

	}

	ReSizeVTS(IDC_STATIC_VTS,m_RectVTS,cx,cy);
	ReSizeVTS(IDC_LISTVTS,m_RectLISTVTS,cx,cy);
	ReSizeBVTS(IDC_BUTTONMENU,m_RectBMENU,cx,cy);
	ReSizeBVTS(IDC_BUTTONSKIP,m_RectBSKIP,cx,cy);
	ReSizeBVTS(IDC_BUTTONPROC,m_RectBPROC,cx,cy);
	ReSizeBVTS(IDC_BUTTONSKIPALL,m_RectBSKIPALL,cx,cy);
	ReSizeBVTS(IDC_BUTTONPROCALL,m_RectBPROCALL,cx,cy);

	ReSizePGC(IDC_STATIC_PGC,m_RectPGC,cx,cy);
	ReSizePGC(IDC_LISTT,m_RectLISTT,cx,cy);
	ReSizeBPGC(IDC_BUTTONPREV,m_RectBPREV,cx,cy);
	ReSizeBPGC(IDC_BUTTONSUBS,m_RectBSUBS,cx,cy);
	ReSizeBPGC(IDC_BUTTONKEEP,m_RectBKEEP,cx,cy);
	ReSizeBPGC(IDC_BUTTONBLANK,m_RectBBLANK,cx,cy);
	ReSizeBPGC(IDC_BUTTONSTRIP,m_RectBSTRIP,cx,cy);
	ReSizeBPGC(IDC_BUTTONCELLS,m_RectBCELLS,cx,cy);

	ReSizeBottom(IDC_BUTTONABORT,m_RectBABOR,cx,cy);
	ReSizeBottom(IDOK,m_RectOK,cx,cy);
	ReSizeBottom(IDCANCEL,m_RectCANCEL,cx,cy);

	int alto,ancho;
	CWnd* pWnd;

	pWnd=GetDlgItem(IDC_PCPROGRESSTOT);
	if (pWnd) 
	{
		ancho=(m_RectEPRGT.right-m_RectEPRGT.left);
		if (ancho <0 ) ancho=0;
		alto=(m_RectEPRGT.bottom-m_RectEPRGT.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(m_RectEPRGT.left,m_RectEPRGT.top+(cy-m_RectApp.bottom),ancho,alto);
	}

	pWnd=GetDlgItem(IDC_PROGRESSTOT);
	if (pWnd) 
	{
		ancho=cx-m_RectApp.right;
		ancho+=(m_RectPRGT.right-m_RectPRGT.left);
		if (ancho <0 ) ancho=0;
		alto=(m_RectPRGT.bottom-m_RectPRGT.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(m_RectPRGT.left,m_RectPRGT.top+(cy-m_RectApp.bottom),ancho,alto);
	}

	RedrawWindow(NULL,NULL,RDW_INVALIDATE);   
}


void CVobBlankerDlg::OnRclickListt(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	CPoint point;
	CMenu menu;

	GetCursorPos(&point);

    VERIFY(menu.LoadMenu(IDR_MENULISTT));
    CMenu* pPopup = menu.GetSubMenu(0);
    ASSERT(pPopup != NULL);

	CheckEnablePopupMenuT(pPopup);
    pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x,point.y , AfxGetMainWnd());
	
	*pResult = 0;
}

void CVobBlankerDlg::OnRclickListvts(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	CPoint point;
	CMenu menu;

	GetCursorPos(&point);

    VERIFY(menu.LoadMenu(IDR_MENULISTVTS));
    CMenu* pPopup = menu.GetSubMenu(0);
    ASSERT(pPopup != NULL);

	CheckEnablePopupMenuVTS(pPopup);
    pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x,point.y , AfxGetMainWnd());

	*pResult = 0;	
}


void CVobBlankerDlg::OnDblclkListt(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	CWnd * pWnd;
	
	pWnd = GetDlgItem(IDC_BUTTONCELLS);
	if (pWnd->IsWindowEnabled())
		OnButtoncells();
	*pResult = 0;
}

// VTS POPUP MENUs

void CVobBlankerDlg::On__menus() 
{
	OnButtonmenu();
}
void CVobBlankerDlg::On__process() 
{
	OnButtonproc();
}
void CVobBlankerDlg::On__skip() 
{
	OnButtonskip();
}
void CVobBlankerDlg::On__skipall() 
{
	OnButtonskipall();
}
void CVobBlankerDlg::On__procall() 
{
	OnButtonprocall();
}

void CVobBlankerDlg::On__blankVTS() 
{
	OnButtonblankVTS();
}


void CVobBlankerDlg::On__videoattr() 
{

	int nItemVTS;
	POSITION posVTS;
	CString csAux;

	CVideoAttrDlg dlgVideoAttr;

	posVTS=m_CListVTS.GetFirstSelectedItemPosition();

	if (posVTS !=NULL)
	{
		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);

		if ( nItemVTS==0) return;
	
		dlgVideoAttr.m_nVTS=nItemVTS;

		dlgVideoAttr.DoModal();	

		csAux=DisplayVideoAttr(nItemVTS);
		m_CListVTS.SetItemText(nItemVTS,5, csAux);
	}
}
void CVobBlankerDlg::On__audioattr() 
{
	// TODO: Add your control notification handler code here
	int nItemVTS;
	POSITION  posVTS;
	CStripDlg dlg;


	posVTS=m_CListVTS.GetFirstSelectedItemPosition();

	if (posVTS !=NULL)
	{
		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);

		dlg.m_nVTS=nItemVTS;
		dlg.m_nT=0;
		dlg.m_mode=ATTRIB;

		dlg.DoModal();
	}
}

// PGC POPUP MENUs
void CVobBlankerDlg::On__blank() 
{
	OnButtonblank();
}

void CVobBlankerDlg::On__replace() 
{
	OnButtonsubs();
}
void CVobBlankerDlg::On__keep() 
{
	OnButtonkeep();
}
void CVobBlankerDlg::On__strip() 
{
	OnButtonstrip();
}
void CVobBlankerDlg::On__preview() 
{
	OnButtonprev();
}
void CVobBlankerDlg::On__cells() 
{
	OnButtoncells();
}

void CVobBlankerDlg::On__audinfo() 
{
	int nItemVTS,nItemT;
	POSITION  posVTS,posT;
	CStripDlg dlg;


	posVTS=m_CListVTS.GetFirstSelectedItemPosition();
	posT=m_CListT.GetFirstSelectedItemPosition();

	if (posVTS !=NULL && posT !=NULL)
	{
		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);
		nItemT=m_CListT.GetNextSelectedItem(posT);

		dlg.m_nVTS=nItemVTS;
		dlg.m_nT=nItemT;
		dlg.m_mode=AUDINFO;

		dlg.DoModal();
	}
}

void CVobBlankerDlg::CheckEnablePopupMenuT(CMenu* pPopup)
{
	POSITION posT,posVTS;
	int nItemT, nItemVTS;
	int nSelected;

	if (theApp.m_bInProcess==true)
	{

		pPopup->EnableMenuItem(ID__PREVIEW, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__BLANK, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__REPLACE, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__KEEP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__STRIP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__AUDINFO, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );

	return;
	}

// Title List	
	posT=m_CListT.GetFirstSelectedItemPosition();
	posVTS=m_CListVTS.GetFirstSelectedItemPosition();
	nSelected=m_CListT.GetSelectedCount();

	if (posT != NULL && posVTS !=NULL)
	{//Enable
		if (nSelected==1)
		{
			pPopup->EnableMenuItem(ID__PREVIEW, MF_BYCOMMAND | MF_ENABLED );
			pPopup->EnableMenuItem(ID__AUDINFO, MF_BYCOMMAND | MF_ENABLED );
		}
		else
		{
			pPopup->EnableMenuItem(ID__PREVIEW, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__AUDINFO, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		}
		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);
		nItemT=m_CListT.GetNextSelectedItem(posT);
		if (theApp.m_iAction[nItemVTS][nItemT]==SKIP)
		{
			pPopup->EnableMenuItem(ID__BLANK, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__REPLACE, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__KEEP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__STRIP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__CELLS, MF_BYCOMMAND | MF_ENABLED );

		}
		else
		{
			if (nSelected==1)
			{
				pPopup->EnableMenuItem(ID__BLANK, MF_BYCOMMAND | MF_ENABLED );
				pPopup->EnableMenuItem(ID__KEEP, MF_BYCOMMAND | MF_ENABLED );
				pPopup->EnableMenuItem(ID__STRIP, MF_BYCOMMAND | MF_ENABLED );
				pPopup->EnableMenuItem(ID__CELLS, MF_BYCOMMAND | MF_ENABLED );
				pPopup->EnableMenuItem(ID__REPLACE, MF_BYCOMMAND | MF_ENABLED );
			}
			else
			{
				pPopup->EnableMenuItem(ID__BLANK, MF_BYCOMMAND | MF_ENABLED );
				pPopup->EnableMenuItem(ID__KEEP, MF_BYCOMMAND | MF_ENABLED );
				pPopup->EnableMenuItem(ID__STRIP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
				pPopup->EnableMenuItem(ID__CELLS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
				pPopup->EnableMenuItem(ID__REPLACE, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );

			}
		}
	}
	else
	{// Disable
		pPopup->EnableMenuItem(ID__PREVIEW, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__AUDINFO, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__BLANK, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__REPLACE, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__KEEP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__STRIP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
	}
}

void CVobBlankerDlg::CheckEnablePopupMenuVTS(CMenu* pPopup)
{
	POSITION posVTS;
	int nItemVTS;
	int nSelected;


	if (theApp.m_bInProcess==true)
	{
		pPopup->EnableMenuItem(ID__SKIP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__PROC, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__PROCALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__SKIPALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__BLANKVTS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MENUS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
	return;
	}

	nSelected=m_CListVTS.GetSelectedCount();

//VTS List
	posVTS=m_CListVTS.GetFirstSelectedItemPosition();
	if (posVTS != NULL)
	{//Enable
		if (nSelected==1)
			pPopup->EnableMenuItem(ID__MENUS, MF_BYCOMMAND | MF_ENABLED );
		else
			pPopup->EnableMenuItem(ID__MENUS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );


		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);
		if (nItemVTS !=0 || nSelected >1)
		{
			pPopup->EnableMenuItem(ID__BLANKVTS, MF_BYCOMMAND | MF_ENABLED );
			pPopup->EnableMenuItem(ID__VIDEOATTR, MF_BYCOMMAND | MF_ENABLED );
			pPopup->EnableMenuItem(ID__AUDIOATTR, MF_BYCOMMAND | MF_ENABLED );
		}
		else
		{
			pPopup->EnableMenuItem(ID__BLANKVTS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__VIDEOATTR, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__AUDIOATTR, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		}
		if (theApp.m_iActionVTS[nItemVTS]==PROCESS)
		{
			pPopup->EnableMenuItem(ID__SKIP, MF_BYCOMMAND | MF_ENABLED );
			pPopup->EnableMenuItem(ID__PROC, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		}
		else
		{
			pPopup->EnableMenuItem(ID__PROC, MF_BYCOMMAND | MF_ENABLED );
			pPopup->EnableMenuItem(ID__SKIP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		}
	}
	else
	{
		pPopup->EnableMenuItem(ID__VIDEOATTR, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__AUDIOATTR, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__PROC, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__SKIP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__BLANKVTS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MENUS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
	}


	if (theApp.m_pIFO[0]==NULL)
	{//Disable
		pPopup->EnableMenuItem(ID__PROCALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__SKIPALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
	}
	else
	{//Enable
		pPopup->EnableMenuItem(ID__PROCALL, MF_BYCOMMAND | MF_ENABLED );
		pPopup->EnableMenuItem(ID__SKIPALL, MF_BYCOMMAND | MF_ENABLED );
	}
}


void CVobBlankerDlg::OnDblclkListvts(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	CWnd * pWnd;
	
	pWnd = GetDlgItem(IDC_BUTTONMENU);
	if (pWnd->IsWindowEnabled())
		OnButtonmenu();
	*pResult = 0;
}

CString CVobBlankerDlg::DisplayVideoAttr(int nVTS ) 
{

	int iVideoAttr,iFormat;
	CString csAux;

	iVideoAttr=theApp.m_iVideoAttr[nVTS];
	iFormat=(iVideoAttr & 0x1000) >> 12;

	if (iFormat == 0 ) csAux="NTSC";
	else csAux="PAL ";
	{
	if ((iVideoAttr & 0x0C00) == 0x0C00 ) csAux+=" 16:9";
	else if ((iVideoAttr & 0x0C00) == 0 ) csAux+="   4:3";
	else csAux+=" unkn";
	}
	if ((iVideoAttr & 0x1000) == 0 )
	{
		if ((iVideoAttr & 0x0C) == 0 ) csAux+=" 720x480";
		if ((iVideoAttr & 0x0C) == 0x04 ) csAux+=" 704x480";
		if ((iVideoAttr & 0x0C) == 0x08 ) csAux+=" 352x480";
		if ((iVideoAttr & 0x0C) == 0x0C ) csAux+=" 352x240";
	}
	else 
	{
		if ((iVideoAttr & 0x0C) == 0 ) csAux+=" 720x576";
		if ((iVideoAttr & 0x0C) == 0x04 ) csAux+=" 704x576";
		if ((iVideoAttr & 0x0C) == 0x08 ) csAux+=" 352x576";
		if ((iVideoAttr & 0x0C) == 0x0C ) csAux+=" 352x288";
	}

	return csAux;
}


void CVobBlankerDlg::OnCheckpostpreforced() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (!m_bCheckPostPre && m_bCheckPostPreForced) m_bCheckPostPre=TRUE;
	UpdateData(FALSE);
	
}

void CVobBlankerDlg::OnCheckpostpre() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (!m_bCheckPostPre && m_bCheckPostPreForced) m_bCheckPostPreForced=FALSE;
	UpdateData(FALSE);
	
}

void CVobBlankerDlg::OnKillfocusEditinput() 
{
	// TODO: Add your control notification handler code here

	CString csAux1,csAux2;


	UpdateData(TRUE);
	csAux1=m_csInput;
	csAux2=theApp.m_csInputPath+"\\VIDEO_TS.IFO";

	csAux1.MakeUpper();
	csAux2.MakeUpper();

	if (csAux1!=csAux2 && !m_csInput.IsEmpty()  )
	{
		OnNewInputfile();
		if (m_bCheckFolder)
			m_csOutput=theApp.m_csInputPath;
		UpdateData (FALSE);
	}
}

void CVobBlankerDlg::OnDropFiles( HDROP hDropInfo)
{
	UINT nFiles;
	CWinApp* pApp;
	TCHAR szFileName[_MAX_PATH];
	CString csAux;
	struct  _stati64 statbuf;
	bool bIsFolder;


	bIsFolder=false;

	SetActiveWindow();      // activate us first !
	POINT ThePoint;

	DragQueryPoint(hDropInfo,&ThePoint);

	nFiles = ::DragQueryFile(hDropInfo, (UINT)-1, NULL, 0);
	pApp = AfxGetApp();
	ASSERT(pApp != NULL);
	if(nFiles> 1)
	{
		MessageBox( "Only one file at a time!.", "Error",  MB_OK | MB_ICONEXCLAMATION );
	}
	else if(nFiles== 1)
	{
		::DragQueryFile(hDropInfo, 0, szFileName, _MAX_PATH);

		csAux =  szFileName; 
		if (_stati64 ( csAux, &statbuf)==0)
			if( statbuf.st_mode & _S_IFDIR ) bIsFolder=true;
			
		csAux.MakeUpper();
		csAux=csAux.Right(4);

		if (bIsFolder || csAux==".IFO" || csAux==".BUP" || csAux==".VOB" )
		{
			csAux =  szFileName; 
			csAux.MakeUpper();
			if (!bIsFolder)
				csAux=csAux.Left(csAux.ReverseFind('\\') );
			csAux+="\\VIDEO_TS.IFO";
			if (_access(csAux,4)==0)
			{
				m_csInput =  csAux; 
				UpdateData (FALSE);
				OnNewInputfile();

				if (m_bCheckFolder)
				{
					m_csOutput=theApp.m_csInputPath;
					UpdateData (FALSE);
				}

			}
			else
				MessageBox( "Unable to open "+csAux, "Error",  MB_OK | MB_ICONEXCLAMATION );
		}
		else
		{
			m_csCLIFile=szFileName;
			m_bCLIMode=m_bFirstLoad=true;
			PostMessage(WM_COMMAND, ID_FILE_OPEN, NULL);
		}
	}

	::DragFinish(hDropInfo);
}



void CVobBlankerDlg::OnCheckfolder() 
{
	// TODO: Add your control notification handler code here
	CWnd* pWnd;

	
	UpdateData(TRUE);
	if (m_bCheckFolder)
	{
		m_csOutput=theApp.m_csInputPath;
		pWnd = GetDlgItem(IDC_EDITOUTPUT);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONOUTPUT);
		pWnd->EnableWindow(FALSE);
	}
	else
	{
		pWnd = GetDlgItem(IDC_EDITOUTPUT);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_BUTTONOUTPUT);
		pWnd->EnableWindow(TRUE);
	}
	UpdateSize();
	UpdateData(FALSE);

}

int CVobBlankerDlg::MoveBckFile(CString csFile, bool bCheck)
{
	int iRet;
	bool bOriginExist, bDestinationExist;

	
	bOriginExist=true;
	if (_access(theApp.m_csOutputPath + "\\" + csFile, 0) == -1) bOriginExist=false;
	bDestinationExist=true;
	if (_access(m_csOutput + "\\" + csFile, 0 ) == -1) bDestinationExist=false;

	if (bCheck && !bOriginExist) return 0;
	if (bCheck && !bDestinationExist) return 0;

	if (bOriginExist)
	{
		iRet=MoveFile(theApp.m_csOutputPath + "\\" + csFile, m_csOutput + "\\" + csFile + ".new");
		if (iRet==0) return 0;
	}

	if (bDestinationExist)
	{
		iRet=MoveFile(m_csOutput + "\\" + csFile, theApp.m_csOutputPath + "\\" + csFile);
		if (iRet==0) return 0;
	}

	if (bOriginExist)
	{
		iRet=MoveFile(m_csOutput + "\\" + csFile + ".new", m_csOutput + "\\" + csFile );
		if (iRet==0) return 0;
	}

	return 1;
}


