#include "stdafx.h"

typedef unsigned char uchar;
#include "FixedVobs.h"
#include "Languages.h"

#define PAL 1
#define NTSC 0

bool MyDeleteFile(const char *szFilename)
// Taken from Autoit //
{
	WIN32_FIND_DATA	findData;
	HANDLE			hSearch;
	bool			bFound = false;				// Not found initially
	bool			bLoop;
	char			szDrive[_MAX_PATH+1];
	char			szDir[_MAX_PATH+1];
	char			szFile[_MAX_PATH+1];
	char			szExt[_MAX_PATH+1];
	char			szTempPath[_MAX_PATH+1];

	strcpy(szTempPath,szFilename);
	// Split the target into bits (used for reconstruction later)
	_splitpath( szTempPath, szDrive, szDir, szFile, szExt );

	// Delete all files matching the criteria
	hSearch = FindFirstFile(szTempPath, &findData);
	bLoop = true;
	while (hSearch != INVALID_HANDLE_VALUE && bLoop == true)
	{
		// Make sure the returned handle is a file and not a directory before we
		// try and do delete type things on it!
		if ( (findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != FILE_ATTRIBUTE_DIRECTORY)
		{
			bFound = true;							// Found at least one match
			
			// Returned data is just the filename, we need to add the path stuff back on
			// The find strcut only returns the file NAME, we need to reconstruct the path!
			strcpy(szTempPath, szDrive);	
			strcat(szTempPath, szDir);
			strcat(szTempPath, findData.cFileName);
			
			if ( DeleteFile(szTempPath) != TRUE )
			{
				FindClose(hSearch);
				return false;						// Error deleting one of the files
			}

		} // End if

		if (FindNextFile(hSearch, &findData) == FALSE)
			bLoop = false;
	}

	FindClose(hSearch);

	return bFound;
}

int get4c(FILE * in)
{
	int iRet;
	int i1,i2,i3,i4;

	i1=fgetc(in);
	i2=fgetc(in);
	i3=fgetc(in);
	i4=fgetc(in);

	if (i4!=EOF) 
		iRet=i1*256*256*256+i2*256*256+i3*256+i4;
	else iRet=0;

	return	iRet;
}

void fput4c( int i4char, FILE *in)
{
	fputc ( (i4char/(256*256*256)), in);
	fputc ( (i4char/(256*256))%256, in);
	fputc ( (i4char/256)%256, in);
	fputc ( (i4char)%256, in);
}


CString lang_long(char * szLang)
{
	int j;
	CString csAux;

	for (j=0,csAux="Unknown";LangTable[j].descr[0]!=0 && csAux=="Unknown";j++)
	{
		if (szLang[0]==LangTable[j].descr[0] &&
			szLang[1]==LangTable[j].descr[1])
			 csAux=  LangTable[j].lang_long;
	}

	return csAux;
}

void MyErrorBox(LPCTSTR text)
{
	AfxMessageBox(text,MB_OK|MB_ICONEXCLAMATION,0);
}

void MyInfoBox(LPCTSTR text)
{
	AfxMessageBox(text,MB_OK|MB_ICONINFORMATION,0);
}

int readpts(uchar *buf)
{
    int a1,a2,a3;
	int pts;

    a1=(buf[0]&0xe)>>1;
    a2=((buf[1]<<8)|buf[2])>>1;
    a3=((buf[3]<<8)|buf[4])>>1;
    pts= (int) ((( (__int64) a1)<<30) | (a2<<15) | a3);
    return pts;
}
/*
void writepts(uchar *buf,ulong pts)
{
    buf[0]=((pts>>29)&0xe)|(buf[0]&0xf1); // this preserves the PTS / DTS / PTSwDTS top bits
    write2(buf+1,(pts>>14)|1);
    write2(buf+3,(pts<<1)|1);
}
*/

CString Size_MBytes(__int64 i64size)
{
	CString csAux;

	if (i64size < 9999)
		csAux.Format(_T("%I64d By"),i64size);
	else if (i64size < 9999*1024)
		csAux.Format(_T("%I64d KB"),i64size/1024);
	else if (i64size < (__int64)9999*1024*1024)
		csAux.Format(_T("%I64d MB"),i64size/1024/1024);
	else
		csAux.Format(_T("%I64d MB"),i64size/1024/1024/1024);
	
	return csAux;


}

CString FormatDuration(DWORD duration)
{
	CString csAux;

	csAux.Format(_T("%02X:%02X:%02X.%02X"),
		duration/(256*256*256),(duration/(256*256))%256,(duration/256)%256,(duration%256) & 0x3f);

	return csAux;
}

int GetNbytes(int nNumber,uchar* address)
{
	int ret,i;

	for (i=ret=0;i<nNumber;i++)
		ret=ret*256+address[i];
	return ret;
}

void Put4bytes(__int64 i64Number,uchar* address)
{

	address[0]= (uchar) (i64Number/(256*256*256));
	address[1]= (uchar) ((i64Number/(256*256))%256);
	address[2]= (uchar) ((i64Number/256)%256);
	address[3]= (uchar) (i64Number%256);

}

void Put2bytes(__int64 i64Number,uchar* address)
{

	address[0]= (uchar) ((i64Number/256)%256);
	address[1]= (uchar) (i64Number%256);

}

int BCD2Dec ( int BCD)
{
	int ret;
	ret = (BCD/0x10)*10 + (BCD%0x10);
	return ret;
}

int Dec2BCD ( int Dec)
{
	int ret;
	ret = (Dec/10)*0x10 + (Dec%10);
	return ret;
}

int DurationInFrames(DWORD dwDuration)
{

	int ifps,ret;
	__int64 i64Dur;

	if ( ((dwDuration%256) & 0x0c0) == 0x0c0 )
		ifps=30;
	else  
		ifps=25;
	
	i64Dur=  (BCD2Dec( (dwDuration%256) & 0x3f));
	i64Dur+= (BCD2Dec( (dwDuration/256)%256 )*ifps);
	i64Dur+= (BCD2Dec( (dwDuration/(256*256))%256 )*ifps*60);
	i64Dur+= (BCD2Dec(  dwDuration/(256*256*256)  )*ifps*60*60);

	ret=(int)(i64Dur);

	return ret;
}

int DurationInSecs(DWORD dwDuration)
{

	int ifps,ret;
	__int64 i64Dur;

	if ( ((dwDuration%256) & 0x0c0) == 0x0c0 )
		ifps=30;
	else  
		ifps=25;
	
	i64Dur=  (BCD2Dec( (dwDuration%256) & 0x3f));
	i64Dur+= (BCD2Dec( (dwDuration/256)%256 )*ifps);
	i64Dur+= (BCD2Dec( (dwDuration/(256*256))%256 )*ifps*60);
	i64Dur+= (BCD2Dec(  dwDuration/(256*256*256)  )*ifps*60*60);

	ret=(int)(i64Dur/ifps);

	return ret;
}

DWORD AddDuration(DWORD dwDuration1, DWORD dwDuration2)
{
	DWORD ret;
	int ifps,hh,mm,ss,ff;
	__int64 i64Dur1, i64Dur2, i64DurT;

	if ( ((dwDuration1%256) & 0x0c0) == 0x0c0 )
		ifps=30;
	else  
		ifps=25;
	
	i64Dur1=  BCD2Dec( (dwDuration1%256) & 0x3f);
	i64Dur1+= BCD2Dec( (dwDuration1/256)%256 )*ifps;
	i64Dur1+= BCD2Dec( (dwDuration1/(256*256))%256 )*ifps*60;
	i64Dur1+= BCD2Dec( dwDuration1/(256*256*256) )*ifps*60*60;

	i64Dur2=  BCD2Dec( (dwDuration2%256) & 0x3f);
	i64Dur2+= BCD2Dec( (dwDuration2/256)%256 )*ifps;
	i64Dur2+= BCD2Dec( (dwDuration2/(256*256))%256 )*ifps*60;
	i64Dur2+= BCD2Dec( dwDuration2/(256*256*256) )*ifps*60*60;

	i64DurT=i64Dur2+i64Dur1;

	ff=Dec2BCD( (int)(i64DurT%ifps)     );
	ss=Dec2BCD( (int)((i64DurT/ifps)%60)   );
	mm=Dec2BCD( (int)((i64DurT/ifps/60)%60) );
	hh=Dec2BCD( (int)(i64DurT/ifps/60/60)  );

	ret=ff + ss*256 + mm*256*256 + hh*256*256*256;

	if (ifps==30)
		ret+= 0x0c0;
	else
		ret+= 0x040;

	return ret;
}

DWORD SubDuration(DWORD dwDuration1, DWORD dwDuration2)
{
	DWORD ret;
	int ifps,hh,mm,ss,ff;
	__int64 i64Dur1, i64Dur2, i64DurT;

	if ( ((dwDuration1%256) & 0x0c0) == 0x0c0 )
		ifps=30;
	else  
		ifps=25;
	
	i64Dur1=  BCD2Dec( (dwDuration1%256) & 0x3f);
	i64Dur1+= BCD2Dec( (dwDuration1/256)%256 )*ifps;
	i64Dur1+= BCD2Dec( (dwDuration1/(256*256))%256 )*ifps*60;
	i64Dur1+= BCD2Dec( dwDuration1/(256*256*256) )*ifps*60*60;

	i64Dur2=  BCD2Dec( (dwDuration2%256) & 0x3f);
	i64Dur2+= BCD2Dec( (dwDuration2/256)%256 )*ifps;
	i64Dur2+= BCD2Dec( (dwDuration2/(256*256))%256 )*ifps*60;
	i64Dur2+= BCD2Dec( dwDuration2/(256*256*256) )*ifps*60*60;

	i64DurT=i64Dur1-i64Dur2;

	ff=Dec2BCD( (int)(i64DurT%ifps)     );
	ss=Dec2BCD( (int)((i64DurT/ifps)%60)   );
	mm=Dec2BCD( (int)((i64DurT/ifps/60)%60) );
	hh=Dec2BCD( (int)(i64DurT/ifps/60/60)  );

	ret=ff + ss*256 + mm*256*256 + hh*256*256*256;

	if (ifps==30)
		ret+= 0x0c0;
	else
		ret+= 0x040;

	return ret;
}

// Sorry, a dirty trick to pass the folder 
CString csGlobalStartFolder;

int CALLBACK BrowseCallbackProc(HWND hwnd,UINT uMsg,LPARAM lp, LPARAM pData)
{
	TCHAR szDir[MAX_PATH];

         switch(uMsg)
		 {
            case BFFM_INITIALIZED: {
               //if (GetCurrentDirectory(sizeof(szDir)/sizeof(TCHAR), szDir))
				if (csGlobalStartFolder.IsEmpty())
                  strcpy(szDir,"C:\\");
				else
                  strcpy(szDir,csGlobalStartFolder);
			   {
                  // WParam is TRUE since you are passing a path.
                  // It would be FALSE if you were passing a pidl.
                  SendMessage(hwnd,BFFM_SETSELECTION,TRUE,(LPARAM)szDir);
               }
               break;
            }
            case BFFM_SELCHANGED:
			{
               // Set the status window to the currently selected path.
               if (SHGetPathFromIDList((LPITEMIDLIST) lp ,szDir))
			   {
                  SendMessage(hwnd,BFFM_SETSTATUSTEXT,0,(LPARAM)szDir);
               }
             break;
            }
            default:
             break;
         }
         return 0;
}


CString SelectFolder (CString csTitulo, CString csStartFolder)
{
	BROWSEINFO bi;
    LPITEMIDLIST pidlBrowse;    
	char	buffer[_MAX_PATH];
	char	path[_MAX_PATH];

	csGlobalStartFolder=csStartFolder;
	bi.hwndOwner = AfxGetMainWnd()->m_hWnd;     
	bi.pidlRoot = NULL; 
	bi.pszDisplayName = buffer;     
	bi.lpszTitle = (const char*)csTitulo; 
	bi.ulFlags = BIF_EDITBOX|  0x40 | BIF_RETURNONLYFSDIRS ;
	//BIF_USENEWUI;     
    bi.lpfn = BrowseCallbackProc;
//	bi.lpfn = NULL;     
	bi.lParam = 0;  
	bi.iImage = 0;
	pidlBrowse = SHBrowseForFolder(&bi);     
	if (pidlBrowse != NULL) 
	{ 
		SHGetPathFromIDList(pidlBrowse,path);
		return CString(path);
	}
	return "";
}


/*

CString SelectFolder (CString csTitulo)
{

//    LPITEMIDLIST pidlRoot = NULL;
//    LPMALLOC pMalloc = NULL;
	BROWSEINFO bi = {0};
    LPITEMIDLIST pidlBrowse=NULL;    
	char	buffer[_MAX_PATH];
	char	path[_MAX_PATH];


    pidlRoot = NULL;
//  SHGetSpecialFolderLocation(NULL,CSIDL_DRIVES, &pidlRoot);
    
	bi.hwndOwner = AfxGetMainWnd()->m_hWnd;     
	bi.pidlRoot = pidlRoot; 
	bi.pszDisplayName = buffer;     
	bi.lpszTitle = (const char*)csTitulo; 
	bi.ulFlags = BIF_EDITBOX |  0x40 | BIF_RETURNONLYFSDIRS ;
//	bi.ulFlags = 0x200;
	bi.lpfn = NULL;     
	bi.lParam = 0;  
	bi.iImage = 0;

	pidlBrowse = SHBrowseForFolder(&bi);     
	if (pidlBrowse != NULL) 
	{ 
		SHGetPathFromIDList(pidlBrowse,path);
		return CString(path);
	}
	return "";
}
*/

int readbuffer(uchar *caracter, FILE *in)
{
	int j;

	if (in == NULL) return -1;
	j =fread (caracter,sizeof (uchar), 2048, in);

	return j;
}


void writebuffer(uchar *caracter, FILE *out)
{

	fwrite (caracter,sizeof(uchar),2048,out);

	return;
}


bool IsNav(uchar* buffer)
{

	int startcode;

	startcode=GetNbytes(4, &buffer[14]);

	if (startcode==443) return true;
	else return false;

}

bool IsVideo (uchar* buffer)
{

	int startcode;

	startcode=GetNbytes(4, &buffer[14]);

	if (startcode==480) return true;
	else return false;

}

bool IsGOP (uchar* buffer)
{

	int startcode, startmpeg;

	startmpeg=0x17+buffer[0x16];
	startcode=GetNbytes(4, &buffer[startmpeg]);

	if (startcode==0x1b3)
	{
		startcode=GetNbytes(4, &buffer[startmpeg+0x58]);
		if (startcode==0x1b8)
			return true;
	}
	
	return false;
}

bool IsClosedGOP (uchar* buffer)
{

	int startcode, startmpeg;

	startmpeg=0x17+buffer[0x16];
	startcode=GetNbytes(4, &buffer[startmpeg]);

	if (startcode==0x1b3)
	{
		startcode=GetNbytes(4, &buffer[startmpeg+0x58]);
		if (startcode==0x1b8)
		{
			if (buffer[startmpeg+0x5f] & 0x40) 
				return true;
		}
	}
	return false;
}

bool IsAudio (uchar* buffer)
{
	int startcode,st_i;

	startcode=GetNbytes(4, &buffer[14]);
	st_i=0x17+buffer[0x16];
/*
0x80-0x87: ac3
0x88-0x8f: dts
0x90-0x9f: unknown
0xa0-0xa7: lpcm
*/
	if ((startcode==445 && buffer[st_i] >0x7f && buffer[st_i] < 0x90) || 
	    (startcode==445 && buffer[st_i] >0x9f && buffer[st_i] < 0xa8) || 
		(startcode>=0x1c0 && startcode<=0x1cf) ) 
			return true;
	else return false;

}

bool IsAudMpeg (uchar* buffer)
{

	int startcode;

	startcode=GetNbytes(4, &buffer[14]);

	if (startcode>=0x1c0 && startcode<=0x1cf)  
		return true;
	else return false;

}

bool IsSubs (uchar* buffer)
{

	int startcode,st_i;

	startcode=GetNbytes(4, &buffer[14]);
	st_i=0x17+buffer[0x16];


	if (startcode==445 && buffer[st_i] >0x1f && buffer[st_i] < 0x40)
			return true;
	else return false;

}


bool IsSynch (uchar *buffer)
{

	int startcode;

	startcode=GetNbytes(4, &buffer[0]);

	if (startcode==0x1BA) return true;
	else return false;

}

int getAudId  (uchar *buffer)
{
	int AudId;

	if (!IsAudio(buffer)) return -1;

	if (IsAudMpeg(buffer))
		AudId=buffer[0x11];
	else
		AudId=buffer[0x17+buffer[0x16]];

	return AudId;
}

__int64 MPEGVideoAttr (uchar *buffer)
{
	__int64 ret;


	if (GetNbytes(4,&buffer[0x17+buffer[0x16]]) != 0x000001b3 )
		return 0;

	ret=GetNbytes(4,&buffer[0x17+buffer[0x16]+4]);

	return ret;

}

int MPEGvert(__int64 i64Attr)
{
   return (int) (i64Attr & 0x000FFF00) >>8;
}

int MPEGhoriz(__int64 i64Attr)
{
   return (int) (i64Attr & 0xFFF00000) >> 20;
}

int MPEGDAR(__int64 i64Attr)
{
   return (int) (i64Attr & 0x0F0) >> 4;

   // 0= forbidden
   // 1= 1:1
   // 2= 4:3
   // 3= 16:9
   // 4= 2,21:1
}

void ModifyLBA (uchar* buffer, __int64 m_i64OutputLBA)
{
// 1st lba number
	buffer[0x30]= (uchar)(m_i64OutputLBA%256);
	buffer[0x2F]= (uchar)((m_i64OutputLBA/256)%256);
	buffer[0x2E]= (uchar)((m_i64OutputLBA/256/256)%256);
	buffer[0x2D]= (uchar)(m_i64OutputLBA/256/256/256);

// 2nd lba number
	buffer[0x040E]=buffer[0x30];
	buffer[0x040D]=buffer[0x2F];
	buffer[0x040C]=buffer[0x2E];
	buffer[0x040B]=buffer[0x2D];
}

void ModifyCID (uchar* buffer, int VobId, int CellId)
{
// VobID
	buffer[0x420]=(uchar)(VobId%256);
	buffer[0x41F]=(uchar)(VobId/256);
//CellID
	buffer[0x422]= (uchar) CellId;
}

void CleanILV (uchar* buffer)
{
// Flags
	buffer[0x427]=buffer[0x428]=(uchar)0;
//End Address
	buffer[0x429]=buffer[0x42a]=buffer[0x42b]=buffer[0x42c]=(uchar)0;
//Next start
	buffer[0x42d]=buffer[0x42e]=buffer[0x42f]=buffer[0x430]=(uchar)0;
// Size
	buffer[0x431]=buffer[0x432]=(uchar)0;
}


void ModifyPUOPS (uchar* buffer)
{
	buffer[0x35]=0;
	buffer[0x36]=0;
	buffer[0x37]=0;
	buffer[0x38]=0;
}



unsigned int ac3bitrate[64]=   {32,32,40,40,48,48,56,56,64,64,
        80,80,96,96,112,112,128,128,160,160,192,192,224,224,256,256,
        320,320,384,384,448,448,512,512,576,576,640,640,
        64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64 };

unsigned int dtsbitrate[32]=   {32,56,64,96,112,128,192,224,256,320,384,448,512,576,640,768,
		960,1024,1152,1280,1344,1408,1411,1472,1536,1920,2048,3072,3840,0,0,0};

unsigned int layerIbitrate[16]=  {0,  32,  64, 96,128,160,192,224,
                                  256,288,320,352,384,416,448, 0};
unsigned int layerIIbitrate[16]= {0,  32,  48, 56, 64, 80, 96,112,
                                  128,160,192,224,256,320,384, 0};
unsigned int layerIIIbitrate[16]={0,  32,  40, 48, 56, 64, 80, 96,
                                  112,128,160,192,224,256,320, 0};


unsigned long int p_bit;
////////////////////////////////////////////////////////////////////////
//      getbits
////////////////////////////////////////////////////////////////////////
unsigned int getbits (int number, unsigned char *p_frame)
{
	unsigned int bit_ini,byte_ini,bit_end,byte_end, output;

	byte_ini=p_bit/8;
	bit_ini=p_bit%8;

	p_bit+=number;

	byte_end=p_bit/8;
	bit_end=p_bit%8;

	if (byte_end==byte_ini)
		output= p_frame[byte_end];
	else if (byte_end==byte_ini+1)
		output= p_frame[byte_end-1]*256 + p_frame[byte_end];
	else
	    output= p_frame[byte_end-2]*256*256+p_frame[byte_end-1]*256+
		      p_frame[byte_end];
		  
	output=(output)>>(8-bit_end);
	output=output & ((1 << number)-1);
    
	return output;
}

int getpcmrate(uchar* buffer)
{
//	int first_acc_p;
	int rate;
	int start,nbit,ncha;

	start=0x17+buffer[0x16];

	ncha=(buffer[start+5] & 0x7) +1;
	nbit=(buffer[start+5] >> 6) & 0x3;

	if (nbit==0) nbit=16;
	else if (nbit==1) nbit=20;
	else if (nbit==2) nbit=24;
	else nbit=0;
//	first_acc_p=GetNbytes(2,&buffer[0x19+buffer[0x16]]);
//	first_acc_p+=(0x1A+buffer[0x16]);


	rate=nbit*48*ncha;
	return rate;

}

int getac3rate(uchar* buffer)
{
	int first_acc_p,rate;

	p_bit=0;

	first_acc_p=GetNbytes(2,&buffer[0x19+buffer[0x16]]);
	first_acc_p+=(0x1A+buffer[0x16]);

	if (buffer[first_acc_p+0]!= 0x0B || buffer[first_acc_p+1]!=0x77)
		return 0;

	rate=ac3bitrate[buffer[first_acc_p+4] & 0x3F];
	return rate;

}

int getdtsrate( uchar* buffer)
{

	int first_acc_p,rate;
	int unused;

	p_bit=0;

	first_acc_p=GetNbytes(2,&buffer[0x19+buffer[0x16]]);
	first_acc_p+=(0x1A+buffer[0x16]);

	if (buffer[first_acc_p+0]!= 0x7F || buffer[first_acc_p+1]!=0xFE ||
		buffer[first_acc_p+2]!= 0x80 || buffer[first_acc_p+3]!=0x01 )
		return 0;

	unused=   getbits (32, &buffer[first_acc_p]); 
	unused=   getbits (1, &buffer[first_acc_p]);
	unused=   getbits (5, &buffer[first_acc_p]);
	unused=   getbits (1, &buffer[first_acc_p]);
	unused=   getbits (7, &buffer[first_acc_p]);
	unused=   getbits (14,&buffer[first_acc_p]);
	unused=   getbits (6, &buffer[first_acc_p]); 
	unused=   getbits (4, &buffer[first_acc_p]);

	rate=     getbits (5, &buffer[first_acc_p]);
	rate=dtsbitrate[rate];

	return rate;
}

int getmpglayer( uchar* buffer)
{

	int first_acc_p,layer;

	first_acc_p=0x17+buffer[0x16];

	if (buffer[first_acc_p+0]!= 0xFF || (buffer[first_acc_p+1] & 0xF0) !=0xF0)
		return 0;

	layer=(buffer[first_acc_p+1] & 0x6)>>1;
	if (layer==3) layer=1;
	else if (layer==1) layer=3;

	return layer;
}

int getmpgrate( uchar* buffer)
{

	int first_acc_p,rate;
	int rateidx,layer;

	first_acc_p=0x17+buffer[0x16];

	if (buffer[first_acc_p+0]!= 0xFF || (buffer[first_acc_p+1] & 0xF0) !=0xF0)
		return 0;

	layer=(buffer[first_acc_p+1] & 0x6)>>1;
	if (layer==3) layer=1;
	else if (layer==1) layer=3;
/*
	For Layer I the following equation is valid: 
	N = 12 * bit_rate / sampling_frequency.
	For Layers II and III the equation becomes: 
	N = 144 * bit_rate / sampling_frequency.
	 384000 / 44100
*/
	rateidx=  (buffer[first_acc_p+2]>>4) & 0xF;

	rate=0;
	if (layer==3)
		rate=layerIIIbitrate[rateidx];
	else if (layer==2)
		rate=layerIIbitrate[rateidx];
	else if (layer==1)
		rate=layerIbitrate[rateidx];

	return rate;

}


void FillSimpleVob(uchar *SimpleVob, int iVideoAttr)
{
// Prepare SimpleVob
// DAR is hacked in MPEG header, but resolution cannot be hacked,
//	it will not work, so different simple Vobs have been created.
// VCD resolution is coded in MPEG-2. All the others are in MPEG-2

	int k;
	__int64 i64AttrMPEG;
	int iFPS;

	for (k=0; k<2048*5;k++)
	{
		if (((iVideoAttr & 0x1000)>>12) == PAL )
		{
			if ((iVideoAttr & 0x0C) == 0 )   
				SimpleVob[k]= PalSimpleVob720x576[k];
			if ((iVideoAttr & 0x0C) == 0x04 ) 
				SimpleVob[k]= PalSimpleVob704x576[k];
			if ((iVideoAttr & 0x0C) == 0x08 ) 
				SimpleVob[k]= PalSimpleVob352x576[k];
			if ((iVideoAttr & 0x0C) == 0x0C ) 
				SimpleVob[k]= PalSimpleVob352x288[k];
		}
		else
		{
			if ((iVideoAttr & 0x0C) == 0 )   
				SimpleVob[k]= NtscSimpleVob720x480[k];
			if ((iVideoAttr & 0x0C) == 0x04 ) 
				SimpleVob[k]= NtscSimpleVob704x480[k];
			if ((iVideoAttr & 0x0C) == 0x08 ) 
				SimpleVob[k]= NtscSimpleVob352x480[k];
			if ((iVideoAttr & 0x0C) == 0x0C ) 
				SimpleVob[k]= NtscSimpleVob352x240[k];
		}
	}


	i64AttrMPEG=GetNbytes(4,&SimpleVob[0x17+SimpleVob[0x16+2048]+4+2048]);
	iFPS= (int) (i64AttrMPEG & 0xF);

	i64AttrMPEG= i64AttrMPEG & 0xFFFFFF00;

	if ((iVideoAttr & 0x0C00) == 0x0C00 )
		//16:9
		i64AttrMPEG+=0x30;
	else if ((iVideoAttr & 0x0C00) == 0 )
		//4:3
		i64AttrMPEG+=0x20;

	i64AttrMPEG+=iFPS;

	Put4bytes (i64AttrMPEG, &SimpleVob[0x17+SimpleVob[0x16+2048]+4+2048]);

}


/////////////////TO COPY PART OF THE CODE....

/*
		for (i64=0;!feof(in) ;i64++)
	{
		for (j=0; j<2048;j++)
			caracter[j]=fgetc(in);
		if (!feof(in))
		{
			if (!(caracter[0]==00 && caracter [1]==00 && caracter[2]==01 && caracter[3]==0xBA))
			{
				fprintf (stderr,"Error: LBA %I64d unsynchronized\n", i64);
				fprintf (log,"Error: LBA %I64d unsynchronized\n", i64);
				return 1;
			}
			startcode=((caracter[14]*256+ caracter[15])*256+ caracter[16])*256+ caracter[17];
 // subpicture/audio pack
			if (startcode==445)
			{
				st_i=0x17+caracter[0x16];
				if ( caracter[st_i] >0x1f && caracter[st_i] <0x30 )
				{
					nusubs++;
					if (extractsubs) writepack(caracter);
				}
				else
				{
					if (caracter[st_i] >0x7f)
					{

// ATENCION Streams conocidos son:
/*

En el startcode: (14 al 17)
000001E0----------> Video stream
000001E1 al 1EF---> Video stream, illegal in DVDs
000001BE----------> Padding Stream
000001BF----------> Private stream 2--> Nav Pack
000001C0-1C7------> Audio Mpeg1 streams 
000001C8-1CF------> Audio Mpeg2 streams 
000001BD----------> Private stream 1--> Subs & audio (ac3 & dts & lpcm)
Y, en este caso, en el StreamID=buffer[0x17+buffer[0x16]];
  0x20-0x3F--> 32 tracks of subs
  0x80-0x87--> ac3
  0x88-0x8f--> dts 
  0xa0-0xa7-->lpcm


0x80-0x87: ac3
0x88-0x8f: dts
0x90-0x9f: unknown
0xa0-0xa7: lpcm
0xa8-0xaf: unknown
0xb0-0xbf: unknown
0xc0-0xc8: mpeg1
0xc9-0xcf: mpeg2
0xd0-0xdf: unknown
0xe0-0xef: unknown
0xf0-0xff: unknown
*/
/*
						nuaudio++;
						if (extractaudio) writepack(caracter);
					}
					else
						nuundef2++;
				}
			}
//  videopack
			else if (startcode==480)
			{
				nuvideo++;
				if (extractvideo) writepack(caracter);
			}
//  Navpack
			else if (startcode==443)
			{
				nunav++;
				if (extractnav)     writepack(caracter);
				if (changevobid)    writepackvobid(caracter,vobini,vobnew);
				if (extractnavinfo) writenavinfo(caracter, i64);
			}
			else
				nuundef1++;
		}

*/

/*
void writenavinfo(int *caracter, __int64 lba)
{

	// There are two different times (but most of the cases identical)
	// PCI stream and DSI stream 
	// VOBID and CELLID are in DSI header
	int vobid, cellid;
	int hh,mm,ss,ff;
	int hor, min, sec, fra, fps;
	int seconds,frames;
	__int64 this_lba;
	int diff, diffold;
	static int fraold=0;


	this_lba= (((__int64)caracter[0x2d]*256 +
		        (__int64)caracter[0x2e])*256 +
				(__int64)caracter[0x2f])*256 +
				(__int64)caracter[0x30];

	hh=caracter[0x45];
	mm=caracter[0x46];
	ss=caracter[0x47];
	ff=caracter[0x48];
	
	hor= (hh/16)*10 + hh%16;
	min= (mm/16)*10 + mm%16;
	sec= (ss/16)*10 + ss%16;
	fra= ((ff/16) & 0x3 )*10 + ff%16;
	fps=0;
	if ((ff & 0xc0 ) == 0x40 ) fps=25;
	if ((ff & 0xc0 ) == 0xc0 ) fps=30;

	seconds= hor*3600+min*60+sec;
	frames = seconds*fps +fra;

    diff   = frames -fraold;
	fraold = frames;
	diffold = diff;

	vobid=caracter[0x41f]*256 + caracter[0x420];
	cellid=caracter[0x422];
	

	fprintf (out,"V/C:%02d%02d this:%08I64X lba:%08I64X sec=%06d fra=%06d time: %02X:%02X:%02X.%02X diff:%04d\n",
		     vobid, cellid, this_lba, lba, seconds, frames, hh,mm,ss,ff&0x3f, diff);
	totwr++;
}
*/


/* Code of TMAPTI 

#define PERCDUR 95
#define MAXENTRIESLOST 2
#define WRITEBUP 1


int ifo_sour[MAXLENGTH];
__int64 length_sour;
int discontinuity;

int readline (char *line, FILE *file)
{
	if ((fgets (line,1024,file))==NULL)
		 return 1;
	return 0;
}

unsigned __int64 findlba(long int sec, long int vobid, long int cellid, FILE *file)
{

//	V/C:0201 this:00007B35 lba:00000000 sec=000000 fra=000000 time: 00:00:00.00 diff:0000

	char linea[1024];
	int match;
	char vobstr[32];
	unsigned __int64 lba;
	char *pcr;
	long int secread;
	static long int secold=0, secacum=0;

	lba=0xFFFFFFFF;
	match=0;
	if (cellid ==0)
	   sprintf (vobstr,"V/C:%02d",vobid);
	else
	   sprintf (vobstr,"V/C:%02d%02d",vobid,cellid);

    while ( match == 0)
	{
		if (readline (linea, file)!=0) match =-1;
		else if (strstr (linea,vobstr) !=NULL) 
		{
			pcr= strstr(linea,"sec=");
			pcr+=4;
			pcr[6]=0;
			sscanf (pcr, "%ld",&secread);

			if (secread < secold)
			{
				discontinuity=1;
				secacum+=secold;
			}
			secold=secread;

			if ( secread+secacum>=sec )
			{
				match =1;
				pcr= strstr(linea,"this:");
				pcr+=5;
				pcr[8]=0;
				sscanf (pcr, "%I64X",&lba);
			}
		}
	}

	return lba;
}


int	writeifo (char* file_out)
{
	FILE *out;
	long int i;
	if ((out=fopen(file_out,"wb"))==NULL)
	{
		fprintf (stderr,"Unable to open output file: %s\n",file_out);
		return 1;
	}

	if (fseek(out,0,SEEK_SET)!=0)
	{
		fclose(out);
		fprintf (stderr,"Unable to positioning in output file\n");
		return 1;
	}
	for (i=0; i< length_sour; i++)
		fputc(ifo_sour[i],out);
	fclose(out);

//	fprintf (stderr, "IFO written. %ld characters\n", length_sour);
	return 0;
}


__int64 readifo (char* file, int *ifo_mem)
{
	__int64 i, length;
	FILE *in;

	if ((in=fopen(file,"rb"))==NULL)
	{
		fprintf (stderr,"Unable to open input file %s\n",file);
		return -1;
	}


	for (i=0;!feof(in) && i< MAXLENGTH ;i++)
		ifo_mem[i]=fgetc(in);
	length=i-1;
	
	fclose(in);

	if (length == MAXLENGTH-1)
	{
		fprintf (stderr, "ERROR: Ifo file too big\n");
		return -1;
	}
	return length;
}

/////////////////////////////////////////////////////////////
//    main
/////////////////////////////////////////////////////////////
int main(int argc, char* argv[])
{

	long int pgc, nusecs, vobid, cellid; 
    char file_out[256];
	long int i;
	long int VTS_PGCI_ini,VTS_PGC_ini, VTS_TMAPTI_ini, VTS_TMAP_ini, VTS_TMAP_end;
	long int nuPGCs, nuPGCs_TMAP;
	long int duration, hh, mm,ss;
	long int maxentries, entries, entriesok;
	unsigned __int64 lba;

	FILE *inlst, *log;

	if (argc < 5 || 
		!( (strcmp (argv[1],"-pgc"))==0 ))
	{
		fprintf (stderr,"Usage: tmapti -pgc <nupgc> -vobid <nuvob> [-cellid <nucell>] [-secs <nusecs>] ifofilein lstfile\n");
		fprintf (stderr,"       Updates tmapti of ifo table according the selected parameters\n");
		fprintf (stderr,"               tmapti uses the space available, but does not make more space\n");
		fprintf (stderr,"       lstfile: file result of navpack -navinfo vob_file \n");
		fprintf (stderr,"       vobid and cellid (optional) select the vobid (and cellid) lbas to use\n");
		fprintf (stderr,"       pgc: selects the pgc table to be updated\n");
		fprintf (stderr,"       -secs sets the number of seconds between the entries\n");
		fprintf (stderr,"             -1 uses the already stored value\n");
		fprintf (stderr,"              0 calculates a safe value\n");
			
	// nusecs=0  means automatic detection 
		return 1;
	}

	pgc=nusecs=vobid=cellid=0;

	for (i=1; i< (long int)(argc-2) ;i++)
	{
		if (strcmp (argv[i],"-pgc")==0)	  {sscanf(argv[i+1],"%ld", &pgc); i++;}
		if (strcmp (argv[i],"-secs")==0)  {sscanf(argv[i+1],"%ld", &nusecs); i++;}
		if (strcmp (argv[i],"-vobid")==0) {sscanf(argv[i+1],"%ld", &vobid); i++;}
		if (strcmp (argv[i],"-cellid")==0) {sscanf(argv[i+1],"%ld", &cellid); i++;}

	}

	if (pgc < 1 || vobid < 1 || cellid<0 )
	{
		fprintf (stderr,"PGC and VOBID numbers must be higher than 0\n");
		return 1;
	}

// readifo

	if ( (length_sour=readifo(argv[argc-2],ifo_sour)) == -1) return (1);

// openlst

	if ((inlst=fopen(argv[argc-1],"r"))==NULL)
	{
		fprintf (stderr,"Unable to open input lst file %s\n",argv[argc-1]);
		return -1;
	}
	if ((log=fopen("tmapti.log","w"))==NULL)
	{
		fprintf (stderr,"Unable to open log file %s\n","tmapti.log");
		return -1;
	}
	

	strcpy(file_out,argv[argc-2]); // ready to write original ifo

// Pointers to Tables
	VTS_PGCI_ini=2048*(((ifo_sour[0xCC]*256+ifo_sour[0xCD])*256+
			                ifo_sour[0xCE])*256+ifo_sour[0xCF]);
	
	VTS_TMAPTI_ini=2048*(((ifo_sour[0xD4]*256+ifo_sour[0xD5])*256+
			                ifo_sour[0xD6])*256+ifo_sour[0xD7]);

// locate selected PGC 
	if ( VTS_PGCI_ini > length_sour || VTS_TMAPTI_ini > length_sour)
	{
		fprintf (stderr,"ERROR: Unable to locate VTS Tables\n");
		return 1;
	}

	nuPGCs=ifo_sour[VTS_PGCI_ini]*256+ifo_sour[VTS_PGCI_ini+1];

	if ( nuPGCs < pgc)
	{
		fprintf (stderr,"ERROR: Unable to find source PGCs\n");
		return 1;
	}

	VTS_PGC_ini=((ifo_sour[VTS_PGCI_ini+0x04+pgc*8]*256+ifo_sour[VTS_PGCI_ini+0x05+pgc*8])*256+
		        ifo_sour[VTS_PGCI_ini+0x06+pgc*8])*256+ifo_sour[VTS_PGCI_ini+0x07+pgc*8]+
				VTS_PGCI_ini;

	hh=ifo_sour[VTS_PGC_ini+4];
	mm=ifo_sour[VTS_PGC_ini+5];
	ss=ifo_sour[VTS_PGC_ini+6];
	duration= ((hh/16)*10+(hh%16))*3600 + ((mm/16)*10+(mm%16))*60 + ((ss/16)*10+(ss%16));

// locate selected TMAP

	nuPGCs_TMAP=ifo_sour[VTS_TMAPTI_ini]*256+ifo_sour[VTS_TMAPTI_ini+1];
	if ( nuPGCs !=  nuPGCs_TMAP)
	{
		fprintf (stderr,"ERROR: nuPGCs mismatch between VTS_TMAPTI and VTS_PGCI. Please fix it manually\n");
		return 1;
	}

	VTS_TMAP_ini=((ifo_sour[VTS_TMAPTI_ini+0x04+pgc*4]*256+ifo_sour[VTS_TMAPTI_ini+0x05+pgc*4])*256+
		        ifo_sour[VTS_TMAPTI_ini+0x06+pgc*4])*256+ifo_sour[VTS_TMAPTI_ini+0x07+pgc*4]+
				VTS_TMAPTI_ini;

// locate the limits of TMAP table
	if (nuPGCs == pgc)
		// last PGC, so use last available byte
		VTS_TMAP_end=((ifo_sour[VTS_TMAPTI_ini+0x04]*256+ifo_sour[VTS_TMAPTI_ini+0x05])*256+
		        ifo_sour[VTS_TMAPTI_ini+0x06])*256+ifo_sour[VTS_TMAPTI_ini+0x07]+
				VTS_TMAPTI_ini;
	else
		// first byte of next PGC
		VTS_TMAP_end=((ifo_sour[VTS_TMAPTI_ini+0x08+pgc*4]*256+ifo_sour[VTS_TMAPTI_ini+0x09+pgc*4])*256+
		        ifo_sour[VTS_TMAPTI_ini+0x0A+pgc*4])*256+ifo_sour[VTS_TMAPTI_ini+0x0B+pgc*4]+
				VTS_TMAPTI_ini - 1;

    maxentries=(VTS_TMAP_end-VTS_TMAP_ini+1)/4 -1;

	// nusecs=-1 uses already stored value
	if (nusecs == -1 ) nusecs= ifo_sour[VTS_TMAP_ini];
	// nusecs=0  means automatic detection 
	// Too many operations, sure there is an easy way to do the same...
	if (nusecs == 0 && maxentries !=0)
	{
		nusecs=duration/maxentries;
		if (nusecs == 0)  nusecs=1;
		entries= duration/nusecs;
		if (entries > maxentries+MAXENTRIESLOST)
			nusecs= (duration*PERCDUR/100)/maxentries*100;
	}

	// to be sure 
	if (nusecs == 0)  nusecs=1;
	entries= duration/nusecs;

// log some info
	fprintf (log, "pgc:%02d vobid:%02d nusecs:%02d entries:%04d maxentries:%04d duration:%06d\n",
		           pgc, vobid, nusecs, entries, maxentries, duration);

	for (i=entriesok=0; i<duration; i+=nusecs)
	{
		discontinuity=0;
		lba=findlba(i, vobid, cellid, inlst);
		if (discontinuity==1)
		{
			discontinuity=0;
			ifo_sour[VTS_TMAP_ini+entriesok*4]+=0x80;
		}
		if (lba!=0xFFFFFFFF  && entriesok <maxentries)
		{
			entriesok++;
			ifo_sour[VTS_TMAP_ini+entriesok*4+3]=(int)(lba%256);
			ifo_sour[VTS_TMAP_ini+entriesok*4+2]=(int)((lba%(256*256))/256);
			ifo_sour[VTS_TMAP_ini+entriesok*4+1]=(int)((lba%(256*256*256))/(256*256));
			ifo_sour[VTS_TMAP_ini+entriesok*4]=(int)(lba/(256*256*256));
			fprintf (log, "entry:%04d sec:%06d lba:%08I64X\n",
		                   entriesok, i, lba);
		}

	}
	// last entry always discontinuity. Not sure, but it seems... 
	if (entriesok > 0 ) ifo_sour[VTS_TMAP_ini+entriesok*4]+=0x80;

	ifo_sour[VTS_TMAP_ini+2]=entriesok/256;
	ifo_sour[VTS_TMAP_ini+3]=entriesok%256;
	ifo_sour[VTS_TMAP_ini]=nusecs;

	// write destination IFO
	writeifo (file_out);
	if (WRITEBUP)
	{
		file_out[strlen(file_out)-3]=0;
		strcat(file_out,"BUP");
		writeifo (file_out);
	}
	fclose (inlst);
	fclose (log);

	return 0;
}


*/ 
//End of TMAPTI code

