// VobBlanker.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "direct.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <Winbase.h>
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "VobBlankerDlg.h"
#include "LogDlg.h"
#include "InfoDlg.h"
#include "CellsDlg.h"
//#include "FixedVobs.h"

#define INI_AUDIO  0x204
#define INI_SUBS   0x256
#define INI_VIDEO  0x200
#define HEADLENGTH 0x3D8


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern int GetNbytes(int nNumber,uchar* address);
extern void Put4bytes(__int64 i64Number,uchar* address);
extern void Put2bytes(__int64 i64Number,uchar* address);
extern DWORD AddDuration(DWORD dwDuration1, DWORD dwDuration2);
extern DWORD SubDuration(DWORD dwDuration1, DWORD dwDuration2);
extern int readbuffer(uchar* caracter, FILE *in);
extern void writebuffer(uchar* caracter, FILE *out);
extern void MyErrorBox(LPCTSTR text);
extern void MyErrorLog_Box(LPCTSTR text);
extern void MyInfoBox(LPCTSTR text);
extern bool IsNav(uchar* buffer);
extern bool IsSynch(uchar* buffer);
extern bool IsVideo(uchar* buffer);
extern bool IsAudio(uchar* buffer);
extern bool IsAudMpeg(uchar* buffer);
extern bool IsSubs(uchar* buffer);
extern bool IsGOP(uchar* buffer);
extern bool IsClosedGOP(uchar* buffer);
extern int Dec2BCD ( int Dec);
extern void	ModifyLBA (uchar* buffer, __int64 m_i64OutputLBA);
extern void	ModifyCID (uchar* buffer, int VobId, int CellId);
extern void	ModifyPUOPS (uchar* buffer);
extern void CleanILV (uchar* buffer);
extern int  DurationInSecs(DWORD dwDuration);
extern int  DurationInFrames(DWORD dwDuration);
extern int getdtsrate( uchar* buffer);
extern int getac3rate( uchar* buffer);
extern int getmpgrate( uchar* buffer);
extern int getmpglayer( uchar* buffer);
extern int getpcmrate( uchar* buffer);
extern int getAudId  (uchar *buffer);
extern int readpts(uchar *buf);
extern void	FillSimpleVob(uchar *SimpleVob,int iVideoAttr);
extern int get4c(FILE * in);
extern void fput4c( int i4char, FILE *in);



int discontinuity;

/////////////////////////////////////////////////////////////////////////////
// CVobBlankerApp

BEGIN_MESSAGE_MAP(CVobBlankerApp, CWinApp)
	//{{AFX_MSG_MAP(CVobBlankerApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVobBlankerApp construction

CVobBlankerApp::CVobBlankerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CVobBlankerApp object

CVobBlankerApp theApp;

void CVobBlankerApp::MyErrorLog_Box(LPCTSTR text)
{
	if (theApp.m_pLog) ((CLogDlg *)(theApp.m_pLog))->LogLine(text);
	MyErrorBox(text);
	theApp.m_nErrors++;
}

void CVobBlankerApp::MyLog(LPCTSTR text)
{
	if (theApp.m_pLog) ((CLogDlg *)(theApp.m_pLog))->LogLine(text);
}
/////////////////////////////////////////////////////////////////////////////
// CVobBlankerApp initialization

BOOL CVobBlankerApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	char szPath[_MAX_PATH];

	for (int i=0; i<MAX_VTS; i++)
	{
		m_pIFO[i]=NULL;
		m_nPGCs[i]=0;
		m_nMPGCs[i]=0;
	}
	m_bInProcess=false;
	m_bLog=false;
	m_nIFOs=0;
	m_pLog=NULL;


	GetModuleFileName( NULL, szPath , _MAX_PATH);
	csPath.Format(_T("%s"),szPath);
	csPath=csPath.Left(csPath.ReverseFind('\\'));

 	CVobBlankerDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}


int CVobBlankerApp::ReadIFOs(CString csVideo_TS)
{
	__int64 i;
	FILE *in;
	int j,k,l;
	int kk,ll;
	CString csAux,csAux2;
	struct  _stati64 statbuf;
	__int64 i64IniSec,i64EndSec;
	int VIDa,VIDb,CIDa,CIDb, same;
	int nADTCells;
	__int64 i64Newlen;


	MemoryDeleteAll();

//	csVideo_TS.MakeUpper();
	m_csVTSname[0]="VIDEO_TS.VOB";
	m_csInputPath=csVideo_TS.Left(csVideo_TS.ReverseFind('\\'));

	if (_stati64 ( csVideo_TS, &statbuf)==0)
		i64Newlen= statbuf.st_size;

	i64Newlen=i64Newlen+MAX_NEWIFOSECTORS*2048; // Allow MAX_NEWSECTORS additional sectors
	i64Newlen=min(MAXLENGTH,i64Newlen);

	if ( m_pIFO[0]==NULL)
		m_pIFO[0]= new uchar[(int)i64Newlen];


// Read VIDEO_TS.IFO
	if ((in=fopen(csVideo_TS,"rb"))==NULL)
	{
		MyErrorBox ("Unable to open input file: "+csVideo_TS);
		return -1;
	}

	for (i=0;!feof(in) && i< i64Newlen ;i++)
		m_pIFO[0][i]=fgetc(in);
	m_i64IFOlen[0]=i-1;
	
	if (in!=NULL) fclose(in);

	if (m_i64IFOlen[0] == i64Newlen-1)
	{
		MyErrorBox ("ERROR: Ifo file too big: "+csVideo_TS);
		return -1;
	}

	m_nIFOs=m_pIFO[0][0x3E]*256+m_pIFO[0][0x3F];

	if ( (m_nIFOs+1) > MAX_VTS)
	{
		csAux.Format(_T("ERROR: Max VTS limit (%d) has been reached."),MAX_VTS-1);
		MyErrorBox (csAux);
		return -1;
	}
	m_TT_SRPT=2048*GetNbytes(4,&m_pIFO[0][0xC4]);
	m_nTotalTitles=GetNbytes(2,&m_pIFO[0][m_TT_SRPT]);
	m_iActionVTS[0]=PROCESS;

	m_ACell_replace.RemoveAll();

	m_i64VTSisize[0]=0;
	csAux=m_csInputPath+'\\'+"VIDEO_TS.VOB";
	if (_stati64 ( csAux, &statbuf)==0)
		m_i64VTSisize[0]= statbuf.st_size;
	m_i64VTSfsize[0]=m_i64Misize[0]=m_i64Misize[0]=m_i64VTSisize[0];

	m_bAngleAll=m_bILVAll=false;
// Read all VTS IFOs ---> VTS index:"j"
	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
	for (j=1; j<m_nIFOs+1 ;j++)
	{
		m_csVTSname[j].Format(_T("VTS_%02d_*.VOB"), j);
		csAux2.Format(_T("VTS_%02d_0.IFO"), j);
		csAux=m_csInputPath+'\\'+csAux2;

		if (_stati64 ( csAux, &statbuf)==0)
			i64Newlen= statbuf.st_size;
		i64Newlen=i64Newlen+MAX_NEWIFOSECTORS*2048; // Allow MAX_NEWSECTORS additional sectors
		i64Newlen=min(MAXLENGTH,i64Newlen);

		if ( m_pIFO[j]==NULL)
			m_pIFO[j]= new uchar[(int)i64Newlen];

		// Read IFO
		if ((in=fopen(csAux,"rb"))==NULL)
		{
			SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
			MyErrorBox ("Unable to open input file: "+csAux);
			return -1;
		}
		for (i=0;!feof(in) && i< i64Newlen ;i++)
			m_pIFO[j][i]=fgetc(in);
		m_i64IFOlen[j]=i-1;
	
		if (in!=NULL) fclose(in);

		// Fill VTS data
		if (m_i64IFOlen[j] == i64Newlen-1)	
		{
			SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
			MyErrorBox ("ERROR: Ifo file too big: "+csAux);
			return -1;
		}
		m_i64VTSisize[j]=m_i64Misize[j]=0;

		csAux2.Format(_T("VTS_%02d_0.VOB"), j);
		csAux=m_csInputPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
		{
			m_i64VTSisize[j]=m_i64Misize[j]= statbuf.st_size;
		}
		m_i64Mfsize[j]=m_i64Misize[j];

		for (k=1; k<10; k++)
		{
			csAux2.Format(_T("VTS_%02d_%d.VOB"), j,k);
			csAux=m_csInputPath+'\\'+csAux2;
			if (_stati64 ( csAux, &statbuf)==0)
				m_i64VTSisize[j]+= statbuf.st_size;
			else 
				if (k!=0) k=20;
		}
		m_i64VTSfsize[j]=m_i64VTSisize[j];

// Fill Titles data	
		m_VTS_PTT_SRPT[j]=2048*GetNbytes(4,&m_pIFO[j][0xC8]);
		m_VTS_PGCI[j]=2048*GetNbytes(4,&m_pIFO[j][0xCC]);
		m_VTS_C_ADT[j]=2048*GetNbytes(4,&m_pIFO[j][0xE0]);
		m_VTS_VOBU_ADMAP[j]=2048*GetNbytes(4,&m_pIFO[j][0xE4]);
		m_VTS_TMAPTI[j]=2048*GetNbytes(4,&m_pIFO[j][0xD4]);

		m_nPGCs[j]=GetNbytes(2,&m_pIFO[j][m_VTS_PGCI[j]]);

		if ( m_nPGCs[j] > MAX_PGC)
		{
			csAux.Format(_T("ERROR: Max PGC limit (%d) has been reached."),MAX_PGC);
			MyErrorBox (csAux);
			return -1;
		}
		if (m_nPGCs[j])
			if (!MemoryNewVTSTitle(j, m_nPGCs[j] ))
			{
				MyErrorBox("ERROR: Memory allocation failed!");
				return -1;
			}

		m_iVideoAttr[j]=m_pIFO[j][0x200]*256+m_pIFO[j][0x201];
		m_iVideoAttrBK[j]=m_iVideoAttr[j];

		m_bAngleVTS[j]=m_bILVVTS[j]=false;

// Compute m_nVOBIDs
		same=0;
		nADTCells=(GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+4])-7)/12;

		for( kk=0, m_nVOBIDs[j]=0; kk< nADTCells ; kk++)
		{
			VIDa=GetNbytes(2, &m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk]);
			for (ll=0,same=0; ll< kk; ll++)
			{
				if (VIDa==GetNbytes(2, &m_pIFO[j][m_VTS_C_ADT[j]+8+12*ll]))
				same=1;
			}
			if (same==0) m_nVOBIDs[j]++;
		}

// Loop PGCs ---> VTS index:"j"; PGC index: "k"
		for (k=0 ; k<m_nPGCs[j] ; k++)
		{
			m_CutInfo[j][k].iIniCell=-1;
			m_CutInfo[j][k].iIniLba=-1;
			m_CutInfo[j][k].iEndCell=-1;
			m_CutInfo[j][k].iEndLba=-1;
			m_CutInfo[j][k].iAction=0;

			m_nTitleInVTS[j][k]=m_pIFO[j][m_VTS_PGCI[j]+0x08+k*8] & 0x7f;
			if (m_pIFO[j][m_VTS_PGCI[j]+0x08+k*8] & 0x80 )
				m_bEntry[j][k]=true;
			else
				m_bEntry[j][k]=false;

			m_nTitle[j][k]=0;
			m_nAngles[j][k]=0;

			for (l=0; l<m_nTotalTitles;l++)
			{
				if (m_pIFO[0][m_TT_SRPT+8+12*l+6]==(UINT)j &&
					m_pIFO[0][m_TT_SRPT+8+12*l+7]== (int)m_nTitleInVTS[j][k])
				{
					m_nTitle[j][k]=l+1;
					m_nAngles[j][k]= m_pIFO[0][m_TT_SRPT+8+12*l+1];
				}
			}
			if (m_nAngles[j][k]> 1)
			{
				m_bAngleAll=true;
				m_bAngleVTS[j]=true;
			}

			m_iAction[j][k]=KEEP;

		// locate the PGC
			m_VTS_PGC[j][k]=GetNbytes(4,&m_pIFO[j][m_VTS_PGCI[j]+0x04+(k+1)*8])+m_VTS_PGCI[j];
			m_dwDuration[j][k]=(DWORD)GetNbytes(4,&m_pIFO[j][m_VTS_PGC[j][k]+4]);
			m_dwDurationOwn[j][k]=0;

			m_C_PBKT[j][k]=GetNbytes(2,&m_pIFO[j][m_VTS_PGC[j][k]+0xE8]);
			if (m_C_PBKT[j][k]!=0  ) m_C_PBKT[j][k]+=m_VTS_PGC[j][k];

			m_C_POST[j][k]=GetNbytes(2,&m_pIFO[j][m_VTS_PGC[j][k]+0xEA]);
			if (m_C_POST[j][k]!=0  ) m_C_POST[j][k]+=m_VTS_PGC[j][k];

			m_PGC_COMM[j][k]=GetNbytes(2,&m_pIFO[j][m_VTS_PGC[j][k]+0xE4]);
			if (m_PGC_COMM[j][k]!=0) m_PGC_COMM[j][k]+=m_VTS_PGC[j][k];

			m_nCells[j][k]=m_pIFO[j][m_VTS_PGC[j][k]+3];
			if ((m_C_POST[j][k]==0 || m_C_PBKT[j][k]==0 ) && m_nCells[j][k]!=0)
				// Seems something is wrong so reset the number of cells.....
			{
				m_nCells[j][k]=0;
				csAux.Format(_T("ERROR: There is something wrong in number of cells in VTS %02d, Title PGC %02d."),j,k);
				MyErrorBox (csAux);
				return -1;
			}
			m_nFirstVID[j][k]=0;
			m_i8CellComm[j][k]=m_i8PreComm[j][k]=m_i8PostComm[j][k]=0;
			if (m_nCells[j][k]!=0)
				m_nFirstVID[j][k]=GetNbytes(2,&m_pIFO[j][m_C_POST[j][k]]);
			if (m_PGC_COMM[j][k]!=0)
			{
				m_i8CellComm[j][k]=GetNbytes(2,&m_pIFO[j][m_PGC_COMM[j][k]+4]);
				m_i8PreComm[j][k]=GetNbytes(2,&m_pIFO[j][m_PGC_COMM[j][k]]);
				m_i8PostComm[j][k]=GetNbytes(2,&m_pIFO[j][m_PGC_COMM[j][k]+2]);
			}
			m_i64Tisize[j][k]=0;
			m_bCellReUsed[j][k]=false;

			m_bILVU[j][k]=false;
            m_csCellBased[j][k].Empty();
			
// Loop Cells ---> VTS index:"j"; PGC index: "k"; Cell index: "l"
			for ( l=0; l< m_nCells[j][k]; l++)
			{
				m_csCellBased[j][k]+='K'; // Keep
				VIDa=GetNbytes(2,&m_pIFO[j][m_C_POST[j][k]+4*l]);
				CIDa=m_pIFO[j][m_C_POST[j][k]+3+4*l];
		 		i64IniSec=GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*l+8]);
				i64EndSec=GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*l+0x14]);

				// check if this cell has been already used
				
				same=0;
				for (kk=0; kk<k ;kk++)
					for (ll=0; ll< m_nCells[j][kk]; ll++)
					{
						VIDb=GetNbytes(2,&m_pIFO[j][m_C_POST[j][kk]+4*ll]);
						CIDb=m_pIFO[j][m_C_POST[j][kk]+3+4*ll];
						if (VIDa==VIDb && CIDa==CIDb)
							same=1;
					}

				if (same==0)
				{

//					Look for cell size in ADT table
					nADTCells=	(GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+4])-7)/12;
					for (kk=0;kk<nADTCells;kk++)
					{
						if (VIDa==GetNbytes(2, &m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk]) &&
						    CIDa==m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+2])
						{
							i64IniSec=GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+4]);
							i64EndSec=GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+8]);
							m_i64Tisize[j][k]+=((i64EndSec-i64IniSec+1)*2048);
						}
					}
					m_dwDurationOwn[j][k] = AddDuration (m_dwDurationOwn[j][k],
						               GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*l+4]) );
				}
				else
				{
					m_bCellReUsed[j][k]=true;
				}
				// Check ILV flag
				if (m_pIFO[j][m_C_PBKT[j][k]+24*l] & 0x04 )
				{
					m_bILVAll=true;
					m_bILVVTS[j]=true;
					m_bILVU[j][k]=true;
				}
			}
		}
		if (m_bILVVTS[j] || m_bAngleVTS[j])
		{
			for (k=0 ; k<m_nPGCs[j] ; k++)
			{
				m_iAction[j][k]=SKIP;
			}
			m_iActionVTS[j]=SKIP;
			m_i64VTSfsize[j]=0;
		}
		else
			m_iActionVTS[j]=PROCESS;
	}

	GetAudioData();

	if ( GetMenuData()!=0 )
	{
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
		return -1;
	}

	GetButtonsData();

	GetMenuIniSize();
	GetMenuEndSize();

	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
	return j;
}

int CVobBlankerApp::GetMenuData()
{
	int j,l,nLU,nPGC,nAbsPGC;
	int	nEntries;
	int VIDa, VIDb, CIDa, CIDb;
	int n,nn,nnn;
	int nArray;
	bool bAlready;
	MENU_CELL_LIST myCell;
	__int64 i64Cellsize, i64IniCell;
	CString csAux;
	int same,nADTCells;
	int kk,ll;

	for (j=0; j<m_nIFOs+1 ;j++)
	{
		if (j==0)
			m_VTSM_PGCI[j]=2048*GetNbytes(4,&m_pIFO[j][0xc8]);
		else
			m_VTSM_PGCI[j]=2048*GetNbytes(4,&m_pIFO[j][0xD0]);
		m_VTSM_C_ADT[j]=2048*GetNbytes(4,&m_pIFO[j][0xD8]);
		m_VTSM_VOBU_ADMAP[j]=2048*GetNbytes(4,&m_pIFO[j][0xDC]);

// Fill LU data
		if (m_VTSM_PGCI[j]==0)
			m_nLUs[j]=0;
		else
			m_nLUs[j]=GetNbytes(2,&m_pIFO[j][m_VTSM_PGCI[j]]);

		if ( m_nLUs[j] > MAX_MLUS)
		{
			csAux.Format(_T("ERROR: Max LU limit (%d) has been reached."),MAX_MLUS);
			MyErrorBox (csAux);
			return -1;
		}
		
// Compute m_nMVOBIDs
		same=0;

		m_nMVOBIDs[j]=0;
		if (m_VTSM_C_ADT[j]==0)
			nADTCells=0;
		else
			nADTCells=(GetNbytes(4,&m_pIFO[j][m_VTSM_C_ADT[j]+4])-7)/12;

		for( kk=0, m_nVOBIDs[j]=0; kk< nADTCells ; kk++)
		{
			VIDa=GetNbytes(2, &m_pIFO[j][m_VTSM_C_ADT[j]+8+12*kk]);
			for (ll=0,same=0; ll< kk; ll++)
			{
				if (VIDa==GetNbytes(2, &m_pIFO[j][m_VTSM_C_ADT[j]+8+12*ll]))
				same=1;
			}
			if (same==0) m_nMVOBIDs[j]++;
		}

		m_nMPGCs[j]=0;
		for (nLU=0; nLU <m_nLUs[j]; nLU++)
		{
			m_VTSM_LU[j][nLU]=   GetNbytes(4,&m_pIFO[j][m_VTSM_PGCI[j]+0x04+(nLU+1)*8])+m_VTSM_PGCI[j];
			m_szLANG_LU[j][nLU][0]= m_pIFO[j][m_VTSM_PGCI[j]+0x00+(nLU+1)*8];
			m_szLANG_LU[j][nLU][1]= m_pIFO[j][m_VTSM_PGCI[j]+0x01+(nLU+1)*8];
			m_szLANG_LU[j][nLU][2]= 0;
			m_nPGCinLU[j][nLU]=  GetNbytes(2,&m_pIFO[j][m_VTSM_LU[j][nLU]]);
			m_nIniPGCinLU[j][nLU]= m_nMPGCs[j];
			if ((m_nMPGCs[j] + m_nPGCinLU[j][nLU]) > MAX_MPGC)
			{
				csAux.Format(_T("ERROR: Max MPGCs limit (%d) has been reached."),MAX_MPGC);
				MyErrorBox (csAux);
				return -1;
			}
			m_nMPGCs[j]+=m_nPGCinLU[j][nLU];
		} // For LUs

		if (m_nMPGCs[j])
			if (!MemoryNewVTSMenu (j, m_nMPGCs[j] ))
			{
				MyErrorBox("ERROR: Memory allocation failed!");
				return -1;
			}

		for (nLU=0; nLU <m_nLUs[j]; nLU++)
		{
			for (nPGC=0; nPGC < m_nPGCinLU[j][nLU]; nPGC++)
			{
				nAbsPGC=nPGC+m_nIniPGCinLU[j][nLU];
				m_nLU_MPGC[j][nAbsPGC]=nLU;
				m_iMAction[j][nAbsPGC]=KEEP;
			    m_MENU_PGC[j][nAbsPGC]= GetNbytes(4,&m_pIFO[j][m_VTSM_LU[j][nLU]+0x04+(nPGC+1)*8])+m_VTSM_LU[j][nLU];

				m_M_C_PBKT[j][nAbsPGC]  =GetNbytes(2,&m_pIFO[j][m_MENU_PGC[j][nAbsPGC]+0xE8]);
				if (m_M_C_PBKT[j][nAbsPGC] !=0) m_M_C_PBKT[j][nAbsPGC] += m_MENU_PGC[j][nAbsPGC];
				m_M_C_POST[j][nAbsPGC]  =GetNbytes(2,&m_pIFO[j][m_MENU_PGC[j][nAbsPGC]+0xEA]);
				if (m_M_C_POST[j][nAbsPGC] !=0) m_M_C_POST[j][nAbsPGC] +=m_MENU_PGC[j][nAbsPGC];
				m_M_PGC_COMM[j][nAbsPGC]=GetNbytes(2,&m_pIFO[j][m_MENU_PGC[j][nAbsPGC]+0xE4]);
				if (m_M_PGC_COMM[j][nAbsPGC] !=0) m_M_PGC_COMM[j][nAbsPGC] +=m_MENU_PGC[j][nAbsPGC];

				m_nMCells[j][nAbsPGC]=m_pIFO[j][m_MENU_PGC[j][nAbsPGC]+3];

				if ( (m_M_C_PBKT[j][nAbsPGC]==0 || m_M_C_POST[j][nAbsPGC] ==0) &&  m_nMCells[j][nAbsPGC]!=0)
					// There is something wrong...
				{
					m_nMCells[j][nAbsPGC]=0;
					csAux.Format(_T("ERROR: There is something wrong in number of cells in VTS %02d, Menu PGC %02d."),j,nAbsPGC);
					MyErrorBox (csAux);
					return -1;
				}
				if (m_nMCells[j][nAbsPGC]==0)
				{
					m_iMAction[j][nAbsPGC]=ZERO;
					m_nMFirstVID[j][nAbsPGC]=0;
				}
				else
				{
					m_nMFirstVID[j][nAbsPGC]=GetNbytes(2,&m_pIFO[j][m_M_C_POST[j][nAbsPGC]]);
				}
				m_i8MCellComm[j][nAbsPGC]=m_i8MPreComm[j][nAbsPGC]=m_i8MPostComm[j][nAbsPGC]=0;
				if (m_M_PGC_COMM[j][nAbsPGC]!=0) 
				{
						m_i8MPreComm[j][nAbsPGC]=GetNbytes(2,&m_pIFO[j][m_M_PGC_COMM[j][nAbsPGC]]);
						m_i8MPostComm[j][nAbsPGC]=GetNbytes(2,&m_pIFO[j][m_M_PGC_COMM[j][nAbsPGC]+2]);
						m_i8MCellComm[j][nAbsPGC]=GetNbytes(2,&m_pIFO[j][m_M_PGC_COMM[j][nAbsPGC]+4]);
				}
				m_dwMDuration[j][nAbsPGC]=(DWORD)GetNbytes(4,&m_pIFO[j][m_MENU_PGC[j][nAbsPGC]+4]);
				m_bMCellReUsed[j][nAbsPGC]=false;
				m_i64MPGCisize[j][nAbsPGC]=0;
	            m_csMCellBased[j][nAbsPGC].Empty();
				for ( l=0; l< m_nMCells[j][nAbsPGC]; l++)
				{
						m_csMCellBased[j][nAbsPGC]+='K'; // Keep
				}

			} // For PGCs
//			m_nMPGCs[j]+=m_nPGCinLU[j][nLU];

		} // For LUs

		m_MenuCells[j].RemoveAll();

		if (m_VTSM_C_ADT[j]==0)
			nEntries=0;
		else
		{
			nEntries=GetNbytes(4,&m_pIFO[j][m_VTSM_C_ADT[j]+4]);
			nEntries=(nEntries-7)/12;
		}
		if (nEntries <0 )  nEntries=0;

		for (n=0;n < nEntries ; n++)
		{
			VIDa=GetNbytes(2,&m_pIFO[j][m_VTSM_C_ADT[j]+8+12*n]);
			CIDa=m_pIFO[j][m_VTSM_C_ADT[j]+8+2+12*n];
			nArray=m_MenuCells[j].GetSize();
			for (nn=0,bAlready=false;nn < nArray  && bAlready==false; nn++)
			{
				VIDb=m_MenuCells[j][nn].VID;
				CIDb=m_MenuCells[j][nn].CID;
				if (VIDa==VIDb && CIDa==CIDb)
				{
					bAlready=true;
					nnn=nn;
				}
			}
			i64IniCell=GetNbytes(4,&m_pIFO[j][m_VTSM_C_ADT[j]+8+12*n+4])*2048;

			i64Cellsize=(GetNbytes(4,&m_pIFO[j][m_VTSM_C_ADT[j]+8+12*n+8])-
				         GetNbytes(4,&m_pIFO[j][m_VTSM_C_ADT[j]+8+12*n+4])+1)*2048;

			if (bAlready)
			{
				if (i64IniCell<m_MenuCells[j][nnn].i64IniCell)
					 m_MenuCells[j][nnn].i64IniCell=i64IniCell;
				m_MenuCells[j][nnn].i64size+=i64Cellsize;
			}
			else
			{
				myCell.VID=VIDa;
				myCell.CID=CIDa;
				myCell.i64size=i64Cellsize;
				myCell.i64IniCell=i64IniCell;
				myCell.nButtons=-1;
				m_MenuCells[j].SetAtGrow(nArray,myCell);
			}
		}
	}  // For VTSs
	
	return 0;
}

int CVobBlankerApp::GetButtonsData()
{
	int nVTS,n,nCells,k,nPGC;
	FILE *in;
	CString csAux;
	__int64 i64;
	int VID,CID;

	for (nVTS=0; nVTS<m_nIFOs+1 ;nVTS++)
	{
		for (nPGC=0; nPGC < m_nMPGCs[nVTS]; nPGC++)
			m_nButtons[nVTS][nPGC]=-1;
	}

	for (nVTS=0; nVTS<m_nIFOs+1 ;nVTS++)
	{
		if (nVTS==0)
			csAux="VIDEO_TS.VOB";
		else
			csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
		csAux=m_csInputPath+'\\'+csAux;
		
		if ( (in=fopen (csAux,"rb"))!=NULL) 
		{
			nCells=m_MenuCells[nVTS].GetSize();

			for (n=0;n<nCells;n++)
			{
				i64=m_MenuCells[nVTS][n].i64IniCell;
				fseek (in,(long)i64,SEEK_SET);
				if (readbuffer(m_buffer,in)==2048)
				{
					if (IsNav(m_buffer))
						m_MenuCells[nVTS][n].nButtons=m_buffer[0x9E];
				}
				else break;

			}
			fclose (in);
		} /* if file opened */

	}
	for (nVTS=0; nVTS<m_nIFOs+1 ;nVTS++)
	{
		for (nPGC=0; nPGC < m_nMPGCs[nVTS]; nPGC++)
		{
			m_nButtons[nVTS][nPGC]=0;
			for (k=0;k<m_nMCells[nVTS][nPGC] && m_nButtons[nVTS][nPGC] >=0;k++)
			{
				VID=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nPGC]+4*k]);
				CID=m_pIFO[nVTS][m_M_C_POST[nVTS][nPGC]+3+4*k];

				nCells=m_MenuCells[nVTS].GetSize();

				for (n=0;n<nCells;n++)
				{
					if (m_MenuCells[nVTS][n].VID==VID && m_MenuCells[nVTS][n].CID==CID)
					{
						if (m_MenuCells[nVTS][n].nButtons==-1)
							m_nButtons[nVTS][nPGC]=-1;
						else
							m_nButtons[nVTS][nPGC]+=m_MenuCells[nVTS][n].nButtons;
					}
				}
			}
		}
	} /* For VTS */
	return 0;
}

void CVobBlankerApp::GetMenuIniSize()
{
// Fills:
//	m_i64MPGCisize[MAX_VTS][MAX_MPGC]
//	m_i64MLUisize[MAX_VTS][MAX_LUS]
//  m_bMCellReUsed[MAX_VTS][MAX_MPGC]

	int j;
	int nArray,nACell,nCell,nPGC,nLU;
	int VIDa, CIDa;
	int VIDb, CIDb;

	for (j=0; j<m_nIFOs+1 ;j++)
	{
		nArray=m_MenuCells[j].GetSize();
		for (nCell=0; nCell<nArray; nCell++)
			m_MenuCells[j][nCell].bAlready=false;

		for (nPGC=0; nPGC <m_nMPGCs[j]; nPGC++)
		{
			m_i64MPGCisize[j][nPGC]=0;
			m_bMCellReUsed[j][nPGC]=false;

			for (nCell=0; nCell <m_nMCells[j][nPGC]; nCell++)
			{
				VIDa=GetNbytes(2,&m_pIFO[j][m_M_C_POST[j][nPGC] +4*nCell]);
				CIDa=m_pIFO[j][m_M_C_POST[j][nPGC] +4*nCell +3];
				for (nACell=0; nACell<nArray; nACell++)
				{
					VIDb=m_MenuCells[j][nACell].VID;
					CIDb=m_MenuCells[j][nACell].CID;
					if (VIDa==VIDb && CIDa==CIDb)
					{
						if 	(m_MenuCells[j][nACell].bAlready)
							m_bMCellReUsed[j][nPGC]=true;
						else
						{
							m_i64MPGCisize[j][nPGC]+=m_MenuCells[j][nACell].i64size;
							m_MenuCells[j][nACell].bAlready=true;
						}
					}
				}
			}
		} // For PGCs

		for (nLU=0; nLU <m_nLUs[j]; nLU++)
		{
			m_i64MLUisize[j][nLU]=0;
			for (nPGC=0; nPGC <m_nPGCinLU[j][nLU]; nPGC++)
				m_i64MLUisize[j][nLU]+=m_i64MPGCisize[j][nPGC+m_nIniPGCinLU[j][nLU]];

		}  // For LUs
	}// For VTSs
}


void CVobBlankerApp::GetMenuEndSize()
{
// Fills:
//	m_i64MPGCfsize[MAX_VTS][MAX_MPGC]
//  m_i64Mfsize[MAX_VTS]

	int j;
	int nArray,nACell,nCell,nPGC,nnPGC,nLU;
	int VIDa, CIDa;
	int VIDb, CIDb;

	for (j=0; j<m_nIFOs+1 ;j++)
	{
		nArray=m_MenuCells[j].GetSize();
		for (nCell=0; nCell<nArray; nCell++)
			m_MenuCells[j][nCell].bAlready=false;

		for (nPGC=0; nPGC <m_nMPGCs[j]; nPGC++)
		{
			m_i64MPGCfsize[j][nPGC]=0;
			if (m_iMAction[j][nPGC] ==BLANK) m_i64MPGCfsize[j][nPGC]=5*2048*m_nMCells[j][nPGC];
			if (m_iMAction[j][nPGC] ==DELPBK) m_i64MPGCfsize[j][nPGC]=0;
			if (m_iMAction[j][nPGC] ==CELLBASED)
				m_i64MPGCfsize[j][nPGC]=CalculateMenuCellBasedSize(j,nPGC);

			nnPGC=nPGC;
			if (m_iMAction[j][nPGC] ==REUSE)
			{
				nnPGC=nPGC-m_nIniPGCinLU[j][m_nLU_MPGC[j][nPGC]];
				nnPGC=nnPGC+m_nIniPGCinLU[j][m_iReuseLU[j][nPGC]];
			}

			if (m_iMAction[j][nPGC] ==REUSE || m_iMAction[j][nPGC] ==KEEP)
			{
				for (nCell=0; nCell <m_nMCells[j][nnPGC]; nCell++)
				{
					VIDa=GetNbytes(2,&m_pIFO[j][m_M_C_POST[j][nnPGC] +4*nCell]);
					CIDa=m_pIFO[j][m_M_C_POST[j][nnPGC] +4*nCell +3];
					for (nACell=0; nACell<nArray; nACell++)
					{
						VIDb=m_MenuCells[j][nACell].VID;
						CIDb=m_MenuCells[j][nACell].CID;
						if (VIDa==VIDb && CIDa==CIDb)
						{
							if 	(!m_MenuCells[j][nACell].bAlready)
							{
								m_i64MPGCfsize[j][nPGC]+=m_MenuCells[j][nACell].i64size;
								m_MenuCells[j][nACell].bAlready=true;
							}
						}
					}
				}
			}
		} // For PGCs

		m_i64Mfsize[j]=0;
		for (nLU=0; nLU <m_nLUs[j]; nLU++)
		{
			m_i64MLUfsize[j][nLU]=0;
			for (nPGC=0; nPGC <m_nPGCinLU[j][nLU]; nPGC++)
				m_i64MLUfsize[j][nLU]+=m_i64MPGCfsize[j][nPGC+m_nIniPGCinLU[j][nLU]];

			m_i64Mfsize[j]+=m_i64MLUfsize[j][nLU];
		}  // For LUs
	}// For VTSs
}

void CVobBlankerApp::GetAudioData()
{
	int i,k,kk;
	int nVTS,nT,nCell;
	int nA,nCode,nId;
	CString csAux,csAux2;
	FILE *in;
	__int64 i64IniSec, i64AccSec;
	struct  _stati64 statbuf;
	uchar AudStatus;
	int AddId;
//	int layer;


	for (nVTS=1; nVTS<m_nIFOs+1 ;nVTS++)
	{
// Fill Pointers

		m_nAudio[nVTS]=GetNbytes(2,&m_pIFO[nVTS][0x202]);
		for (nA=0; nA<8; nA++)
		{
			m_iIdAudio[nVTS][nA]=-1;
			m_iBRAudio[nVTS][nA]=0;
			for (nT=0 ; nT<m_nPGCs[nVTS] ; nT++)
			{
				m_bIdTAudioStrip[nVTS][nA][nT]=false;
				m_iIdTAudio[nVTS][nA][nT]=-1;
			}
		}


		for (nA=0; nA<m_nAudio[nVTS]; nA++)
		{
			nCode=m_pIFO[nVTS][0x204+8*nA] >> 5;
			if (nCode==0) { AddId=0x80; csAux="ac3";}
			if (nCode==1) { AddId=0x80; csAux="???";}
			if (nCode==2) { AddId=0xC0; csAux="Mpeg1";}
			if (nCode==3) { AddId=0xC8; csAux="Mpeg2";}
			if (nCode==4) { AddId=0xA0; csAux="LPCM";}
			if (nCode==5) { AddId=0x80; csAux="???";}
			if (nCode==6) { AddId=0x88; csAux="DTS";}
			if (nCode==7) { AddId=0x80; csAux="???";}
// track id
			for (nT=0,AudStatus=0 ; nT<m_nPGCs[nVTS] ; nT++)
			{
				AudStatus=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nA*2+0x0c];
				if ( (AudStatus & 0x80) && m_iIdAudio[nVTS][nA] == -1 ) 
					m_iIdAudio[nVTS][nA]=(AudStatus & 0x07)+AddId;

				if (AudStatus & 0x80)
					m_iIdTAudio[nVTS][nA][nT]=(AudStatus & 0x07)+AddId;
				else
					m_iIdTAudio[nVTS][nA][nT]=-1;

				m_bIdTAudioStrip[nVTS][nA][nT]=false;

			}

			nId=m_iIdAudio[nVTS][nA];

			if (nId != -1 && ((nId<=0x8f && nId>=0x80) || 
				              (nId<=0xa7 && nId>=0xa0) ||
							  (nId<=0xc7 && nId>=0xc0) ))
			{
				for (nT=0;nT<m_nPGCs[nVTS] && m_iBRAudio[nVTS][nA]==0;nT++)
				{
					for ( nCell=0; nCell<2 && nCell < m_nCells[nVTS][nT] &&  m_iBRAudio[nVTS][nA]==0;nCell++)
					{
					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+8])+1;
					i64AccSec=0;
						for (k=1; k<10; k++)
						{
							csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,k);
							kk=k;
							csAux=m_csInputPath+'\\'+csAux2;
							if (_stati64 ( csAux, &statbuf)==0)
								{
								i64AccSec+= (statbuf.st_size/2048);
								if (i64AccSec > i64IniSec)
								{
									k=10;
									i64AccSec-= (statbuf.st_size/2048);
								}
							}
							else 
								k=20;
						}

						if (k==11)
						{
							in=fopen (csAux,"rb");
							fseek(in, (int)( (i64IniSec-i64AccSec )*2048) ,SEEK_SET);

// Look for a Audio pack, but only in a few packs...
							for (i=0;i<MAXLOOKFORAUDIO && m_iBRAudio[nVTS][nA]==0; i++ )
							{
								if (readbuffer(m_buffer,in)!=2048)
								{
									if (in !=NULL) fclose (in);
									kk++;
									csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS, kk);
									csAux=m_csInputPath+ '\\' +csAux2;
									in=fopen(csAux,"rb");
									if (readbuffer(m_buffer,in)!=2048)
									{
//										MyErrorBox("Error: Reached end of VOB too early");
										if (in !=NULL) fclose (in);
									}
								}
								if (IsAudio(m_buffer)  && getAudId(m_buffer)== nId)
								{
									if (nId >=0x80 && nId <=0x87)
										m_iBRAudio[nVTS][nA]=getac3rate(m_buffer);
									else if (nId >=0x88 && nId <=0x8f)
										m_iBRAudio[nVTS][nA]=getdtsrate(m_buffer);
									else if (nId >=0xa0 && nId <=0xa7)
										m_iBRAudio[nVTS][nA]=getpcmrate(m_buffer);
									else if (nId >=0xc0 && nId <=0xc7)
									{
//										layer=getmpglayer(m_buffer);
//										csAux2.Format(_T(" L %d"),layer);
//										csAux=csAux+csAux2;
										m_iBRAudio[nVTS][nA]=getmpgrate(m_buffer);
									}
								}
							}
							if (in !=NULL) fclose(in);
						}
					}
				}
			}
		}
	}
}

uchar CVobBlankerApp::ST_GetAudioStatus(int nVTS, int nT, int nA)
{
	uchar AudStatus;

	AudStatus=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nA*2+0x0c];

	return AudStatus;
}

int CVobBlankerApp::ST_GetAudioDelay(int nVTS, int nT, int nA)
{
	// returns delay in milisecs. 0x7fffffff if unknown 
	int nId,nCell;
	__int64 i64AccSec,i64IniSec;
	int k,kk,i;
	bool bFirstVideo,bFirstAudio;
	CString csAux, csAux2;
	FILE *in;
	struct  _stati64 statbuf;
	int iAudPTS,iVidPTS;
	int AudDelay;
	

	nId=m_iIdAudio[nVTS][nA];

	bFirstVideo=false;
	bFirstAudio=false;
	for ( nCell=0; nCell<2 && nCell < m_nCells[nVTS][nT] && (bFirstVideo==false || bFirstAudio==false ) ;nCell++)
	{
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+8])+1;
		i64AccSec=0;
		for (k=1; k<10; k++)
		{
			csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,k);
			kk=k;
			csAux=m_csInputPath+'\\'+csAux2;
			if (_stati64 ( csAux, &statbuf)==0)
			{
				i64AccSec+= (statbuf.st_size/2048);
				if (i64AccSec > i64IniSec)
				{
					k=10;
					i64AccSec-= (statbuf.st_size/2048);
				}
			}
			else 
				k=20;
		}
		if (k==11)
		{
			in=fopen (csAux,"rb");
			fseek(in, (int)( (i64IniSec-i64AccSec )*2048) ,SEEK_SET);
// Look for a Video and Audio pack, but only in a few packs...
			for (i=0;i<MAXLOOKFORAUDIO && (bFirstVideo==false || bFirstAudio==false ); i++ )
			{
				if (readbuffer(m_buffer,in)!=2048)
				{
					if (in !=NULL) fclose (in);
					kk++;
					csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS, kk);
					csAux=m_csInputPath+ '\\' +csAux2;
					in=fopen(csAux,"rb");
					if (readbuffer(m_buffer,in)!=2048)
					{
//						MyErrorBox("Error: Reached end of VOB too early");
						if (in !=NULL)  fclose (in);
						i=MAXLOOKFORAUDIO;
					}
				}
				if (bFirstAudio==false && IsAudio(m_buffer) && 
					getAudId (m_buffer)==nId )
				{
					if (m_buffer[0x15] & 0x80) 
					{
						bFirstAudio=true;
						iAudPTS= readpts(&m_buffer[0x17]);
					}
				}
				if (bFirstVideo==false && IsVideo(m_buffer) )
				{
					if (m_buffer[0x15] & 0x80) 
					{
						bFirstVideo=true;
						iVidPTS= readpts(&m_buffer[0x17]);
					}
				}
			}
			if (in !=NULL) fclose(in);
		} // If k==1

	} // For nCell

	if (!bFirstAudio || !bFirstVideo) return 0x7fffffff;

	AudDelay=iAudPTS-iVidPTS;
	if (AudDelay <0)
		AudDelay-=44;
	else
		AudDelay+=44;
	AudDelay/=90;

	return AudDelay;
}


	// Exit Value
int CVobBlankerApp::ExitInstance()
{
	int ret;

	MemoryDeleteAll();
	
	ret= CWinApp::ExitInstance();
	return ret;

}

void CVobBlankerApp::UpdateProgress( CWnd* pDlg, int nPerc)
{
	MSG msg;
	static int oldPerc=-1;

	
	if ( pDlg )
	{
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		if (oldPerc!=nPerc)
		{
			oldPerc=nPerc;
			((CVobBlankerDlg *)pDlg)->UpdateProgress(nPerc);
		}
	}
}

void CVobBlankerApp::UpdateProgressCell( CWnd* pDlg, int nPerc)
{
	MSG msg;
	static int oldPerc=-1;

	
	if ( pDlg )
	{
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		if (oldPerc!=nPerc)
		{
			oldPerc=nPerc;
			((CCellsDlg *)pDlg)->UpdateProgress(nPerc);
		}
	}
}

void CVobBlankerApp::ProcessVob(int nVTS, CWnd* pDlg)
{

	__int64 i64size;
	int k;
	CString csAuxIn,csAux;
	struct  _stati64 statbuf;
	FILE *log;

	m_ACell_list.RemoveAll();
	m_ANavinfo.RemoveAll();
	for (k=0;k<8;k++)
		m_AAudioinfo[k].RemoveAll();
	for (k=0;k<32;k++)
		m_ASubsinfo[k].RemoveAll();

	m_Fin=m_Fout=NULL;
	i64size=0;
	for (k=1; k<10; k++)
	{
		csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS,k);
		csAuxIn=m_csInputPath+'\\'+csAux;
		if (_stati64 ( csAuxIn, &statbuf)==0)
		{
			m_i64VOBsize[k]= statbuf.st_size;
			i64size+=m_i64VOBsize[k];
		}
		else k=20;
	}

// Prepare SimpleVob
// DAR is hacked in MPEG header, but resolution cannot be hacked,
//	it will not work, so different simple Vobs have been created.
// VCD resolution is coded in MPEG-1. All the others are in MPEG-2
// 704x576/480 is only hacked. Probably it does not work.
	FillSimpleVob(SimpleVob,m_iVideoAttr[nVTS]);

	if (((m_iVideoAttr[nVTS] & 0x1000)>>12) == PAL ) m_ticsperframe=3600;
	else m_ticsperframe=3003;

// Calculate Total number of packs.
	m_i64OutputLBA=0;
	m_i64TotalLBA=0;
	m_nVOBIDsInProcess = m_nVOBIDs[nVTS];
	for (k=0; k<m_nPGCs[nVTS];k++)
	{
		m_iFixDuration=0;
		if (m_iAction[nVTS][k]==KEEP )          m_i64TotalLBA+=(m_i64Tisize[nVTS][k]/2048);
		else if (m_iAction[nVTS][k]==BLANK   )  m_i64TotalLBA+=(m_nCells[nVTS][k]*5);
		else if (m_iAction[nVTS][k]==REPLACE )  m_i64TotalLBA+=m_i64Rsize[nVTS][k]/2048;
		else if (m_iAction[nVTS][k]==STRIP   )  m_i64TotalLBA+=m_i64Rsize[nVTS][k]/2048;
		else if (m_iAction[nVTS][k]==CUT     )  m_i64TotalLBA+=m_i64Rsize[nVTS][k]/2048;
		else if (m_iAction[nVTS][k]==CELLBASED) m_i64TotalLBA+=m_i64Rsize[nVTS][k]/2048;
	}
	if( m_i64TotalLBA==0) m_i64TotalLBA=1;

	m_nVobout=1;
	csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobout);
	m_csFout=m_csOutputPath+ '\\' +csAux;
	m_Fout=fopen(m_csFout,"wb");

	csAux.Format(_T("VTS %02d: Processing VOB (Titles)"),nVTS);
	MyLog(csAux);

	m_bFixVobs=false;

	for (k=0; k<m_nPGCs[nVTS] && m_bInProcess==true;k++)
	{
		if (m_iAction[nVTS][k]==KEEP )				TitleKeep(nVTS,k,pDlg);
		else if (m_iAction[nVTS][k]==STRIP )		TitleStrip(nVTS,k,pDlg);
		else if (m_iAction[nVTS][k]==BLANK)			TitleBlank(nVTS,k,pDlg);
		else if (m_iAction[nVTS][k]==REPLACE)		TitleReplace(nVTS,k,pDlg);
		else if (m_iAction[nVTS][k]==CUT)			TitleCut(nVTS,k,pDlg);
		else if (m_iAction[nVTS][k]==CELLBASED)		TitleCellBased(nVTS,k,pDlg);
	}	

	if (m_Fout!=NULL) fclose(m_Fout);
	if (m_Fin !=NULL) fclose(m_Fin);
	m_Fin=m_Fout=NULL;

	if (LOGNAV && m_bLog)
	{
		csAux.Format(_T("C:\\navinfo_%02d_log.txt"),nVTS);

		log=fopen(csAux,"w");
		fprintf (log,"#     LBA     LastLBA   VID/CID Duration Frames   PTS0   PST1\n");
		for (k=0;k<m_ANavinfo.GetSize();k++)
		{
			csAux.Format(_T("%04d %08I64X %08I64X--->%02d %02d %08X %08d %08d %8d"), k,
				m_ANavinfo[k].LBA,m_ANavinfo[k].LastLBA,
				m_ANavinfo[k].VID,m_ANavinfo[k].CID,
				m_ANavinfo[k].dwDuration, m_ANavinfo[k].frames,
				m_ANavinfo[k].iPTS0, m_ANavinfo[k].iPTS1 );
			fprintf (log,"%s\n",csAux);
		}
		fclose(log);
	}


}

void CVobBlankerApp::FV_FixVob(int n, CWnd* pDlg)
{
	int nCells,nNavs;
	int	Vobid,Cellid;
	int i,j,k,kk;
	__int64 iPack, iTotalPacks;
	int nCellsToBeCorrected;
	CString csAux,csAux2;
	__int64 nSectVobout[10];
	int nVobout, newVobout,nFiles;
	struct  _stati64 statbuf;
	__int64 i64sectors;


	for (k=1; k<10; k++)
	{
		csAux2.Format(_T("VTS_%02d_%d.VOB"), n,k);
		csAux=m_csOutputPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
			nSectVobout[k]= statbuf.st_size/2048;
		else 
		{
			nFiles=k-1;
			k=20;
		}
	}

	
	nCells=m_ACell_list.GetSize();
	nNavs=m_ANavinfo.GetSize();
	nCellsToBeCorrected=0;

///////////////////////////////////////////////////////
// Cell Info : Fills m_ACell_list Array
	m_nVOBIDs[n]=FillCellInfo(n);

// Calculate Total number of Nav Packs to be corrected.
	iTotalPacks=0;
	for (i=0; i<nCells; i++)
	{
		if (m_ACell_list[i].bFixPointers)
		{
			nCellsToBeCorrected++;
			iTotalPacks+=m_ACell_list[i].nNavs;
		}
	}
	csAux.Format(_T("VTS %02d: Fixing VOB pointers in %d Cells of %d"),
		          n, nCellsToBeCorrected, nCells);
	MyLog(csAux);


// DO THE JOB
	m_Fout=NULL;
	nVobout=0;

	for (i=0,iPack=0; i<nCells; i++)
	{
		if (m_ACell_list[i].bFixPointers)
		{
			Vobid=m_ACell_list[i].VID;
			Cellid=m_ACell_list[i].CID;
			csAux.Format(_T("     Fixing Cell # %d, VID=%d  CID=%d"),i+1,Vobid,Cellid);
			MyLog(csAux);

//	Copy the Navinfo of the Cell
			m_CellNavinfo.RemoveAll();

			for ( k=0,kk=0 ; k< nNavs ; k++)
			{
				if (Cellid == m_ANavinfo[k].CID &&
						Vobid  == m_ANavinfo[k].VID )
				{
					m_CellNavinfo.SetAtGrow (kk, m_ANavinfo[k]);
					kk++;
				}
			}
			m_nNavsInCell=m_CellNavinfo.GetSize();

// Copy Audio & Subs in Cell info 
			for (j=0;j<8;j++)
			{
  				m_nAudioStream[j]=m_AAudioinfo[j].GetSize();
				m_CellAudioinfo[j].RemoveAll();

				for ( k=0,kk=0 ; k< m_nAudioStream[j] ; k++)
				{
					if (Cellid == m_AAudioinfo[j][k].CID &&
							Vobid  == m_AAudioinfo[j][k].VID )
					{
						m_CellAudioinfo[j].SetAtGrow (kk, m_AAudioinfo[j][k]);
						kk++;
					}
				}
				m_nAudioInCell[j]=m_CellAudioinfo[j].GetSize();
			}

			for (j=0;j<32;j++)
			{
  				m_nSubsStream[j]=m_ASubsinfo[j].GetSize();
				m_CellSubsinfo[j].RemoveAll();

				for ( k=0,kk=0 ; k< m_nSubsStream[j] ; k++)
				{
					if (Cellid == m_ASubsinfo[j][k].CID &&
							Vobid  == m_ASubsinfo[j][k].VID )
					{
						m_CellSubsinfo[j].SetAtGrow (kk, m_ASubsinfo[j][k]);
						kk++;
					}
				}
				m_nSubsInCell[j]=m_CellSubsinfo[j].GetSize();

			}

			for (k=0; k<m_nNavsInCell; k++)
			{
				if ((iPack%MODUPDATEPACK) == 0) UpdateProgress(pDlg, (int)((100*iPack)/iTotalPacks));
				iPack++;

				for (j=1, i64sectors=0; j<=nFiles;j++)
				{
					i64sectors+=nSectVobout[j];
					if (m_CellNavinfo[k].LBA <= i64sectors)
					{
						i64sectors=i64sectors-nSectVobout[j];
						newVobout=j;
						j=20;
					}
					else
						if (j==nFiles)
						{
							csAux.Format(_T("    ERROR: NavPack out of VOB!!"));
							if (m_Fout !=NULL) {fclose(m_Fout); m_Fout=NULL;}
							MyErrorLog_Box(csAux);
							return;
						}

				}
				if (newVobout !=nVobout)
				{
					nVobout=newVobout;
					if (m_Fout !=NULL) {fclose(m_Fout); m_Fout=NULL;}
					csAux.Format(_T("VTS_%02d_%d.VOB"), n, nVobout);
					m_csFout=m_csOutputPath+ '\\' +csAux;
					m_Fout=fopen(m_csFout,"r+b");
				}
// Locate the Pack in the File
				fseek(m_Fout, (long) ((m_CellNavinfo[k].LBA-i64sectors)*2048), SEEK_SET);
				readbuffer(m_buffer,m_Fout);
				fseek(m_Fout, (long) ((m_CellNavinfo[k].LBA-i64sectors)*2048), SEEK_SET);
				if (!IsNav(m_buffer) ||
					m_buffer[0x420]!=(uchar)(Vobid%256) ||
					m_buffer[0x41F]!=(uchar)(Vobid/256) ||
					m_buffer[0x422]!= (uchar) Cellid     )
				{
					csAux.Format(_T("     WARNING: NavPack not found LBA= %I64d"),m_CellNavinfo[k].LBA);
					MyLog (csAux);
					m_nWarnings++;
				}
				else
				{
					FV_FixNavPack(k);
					writebuffer(m_buffer,m_Fout);
				}
			} /* For k (PAcksinCell) */		
		} /* if FixPointers */
	} /* For i (Cells) */

//	Free Audio  & Subs memory (Navs and Cells are used in ProcessIFO)
	for (k=0;k<8 ;k++)
	{
		m_AAudioinfo[k].RemoveAll();
		m_CellAudioinfo[k].RemoveAll();
	}
	for (k=0;k<32 ;k++)
	{
		m_ASubsinfo[k].RemoveAll();
		m_CellSubsinfo[k].RemoveAll();
	}

	if (m_Fout !=NULL) {fclose(m_Fout); m_Fout=NULL;}
}

void CVobBlankerApp::FV_FixNavPack(int n)
{

/*
NavPack is in m_buffer;
n is the index of m_CellNavinfo;
m_CellNavinfo has all required NavInfo of the Cell

typedef struct NAVINFO
{
    __int64 LBA,LastLBA;
    int VID,CID;
	DWORD dwDuration;
	int frames,seconds;
} NAVINFO;

typedef struct CELL_LIST
{
    int VID,CID;
    __int64 i64FirstLBAFirstVOBU, i64FirstLBALastVOBU, i64LastLBALastVOBU;
	DWORD dwDuration;
	bool bFixPointers;
} CELL_LIST;
*/

	int j,nff,nrew;
	int vff, vrew;
	int myPTS0,myPTS1;
	static int timeline[19]={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,
                         20,60,120,240};
	__int64 s,ss,CurrentValue;
	CString csAux;
	int nn,nnn;

//	int id;


// DSI Navigational pointers
	myPTS0= (int) GetNbytes(4,&m_buffer[0x39]);
	myPTS1= (int) GetNbytes(4,&m_buffer[0x3d]);

	Put4bytes(FV_GetSect(n,FV_FindNextVideo(n,1),0,0xbfffffff), &m_buffer[0x4f1]);
	Put4bytes(FV_GetSect(n,n+1,0,0x3fffffff), &m_buffer[0x541]);
	Put4bytes(FV_GetSect(n,n-1,0,0x3fffffff), &m_buffer[0x545]);
	Put4bytes(FV_GetSect(n,FV_FindNextVideo(n,-1),0,0xbfffffff), &m_buffer[0x595]);

	vff=n;
	vrew=n;
	for( j=0; j<19; j++ )
	{
		nff=FV_FindVobu(myPTS0+timeline[j]*45000, 0,m_nNavsInCell-1);
// a hack -- the last vobu in the cell shouldn't have any forward ptrs
		if( n==(m_nNavsInCell-1))
			nff=n+1;
		nrew=FV_FindVobu(myPTS0-timeline[j]*45000,0,m_nNavsInCell-1);

		Put4bytes(FV_GetSect(n,nff,j>=15 && nff>vff+1,0x3fffffff), &m_buffer[0x53d-j*4]);
		Put4bytes(FV_GetSect(n,nrew,j>=15 && nrew<vrew-1,0x3fffffff), &m_buffer[0x549+j*4]);
		vff=nff;
		vrew=nrew;
	}

// Audio pointers
	
	for( j=0; j<8; j++ )
	{
		CurrentValue=GetNbytes(2,&m_buffer[0x599+j*2]);
		if (CurrentValue == 0 )
			s=0;
//		else if (CurrentValue == 0x3fff)
//			s=0x3fff;
		else if (m_nAudioStream[j]==0)
			s=0;
		else
		{
			ss=FV_FindAudSect(j,myPTS0,myPTS1);

			if( ss>=0 )
			{
				s=ss-m_CellNavinfo[n].LBA;
				if( s > 0x1fff || s < -(0x1fff))
				{
					csAux.Format(_T("     WARNING: audio sector out of range: %I64d (LBA #%I64d, pts %d)"),
						             ss,m_CellNavinfo[n].LBA,myPTS0);
					MyLog(csAux);
					m_nWarnings++;
					s=0;
				}
				if( s < 0 )
					s=(-s)|0x8000;
			}
			else
				s=0x3fff;
		}
		Put2bytes(s, &m_buffer[0x599+j*2]);
	}


// Subs pointers. These pointers should point to a Nav Pack, not to  a sub pack
// The Nav pack identifies the VOBU where the sub is located.
	for( j=0; j<32 ; j++ )
	{
		CurrentValue=GetNbytes(4,&m_buffer[0x5a9+j*4]);
		if (CurrentValue == 0 )
			s=0;
		else if (CurrentValue == 0x7fffffff)
			s=0x7fffffff;
		else if (m_nSubsStream[j]==0)
			s=0;
        else
		{
// I do not understand exactly what has to be done. But seems 0x7fffffff is the usual value
// So I will try to find the closest NavPack to the CurrentValue, taking into account
// VOBUs only can be reduced (by a strip)
			if ( CurrentValue & 0x80000000 )
			{ // backward
				ss=m_CellNavinfo[n].LBA-(CurrentValue & 0x7fffffff);
				for (nn=n-1,nnn=n ; nn>=0 ; nn--)
					if ( m_CellNavinfo[nn].LBA >= ss )
						nnn=nn;
					else
						nn=-1;
				if (nnn==n)
					s=0x7fffffff;
				else
					s=(m_CellNavinfo[n].LBA-m_CellNavinfo[nnn].LBA)|0x80000000;

			}
			else
			{  //forward
				ss=m_CellNavinfo[n].LBA+CurrentValue;
				for (nn=n+1,nnn=n ; nn<m_nNavsInCell ; nn++)
					if ( m_CellNavinfo[nn].LBA <= ss )
						nnn=nn;
					else
						nn=m_nNavsInCell;
				if (nnn==n)
					s=0x7fffffff;
				else
					s=m_CellNavinfo[nnn].LBA-m_CellNavinfo[n].LBA;
			}
	
  		}
		Put4bytes(s, &m_buffer[0x5a9+j*4]);
	} 

/*
			id=findspuidx(j,myPTS0);
// if the sup overlaps this VOBU (A), point to A
// else if (A before here or doesn't exist) and (B after here or doesn't exist),point to here
// else point to B

                    if( id>=0 && 
                        ach->audpts[id].pts[0]<vi->sectpts[1] &&
                        ach->audpts[id].pts[1]>=vi->sectpts[0] )
                        s=FV_FindVobubysect(p,ach->audpts[id].sect);
                    else if( (id<0 || ach->audpts[id].pts[1]<vi->sectpts[0]) &&
                             (id+1==ach->numaudpts || ach->audpts[id+1].pts[0]>=vi->sectpts[1]) )
                        s=i;
                    else
                        s=FV_FindVobubysect(p,ach->audpts[id+1].sect);
                    id=(s<i);
                    s=FV_GetSect(p,i,s,0,0x7fffffff)&0x7fffffff;
                    if(!s)
                        s=0x7fffffff;
                    if(s!=0x7fffffff && id)
                        s|=0x80000000;
*/

	// Other pointers
	Put4bytes( m_CellNavinfo[n].LastLBA-m_CellNavinfo[n].LBA, &m_buffer[0x40f]);

}

int CVobBlankerApp::FV_FindVobu(int pts,int l,int h)
{
	int m;

    if( h<l )
        return l-1;
    if( pts<   m_CellNavinfo[l].iPTS0 )
        return l-1;
    if( pts>=  m_CellNavinfo[h].iPTS1 )
        return h+1;
    while(l<h) 
	{
// binary search!
        m=(l+h+1)/2;
        if( pts < m_CellNavinfo[m].iPTS0 )
            h=m-1;
        else
            l=m;
    }
    return l;
}

unsigned int CVobBlankerApp::FV_GetSect(int curvobnum,int jumpvobnum,int skip,unsigned notfound)
{

    int l,h,i;

    if( skip )
	{

        // only set skip bit if one of the VOBU's from here to there contain video
        if( curvobnum<jumpvobnum )
		{
            l=curvobnum+1;
            h=jumpvobnum-1;
        }
		else
		{
            l=jumpvobnum+1;
            h=curvobnum-1;
        }
        for( i=l; i<=h; i++ )
            if( m_CellNavinfo[i].hasvideo )
                break;
        if( i<=h )
            skip=0x40000000;
        else
            skip=0;
    }
    if( jumpvobnum < 0 || jumpvobnum >= m_nNavsInCell )
        return notfound|skip;

    return abs((int)( m_CellNavinfo[jumpvobnum].LBA-m_CellNavinfo[curvobnum].LBA))
        |(m_CellNavinfo[jumpvobnum].hasvideo?0x80000000:0)
        |skip;
}

int CVobBlankerApp::FV_FindNextVideo(int cur, int dir)
{
// find next (dir=1) or previous(dir=-1) vobu with video
    int i;
  
    switch(dir)
	{
    case 1:  // forward
        for(i = cur+1; i < m_nNavsInCell; i++) if(m_CellNavinfo[i].hasvideo) return i;
        return -1;
    case -1: // backward
        for(i = cur-1; i > -1; i--) if(m_CellNavinfo[i].hasvideo) return i;
        return -1;
    default:
        // ??
        return -1;
    }
}

__int64 CVobBlankerApp::FV_FindAudSect(int aind, int pts0, int pts1)
{
    int l,h,m;
	int audpts;

	l=0;
	h=m_nAudioInCell[aind]-1;

	if( h<l )
		return -1;
	while(h>l)
	{
		m=(l+h+1)/2;
		audpts=m_CellAudioinfo[aind][m].iPTS;
		if( pts0 < audpts)
			h=m-1;
		else
			l=m;
	}
	audpts=m_CellAudioinfo[aind][l].iPTS;
	if( audpts > pts1 )
		return -1;
	return m_CellAudioinfo[aind][l].LBA;
}


void CVobBlankerApp::TitleCellBased(int nVTS,int nT, CWnd* pDlg)
{
	int i, nCell,k;
	CString csAux;
	bool bAlready;
	CELL_LIST myCell_list;
	int CellId,VobId, OldCellId, OldVobId;
	int iArraysize;
	__int64 i64,i64CellLBA;
	struct  _stati64 statbuf;
	DWORD dwVOBUDuration;
	bool bWarning;


//  Loop cell by cell 

	csAux.Format(_T("VTS %02d: Cell Based PGC %02d"),nVTS,nT+1);
    MyLog(csAux);

	for (nCell=0; nCell<m_nCells[nVTS][nT] ;nCell++)
	{
		CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4+3];
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4]);

// Check if CID+VID has been already processed.
		iArraysize=m_ACell_list.GetSize();
		for (i=0, bAlready=false; i<iArraysize; i++)
		{
			if (m_ACell_list[i].CID == CellId &&
				m_ACell_list[i].VID == VobId)
				bAlready=true;
		}
		if (bAlready==false)
		{
// Record every CID+VID processed.
			myCell_list.CID=CellId;
			myCell_list.VID=VobId;
			myCell_list.bFixPointers=false;
			m_ACell_list.SetAtGrow(iArraysize,myCell_list);
		}

		m_iFixDuration=0;

		switch (m_csCellBased[nVTS][nT][nCell])
		{
		case 'R':
			csAux.Format(_T("     Replacing Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
			MyLog(csAux);

			for (i=0, m_csFin.Empty() ; i< m_ACell_replace.GetSize() && m_csFin.IsEmpty(); i++)
			{
				if (m_ACell_replace[i].VID==VobId && 
					m_ACell_replace[i].CID==CellId &&
					m_ACell_replace[i].nVTS==nVTS &&
					m_ACell_replace[i].iDomain==TITLES)
					m_csFin=m_ACell_replace[i].csPath;
			}
			m_Fin=NULL;
			if (! (m_csFin.IsEmpty()) )  m_Fin=fopen(m_csFin,"rb");

			if (m_Fin ==NULL)
			{
				MyErrorLog_Box("Error opening input VOB: "+m_csFin);
				m_bInProcess=false;
				return;
			}
			if (bAlready)
			{
				m_nVOBIDsInProcess++;
				myCell_list.CID=1;
				myCell_list.VID=m_nVOBIDsInProcess;
				myCell_list.bFixPointers=false;
				m_ACell_list.SetAtGrow(iArraysize,myCell_list);

				VobId=m_nVOBIDsInProcess;
				CellId=1;
			}
			if (_stati64 ( m_csFin, &statbuf)==0)
				i64CellLBA=statbuf.st_size/2048;

			OldCellId=OldVobId=-1;
			bWarning=false;

// Seems compatible with ADDOFFDURATION....
			if (m_bCheckElapsed) m_iFixDuration=GETOFFDURATION;

			for (i64=0 ; i64<i64CellLBA && m_bInProcess==true ; i64++)
			{
				if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA));
				if (readbuffer(m_buffer,m_Fin)!=2048)
				{
					MyErrorLog_Box("Input error: Reached end of VOB too early");
					m_bInProcess=false;
					return;
				}
				if (IsSynch(m_buffer) != true)
				{
					MyErrorLog_Box("Error reading input VOB: Unsynchronized");
					m_bInProcess=false;
					return;
				}

				if (m_bInProcess==true)
				{
					if (IsNav(m_buffer))
					{
						if (OldVobId==-1)
						{
							OldVobId=GetNbytes(2,&m_buffer[0x41F]);
							OldCellId=m_buffer[0x422];
						}
						else
						{
							if (OldVobId!=GetNbytes(2,&m_buffer[0x41F]) || 
								OldCellId!=m_buffer[0x422])
							{
							// A new Cell has been detected
								OldVobId=GetNbytes(2,&m_buffer[0x41F]);
								OldCellId=m_buffer[0x422];
								if (!bWarning)
								{
									bWarning=true;
									MyLog("     WARNING: Number of Cells in replacing VOB higher than one. Continuing with same cell VID/CID");
									m_nWarnings++;
								}
								k=m_ANavinfo.GetSize()-1;
								if (k>=0)
								{
									m_iFixDuration=ADDOFFDURATION;
									m_dwOffDuration=m_ANavinfo[k].dwDuration;
									dwVOBUDuration=(m_ANavinfo[k].iPTS1-m_ANavinfo[k].iPTS0)/(m_ticsperframe);
									dwVOBUDuration=Dec2BCD(dwVOBUDuration);
									dwVOBUDuration=dwVOBUDuration|(m_dwOffDuration & 0xc0);
									m_dwOffDuration=AddDuration(m_dwOffDuration,dwVOBUDuration);
								}
							}
						}

						ModifyCID (m_buffer,VobId, CellId);
						ModifyLBA (m_buffer,m_i64OutputLBA);
						CleanILV(m_buffer);
					}
				WritePack(m_buffer,nVTS);
				}
			}
			if (m_Fin !=NULL) { fclose(m_Fin); m_Fin=NULL;}
			break;
		case 'B':
			if (bAlready)
			{
				m_nVOBIDsInProcess++;
				myCell_list.CID=1;
				myCell_list.VID=m_nVOBIDsInProcess;
				myCell_list.bFixPointers=false;
				m_ACell_list.SetAtGrow(iArraysize,myCell_list);

				VobId=m_nVOBIDsInProcess;
				CellId=1;
			}
			OutputBlankCell(nVTS, VobId, CellId);
			csAux.Format(_T("     Blanking Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
			MyLog(csAux);

			break;
		case 'K':
		default:
			if (bAlready)
			{
				csAux.Format(_T("     Skiping already processed cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
			}
			else
			{
				csAux.Format(_T("     Keeping Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
				TitleCellKeep(nVTS, nT, nCell, pDlg);
			}
			break;
		}
	}
}

void CVobBlankerApp::TitleCellKeep(int nVTS,int nT, int nCell, CWnd* pDlg)
{

	int k;
	__int64 i64sectors, i64IniSec,i64EndSec,i64;
	CString csAux;
	int iArraysize;
	bool bMyCell;
	int VobId,CellId;

//  Output a new CID+VID
//  Locate the cell
	VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+4*nCell]);
	CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+3+4*nCell];
	i64sectors=0;
	i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
	i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
	for (k=1;k<10;k++)
	{
		i64sectors+=(m_i64VOBsize[k]/2048);
		if (i64IniSec<i64sectors)
		{
			i64sectors-=(m_i64VOBsize[k]/2048);
			m_nVobin=k;
			k=20;
		}
	}
	csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}
	fseek(m_Fin, (long) ((i64IniSec-i64sectors)*2048), SEEK_SET);

	for (i64=0,bMyCell=true;i64< (i64EndSec-i64IniSec+1) && m_bInProcess==true;i64++)
	{
	//readpack
		if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA));
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			if (m_Fin!=NULL) fclose (m_Fin);
			m_nVobin++;
			csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
			m_csFin=m_csInputPath+ '\\' +csAux;
			m_Fin=fopen(m_csFin,"rb");
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				m_bInProcess=false;
				return;
			}
		}
		if (IsSynch(m_buffer) != true)
		{
			MyErrorLog_Box("Error reading input VOB: Unsynchronized");
			m_bInProcess=false;
			return;
		}
		if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				if (m_buffer[0x420]==(uchar)(VobId%256) &&
					m_buffer[0x41F]==(uchar)(VobId/256) &&
					m_buffer[0x422]== (uchar) CellId)
					bMyCell=true;
				else
					bMyCell=false;
				if (bMyCell)
				{
					ModifyLBA (m_buffer,m_i64OutputLBA);
					CleanILV(m_buffer);
					WritePack (m_buffer,nVTS);
				}
			}
			else
			{
				if (bMyCell)	WritePack (m_buffer,nVTS);
			}
		}
	}
	if (m_Fin!=NULL) fclose (m_Fin);
	m_Fin=NULL;


// Mark Cell with FV_FixVobPointers if required
// Check ILV flag
	if (m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell] & 0x04 )
	{
		m_bFixVobs=true;
		iArraysize=m_ACell_list.GetSize();
		m_ACell_list[iArraysize-1].bFixPointers=true;
	}
}

void CVobBlankerApp::TitleKeep(int nVTS,int nT, CWnd* pDlg)
{
	int i,nCell;
	int CellId, VobId;
//	int k;
//	__int64 i64sectors, i64IniSec,i64EndSec,i64;
//	bool bMyCell;
	CString csAux;
	bool bAlready;
	CELL_LIST myCell_list;
	int iArraysize;

//  Loop cell by cell 

	csAux.Format(_T("VTS %02d: Keeping PGC %02d"),nVTS,nT+1);
    MyLog(csAux);

	m_iFixDuration=0;

	for (nCell=0; nCell<m_nCells[nVTS][nT] ;nCell++)
	{
		CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4+3];
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4]);

// Check if CID+VID has been already processed.
		iArraysize=m_ACell_list.GetSize();
		for (i=0, bAlready=false; i<iArraysize; i++)
		{
			if (m_ACell_list[i].CID == CellId &&
				m_ACell_list[i].VID == VobId)
				bAlready=true;
		}
		if (bAlready==false)
		{
// Record every CID+VID processed.
			myCell_list.CID=CellId;
			myCell_list.VID=VobId;
			myCell_list.bFixPointers=false;
			m_ACell_list.SetAtGrow(iArraysize,myCell_list);

			TitleCellKeep(nVTS, nT, nCell, pDlg);
		}  //if bAlready 
	}
}

void CVobBlankerApp::OutputBlankCell(int nVTS,int VobId,int CellId)
{
	int i,j;
	
	for (i=0;i<5; i++)
	{
		for (j=0; j< 2048; j++)
		{
			m_buffer[j]=SimpleVob[i*2048+j];
		}
		if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				ModifyLBA (m_buffer,m_i64OutputLBA);
				ModifyCID (m_buffer,VobId, CellId);
			}
			WritePack(m_buffer,nVTS);
		}
	}
}

void CVobBlankerApp::TitleCut(int nVTS,int nT, CWnd* pDlg)
{
	int i,k,nCell;
	int CellId, VobId;
	__int64 i64sectors, i64IniSec,i64EndSec,i64, i64OutputLBAini;
	CString csAux;
	bool bAlready,bAlreadyNav;
	CELL_LIST myCell_list;
	int iArraysize;
	int IniLba,EndLba,IniCell,EndCell,iAction;
	bool	bSecondPart;
	bool bMyCell;


	csAux.Format(_T("VTS %02d: Cutting PGC %02d"),nVTS,nT+1);
	MyLog(csAux);

	iAction=m_CutInfo[nVTS][nT].iAction;
	IniCell=m_CutInfo[nVTS][nT].iIniCell;
	IniLba= m_CutInfo[nVTS][nT].iIniLba;
	EndCell=m_CutInfo[nVTS][nT].iEndCell;
	EndLba= m_CutInfo[nVTS][nT].iEndLba;
	if (IniCell <0) IniCell=1;
	if (EndCell <0) EndCell=m_nCells[nVTS][nT];
	if (IniLba <0)  IniLba=0;
	if (EndLba <0) 
	{
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*m_nCells[nVTS][nT]+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*m_nCells[nVTS][nT]+0x14]);
		EndLba= (int)(i64EndSec-i64IniSec+1) ;
	}

	bSecondPart=false;

//  Loop cell by cell 

	for (nCell=0; nCell<m_nCells[nVTS][nT] ;nCell++)
	{
		CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4+3];
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4]);
		m_iFixDuration=0;

// Check if CID+VID has been already processed.
		iArraysize=m_ACell_list.GetSize();
		for (i=0, bAlready=false; i<iArraysize; i++)
		{
			if (m_ACell_list[i].CID == CellId &&
				m_ACell_list[i].VID == VobId)
				bAlready=true;
		}
		if ( bSecondPart==true ) bAlready=false;

		i64OutputLBAini=m_i64OutputLBA;

		if (bAlready==false )
		{
// Record every CID+VID processed.
			if ( bSecondPart==false )
			{
				myCell_list.CID=CellId;
				myCell_list.VID=VobId;
				myCell_list.bFixPointers=false;
				m_ACell_list.SetAtGrow(iArraysize,myCell_list);
			}

			if (((nCell < IniCell || nCell > EndCell) && iAction==0 ) ||
				((nCell > IniCell && nCell < EndCell) && iAction!=0 ) ) 
			// Blank Cell
				OutputBlankCell(nVTS,VobId, CellId);

			else
			// Process Cell
			{

				if (((nCell > IniCell && nCell < EndCell) && iAction==0) ||
					((nCell < IniCell || nCell > EndCell) && iAction!=0) )
				{
					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
				}
				else
				{
// Mark the Cell to be adjusted TODO: Check if the Cell is complete. In this case no adjustments are needed
					m_bFixVobs=true;
					iArraysize=m_ACell_list.GetSize();
					m_ACell_list[iArraysize-1].bFixPointers=true;
				}
				if (nCell == IniCell && iAction==0)
				{
					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64IniSec+=IniLba;
					i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64EndSec < i64IniSec) i64IniSec=i64EndSec;
					m_iFixDuration=GETOFFDURATION;
				}
				if (nCell == EndCell && iAction==0)
				{
					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec=i64IniSec+EndLba;
					if ( i64EndSec > GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]))
						i64EndSec = GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
				}
				if (nCell == IniCell && nCell == EndCell && iAction==0)
				{
					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec= i64IniSec+EndLba;
					i64IniSec+=IniLba;
					if ( i64EndSec > GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]))
						i64EndSec = GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64EndSec < i64IniSec) i64IniSec=i64EndSec;
					m_iFixDuration=GETOFFDURATION;
				}


				if (nCell == IniCell && iAction!=0)
				{
					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec=i64IniSec+IniLba-1;
					if (i64EndSec > GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]))
					   i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
				}
				if (nCell == EndCell && iAction!=0)
				{
					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64IniSec+=EndLba;
					i64EndSec = GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64EndSec < i64IniSec) i64IniSec=i64EndSec;
					m_iFixDuration=GETOFFDURATION;
				}

				if (nCell == IniCell && nCell == EndCell && iAction!=0)
				{
// In this case we have to keep two parts of the Cell.To keep the code as it is
// I am adding a bool to do a nCell-- at the end;
// Part One. From start to Start mark
					if (bSecondPart==false)
					{
						i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
						i64EndSec= i64IniSec+IniLba-1;
						if ( i64EndSec > GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]))
							i64EndSec = GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
						bSecondPart=true;
						m_iFixDuration=SAVEOFFDURATION;
					}
					else
// Part Two. From End mark to End 
					{
						i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
						i64IniSec= i64IniSec+EndLba;
						i64EndSec= GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
						if (i64EndSec < i64IniSec) i64IniSec=i64EndSec;
						bSecondPart=false;
						m_iFixDuration=CALCULATE_FIXOFFDURATION;
					}
				}

//  Output a new CID+VID
//  Locate the cell
				i64sectors=0;
				for (k=1;k<10;k++)
				{
					i64sectors+=(m_i64VOBsize[k]/2048);
					if (i64IniSec<i64sectors)
					{
						i64sectors-=(m_i64VOBsize[k]/2048);
						m_nVobin=k;
						k=20;
					}
				}
				csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
				m_csFin=m_csInputPath+ '\\' +csAux;
				m_Fin=fopen(m_csFin,"rb");
				if (m_Fin ==NULL)
				{
					MyErrorLog_Box("Error opening input VOB: "+m_csFin);
					m_bInProcess=false;
					return;
				}

				fseek(m_Fin, (long) ((i64IniSec-i64sectors)*2048), SEEK_SET);

	// Guarantee to start with a Nav Pack
				bAlreadyNav=false;
		
				for (i64=0,bMyCell=true;i64< (i64EndSec-i64IniSec+1) && i64EndSec!=i64IniSec && m_bInProcess==true;i64++)
				{
	//readpack
					if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA));
					if (readbuffer(m_buffer,m_Fin)!=2048)
					{
						if (m_Fin!=NULL) fclose (m_Fin);
						m_nVobin++;
						csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
						m_csFin=m_csInputPath+ '\\' +csAux;
						m_Fin=fopen(m_csFin,"rb");
	
						if (readbuffer(m_buffer,m_Fin)!=2048)
						{
							MyErrorLog_Box("Input error: Reached end of VOB too early");
							m_bInProcess=false;
							return;
						}
					}
					if (IsSynch(m_buffer) != true)
					{
						MyErrorLog_Box("Error reading input VOB: Unsynchronized");
						m_bInProcess=false;
						return;
					}

					if (m_bInProcess==true)
					{
						if (IsNav(m_buffer))
						{
							if (m_buffer[0x420]==(uchar)(VobId%256) &&
								m_buffer[0x41F]==(uchar)(VobId/256) &&
								m_buffer[0x422]== (uchar) CellId)
								bMyCell=true;
							else
								bMyCell=false;

							if (bMyCell)
							{
								ModifyLBA (m_buffer,m_i64OutputLBA);
								bAlreadyNav=true;
								WritePack (m_buffer,nVTS);
							}
						}
						else
						{
							if (bMyCell && bAlreadyNav)	WritePack (m_buffer,nVTS);
						}
					}
				}
				if (m_Fin!=NULL) fclose (m_Fin);
				m_Fin=NULL;
			}/* else Process Cell */
			if (i64OutputLBAini==m_i64OutputLBA)
				OutputBlankCell(nVTS,VobId, CellId);

// Mark Cell with FV_FixVobPointers if required
// Check ILV flag
			if (m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell] & 0x04 )
			{
				m_bFixVobs=true;
				iArraysize=m_ACell_list.GetSize();
				m_ACell_list[iArraysize-1].bFixPointers=true;
			}
		} /* if bAlready */	
		if (bSecondPart==true) 
			nCell--;
	} /* for*/
}


void CVobBlankerApp::TitleStrip(int nVTS,int nT, CWnd* pDlg)
{
	int i,j,k,nCell;
	int CellId, VobId;
	__int64 i64sectors, i64IniSec,i64EndSec,i64;
	CString csAux;
	bool bAlready;
	CELL_LIST myCell_list;
	int iArraysize;
	bool   bKeepAud;
	int nA;
	int ilastpack;
	__int64 i64aux,i64auxp1,i64auxp2,i64auxp3,i64auxp4;

//  Loop cell by cell 
	csAux.Format(_T("VTS %02d: Stripping PGC %02d"),nVTS,nT+1);
	MyLog(csAux);

	m_iFixDuration=0;

	for (nCell=0; nCell<m_nCells[nVTS][nT] ;nCell++)
	{
		CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4+3];
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4]);

// Check if CID+VID has been already processed.
		iArraysize=m_ACell_list.GetSize();
		for (i=0, bAlready=false; i<iArraysize; i++)
		{
			if (m_ACell_list[i].CID == CellId &&
				m_ACell_list[i].VID == VobId)
				bAlready=true;
		}
		if (bAlready==false)
		{
			m_bFixVobs=true;
// Record every CID+VID processed.
			myCell_list.CID=CellId;
			myCell_list.VID=VobId;
			myCell_list.bFixPointers=true;
			m_ACell_list.SetAtGrow(iArraysize,myCell_list);

//  Output a new CID+VID
//  Locate the cell
			i64sectors=0;
			i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
			i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
			for (k=1;k<10;k++)
			{
				i64sectors+=(m_i64VOBsize[k]/2048);
				if (i64IniSec<i64sectors)
				{
					i64sectors-=(m_i64VOBsize[k]/2048);
					m_nVobin=k;
					k=20;
				}
			}
			csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
			m_csFin=m_csInputPath+ '\\' +csAux;
			m_Fin=fopen(m_csFin,"rb");
			if (m_Fin ==NULL)
			{
				MyErrorLog_Box("Error opening input VOB: "+m_csFin);
				m_bInProcess=false;
				return;
			}

			fseek(m_Fin, (long) ((i64IniSec-i64sectors)*2048), SEEK_SET);

			ilastpack=0;
			for (i64=0;i64< (i64EndSec-i64IniSec+1) && m_bInProcess==true;i64+=(ilastpack+1))
			{

//				if ((i64%MODUPDATE) == 0)
				UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA));

	//readVOBU
				if (readbuffer(m_buffer,m_Fin)!=2048)
				{
					if (m_Fin!=NULL) fclose (m_Fin);
					m_nVobin++;
					csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
					m_csFin=m_csInputPath+ '\\' +csAux;
					m_Fin=fopen(m_csFin,"rb");
					if (readbuffer(m_buffer,m_Fin)!=2048)
					{
						MyErrorLog_Box("Input error: Reached end of VOB too early");
						m_bInProcess=false;
						return;
					}
				}
				if (IsSynch(m_buffer) != true)
				{
					MyErrorLog_Box("Error reading input VOB: Unsynchronized");
					m_bInProcess=false;
					return;
				}
				if (!IsNav(m_buffer))
				{
					MyErrorLog_Box("Input error: Not found a nav pack where it should be");
					m_bInProcess=false;
					return;
				}

				ilastpack= GetNbytes(4,&m_buffer[0x40f]);
				if (ilastpack >= MAXPACKSPERVOBU-1 )
				{
					MyErrorLog_Box("Input error: VOBU too large");
					m_bInProcess=false;
					return;
				}

				for (j=1 ; j<ilastpack+1 && m_bInProcess; j++)
				{
					if (readbuffer(&m_buffer[2048*j],m_Fin)!=2048)
					{
						if (m_Fin!=NULL) fclose (m_Fin);
						m_nVobin++;
						csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
						m_csFin=m_csInputPath+ '\\' +csAux;
						m_Fin=fopen(m_csFin,"rb");

						if (readbuffer(&m_buffer[2048*j],m_Fin)!=2048)
						{
							MyErrorLog_Box("Input error: Reached end of VOB too early");
							m_bInProcess=false;
							return;
						}
						if (IsSynch(&m_buffer[2048*j]) != true)
						{
							MyErrorLog_Box("Error reading input VOB: Unsynchronized");
							m_bInProcess=false;
							return;
						}
					}
				}
//Adjust Nav pointers
				i64auxp1=GetNbytes(4,&m_buffer[0x40f]);
				i64auxp2=GetNbytes(4,&m_buffer[0x413]);
				i64auxp3=GetNbytes(4,&m_buffer[0x417]);
				i64auxp4=GetNbytes(4,&m_buffer[0x41B]);

				for (j=1 ; j<ilastpack+1 && m_bInProcess; j++)
				{
					if (IsAudio(&m_buffer[2048*j]) )
					{
						bKeepAud=true;
						for (nA=0; nA<m_nAudio[nVTS] && bKeepAud ;nA++)
							 if ( m_bIdTAudioStrip[nVTS][nA][nT]==true &&
									getAudId(&m_buffer[2048*j]) == m_iIdTAudio[nVTS][nA][nT])
							bKeepAud=false;

						if (!bKeepAud)
						{
							i64aux=GetNbytes(4,&m_buffer[0x40f]);
							if ( j< i64auxp1+1)
								Put4bytes( i64aux-1, &m_buffer[0x40f]);
							i64aux=GetNbytes(4,&m_buffer[0x413]);
							if ( j< i64auxp2+1)
								Put4bytes( i64aux-1, &m_buffer[0x413]);
							i64aux=GetNbytes(4,&m_buffer[0x417]);
							if ( j< i64auxp3+1)
								Put4bytes( i64aux-1, &m_buffer[0x417]);
							i64aux=GetNbytes(4,&m_buffer[0x41B]);
							if ( j< i64auxp4+1)
								Put4bytes( i64aux-1, &m_buffer[0x41B]);
						}
					}
				}
//Write VOBU
				for (j=0 ; j<ilastpack+1 && m_bInProcess; j++)
				{
					if (IsNav(&m_buffer[2048*j]))
					{
						ModifyLBA (&m_buffer[2048*j],m_i64OutputLBA);
						WritePack(&m_buffer[2048*j],nVTS);
					}
					else if (IsAudio(&m_buffer[2048*j]) )
					{
						bKeepAud=true;
						for (nA=0; nA<m_nAudio[nVTS] && bKeepAud ;nA++)
							 if ( m_bIdTAudioStrip[nVTS][nA][nT]==true &&
									getAudId(&m_buffer[2048*j]) == m_iIdTAudio[nVTS][nA][nT])
							bKeepAud=false;

						if (bKeepAud) 
							WritePack(&m_buffer[2048*j],nVTS);
					}
					else
						WritePack(&m_buffer[2048*j],nVTS);
				}

			}
			if (m_Fin!=NULL) fclose (m_Fin);
			m_Fin=NULL;
		}
	}
}


void CVobBlankerApp::TitleReplace(int nVTS,int nT, CWnd* pDlg)
{

	__int64 i64,i64TitleLBA;
	int Vobid,Cellid,LastCellid,LastVobid,nCell;
	CString csAux,csAux1;
	CELL_LIST myCell_list;
	int iArraysize;
	int i,j,k;
	bool bAlready,bWarning;
	int CellsToBeReplaced;
	int CellIndex[1024];
	DWORD dwVOBUDuration;


// VOB should contains one and only one Title with the SAME number of cells
	csAux.Format(_T("VTS %02d: Replacing PGC %02d by %s"),nVTS,nT+1,m_csReplace[nVTS][nT]);
	MyLog(csAux);

	m_nVobin=1;

	csAux1=m_csReplace[nVTS][nT];
	csAux=csAux1.Left(csAux1.GetLength()-5);
	csAux1.Format(_T("%d.VOB"),m_nVobin);
	m_csFin=csAux+csAux1;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}


// Detect how many Cells should be replaced and store them in CellIndex
	for (nCell=CellsToBeReplaced=0; nCell<m_nCells[nVTS][nT]; nCell++)
	{
		Cellid=m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4+3];
		Vobid=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4]);

	// Check if CID+VID has been already processed.
		iArraysize=m_ACell_list.GetSize();
		for (i=0, bAlready=false; i<iArraysize; i++)
		{
			if (m_ACell_list[i].CID == Cellid &&
				m_ACell_list[i].VID == Vobid)
				bAlready=true;
		}
		if (bAlready==false) 
		{
			CellIndex[CellsToBeReplaced]=nCell;
			CellsToBeReplaced++;
		}
	}

	csAux.Format(_T("     Cells to be replaced=%d"),CellsToBeReplaced);
	MyLog(csAux);

	LastCellid=LastVobid=-1;
	i64TitleLBA=m_i64Rsize[nVTS][nT]/2048;
	bWarning=false;

	m_iFixDuration=0;

	for (nCell=0,i64=0 ; i64<i64TitleLBA && m_bInProcess==true ; i64++)
	{
// Seems compatible with ADDOFFDURATION...if (m_bCheckElapsed) m_iFixDuration=GETOFFDURATION;
	//readpack
		if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA));
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			m_nVobin++;
			csAux1=m_csReplace[nVTS][nT];
			csAux=csAux1.Left(csAux1.GetLength()-5);
			csAux1.Format(_T("%d.VOB"),m_nVobin);
			m_csFin=csAux+csAux1;
			m_Fin=fopen(m_csFin,"rb");
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				m_bInProcess=false;
				return;
			}
		}
		if (IsSynch(m_buffer) != true)
		{
			MyErrorLog_Box("Error reading input VOB: Unsynchronized");
			m_bInProcess=false;
			return;
		}

		if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				Cellid=m_buffer[0x422];
				Vobid=m_buffer[0x41F]*256+m_buffer[0x420];

				if (Cellid!=LastCellid || Vobid!=LastVobid)
				{
					if( nCell>= CellsToBeReplaced)
					{
						if (!bWarning)
						{
							MyLog("     WARNING: Number of Cells higher than original. Continuing with same cell VID/CID");
							m_nWarnings++;
						}
						nCell--;
						bWarning=true;

						k=m_ANavinfo.GetSize()-1;
						if (k>=0)
						{
							m_iFixDuration=ADDOFFDURATION;

							m_dwOffDuration=m_ANavinfo[k].dwDuration;
							dwVOBUDuration=(m_ANavinfo[k].iPTS1-m_ANavinfo[k].iPTS0)/(m_ticsperframe);
							dwVOBUDuration=Dec2BCD(dwVOBUDuration);
							dwVOBUDuration=dwVOBUDuration|(m_dwOffDuration & 0xc0);
							m_dwOffDuration=AddDuration(m_dwOffDuration,dwVOBUDuration);
						}
					}
					nCell++;
					LastVobid=Vobid;
					LastCellid=Cellid;

					Cellid=m_pIFO[nVTS][m_C_POST[nVTS][nT]+(CellIndex[nCell-1])*4+3];
					Vobid=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+(CellIndex[nCell-1])*4]);
					csAux.Format(_T("     Replacing Cell # %d, VID=%d  CID=%d"),nCell+1,Vobid,Cellid);
					MyLog(csAux);

				}


				Cellid=m_pIFO[nVTS][m_C_POST[nVTS][nT]+(CellIndex[nCell-1])*4+3];
				Vobid=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+(CellIndex[nCell-1])*4]);


// Check if CID+VID has been already processed. (Not really needed)
				iArraysize=m_ACell_list.GetSize();
				for (i=0, bAlready=false; i<iArraysize; i++)
				{
					if (m_ACell_list[i].CID == Cellid &&
						m_ACell_list[i].VID == Vobid)
						bAlready=true;
				}
				if (bAlready==false)
				{
// Record every CID+VID processed.
					myCell_list.CID=Cellid;
					myCell_list.VID=Vobid;
					myCell_list.bFixPointers=false;
					m_ACell_list.SetAtGrow(iArraysize,myCell_list);
				}

				ModifyCID (m_buffer,Vobid, Cellid);
				ModifyLBA (m_buffer,m_i64OutputLBA);
				CleanILV(m_buffer);
			}
			WritePack(m_buffer,nVTS);
		}
	}
	if(m_bInProcess==true && nCell!=CellsToBeReplaced)
	{
		m_nWarnings++;
		MyLog("    WARNING: Number of Cells lower than original. Continuing with blank cells");

		while (nCell < CellsToBeReplaced )
		{
			nCell++;
			Cellid=m_pIFO[nVTS][m_C_POST[nVTS][nT]+(CellIndex[nCell-1])*4+3];
			Vobid=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+(CellIndex[nCell-1])*4]);
			csAux.Format(_T("     Outputing blank Cell # %d, VID=%d  CID=%d"),nCell+1,Vobid,Cellid);
			MyLog(csAux);


// Output a new CID+VID
// Record every CID+VID processed.
			iArraysize=m_ACell_list.GetSize();
			myCell_list.CID=Cellid;
			myCell_list.VID=Vobid;
			myCell_list.bFixPointers=false;
			m_ACell_list.SetAtGrow(iArraysize,myCell_list);
			for (i=0;i<5; i++)
			{
				for (j=0; j< 2048; j++)
				{
					m_buffer[j]=SimpleVob[i*2048+j];
				}
				if (m_bInProcess==true)
				{
					if (IsNav(m_buffer))
					{
						ModifyLBA (m_buffer,m_i64OutputLBA);
						ModifyCID (m_buffer,Vobid, Cellid);
					}
					WritePack(m_buffer,nVTS);
				}
			}
		}
	}
	if (m_Fin!=NULL) fclose (m_Fin);
	m_Fin=NULL;

}


void CVobBlankerApp::TitleBlank(int nVTS,int nT, CWnd* pDlg)
{
	int i,j,nCell;
	int CellId, VobId;
	bool bAlready;
	CELL_LIST myCell_list;
	int iArraysize;
	CString csAux;

	csAux.Format(_T("VTS %02d: Blanking PGC %02d"),nVTS,nT+1);
	MyLog(csAux);

	m_iFixDuration=0;

	for (nCell=0; nCell<m_nCells[nVTS][nT] ;nCell++)
	{
		CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4+3];
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4]);

// Check if CID+VID has been already processed.
		iArraysize=m_ACell_list.GetSize();
		for (i=0, bAlready=false; i<iArraysize; i++)
		{
			if (m_ACell_list[i].CID == CellId &&
				m_ACell_list[i].VID == VobId)
				bAlready=true;
		}
		if (bAlready==false)
		{
// Record every CID+VID processed.
			myCell_list.CID=CellId;
			myCell_list.VID=VobId;
			myCell_list.bFixPointers=false;
			m_ACell_list.SetAtGrow(iArraysize,myCell_list);

// Output a new CID+VID
			for (i=0;i<5; i++)
			{
				for (j=0; j< 2048; j++)
				{
					m_buffer[j]=SimpleVob[i*2048+j];
				}
				if (m_bInProcess==true)
				{
					if (IsNav(m_buffer))
					{
						ModifyLBA (m_buffer,m_i64OutputLBA);
						ModifyCID (m_buffer,VobId, CellId);
					}
					WritePack(m_buffer,nVTS);
				}
			}
		} /* if bAlready */
	} /* for */
}


void CVobBlankerApp::WritePack(uchar* buffer,int nVTS)
{
	CString csAux;
	NAVINFO myNavinfo;
	AUDIOINFO myAudioinfo;
	SUBSINFO mySubsinfo;
//	int hh,mm,ss,ff,hor,min,sec,fra,fps;
	int iArraysize;
	static int VobId=0;
	static int CellId=0;
	int streamID;
	DWORD dwVOBUDuration;

	if (m_bInProcess==true)
	{
		if (m_i64OutputLBA!=0 && ((m_i64OutputLBA)%(512*1024-1))==0 && nVTS!=0)
		{
			if (m_Fout!=NULL) fclose(m_Fout);
			m_nVobout++;
			csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobout);
			m_csFout=m_csOutputPath+ '\\' +csAux;
			m_Fout=fopen(m_csFout,"wb");
		}

		if (IsNav(buffer)) 
		{
			myNavinfo.LastLBA=m_i64OutputLBA;
			myNavinfo.LBA=m_i64OutputLBA;
			myNavinfo.CID=buffer[0x422];
			myNavinfo.VID=buffer[0x41F]*256+buffer[0x420];
			myNavinfo.dwDuration=GetNbytes(4,&buffer[0x45]);
			myNavinfo.hasvideo=false;
			myNavinfo.iPTS0= (int) GetNbytes(4,&buffer[0x39]);
			myNavinfo.iPTS1= (int) GetNbytes(4,&buffer[0x3d]);

			VobId=myNavinfo.VID;
			CellId=myNavinfo.CID;

// CODE RELATED WITH REPLACING TITLES: FIXING ELAPSED TIME
			if (m_iFixDuration==ADDOFFDURATION)
				myNavinfo.dwDuration=AddDuration(myNavinfo.dwDuration,m_dwOffDuration);

// CODE RELATED WITH CUTING TITLES: FIXING ELAPSED TIME
			if (m_iFixDuration==FIXOFFDURATION)
				myNavinfo.dwDuration=SubDuration(myNavinfo.dwDuration,m_dwOffDuration);

			if (m_iFixDuration==GETOFFDURATION)
			{
				m_dwOffDuration=myNavinfo.dwDuration;
				myNavinfo.dwDuration=myNavinfo.dwDuration & 0xc0;
				m_iFixDuration=FIXOFFDURATION;
			}
			if (m_iFixDuration==SAVEOFFDURATION)
			{
				m_dwOffDuration=myNavinfo.dwDuration;
				dwVOBUDuration=(myNavinfo.iPTS1-myNavinfo.iPTS0)/(m_ticsperframe);
				dwVOBUDuration=Dec2BCD(dwVOBUDuration);
				dwVOBUDuration=dwVOBUDuration|(m_dwOffDuration & 0xc0);
				m_dwOffDuration=AddDuration(m_dwOffDuration,dwVOBUDuration);
			}

			if (m_iFixDuration==CALCULATE_FIXOFFDURATION)
			{
				m_dwOffDuration=SubDuration(myNavinfo.dwDuration,m_dwOffDuration);
				myNavinfo.dwDuration=SubDuration(myNavinfo.dwDuration,m_dwOffDuration);
				m_iFixDuration=FIXOFFDURATION;
			}

//////////////////////////////////

			myNavinfo.frames=DurationInFrames(myNavinfo.dwDuration);
			myNavinfo.seconds=DurationInSecs(myNavinfo.dwDuration);

			iArraysize=m_ANavinfo.GetSize();
			m_ANavinfo.SetAtGrow(iArraysize,myNavinfo);

			if (m_bCheckVobPuops) ModifyPUOPS(buffer);	
			if (m_iFixDuration) 
			{
				Put4bytes(myNavinfo.dwDuration,&buffer[0x45]);
				Put4bytes(myNavinfo.dwDuration,&buffer[0x423]);
			}
		}

		if (IsAudio(buffer)) 
		{
			myAudioinfo.LBA=m_i64OutputLBA;
			myAudioinfo.CID=CellId;
			myAudioinfo.VID=VobId;
			streamID=buffer[0x17+buffer[0x16]];
			if (buffer[0x15] & 0x80) 
				myAudioinfo.iPTS= readpts(&buffer[0x17]);
			else
				myAudioinfo.iPTS=0;
			iArraysize=m_AAudioinfo[streamID & 0x07].GetSize();
			m_AAudioinfo[streamID & 0x07].SetAtGrow(iArraysize,myAudioinfo);
		}

		if (IsSubs(buffer)) 
		{
			mySubsinfo.LBA=m_i64OutputLBA;
			mySubsinfo.CID=CellId;
			mySubsinfo.VID=VobId;
			streamID=buffer[0x17+buffer[0x16]];
			if (buffer[0x15]&0x80) 
				mySubsinfo.iPTS= readpts(&buffer[0x17]);
			else
				mySubsinfo.iPTS=0;
			iArraysize=m_ASubsinfo[streamID & 0x1F].GetSize();
			m_ASubsinfo[streamID & 0x1F].SetAtGrow(iArraysize,mySubsinfo);
		}


		iArraysize=m_ANavinfo.GetSize();
		if (iArraysize >0) 
			m_ANavinfo[iArraysize-1].LastLBA=m_i64OutputLBA;
		if (IsVideo(buffer))
			m_ANavinfo[iArraysize-1].hasvideo=true;
		writebuffer(buffer,m_Fout);
		m_i64OutputLBA++;
		m_i64GranTotalCurr++;
	}

}

void CVobBlankerApp::ProcessMenu(int nVTS, CWnd* pDlg)
{
	int k;
	__int64 i64size;
	CString csAuxIn,csAux;
	struct  _stati64 statbuf;
	int iVideoAttr;

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Processing VOB (Menus)"));
	else
		csAux.Format(_T("VTS %02d: Processing VOB (Menus)"),nVTS);
	MyLog(csAux);

	m_Fin=m_Fout=NULL;
	i64size=0;

	if (nVTS!=0)
		csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
	else
		csAux.Format(_T("VIDEO_TS.VOB"));

	csAuxIn=m_csInputPath+'\\'+csAux;
	if (_stati64 ( csAuxIn, &statbuf)==0)
		i64size= statbuf.st_size;
	else return;

		
	iVideoAttr=m_pIFO[nVTS][0x100]*256+m_pIFO[nVTS][0x101];

	FillSimpleVob(SimpleVob,iVideoAttr);

	if (((iVideoAttr & 0x1000)>>12) == PAL ) m_ticsperframe=3600;
	else m_ticsperframe=3003;

	m_ACell_list.RemoveAll();
	m_ANavinfo.RemoveAll();

// Calculate Total number of packs.
	m_i64OutputLBA=0;
	m_i64TotalLBA=0;
	m_nVOBIDsInProcess = m_nMVOBIDs[nVTS];
	for (k=0; k<m_nMPGCs[nVTS];k++)
	{
		if (m_iMAction[nVTS][k]==KEEP )         m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
		else if (m_iMAction[nVTS][k]==BLANK  )  m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
		else if (m_iMAction[nVTS][k]==DELPBK )  m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
		else if (m_iMAction[nVTS][k]==CELLBASED )  m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
		else if (m_iMAction[nVTS][k]==ZERO    )  m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
		else if (m_iMAction[nVTS][k]==REUSE   )  m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
	}
	if( m_i64TotalLBA==0) m_i64TotalLBA=1;

	if (nVTS!=0)
		csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
	else
		csAux.Format(_T("VIDEO_TS.VOB"));

	m_csFout=m_csOutputPath+ '\\' +csAux;
	m_Fout=fopen(m_csFout,"wb");
/*
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
*/
	for (k=0; k<m_nMPGCs[nVTS] && m_bInProcess==true;k++)
	{
		m_iFixDuration=0;
		if (m_iMAction[nVTS][k]==KEEP )				MenuKeep(nVTS,k,pDlg);
		else if (m_iMAction[nVTS][k]==BLANK )		MenuBlank(nVTS,k,pDlg);
		else if (m_iMAction[nVTS][k]==DELPBK)		MenuDelpbk(nVTS,k,pDlg);
		else if (m_iMAction[nVTS][k]==CELLBASED)	MenuCellBased(nVTS,k,pDlg);
		else if (m_iMAction[nVTS][k]==ZERO)			MenuZero(nVTS,k,pDlg);
		else if (m_iMAction[nVTS][k]==REUSE)		MenuReuse(nVTS,k,pDlg);
	}	

	if (m_Fout!=NULL) fclose(m_Fout);
	if (m_Fin !=NULL) fclose(m_Fin);
	m_Fin=m_Fout=NULL;

	i64size=0;
	if (_stati64 ( m_csFout, &statbuf)==0)
		i64size= statbuf.st_size;

	if (i64size==0)
	{
		if (nVTS==0)
			csAux.Format(_T("VIDEO_TS: Menu final size= 0. Deleting menu."));
		else
			csAux.Format(_T("VTS %02d: Menu final size= 0. Deleting menu."),nVTS);
		MyLog(csAux);
		DeleteFile(m_csFout);
	}
}

void CVobBlankerApp::MenuKeep(int nVTS,int nT, CWnd* pDlg)
{
	int i,nCell;
	int CellId, VobId;
//	int k;
//	__int64 i64sectors, i64IniSec,i64EndSec,i64;
//	bool bMyCell;
	CString csAux;
	bool bAlready;
	CELL_LIST myCell_list;
	int iArraysize;
	int nLU,nPGC;

	nLU=m_nLU_MPGC[nVTS][nT];
	nPGC=nT-m_nIniPGCinLU[nVTS][nLU];

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Keeping Menu LU %02d, PGC %02d"),nLU+1,nPGC+1);
	else
		csAux.Format(_T("VTS %02d: Keeping Menu LU %02d, PGC %02d"),nVTS,nLU+1,nPGC+1);
    MyLog(csAux);


//  Loop cell by cell 
	m_iFixDuration=0;

	for (nCell=0; nCell<m_nMCells[nVTS][nT] ;nCell++)
	{
		CellId=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+nCell*4+3];
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+nCell*4]);
// Check if CID+VID has been already processed.
		iArraysize=m_ACell_list.GetSize();
		for (i=0, bAlready=false; i<iArraysize; i++)
		{
			if (m_ACell_list[i].CID == CellId &&
				m_ACell_list[i].VID == VobId)
				bAlready=true;
		}
		if (bAlready==false)
		{
// Record every CID+VID processed.
			myCell_list.CID=CellId;
			myCell_list.VID=VobId;
			myCell_list.bFixPointers=false;
			m_ACell_list.SetAtGrow(iArraysize,myCell_list);

			MenuCellKeep(nVTS, nT, nCell, pDlg);
		}  //if bAlready 
	}
}

void CVobBlankerApp::MenuCellKeep(int nVTS,int nT, int nCell, CWnd* pDlg)
{
	__int64 i64sectors, i64IniSec,i64EndSec,i64;
	CString csAux;
	bool bMyCell;
	int VobId,CellId;

//  Output a new CID+VID
//  Locate the cell
	i64sectors=0;
	i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+8]);
	i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]);
	VobId=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+4*nCell]);
	CellId=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+3+4*nCell];

	if (nVTS==0)
		csAux="VIDEO_TS.VOB";
	else
		csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	if (m_Fin ==NULL)  
	{
		MyErrorLog_Box("Error opening input Menu VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}
	fseek(m_Fin, (long) ((i64IniSec-i64sectors)*2048), SEEK_SET);

	for (i64=0,bMyCell=true;i64< (i64EndSec-i64IniSec+1) && m_bInProcess==true;i64++)
	{
	//readpack
		if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA));
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			MyErrorLog_Box("Input error: Reached end of VOB too early");
			m_bInProcess=false;
			return;
		}
		if (IsSynch(m_buffer) != true)
		{
			MyErrorLog_Box("Error reading input VOB: Unsynchronized");
			m_bInProcess=false;
			return;
		}
		if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				if (m_buffer[0x420]==(uchar)(VobId%256) &&
					m_buffer[0x41F]==(uchar)(VobId/256) &&
					m_buffer[0x422]== (uchar) CellId)
					bMyCell=true;
				else
					bMyCell=false;
				if (bMyCell)
				{
					ModifyLBA (m_buffer,m_i64OutputLBA);
					CleanILV(m_buffer);
					WritePack (m_buffer,0);
				}
			}
			else
			{
				if (bMyCell)	WritePack (m_buffer,0);
			}
		}
	}
	if (m_Fin !=NULL) fclose (m_Fin); 

// Mark Cell with FV_FixVobPointers if required
// Check ILV flag
//	if (m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell] & 0x04 )
//	{
//		m_bFixVobs=true;
//		iArraysize=m_ACell_list.GetSize();
//		m_ACell_list[iArraysize-1].bFixPointers=true;
//	}
}

void CVobBlankerApp::MenuDelpbk(int nVTS,int nT, CWnd* pDlg)
{
	CString csAux;
	int nLU,nPGC;

	nLU=m_nLU_MPGC[nVTS][nT];
	nPGC=nT-m_nIniPGCinLU[nVTS][nLU];

	if(nVTS==0)
		csAux.Format(_T("VIDEO_TS: Deleting PBK Menu LU %02d, PGC %02d"),nLU+1,nPGC+1);
	else
		csAux.Format(_T("VTS %02d: Deleting PBK Menu LU %02d, PGC %02d"),nVTS,nLU+1,nPGC+1);
    MyLog(csAux);

	m_nMCells[nVTS][nT]=0;
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+3]=0;
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+2]=0; // Programs

	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE6]=0; // offset to program map
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE6+1]=0; 
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE8]=0; // offset to playback
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE8+1]=0; 
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xEA]=0; // offset to position
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xEA+1]=0; 

	m_nMFirstVID[nVTS][nT]=0;
	m_dwMDuration[nVTS][nT]=(m_dwMDuration[nVTS][nT] & 0x000000C0);
	Put4bytes((__int64) m_dwMDuration[nVTS][nT],&m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+4]);
}

void CVobBlankerApp::MenuZero(int nVTS,int nT, CWnd* pDlg)
{
	// Nothing to do.
}
void CVobBlankerApp::MenuCellBased(int nVTS,int nT, CWnd* pDlg)
{
	int i, nCell,k;
	CString csAux;
	bool bAlready;
	CELL_LIST myCell_list;
	int CellId,VobId,OldVobId,OldCellId;
	int iArraysize;
	__int64 i64,i64CellLBA;
	struct  _stati64 statbuf;
	int nLU,nPGC;
	DWORD dwVOBUDuration;
	bool bWarning;


	nLU=m_nLU_MPGC[nVTS][nT];
	nPGC=nT-m_nIniPGCinLU[nVTS][nLU];

	if(nVTS==0)
		csAux.Format(_T("VIDEO_TS: Cell Based Menu LU %02d, PGC %02d"),nLU+1,nPGC+1);
	else
		csAux.Format(_T("VTS %02d: Cell Based Menu LU %02d, PGC %02d"),nVTS,nLU+1,nPGC+1);
    MyLog(csAux);

	for (nCell=0; nCell<m_nMCells[nVTS][nT] ;nCell++)
	{
		CellId=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+nCell*4+3];
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+nCell*4]);

// Check if CID+VID has been already processed.
		iArraysize=m_ACell_list.GetSize();
		for (i=0, bAlready=false; i<iArraysize; i++)
		{
			if (m_ACell_list[i].CID == CellId &&
				m_ACell_list[i].VID == VobId)
				bAlready=true;
		}
		if (bAlready==false)
		{
// Record every CID+VID processed.
			myCell_list.CID=CellId;
			myCell_list.VID=VobId;
			myCell_list.bFixPointers=false;
			m_ACell_list.SetAtGrow(iArraysize,myCell_list);
		}

		m_iFixDuration=0;

		switch (m_csMCellBased[nVTS][nT][nCell])
		{
		case 'R':
			csAux.Format(_T("     Replacing Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
			MyLog(csAux);

			for (i=0, m_csFin.Empty() ; i< m_ACell_replace.GetSize() && m_csFin.IsEmpty(); i++)
			{
				if (m_ACell_replace[i].VID==VobId && 
					m_ACell_replace[i].CID==CellId &&
					m_ACell_replace[i].nVTS==nVTS &&
					m_ACell_replace[i].iDomain==MENUS)
					m_csFin=m_ACell_replace[i].csPath;
			}
			m_Fin=NULL;
			if (! (m_csFin.IsEmpty()) )  m_Fin=fopen(m_csFin,"rb");

			if (m_Fin ==NULL)
			{
				MyErrorLog_Box("Error opening input VOB: " + m_csFin);
				m_bInProcess=false;
				return;
			}
			if (bAlready)
			{
				m_nVOBIDsInProcess++;
				myCell_list.CID=1;
				myCell_list.VID=m_nVOBIDsInProcess;
				myCell_list.bFixPointers=false;
				m_ACell_list.SetAtGrow(iArraysize,myCell_list);

				VobId=m_nVOBIDsInProcess;
				CellId=1;
			}

			if (_stati64 ( m_csFin, &statbuf)==0)
				i64CellLBA=statbuf.st_size/2048;

			OldCellId=OldVobId=-1;		
			bWarning=false;

			// Seems compatible with ADDOFFDURATION...
			if (m_bCheckElapsed) m_iFixDuration=GETOFFDURATION;

			for (i64=0 ; i64<i64CellLBA && m_bInProcess==true ; i64++)
			{
				if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA));
				if (readbuffer(m_buffer,m_Fin)!=2048)
				{
					MyErrorLog_Box("Input error: Reached end of VOB too early");
					m_bInProcess=false;
					if (m_Fin !=NULL) { fclose(m_Fin); m_Fin=NULL;}
					return;
				}
				if (IsSynch(m_buffer) != true)
				{
					MyErrorLog_Box("Error reading input VOB: Unsynchronized");
					m_bInProcess=false;
					if (m_Fin !=NULL) { fclose(m_Fin); m_Fin=NULL;}
					return;
				}

				if (m_bInProcess==true)
				{
					if (IsNav(m_buffer))
					{
						if (OldVobId==-1)
						{
							OldVobId=GetNbytes(2,&m_buffer[0x41F]);
							OldCellId=m_buffer[0x422];
						}
						else
						{
							if (OldVobId!=GetNbytes(2,&m_buffer[0x41F]) || 
								OldCellId!=m_buffer[0x422])
							{
							// A new Cell has been detected
								OldVobId=GetNbytes(2,&m_buffer[0x41F]);
								OldCellId=m_buffer[0x422];
								if (!bWarning)
								{
									bWarning=true;
									MyLog("     WARNING: Number of Cells in replacing VOB higher than one. Continuing with same cell VID/CID");
									m_nWarnings++;
								}

								k=m_ANavinfo.GetSize()-1;
								if (k>=0)
								{
									m_iFixDuration=ADDOFFDURATION;
									m_dwOffDuration=m_ANavinfo[k].dwDuration;
									dwVOBUDuration=(m_ANavinfo[k].iPTS1-m_ANavinfo[k].iPTS0)/(m_ticsperframe);
									dwVOBUDuration=Dec2BCD(dwVOBUDuration);
									dwVOBUDuration=dwVOBUDuration|(m_dwOffDuration & 0xc0);
									m_dwOffDuration=AddDuration(m_dwOffDuration,dwVOBUDuration);
								}
							}
						}

						ModifyCID (m_buffer,VobId, CellId);
						ModifyLBA (m_buffer,m_i64OutputLBA);
						CleanILV(m_buffer);
					}
				WritePack(m_buffer,0);
				}
			}
			if (m_Fin !=NULL) { fclose(m_Fin); m_Fin=NULL;}
			break;
		case 'B':
			if (bAlready)
			{
				m_nVOBIDsInProcess++;
				myCell_list.CID=1;
				myCell_list.VID=m_nVOBIDsInProcess;
				myCell_list.bFixPointers=false;
				m_ACell_list.SetAtGrow(iArraysize,myCell_list);

				VobId=m_nVOBIDsInProcess;
				CellId=1;
			}
			OutputBlankCell(0, VobId, CellId);
			csAux.Format(_T("     Blanking Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
			MyLog(csAux);

			break;
		case 'K':
		default:
			if (bAlready)
			{
				csAux.Format(_T("     Skiping already processed cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
			}
			else
			{
				csAux.Format(_T("     Keeping Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
				MenuCellKeep(nVTS, nT, nCell, pDlg);
			}
			break;
		}
	}}
void CVobBlankerApp::MenuBlank(int nVTS,int nT, CWnd* pDlg)
{
	CString csAux;
	int nLU,nPGC;
	int i,j,nCell;
	int CellId, VobId;
	bool bAlready;
	CELL_LIST myCell_list;
	int iArraysize;

	nLU=m_nLU_MPGC[nVTS][nT];
	nPGC=nT-m_nIniPGCinLU[nVTS][nLU];

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Blanking Menu LU %02d, PGC %02d"),nLU+1,nPGC+1);
	else
		csAux.Format(_T("VTS %02d: Blanking Menu LU %02d, PGC %02d"),nVTS,nLU+1,nPGC+1);
    MyLog(csAux);

	m_iFixDuration=0;

	for (nCell=0; nCell<m_nMCells[nVTS][nT] ;nCell++)
	{
		CellId=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+nCell*4+3];
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+nCell*4]);

// Check if CID+VID has been already processed.
		iArraysize=m_ACell_list.GetSize();
		for (i=0, bAlready=false; i<iArraysize; i++)
		{
			if (m_ACell_list[i].CID == CellId &&
				m_ACell_list[i].VID == VobId)
				bAlready=true;
		}
		if (bAlready==false)
		{
// Record every CID+VID processed.
			myCell_list.CID=CellId;
			myCell_list.VID=VobId;
			myCell_list.bFixPointers=false;
			m_ACell_list.SetAtGrow(iArraysize,myCell_list);

// Output a new CID+VID
			for (i=0;i<5; i++)
			{
				for (j=0; j< 2048; j++)
				{
					m_buffer[j]=SimpleVob[i*2048+j];
				}
				if (m_bInProcess==true)
				{
					if (IsNav(m_buffer))
					{
						ModifyLBA (m_buffer,m_i64OutputLBA);
						ModifyCID (m_buffer,VobId, CellId);
					}
					WritePack(m_buffer,0);
				}
			}
		} /* if bAlready */
	} /* for */
}

void CVobBlankerApp::MenuReuse(int nVTS,int nT, CWnd* pDlg)
{
	CString csAux;
	int i;
	int nLU,nPGC,nLUR;
	int nnT;
	int nCell,VobId,CellId;
	int iArraysize;
	bool bAlready;
	CELL_LIST myCell_list;


	nLU=m_nLU_MPGC[nVTS][nT];
	nPGC=nT-m_nIniPGCinLU[nVTS][nLU];
	nLUR=m_iReuseLU[nVTS][nT];
	nnT=m_nIniPGCinLU[nVTS][nLUR]+nPGC;

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Menu LU %02d, PGC %02d, reusing from LU %02d"),nLU+1,nPGC+1,nLUR+1);
	else
		csAux.Format(_T("VTS %02d: Menu LU %02d, PGC %02d, reusing from LU %02d"),nVTS,nLU+1,nPGC+1,nLUR+1);
    MyLog(csAux);

//  Loop cell by cell 
	m_iFixDuration=0;

	for (nCell=0; nCell<m_nMCells[nVTS][nnT] ;nCell++)
	{
		CellId=m_pIFO[nVTS][m_M_C_POST[nVTS][nnT]+nCell*4+3];
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nnT]+nCell*4]);
// Check if CID+VID has been already processed.
		iArraysize=m_ACell_list.GetSize();
		for (i=0, bAlready=false; i<iArraysize; i++)
		{
			if (m_ACell_list[i].CID == CellId &&
				m_ACell_list[i].VID == VobId)
				bAlready=true;
		}
		if (bAlready==false)
		{
// Record every CID+VID processed.
			myCell_list.CID=CellId;
			myCell_list.VID=VobId;
			myCell_list.bFixPointers=false;
			m_ACell_list.SetAtGrow(iArraysize,myCell_list);

			MenuCellKeep(nVTS, nnT, nCell, pDlg);
		}  //if bAlready 
	}
}

///CODE RELATED WITH IFO PROCESSING
uchar* pIFO;

void CVobBlankerApp::ProcessIfoVTSPrepare(int nVTS, CWnd* pDlg)
{
	CString csAux;
	int i;

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Opening IFO"),nVTS);
	else
		csAux.Format(_T("VTS %02d: Opening IFO"),nVTS);
	MyLog(csAux);

	pIFO= new uchar[MAXLENGTH];
	for (i=0;i<m_i64IFOlen[nVTS];i++)
		pIFO[i]=m_pIFO[nVTS][i];

	m_MenuDiscountSectors[nVTS]=0;
}

void CVobBlankerApp::ProcessIfoVTSMenu(int nVTS, CWnd* pDlg)
{
	int iACells,iANavs,nVOBIDs;
	int iVideoAttr,iFormat;
	CString csAux;
	int nT, nCell, CellId,VobId;
	int nLU,nLUR,nPGC,nnT;
	int k;
	DWORD dwDuration,dwPGCDuration;
	int Maxbyte,Nsec;
	int nADTSectors,IniADTSectors;
	int nADMAPSectors,IniADMAPSectors;
	int iOffset,iPointer;
	int iRet;
	int nA;

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Processing IFO (Menu)"));
	else
		csAux.Format(_T("VTS %02d: Processing IFO (Menu)"),nVTS);
	MyLog(csAux);

	iACells=m_ACell_list.GetSize();
	iANavs=m_ANavinfo.GetSize();
///////////////////////////////////////////////////////
// Cell Info 
	m_nVOBIDsInProcess = m_nMVOBIDs[nVTS]; //FillCellInfo returns the actual nVOBIDs

	nVOBIDs = FillCellInfo(nVTS);
///////////////////////////////////////////////////////
// Cell & Menu PGCs loop
	iVideoAttr=m_pIFO[nVTS][0x100]*256+m_pIFO[nVTS][0x101];
	iFormat=(iVideoAttr & 0x1000) >> 12;

	csAux.Format(_T("     Looping into Menu PGCs and cells"));
	MyLog(csAux);

	for (nT=0;nT<m_nMPGCs[nVTS];nT++)
	{
		if (iFormat==NTSC)
			dwPGCDuration=0xC0;
		else
			dwPGCDuration=0x40;
		nnT=nT;
		if (m_iMAction[nVTS][nT]==REUSE )
		{
			nLU=m_nLU_MPGC[nVTS][nT];
			nPGC=nT-m_nIniPGCinLU[nVTS][nLU];
			nLUR=m_iReuseLU[nVTS][nT];
			nnT=m_nIniPGCinLU[nVTS][nLUR]+nPGC;	
		}
		for (nCell=0;nCell<m_nMCells[nVTS][nT];nCell++)
		{
			// Use the same order and algorithm to generate new VOBids...
			if  (m_iMAction[nVTS][nT]==CELLBASED && 
				(m_csMCellBased[nVTS][nT][nCell]=='B' ||
				 m_csMCellBased[nVTS][nT][nCell]=='R' ) &&
				 IsReused(MENUS, nVTS,nT,nCell) )
			{
				m_nVOBIDsInProcess++;
				CellId=1;
				VobId=m_nVOBIDsInProcess;
				pIFO[m_M_C_POST[nVTS][nT]+nCell*4+3]=CellId;
				Put2bytes( VobId, &pIFO[m_M_C_POST[nVTS][nT]+nCell*4]);

			}
			CellId=pIFO[m_M_C_POST[nVTS][nnT]+nCell*4+3];
			VobId=GetNbytes(2,&pIFO[m_M_C_POST[nVTS][nnT]+nCell*4]);

			Put2bytes(VobId,&pIFO[m_M_C_POST[nVTS][nT]+nCell*4]);
			pIFO[m_M_C_POST[nVTS][nT]+nCell*4+3]=CellId;

// PGC PBKT Cell Headers manipulations: Cell Still Time
			if  (  ( m_iMAction[nVTS][nT]==CELLBASED && 
				     m_csMCellBased[nVTS][nT][nCell]=='B') ||
				 m_iMAction[nVTS][nT]==BLANK ) 
			{
			// Reset to Zero Cell still time.
				pIFO[m_M_C_PBKT[nVTS][nT]+nCell*24+2]=0;
			}

// PGC PBKT Cell Headers manipulations: STC Discontinuity
			if  (  ( m_iMAction[nVTS][nT]==CELLBASED && 
				     (m_csMCellBased[nVTS][nT][nCell]=='B' || m_csMCellBased[nVTS][nT][nCell]=='R' ))
					 ||	 m_iMAction[nVTS][nT]==BLANK ) 
			{
			// Mark as STC Discontinuity this and the following cells.
				pIFO[m_M_C_PBKT[nVTS][nT]+nCell*24] = 0x02 ;
				if ( (nCell+1) <m_nMCells[nVTS][nT])
					pIFO[m_M_C_PBKT[nVTS][nT]+(nCell+1)*24] = 0x02 ;
			}

			for (k=0; k< iACells; k++)
			{
				if (VobId==m_ACell_list[k].VID && CellId==m_ACell_list[k].CID)
				{
// Clear ILV Flags
					Put4bytes(0,  &pIFO[m_M_C_PBKT[nVTS][nT]+nCell*24+0x0C]);
					pIFO[m_M_C_PBKT[nVTS][nT]+nCell*24]=pIFO[m_M_C_PBKT[nVTS][nnT]+nCell*24] & 0xFB;
// Copy Cells Info
					if (m_ACell_list[k].i64FirstLBAFirstVOBU != -1)
						Put4bytes(m_ACell_list[k].i64FirstLBAFirstVOBU,  &pIFO[m_M_C_PBKT[nVTS][nT]+nCell*24+8]);
					if (m_ACell_list[k].i64FirstLBALastVOBU != -1)
						Put4bytes(m_ACell_list[k].i64FirstLBALastVOBU,  &pIFO[m_M_C_PBKT[nVTS][nT]+nCell*24+0x10]);
					if (m_ACell_list[k].i64LastLBALastVOBU != -1)
						Put4bytes(m_ACell_list[k].i64LastLBALastVOBU,  &pIFO[m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					dwDuration=m_ACell_list[k].dwDuration;
					if (dwDuration != -1)
					{
						if (dwDuration==0x40 || (dwDuration==0 && iFormat==PAL))
							dwDuration=0x12+0x40;
						if (dwDuration==0x0c0 || (dwDuration==0 && iFormat==NTSC ) ) 
							dwDuration=0x0c0+0x15;
						Put4bytes(dwDuration,  &pIFO[m_M_C_PBKT[nVTS][nT]+nCell*24+4]);
						dwPGCDuration= AddDuration(dwDuration,dwPGCDuration);
					}
					k=iACells;
				}
			}

		} /* For Cells */
		Put4bytes(dwPGCDuration, &pIFO[m_MENU_PGC[nVTS][nT]+4]);
// May be Delete playback has modified m_pIFO
		pIFO[m_MENU_PGC[nVTS][nT]+3]=     m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+3];
		pIFO[m_MENU_PGC[nVTS][nT]+2]=     m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+2]; 
		pIFO[m_MENU_PGC[nVTS][nT]+0xE6]=  m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE6]; 
		pIFO[m_MENU_PGC[nVTS][nT]+0xE6+1]=m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE6+1]; 
		pIFO[m_MENU_PGC[nVTS][nT]+0xE8]=  m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE8]; 
		pIFO[m_MENU_PGC[nVTS][nT]+0xE8+1]=m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE8+1]; 
		pIFO[m_MENU_PGC[nVTS][nT]+0xEA]=  m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xEA]; 
		pIFO[m_MENU_PGC[nVTS][nT]+0xEA+1]=m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xEA+1]; 

// Clear audio/sub status and PGC still time if blanking
		if (m_iMAction[nVTS][nT]==BLANK)
		{
			for (nA=0;nA<8;nA++)
			{
				pIFO[m_MENU_PGC[nVTS][nT]+nA*2+0x0c]=0;
				pIFO[m_MENU_PGC[nVTS][nT]+nA*2+0x0c+1]=0;
			}
			for (nA=0;nA<32;nA++)
			{
				pIFO[m_MENU_PGC[nVTS][nT]+nA*4+0x1c]=0;
				pIFO[m_MENU_PGC[nVTS][nT]+nA*4+0x1c+1]=0;
				pIFO[m_MENU_PGC[nVTS][nT]+nA*4+0x1c+2]=0;
				pIFO[m_MENU_PGC[nVTS][nT]+nA*4+0x1c+3]=0;
			}
			pIFO[m_MENU_PGC[nVTS][nT]+0xA3]=0;
		}

// Change Post into precommands

		if ( m_bCheckPostPre && m_iMAction[nVTS][nT]==BLANK && m_M_PGC_COMM[nVTS][nT]!=0 )
// Action is blanking, table exists and checbox acive)
		{
			iRet=ChangePostIntoPre(MENUS,nVTS,nT);
			if (iRet>=0)  {m_nPostPre++; m_nActualPostPre++;}
			if (iRet==-2)  m_nPostPre++;
		}
	} /* for PGCs */

/////////////////////////////////////////////////////
// VTS_C_ADT : Total reconstruction of this table;
	if (m_VTSM_C_ADT[nVTS]==0)
	{
		csAux.Format(_T("     VTSM_C_ADT table did not exist"));
		MyLog(csAux);
		nADTSectors= 0; 
		IniADTSectors=0;
	}
	else
	{
		IniADTSectors=GetNbytes(4,&pIFO[m_VTSM_C_ADT[nVTS]+4]);
		IniADTSectors=IniADTSectors/2048+1;
		if (iACells==0)
		{
			csAux.Format(_T("     VTSM_C_ADT table has been deleted"));
			MyLog(csAux);
			nADTSectors= 0;
			Put4bytes(0,&pIFO[0xD8]);
//			m_VTSM_C_ADT[nVTS]=0;
			nADTSectors= 0;
		}
		else
		{
			csAux.Format(_T("     Building VTSM_C_ADT table"));
			MyLog(csAux);


			pIFO[m_VTSM_C_ADT[nVTS]+0]=nVOBIDs/256;
			pIFO[m_VTSM_C_ADT[nVTS]+1]=nVOBIDs%256;
			pIFO[m_VTSM_C_ADT[nVTS]+2]=0;
			pIFO[m_VTSM_C_ADT[nVTS]+3]=0;
			Put4bytes( iACells*12+7 ,&pIFO[m_VTSM_C_ADT[nVTS]+4]);
			for (k=0;k<iACells;k++)
			{
				pIFO[m_VTSM_C_ADT[nVTS]+8+12*k  ]=m_ACell_list[k].VID/256;
				pIFO[m_VTSM_C_ADT[nVTS]+8+12*k+1]=m_ACell_list[k].VID%256;
				pIFO[m_VTSM_C_ADT[nVTS]+8+12*k+2]=m_ACell_list[k].CID;
				pIFO[m_VTSM_C_ADT[nVTS]+8+12*k+3]=0;

				if (m_ACell_list[k].i64FirstLBAFirstVOBU != -1)
						Put4bytes(m_ACell_list[k].i64FirstLBAFirstVOBU, &pIFO[m_VTSM_C_ADT[nVTS]+8+12*k+4]);
				if (m_ACell_list[k].i64LastLBALastVOBU != -1)
						Put4bytes(m_ACell_list[k].i64LastLBALastVOBU,&pIFO[m_VTSM_C_ADT[nVTS]+8+12*k+8]);

			}

			nADTSectors= (iACells*12+7)/2048 +1; 
		}
	}

///////////////////////////////////////////////////////
// VTSM_VOBU_ADMAP
// DO NOT REDUCE OR GROW IFOS BY THE MOMENT
	
	if (m_VTSM_VOBU_ADMAP[nVTS]==0)
	{
		csAux.Format(_T("     VTSM_VOBU_ADMAP table did not exist"));
		MyLog(csAux);
		IniADMAPSectors=0;
		nADMAPSectors=0;
		Maxbyte=-1;
	}
	else
	{
		IniADMAPSectors=GetNbytes(4,&pIFO[m_VTSM_VOBU_ADMAP[nVTS]]);
		IniADMAPSectors=IniADMAPSectors/2048+1;
		if (iANavs==0)
		{
			csAux.Format(_T("     VTSM_VOBU_ADMAP table has been deleted"));
			MyLog(csAux);
//			m_VTSM_VOBU_ADMAP[nVTS]=0;
			Put4bytes(0,&pIFO[0xDC]);
			nADMAPSectors=0;
			Maxbyte=-1;
		}
		else
		{
			csAux.Format(_T("     Filling VTSM_VOBU_ADMAP table"));
			MyLog(csAux);
			Maxbyte = iANavs*4+3;
			Nsec= Maxbyte/2048+1;
		
			for ( k=0 ; k<iANavs ; k++)
				Put4bytes(m_ANavinfo[k].LBA,&pIFO[m_VTSM_VOBU_ADMAP[nVTS]+4+4*k]);

			Put4bytes(Maxbyte,&pIFO[m_VTSM_VOBU_ADMAP[nVTS]]);
			nADMAPSectors=Maxbyte;
			nADMAPSectors=nADMAPSectors/2048+1;
		}
	}

// Correct 	m_VTSM_VOBU_ADMAP (may be ADT table has been reduced)

	if (nADTSectors<IniADTSectors)
	{
		if (nADMAPSectors)
		{
			iOffset=(IniADTSectors-nADTSectors)*2048;
			for (k=0;k <=Maxbyte; k++)
				pIFO[m_VTSM_VOBU_ADMAP[nVTS]-iOffset+k]=pIFO[m_VTSM_VOBU_ADMAP[nVTS]+k];
			iPointer=GetNbytes(4, &pIFO[0xDC]);
			Put4bytes(iPointer-(IniADTSectors-nADTSectors),&pIFO[0xDC]) ; // Pointer to ADMAP_MENU
		}
	}

	m_MenuDiscountSectors[nVTS]=(IniADTSectors-nADTSectors) + (IniADMAPSectors-nADMAPSectors);
	if (nVTS==0)
		m_i64IFOlen[0]-=(m_MenuDiscountSectors[nVTS]*2048);
}


void CVobBlankerApp::ProcessIfoVTSTitle(int nVTS, CWnd* pDlg)
{
	int k, Maxbyte, Nsec;
	int	iACells,iANavs;
	int nT,nCell;
	int nA;
	CString csAux,csFout;
	int CellId,VobId;
	DWORD dwDuration, dwPGCDuration;
	int iFormat;
	int nADTSectors, IniADTSectors, nADMAPSectors, IniADMAPSectors, nADTBytes;
	int iOffset,iPointer;
	CString csAux2;
	int nVOBIDs;
	int iRet;
	int	iAction,IniCell,EndCell;

	csAux.Format(_T("VTS %02d: Processing IFO (Titles)"),nVTS);
	MyLog(csAux);

	iACells=m_ACell_list.GetSize();
	iANavs=m_ANavinfo.GetSize();

///////////////////////////////////////////////////////
// Cell Info 
	m_nVOBIDsInProcess = m_nVOBIDs[nVTS]; //FillCellInfo returns the actual nVOBIDs

	nVOBIDs=FillCellInfo(nVTS);
///////////////////////////////////////////////////////
// Cell & Title PGCs loop
	iFormat=(m_iVideoAttr[nVTS] & 0x1000) >> 12;

	csAux.Format(_T("     Looping into Title PGCs and cells"));
	MyLog(csAux);

	for (nT=0;nT<m_nPGCs[nVTS];nT++)
	{
		if (iFormat==NTSC)
			dwPGCDuration=0xC0;
		else
			dwPGCDuration=0x40;
		
		for (nCell=0;nCell<m_nCells[nVTS][nT];nCell++)
		{
// Use the same order and algorithm to generate new VOBids...
			if  (m_iAction[nVTS][nT]==CELLBASED && 
				(m_csCellBased[nVTS][nT][nCell]=='B' ||
				 m_csCellBased[nVTS][nT][nCell]=='R' ) &&
				 IsReused(TITLES, nVTS,nT,nCell) )
			{
				m_nVOBIDsInProcess++;
				CellId=1;
				VobId=m_nVOBIDsInProcess;
				pIFO[m_C_POST[nVTS][nT]+nCell*4+3]=CellId;
				Put2bytes( VobId, &pIFO[m_C_POST[nVTS][nT]+nCell*4]);

			}
			CellId=pIFO[m_C_POST[nVTS][nT]+nCell*4+3];
			VobId=GetNbytes(2,&pIFO[m_C_POST[nVTS][nT]+nCell*4]);

// PGC PBKT Cell Headers manipulations: Cell Still Time
			if  (  ( m_iAction[nVTS][nT]==CELLBASED && 
				     m_csCellBased[nVTS][nT][nCell]=='B') ||
				 m_iAction[nVTS][nT]==BLANK ) 
			{
			// Reset to Zero Cell still time.
				pIFO[m_C_PBKT[nVTS][nT]+nCell*24+2]=0;
			}
// PGC PBKT Cell Headers manipulations: STC Discontinuity
			if  (  ( m_iAction[nVTS][nT]==CELLBASED && 
				     (m_csCellBased[nVTS][nT][nCell]=='B' || m_csCellBased[nVTS][nT][nCell]=='R' ))
					 ||	 m_iAction[nVTS][nT]==BLANK ) 
			{
			// Mark as STC Discontinuity this cell and the following one.
				pIFO[m_C_PBKT[nVTS][nT]+nCell*24] = 0x02 ;
				if ((nCell+1) <m_nCells[nVTS][nT])
					pIFO[m_C_PBKT[nVTS][nT]+(nCell+1)*24] = 0x02 ;
			}
// PGC PBKT Cell Headers manipulations: Clear STC Discontinuity in PGC replace
			if  ( m_iAction[nVTS][nT]==REPLACE ) 
			{
			// Assuming a continuous PGC is used to replace: 
			// Mark STC Discontinuity in the first cell and clear in all the rest.
				pIFO[m_C_PBKT[nVTS][nT]+nCell*24] = 0x08 ;
				if (nCell==0)
					pIFO[m_C_PBKT[nVTS][nT]+nCell*24] = 0x02 ;
			}

// PGC PBKT Cell Headers manipulations: STC Discontinuity in Cut title
			if ( m_iAction[nVTS][nT]==CUT)
			{
				iAction=m_CutInfo[nVTS][nT].iAction;
				IniCell=m_CutInfo[nVTS][nT].iIniCell;
				EndCell=m_CutInfo[nVTS][nT].iEndCell;

				if (((nCell < IniCell || nCell > EndCell) && iAction==0 ) ||
					((nCell > IniCell && nCell < EndCell) && iAction!=0 ) ) 
					// Blank Cell
					pIFO[m_C_PBKT[nVTS][nT]+nCell*24] = 0x02 ;
				else
				{
					/*
					if (((nCell > IniCell && nCell < EndCell) && iAction==0) ||
						((nCell < IniCell || nCell > EndCell) && iAction!=0) )
					{
// Intermediate Cell 
					}
					*/
					if (iAction==0 && nCell == IniCell)  //Modo Keep
					{
						pIFO[m_C_PBKT[nVTS][nT]+nCell*24] = 0x02 ;
					}
					if (iAction==0 && nCell == EndCell  )  //Modo Cut
					{
						pIFO[m_C_PBKT[nVTS][nT]+nCell*24] = 0x02 ;
					}
				}
			}
			for (k=0; k< iACells; k++)
			{
				if (VobId==m_ACell_list[k].VID && CellId==m_ACell_list[k].CID)
				{
// Clear ILV Flags
					Put4bytes(0,  &pIFO[m_C_PBKT[nVTS][nT]+nCell*24+0x0C]);
					pIFO[m_C_PBKT[nVTS][nT]+nCell*24]=pIFO[m_C_PBKT[nVTS][nT]+nCell*24] & 0xFB;
// Copy Cells Info
					if (m_ACell_list[k].i64FirstLBAFirstVOBU != -1)
						Put4bytes(m_ACell_list[k].i64FirstLBAFirstVOBU,  &pIFO[m_C_PBKT[nVTS][nT]+nCell*24+8]);
					if (m_ACell_list[k].i64FirstLBALastVOBU != -1)
						Put4bytes(m_ACell_list[k].i64FirstLBALastVOBU,  &pIFO[m_C_PBKT[nVTS][nT]+nCell*24+0x10]);
					if (m_ACell_list[k].i64LastLBALastVOBU != -1)
						Put4bytes(m_ACell_list[k].i64LastLBALastVOBU,  &pIFO[m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					dwDuration=m_ACell_list[k].dwDuration;
					if (dwDuration != -1)
					{
						if (dwDuration==0x40 || (dwDuration==0 && iFormat==PAL))
							dwDuration=0x12+0x40;
						if (dwDuration==0x0c0 || (dwDuration==0 && iFormat==NTSC ) ) 
							dwDuration=0x0c0+0x15;
						Put4bytes(dwDuration,  &pIFO[m_C_PBKT[nVTS][nT]+nCell*24+4]);
						dwPGCDuration= AddDuration(dwDuration,dwPGCDuration);
					}
					k=iACells;
				}
			}
		} /* For Cells */
		Put4bytes(dwPGCDuration, &pIFO[m_VTS_PGC[nVTS][nT]+4]);

// Clear audio status if audio strip
		if (m_iAction[nVTS][nT]==STRIP)
		{
			for (nA=0;nA<m_nAudio[nVTS];nA++)
				if ( m_bIdTAudioStrip[nVTS][nA][nT]) 
					pIFO[m_VTS_PGC[nVTS][nT]+nA*2+0x0c]=0;
		}
// Clear audio/sub status and PGC still time if blanking
		if (m_iAction[nVTS][nT]==BLANK)
		{
			for (nA=0;nA<8;nA++)
			{
				pIFO[m_VTS_PGC[nVTS][nT]+nA*2+0x0c]=0;
				pIFO[m_VTS_PGC[nVTS][nT]+nA*2+0x0c+1]=0;
			}
			for (nA=0;nA<32;nA++)
			{
				pIFO[m_VTS_PGC[nVTS][nT]+nA*4+0x1c]=0;
				pIFO[m_VTS_PGC[nVTS][nT]+nA*4+0x1c+1]=0;
				pIFO[m_VTS_PGC[nVTS][nT]+nA*4+0x1c+2]=0;
				pIFO[m_VTS_PGC[nVTS][nT]+nA*4+0x1c+3]=0;
			}
			pIFO[m_VTS_PGC[nVTS][nT]+0xA3]=0;
		}
// Change Post into precommands
		if ( m_bCheckPostPre && m_iAction[nVTS][nT]==BLANK && m_PGC_COMM[nVTS][nT]!=0 )
// Action is blanking, table exists and checkboxactive
		{
			iRet=ChangePostIntoPre(TITLES,nVTS,nT);
			if (iRet>=0)  {m_nPostPre++; m_nActualPostPre++;}
			if (iRet<=-2)  m_nPostPre++;
		}
	} /* for Titles */

/////////////////////////////////////////////////////
// VTS_C_ADT : Total reconstruction of this table;

	if (m_VTS_C_ADT[nVTS]==0 || iACells==0)
	{
		csAux.Format(_T("     ERROR: VTS_C_ADT table did not exist or has been deleted"));
		MyLog(csAux);
		return;
	}
	
	IniADTSectors=GetNbytes(4,&pIFO[m_VTS_C_ADT[nVTS]+4]);
	IniADTSectors=IniADTSectors/2048+1;

	csAux.Format(_T("     Building VTS_C_ADT table"));
	MyLog(csAux);

	pIFO[m_VTS_C_ADT[nVTS]+0]=nVOBIDs/256;
	pIFO[m_VTS_C_ADT[nVTS]+1]=nVOBIDs%256;
	pIFO[m_VTS_C_ADT[nVTS]+2]=0;
	pIFO[m_VTS_C_ADT[nVTS]+3]=0;
	Put4bytes( iACells*12+7 ,&pIFO[m_VTS_C_ADT[nVTS]+4]);
	for (k=0;k<iACells;k++)
	{
		pIFO[m_VTS_C_ADT[nVTS]+8+12*k  ]=m_ACell_list[k].VID/256;
		pIFO[m_VTS_C_ADT[nVTS]+8+12*k+1]=m_ACell_list[k].VID%256;
		pIFO[m_VTS_C_ADT[nVTS]+8+12*k+2]=m_ACell_list[k].CID;
		pIFO[m_VTS_C_ADT[nVTS]+8+12*k+3]=0;

		if (m_ACell_list[k].i64FirstLBAFirstVOBU != -1)
				Put4bytes(m_ACell_list[k].i64FirstLBAFirstVOBU, &pIFO[m_VTS_C_ADT[nVTS]+8+12*k+4]);
		if (m_ACell_list[k].i64LastLBALastVOBU != -1)
				Put4bytes(m_ACell_list[k].i64LastLBALastVOBU,&pIFO[m_VTS_C_ADT[nVTS]+8+12*k+8]);

	}

	nADTSectors= (iACells*12+7)/2048 +1; 
	nADTBytes=iACells*12+8;

///////////////////////////////////////////////////////
// VTS_TMAPTI
	csAux.Format(_T("     Processing TMPATI table"));
	MyLog(csAux);

	for (nT=0;nT<m_nPGCs[nVTS];nT++)
		ProcessTmapti(nVTS, nT, pIFO);

///////////////////////////////////////////////////////
// VTS_VOBU_ADMAP
// DO NOT REDUCE IFOS BY THE MOMENT
// ADT TABLE SHOULD BE SMALLER OR EQUAL THAN BEFORE.

	if (m_VTS_VOBU_ADMAP[nVTS]==0 || iANavs==0)
	{
		csAux.Format(_T("     ERROR: VTS_VOBU_ADMAP table did not exist or has been deleted"));
		MyLog(csAux);
		return;
	}
	IniADMAPSectors=GetNbytes(4,&pIFO[m_VTS_VOBU_ADMAP[nVTS]]);
	IniADMAPSectors=IniADMAPSectors/2048+1;

	csAux.Format(_T("     Filling VTS_VOBU_ADMAP table"));
	MyLog(csAux);
	Maxbyte = iANavs*4+3;
	Nsec= Maxbyte/2048+1;
		
	for ( k=0 ; k<iANavs ; k++)
		Put4bytes(m_ANavinfo[k].LBA,&pIFO[m_VTS_VOBU_ADMAP[nVTS]+4+4*k]);

	Put4bytes(Maxbyte,&pIFO[m_VTS_VOBU_ADMAP[nVTS]]);
	nADMAPSectors=Maxbyte;
	nADMAPSectors=nADMAPSectors/2048+1;

// Correct 	VTS_C_ADT if MENUS tables have been reduced
	if (m_MenuDiscountSectors[nVTS]!=0)
	{
		csAux.Format(_T("     Menus tables have been reduced. Adjusting ADT & ADMAP tables"));
		MyLog(csAux);
		iOffset=m_MenuDiscountSectors[nVTS]*2048;
		for (k=0;k < nADTBytes ; k++)
				pIFO[m_VTS_C_ADT[nVTS]-iOffset+k]=pIFO[m_VTS_C_ADT[nVTS]+k];
		iPointer=GetNbytes(4, &pIFO[0xE0]);
		Put4bytes(iPointer-(m_MenuDiscountSectors[nVTS]),&pIFO[0xE0]) ; // Pointer to ADT

	}

// Correct 	VTS_VOBU_ADMAP (may be ADT table has been reduced)
	if (nADTSectors<IniADTSectors || m_MenuDiscountSectors[nVTS]!=0)
	{
		m_TotalDiscountSectors[nVTS]=IniADTSectors-nADTSectors+m_MenuDiscountSectors[nVTS];

		iOffset=(m_TotalDiscountSectors[nVTS])*2048;
		for (k=0;k <=Maxbyte; k++)
			pIFO[m_VTS_VOBU_ADMAP[nVTS]-iOffset+k]=pIFO[m_VTS_VOBU_ADMAP[nVTS]+k];
		iPointer=GetNbytes(4, &pIFO[0xE4]);
		Put4bytes(iPointer-(m_TotalDiscountSectors[nVTS]),&pIFO[0xE4]) ; // Pointer to ADMAP
	}
	else
		m_TotalDiscountSectors[nVTS]=0;

	m_TotalDiscountSectors[nVTS]+=(IniADMAPSectors-nADMAPSectors);
	m_i64IFOlen[nVTS]-=(m_TotalDiscountSectors[nVTS]*2048);

/*
OJO la ADT puede ser mas grande que antes.???..
*/
}

void CVobBlankerApp::ProcessIfoVTSEnd(int nVTS, CWnd* pDlg)
{

	CString csAux,csFout,csAux2;
	FILE *out;
	int i;
	int nIFOSectors,nMenuSectors,nVOBSectors;
	struct  _stati64 statbuf;
	int nT;

	csAux.Format(_T("VTS %02d: Processing IFO (Ending and writting)"),nVTS);
	MyLog(csAux);

	for (nT=0;nT<m_nPGCs[nVTS];nT++)
		if (m_bCheckIfoPuops)
			Put4bytes(0, &pIFO[m_VTS_PGC[nVTS][nT]+8]);

	for (nT=0;nT<m_nMPGCs[nVTS];nT++)
		if (m_bCheckIfoPuops)
			Put4bytes(0, &pIFO[m_MENU_PGC[nVTS][nT]+8]);

//////////////////////////////////////////////////////
// SECTORS

	nIFOSectors= (int) (m_i64IFOlen[nVTS]/2048);

// Use output path for menus. May be process menus is not selected,
//	but they should be copied previously..
	csAux2.Format(_T("VTS_%02d_0.VOB"), nVTS);
	csAux=m_csOutputPath+'\\'+csAux2;
	if (_stati64 ( csAux, &statbuf)==0)
		nMenuSectors= (int)(statbuf.st_size/2048);
	else 
		nMenuSectors=-1;

// Use output path for vobs.
	nVOBSectors=0;
	for (i=1; i<10; i++)
	{
		csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,i);
		csAux=m_csOutputPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
			nVOBSectors+= (int)(statbuf.st_size/2048);
		else 
			if (i!=0) i=20;
	}

	Put4bytes(nIFOSectors-1,&pIFO[0x1C]);
	if (nMenuSectors>=0)
		Put4bytes(nIFOSectors,&pIFO[0xC0]);
	else
	{
		// Menu does not exist
		nMenuSectors=0;
		Put4bytes(0,&pIFO[0xC0]);
	}
	Put4bytes(nIFOSectors+nMenuSectors,&pIFO[0xC4]);
	Put4bytes(nIFOSectors*2+nMenuSectors+nVOBSectors-1,&pIFO[0x0C]);

// write IFO & BUP
	csAux.Format(_T("VTS_%02d_0.IFO"), nVTS);
	csAux=m_csOutputPath+ '\\' +csAux;
	out=fopen(csAux,"wb");
	if (out!=NULL)
	{
		for (i=0;i<m_i64IFOlen[nVTS];i++)
			fputc (pIFO[i],out);
		fclose(out);
	}
	else
		MyLog("Error writting IFO");

	csAux.Format(_T("VTS_%02d_0.BUP"), nVTS);
	csAux=m_csOutputPath+ '\\' +csAux;
	out=fopen(csAux,"wb");
	if (out!=NULL)
	{
		for (i=0;i<m_i64IFOlen[nVTS];i++)
			fputc (pIFO[i],out);
		fclose(out);
	}
	else
		MyLog("Error writting BUP");


	delete[] pIFO;

	MyLog("");
// Recovers original size to allow a new run
	m_i64IFOlen[nVTS]+=(m_TotalDiscountSectors[nVTS]*2048);
}

void CVobBlankerApp::ProcessIfoMGR(CWnd* pDlg)
{
	int i;
	FILE *out;
	CString csFout,csAux,csAux2, csPath;
	int nIFOSectors, nMenuSectors,nVOBSectors,nStart;
	UINT nStartSector[MAX_VTS];
	UINT FirstFreeSector;
	struct  _stati64 statbuf;
	int nVTS, nT, k;


//	ProcessIfoVTSPrepare(0,pDlg);

//	ProcessIfoVTSMenu(0,pDlg);

// Folder where check sizes
	if (m_bCheckFolder) csPath=m_csInputPath;
	else csPath=m_csOutputPath;

//////////////////////////////////////////////////////
// OWN SECTORS

	nIFOSectors= (int) (m_i64IFOlen[0]/2048);

// Use output path for menus. May be process menus is not selected,
//	but they should be copied previously..
	csAux=csPath+'\\'+"VIDEO_TS.VOB";
	if (_stati64 ( csAux, &statbuf)==0)
		nMenuSectors= (int)(statbuf.st_size/2048);
	else 
		nMenuSectors=-1;

	Put4bytes(nIFOSectors-1,&pIFO[0x1C]);
	if (nMenuSectors>=0)
		Put4bytes(nIFOSectors,&pIFO[0xC0]);
	else
	{
		// menu does not exist
		nMenuSectors=0;
		Put4bytes(0,&pIFO[0xC0]);
	}
	Put4bytes(nIFOSectors*2+nMenuSectors-1,&pIFO[0x0C]);

	FirstFreeSector=nIFOSectors*2+nMenuSectors;
//////////////////////////////////////////////////////
// TT_SRPT: Table of titles

// Calculate start sector of each VTS

	for (nVTS=1 ; nVTS<m_nIFOs+1 ; nVTS++)
	{
		nStartSector[nVTS]=FirstFreeSector;

// Use output path for IFOs. May be their size has changed,
		csAux2.Format(_T("VTS_%02d_0.IFO"), nVTS);
		csAux=csPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
			nIFOSectors= (UINT)(statbuf.st_size/2048);
		else 
			nIFOSectors= (UINT) (m_i64IFOlen[nVTS]/2048);

// Use output path for menus. May be process menus is not selected,
//	but they should be copied previously..
		csAux2.Format(_T("VTS_%02d_0.VOB"), nVTS);
		csAux=csPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
			nMenuSectors= (UINT)(statbuf.st_size/2048);
		else 
			nMenuSectors=0;
// Use output path for vobs.
		nVOBSectors=0;
		for (k=1; k<10; k++)
		{
			csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,k);
			csAux=m_csOutputPath+'\\'+csAux2;
			if (_stati64 ( csAux, &statbuf)==0)
				nVOBSectors+= (UINT)(statbuf.st_size/2048);
			else 
				if (k!=0) k=20;
		}

		FirstFreeSector+= (2*nIFOSectors+nMenuSectors+nVOBSectors);
	}

///////////////////////////////////////////////////////
// Titles loop
	for (k=0;k< m_nTotalTitles ; k++)
	{
		nStart=GetNbytes(1,&pIFO[m_TT_SRPT+8+12*k+6]);
		Put4bytes(nStartSector[nStart],&pIFO[m_TT_SRPT+8+12*k+8]);
		if (m_bCheckIfoPuops)
			pIFO[m_TT_SRPT+8+12*k]=pIFO[m_TT_SRPT+8+12*k] & 0xFC;
	}

///////////////////////////////////////////////////////
//  Menu PGCs loop
	for (nT=0;nT<m_nMPGCs[0];nT++)
		if (m_bCheckIfoPuops)
			Put4bytes(0, &pIFO[m_MENU_PGC[0][nT]+8]);

//  First Play PGC
	if (m_bCheckIfoPuops)
		Put4bytes(0, &pIFO[GetNbytes(4,&pIFO[0x84])+8]);

	
// Repeat postcommands in PGCs??

	csAux.Format(_T("VIDEO_TS: Processing IFO (Ending and writting)"),nVTS);
	MyLog(csAux);


// write IFO & BUP
	csFout=m_csOutputPath+ '\\' +"VIDEO_TS.IFO";
	out=fopen(csFout,"wb");
	if (out!=NULL)
	{
		for (i=0;i<m_i64IFOlen[0];i++)
			fputc (pIFO[i],out);
		fclose(out);
	}
	else
		MyLog("Error writting IFO");

	csFout=m_csOutputPath+ '\\' +"VIDEO_TS.BUP";
	out=fopen(csFout,"wb");
	if (out!=NULL)
	{
		for (i=0;i<m_i64IFOlen[0];i++)
			fputc (pIFO[i],out);
		fclose(out);
	}
	else
		MyLog("Error writting BUP");

	delete[] pIFO;
// Recovers original size to allow a new run
	m_i64IFOlen[0]+=(m_MenuDiscountSectors[0]*2048);
}

int CVobBlankerApp::AdjustSectors(CString csPath)
{
	int		iIFOSectors[MAX_VTS];
	int		iMenuSectors[MAX_VTS];
	int		iVOBSectors[MAX_VTS];
	int		FirstFreeSector;
	int		iStartSector[MAX_VTS];
	CString csAux,csAux2;
	int		iTT_SRPT;
	int		nVTS;
	struct _stati64	statbuf;
	int		i,nStart;

	FILE * in;


	for (nVTS=1 ; nVTS<m_nIFOs+1 ; nVTS++)
	{
		csAux2.Format(_T("VTS_%02d_0.IFO"), nVTS);
		csAux=csPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
			iIFOSectors[nVTS]= (int)(statbuf.st_size/2048);
		else 
			iIFOSectors[nVTS]=-1;

		csAux2.Format(_T("VTS_%02d_0.VOB"), nVTS);
		csAux=csPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
			iMenuSectors[nVTS]= (int)(statbuf.st_size/2048);
		else 
			iMenuSectors[nVTS]=-1;

		iVOBSectors[nVTS]=0;
		for (i=1; i<10; i++)
		{
			csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,i);
			csAux=csPath+'\\'+csAux2;
			if (_stati64 ( csAux, &statbuf)==0)
				iVOBSectors[nVTS]+= (int)(statbuf.st_size/2048);
			else 
				if (i!=0) i=20;
		}
	}

	csAux=csPath+"\\VIDEO_TS.IFO";
	if (_stati64 ( csAux, &statbuf)==0)
		iIFOSectors[0]= (int)(statbuf.st_size/2048);
	else 
		iIFOSectors[0]=-1;

	csAux=csPath+"\\VIDEO_TS.VOB";
	if (_stati64 ( csAux, &statbuf)==0)
		iMenuSectors[0]= (int)(statbuf.st_size/2048);
	else 
		iMenuSectors[0]=-1;

	iVOBSectors[0]=0;

	for (nVTS=1 ; nVTS<m_nIFOs+1 ; nVTS++)
	{
//////////////////////////////////////////////////////
// SECTORS IN VTS_XX_0.IFO

		csAux.Format(_T("VTS_%02d_0.IFO"), nVTS);
		csAux=csPath+'\\'+csAux;

		csAux2.Format(_T("VTS_%02d_0.BUP"), nVTS);
		csAux2=csPath+'\\'+csAux2;

		if ((in=fopen(csAux,"r+b"))==NULL)
		{
			MyLog ("Unable to open IFO file: " + csAux);
			return 0;
		}

		fseek(in,0x1C,SEEK_SET);
		fput4c(iIFOSectors[nVTS]-1,in);

		fseek(in,0xC0,SEEK_SET);
		if (iMenuSectors[nVTS]>=0)
			fput4c(iIFOSectors[nVTS],in);
		else
		{
		// Menu does not exist
			iMenuSectors[nVTS]=0;
			fput4c(0,in);
		}

		fseek(in,0xC4,SEEK_SET);
		fput4c(iIFOSectors[nVTS]+iMenuSectors[nVTS],in);

		fseek(in,0x0C,SEEK_SET);
		fput4c(2*iIFOSectors[nVTS]+iMenuSectors[nVTS]+iVOBSectors[nVTS]-1,in);
	
		fclose(in);
//		MyLog (csAux + " modified. Updating BUP");
		CopyFile(csAux, csAux2,FALSE);

	}


//////////////////////////////////////////////////////
// SECTORS IN VIDEO_TS.IFO

// OWN SECTORS
	csAux=csPath+"\\VIDEO_TS.IFO";
	csAux2=csPath+"\\VIDEO_TS.BUP";
	
	if ((in=fopen(csAux,"r+b"))==NULL)
	{
		MyLog("Unable to open IFO file: " + csAux);
		return 0;
	}

	fseek(in,0x1C,SEEK_SET);
	fput4c(iIFOSectors[0]-1,in);

	fseek(in,0xC0,SEEK_SET);
	if (iMenuSectors[0]>=0)
		fput4c(iIFOSectors[0],in);
	else
	{
	// Menu does not exist
		iMenuSectors[0]=0;
		fput4c(0,in);
	}

	fseek(in,0x0C,SEEK_SET);
	fput4c(2*iIFOSectors[0]+iMenuSectors[0]-1,in);
	

// TT_SRPT: Table of titles
// Calculate start sector of each VTS
	FirstFreeSector=iIFOSectors[0]*2+iMenuSectors[0];
	for (nVTS=1 ; nVTS<m_nIFOs+1 ; nVTS++)
	{
		iStartSector[nVTS]=FirstFreeSector;
		FirstFreeSector+= (2*iIFOSectors[nVTS]+iMenuSectors[nVTS]+iVOBSectors[nVTS]);
	}	
///////////////////////////////////////////////////////
// Titles loop

	fseek(in,0x0C4,SEEK_SET);
	iTT_SRPT=2048*get4c(in);

	for (i=0;i< m_nTotalTitles ; i++)
	{
		if (fseek(in,iTT_SRPT+8+12*i+6,SEEK_SET)==0)
		{
			nStart=getc(in);
			if (nStart !=EOF && nStart < m_nIFOs+1 && nStart >0)
			{
				fseek(in,iTT_SRPT+8+12*i+8,SEEK_SET);
				fput4c(iStartSector[nStart],in);
			}
			else
			{
				MyLog ("Unable to adjust all title sectors");
				fclose(in);
				return 0;
			}
		}
		else
		{
			MyLog ("Unable to get title number in VIDEO_TS.IFO");
			fclose(in);
			return 0;
		}
	}

	fclose(in);
//	MyLog (csAux + " modified. Updating BUP");
	CopyFile(csAux, csAux2,FALSE);
	return 1;
}

void CVobBlankerApp::ProcessTmapti(int nVTS, int nT, uchar* pIFO)
{

#define PERCDUR 95
#define MAXENTRIESLOST 2

	int duration, nuPGCs, nuPGCs_TMAP;
	int nusecs, i, idx;
	int VTS_TMAP_ini, VTS_TMAP_end;
	int maxentries, entries, entriesok;
	__int64 lba;
	CString csAux;
	FILE *log;


	if (m_VTS_TMAPTI[nVTS] == 0)
		// No TMAPTI table
		return;

	nuPGCs=GetNbytes(2,&pIFO[m_VTS_PGCI[nVTS]]);

	if ( nuPGCs <= nT)
	{
		csAux.Format(_T("     WARNING: Something wrong in number of PGCs: %d"),nT);
		MyLog(csAux);
		m_nWarnings++;
//		MyErrorBox("ERROR: Something wrong in number of PGCs");
		return;
	}

	duration= GetNbytes(4,&pIFO[m_VTS_PGC[nVTS][nT] + 4]);
	duration= DurationInSecs( GetNbytes(4,&pIFO[m_VTS_PGC[nVTS][nT] + 4]));

//	if (m_iAction[nVTS][nT]==CUT)
//		duration-=(m_CutInfo[nVTS][nT].iEndSeconds-m_CutInfo[nVTS][nT].iIniSeconds);
	
// locate selected TMAP

	nuPGCs_TMAP= GetNbytes( 2, &pIFO[m_VTS_TMAPTI[nVTS]]);

	if ( nuPGCs !=  nuPGCs_TMAP)
	{
//		MyErrorBox("ERROR: nuPGCs mismatch between VTS_TMAPTI and VTS_PGCI.");
		csAux.Format(_T("     WARNING: nuPGCs mismatch between VTS_TMAPTI and VTS_PGCI %d"),nT);
		MyLog(csAux);
		m_nWarnings++;
		return;
	}

	VTS_TMAP_ini= GetNbytes( 4, &pIFO[m_VTS_TMAPTI[nVTS] + 8 + nT*4 ]) + m_VTS_TMAPTI[nVTS];


// locate the limits of TMAP table
	if (nuPGCs == nT+1)
		// last PGC, so use last available byte
		VTS_TMAP_end=GetNbytes( 4, &pIFO[m_VTS_TMAPTI[nVTS] + 4 ]) + m_VTS_TMAPTI[nVTS] -1;
	else
		// first byte of next PGC
		VTS_TMAP_end=GetNbytes( 4, &pIFO[m_VTS_TMAPTI[nVTS] + 12 + nT*4 ]) + m_VTS_TMAPTI[nVTS] -1;

    maxentries=(VTS_TMAP_end-VTS_TMAP_ini+1)/4-1 ;
	if (maxentries <0) maxentries=0;

	if ( maxentries !=0)
	{
		nusecs=duration/maxentries;
		if (nusecs == 0)  nusecs=1;
		entries= duration/nusecs;
		if (entries > maxentries+MAXENTRIESLOST)
			nusecs= (duration*PERCDUR/100)/maxentries + 1;
	}
	else
	{
		entries=0;
		nusecs=duration+1;
	}

	// to be sure 
	if (nusecs == 0)  nusecs=1;
	entries= duration/nusecs;

	if (LOGTMAPTI && m_bLog)
	{
		csAux.Format(_T("C:\\tmapti_%02d_%02d_log.txt"),nVTS,nT);
		log=fopen(csAux,"w");
		fprintf (log, "pgc:%02d nusecs:%02d entries:%04d maxentries:%04d duration:%06d\n",
		           nT+1, nusecs, entries, maxentries, duration);
	}


	for (i=entriesok=idx=0; i<duration; i+=nusecs)
	{
		discontinuity=0;
		idx=Findidxlba(idx, i, nVTS, nT,pIFO);
		lba= m_ANavinfo[idx].LBA;
// entriesok is incremented later, in order to apply discontinuity 
// to the previous index, like IFOEdit does. Not sure if it is ok or not
		
		if (discontinuity==1)
		{
			discontinuity=0;
			pIFO[VTS_TMAP_ini+entriesok*4]+=0x80;
		}
		if (lba!=0xFFFFFFFF  && entriesok <maxentries)
		{
			entriesok++;
			Put4bytes(lba, &pIFO[VTS_TMAP_ini+entriesok*4]);
			if (LOGTMAPTI && m_bLog)
				fprintf (log, "entry:%04d sec:%06d lba:%08I64X\n",
		                   entriesok, i, lba);
		}

	}
	if (LOGTMAPTI && m_bLog)  fclose (log);

// last entry always discontinuity. Not sure, but it seems... 
	if (entriesok > 0 &&
		(pIFO[VTS_TMAP_ini+entriesok*4] & 0x80)==0 )
		pIFO[VTS_TMAP_ini+entriesok*4]+=0x80;

	pIFO[VTS_TMAP_ini+2]=entriesok/256;
	pIFO[VTS_TMAP_ini+3]=entriesok%256;
	pIFO[VTS_TMAP_ini]=nusecs;
}

int CVobBlankerApp::Findidxlba (int iniidx, int sec, int nVTS, int nT, uchar* pIFO)
{

	int k, match, CellId, VobId,nCell;
	__int64 lba;
	static int secold,secacum;
	int secread;

	lba=0xFFFFFFFF;
	match=0;

// Init
	if (iniidx==0) 
	{
		secacum=secold=0;
		discontinuity=0;
		iniidx=-1;  // to start from 0 
	}

    for (k=iniidx+1 ; k < m_ANavinfo.GetSize() && match==0 ; k++)
	{
		for (nCell=0;nCell<m_nCells[nVTS][nT] && match==0 ;nCell++)
		{
			CellId=pIFO[m_C_POST[nVTS][nT]+nCell*4+3];
			VobId=GetNbytes(2,&pIFO[m_C_POST[nVTS][nT]+nCell*4]);
			if (VobId==m_ANavinfo[k].VID && CellId==m_ANavinfo[k].CID)
			{
				secread=m_ANavinfo[k].seconds;
//				discontinuity=0;
				if (secread < secold)
				{
					discontinuity=1;
					secacum+=secold;
				}

				if (secread > secold + MAXVOBUSECSLENGTH)
				{
// Something happens. i.e.: a cut. Now duration are fixed 
//  so it is not really needed, but..., 
					discontinuity=1;
					secacum-=(secread-secold);
				}

				secold=secread;
				if ( secread+secacum>=sec )
				{
					match =1;
					iniidx=k;
				}
			}
		}
	}

	if (match)
		return iniidx;
	else
		return m_ANavinfo.GetSize()-1;
}




/*Para el preview */

 
__int64 CVobBlankerApp::PR_CellSectors(int iDomain, int nVTS, int nT, int nCell)
{
	__int64 i64AccSec,i64IniSec,i64EndSec;
    
	if (iDomain==TITLES)
	{
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+0x14]);
		i64AccSec=(i64EndSec-i64IniSec+1);
	}
	else
	{
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+24*nCell+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+24*nCell+0x14]);
		i64AccSec=(i64EndSec-i64IniSec+1);
	}
	return i64AccSec;

}

__int64 CVobBlankerApp::PR_CellIniSector(int m_iDomain, int nVTS, int nT, int nCell)
{
	__int64 i64IniSec;
    
	if (m_iDomain==TITLES)
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+8]);
	else
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+24*nCell+8]);

	return i64IniSec;

}

int CVobBlankerApp::CellVID(int nVTS,int nT,int nCell) 
{
	int iVID;

	iVID=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+4*nCell]);
	return iVID;
}

int CVobBlankerApp::CellCID(int nVTS,int nT,int nCell) 
{
	int iCID;

	iCID=m_pIFO[nVTS][m_C_POST[nVTS][nT]+3+4*nCell];
	return iCID;
}
int CVobBlankerApp::CellMVID(int nVTS,int nT,int nCell) 
{
	int iVID;

	iVID=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+4*nCell]);
	return iVID;
}

int CVobBlankerApp::CellMCID(int nVTS,int nT,int nCell) 
{
	int iCID;

	iCID=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+3+4*nCell];
	return iCID;
}
__int64 CVobBlankerApp::PR_LocateNavSector(int iDomain, int nVTS, int iVID, int iCID, __int64 i64sector, bool iNext)
{
	int k,iSectorsRead;
	__int64 i64AccSec;
	CString csAux,csAux2;
	struct  _stati64 statbuf;
	FILE *in;
	int nSectorsRead;
	int nRead;
	int iSaveSectorsRead;
	bool bfoundNav;

#define MAXREAD 4096

	if ( iDomain==TITLES)
	{
// TODO: Guarantee change of file ...
		i64AccSec=0;
		for (k=1; k<10; k++)
		{
			csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,k);
			csAux=m_csInputPath+'\\'+csAux2;
			if (_stati64 ( csAux, &statbuf)==0)
			{
				i64AccSec+= (statbuf.st_size/2048);
				if (i64AccSec > i64sector)
				{
					k=10;
					i64AccSec-= (statbuf.st_size/2048);
				}
			}
			else 
				k=20;
		}

		if (k==11)
		{
			in=fopen (csAux,"rb");
			fseek(in, (int)( (i64sector-i64AccSec )*2048) ,SEEK_SET);

			bfoundNav=false;
			iSectorsRead=nSectorsRead=0;
			while ( ( nRead=readbuffer(m_buffer,in) )== 2048  && nSectorsRead < MAXREAD)
			{
				nSectorsRead++;
				if (IsNav(m_buffer))
				{
					// This piece of code guarantee the CellID in a ILV Cell
					if (  (m_buffer[0x41f]*256 + m_buffer[0x420]) == iVID &&
							m_buffer[0x422]== iCID) 
					{
						bfoundNav=true;
						iSaveSectorsRead=iSectorsRead;
						if ( iNext==false ) break;
					}
					else bfoundNav=false;
				}
				if (IsVideo(m_buffer))
				{
					if (iNext && bfoundNav)
					{
						iSectorsRead=iSaveSectorsRead;
						break;
					}
				}

				if ( iNext) iSectorsRead++;
				else iSectorsRead--;
				fseek(in, (int)( (i64sector-i64AccSec+iSectorsRead )*2048) ,SEEK_SET);
			}

			if (in !=NULL) fclose(in);
	
			if (!bfoundNav || nRead!= 2048 || nSectorsRead==MAXREAD) return -1;
	
			return iSectorsRead+i64sector;
		}

	return 0;
	}

	else  //Menus
	{
		if (nVTS==0)
			csAux2="VIDEO_TS.VOB";
		else
			csAux2.Format(_T("VTS_%02d_0.VOB"), nVTS);
		csAux=m_csInputPath+'\\'+csAux2;
		i64AccSec=0;
		in=fopen (csAux,"rb");
		fseek(in, (int)( (i64sector-i64AccSec )*2048) ,SEEK_SET);


		iSectorsRead=nSectorsRead=0;
		bfoundNav=false;
		while ((nRead=readbuffer(m_buffer,in))== 2048  && nSectorsRead < MAXREAD)
		{
			nSectorsRead++;
			if (IsNav(m_buffer))
			{
				// This piece of code guarantee the CellID in a ILV Cell and a VOBU with video
				if (  (m_buffer[0x41f]*256 + m_buffer[0x420]) == iVID &&
						m_buffer[0x422]== iCID)
				{
					bfoundNav=true;
					iSaveSectorsRead=iSectorsRead;
					if ( iNext==false ) break;
				}
				else bfoundNav=false;
			}
			if (IsVideo(m_buffer))
			{
				if (iNext && bfoundNav)
				{
					iSectorsRead=iSaveSectorsRead;
					break;
				}
			}

			if ( iNext) iSectorsRead++;
			else iSectorsRead--;
			if (iSectorsRead==0 && iNext==false) break;
			fseek(in, (int)( (i64sector-i64AccSec+iSectorsRead )*2048) ,SEEK_SET);
		}

		if (in !=NULL) fclose(in);

		if (!bfoundNav || nRead!= 2048 || nSectorsRead==MAXREAD) return -1;

		return iSectorsRead+i64sector;
	}
}

bool CVobBlankerApp::PR_IsClosedGOP(int nVTS,int nT, int nCell, int iSector)
{
	int i;
	int k,kk;
	__int64 i64IniSec, i64AccSec;
	CString csAux,csAux2;
	struct  _stati64 statbuf;
	FILE *in;

    
	i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+8]) + iSector +1;

	i64AccSec=0;
	for (k=1; k<10; k++)
	{
		csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,k);
		kk=k;
		csAux=m_csInputPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
		{
			i64AccSec+= (statbuf.st_size/2048);
			if (i64AccSec > i64IniSec)
			{
				k=10;
				i64AccSec-= (statbuf.st_size/2048);
			}
		}
		else 
			k=20;
	}

	if (k!=11) return true;

	in=fopen (csAux,"rb");
	fseek(in, (int)( (i64IniSec-i64AccSec )*2048) ,SEEK_SET);

// Look for a Video pack, but only in a few packs...
	for (i=0;i<100 ; i++ )
	{
		if (readbuffer(m_buffer,in)!=2048)
		{
			fclose (in);
			kk++;
			csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS, kk);
			csAux=m_csInputPath+ '\\' +csAux2;
			in=fopen(csAux,"rb");
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
//				MyErrorBox("Error: Reached end of VOB too early");
				if (in !=NULL) fclose(in);
				return true;
			}
		}
		if (IsVideo(m_buffer))
		{
			if (IsGOP (m_buffer))
			{
				if (in !=NULL) fclose(in);
				if (IsClosedGOP (m_buffer))
					return true;
				else
					return false;
			}
		}
		if (IsNav(m_buffer))
		{
// We are in a new VOBU. Something has been wrong. Return silently....
//			MyErrorBox("Do not find video in this VOBU");
			if (in !=NULL) fclose(in);
			return true;
		}
	}
//	MyErrorBox("Unable to find a GOP");
	if (in !=NULL) fclose(in);
	return true;
}


void CVobBlankerApp::CalculateCutSize(int nVTS, int nT)
{
	int l,j,k,kk,ll;
	int same;
	int VIDa,VIDb,CIDa,CIDb;
	__int64 i64IniSec, i64EndSec;
	__int64 i64IniSecADT, i64EndSecADT;
	int nADTCells;
	int IniLba,EndLba,IniCell,EndCell,iAction;

	j=nVTS;
	k=nT;
	m_i64Rsize[j][k]=0;

	iAction=m_CutInfo[j][k].iAction;
	IniCell=m_CutInfo[j][k].iIniCell;
	IniLba= m_CutInfo[j][k].iIniLba;
	EndCell=m_CutInfo[j][k].iEndCell;
	EndLba= m_CutInfo[j][k].iEndLba;
	if (IniCell <0) IniCell=1;
	if (EndCell <0) EndCell=m_nCells[j][k];
	if (IniLba <0)  IniLba=0;
	if (EndLba <0) 
	{
		i64IniSec=GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*m_nCells[j][k]+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*m_nCells[j][k]+0x14]);
		EndLba= (int)(i64EndSec-i64IniSec+1) ;

	}

	nADTCells=	(GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+4])-7)/12;

	for ( l=0; l< m_nCells[j][k]; l++)
	{
		VIDa=GetNbytes(2,&m_pIFO[j][m_C_POST[j][k]+4*l]);
		CIDa=m_pIFO[j][m_C_POST[j][k]+3+4*l];
		i64IniSec=GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*l+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*l+0x14]);

				// check if this cell has been already used
		same=0;
		for (kk=0; kk<k ;kk++)
			for (ll=0; ll< m_nCells[j][kk]; ll++)
			{
				VIDb=GetNbytes(2,&m_pIFO[j][m_C_POST[j][kk]+4*ll]);
				CIDb=m_pIFO[j][m_C_POST[j][kk]+3+4*ll];
				if (VIDa==VIDb && CIDa==CIDb)
					same=1;
			}

		if (same==0)
		{
			if (iAction==0)
			{
				if (l >= IniCell && l <= EndCell )
				{
					for (kk=0;kk<nADTCells;kk++)
					{
						if (VIDa==GetNbytes(2, &m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk]) &&
							CIDa==m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+2])
						{
							i64IniSecADT=GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+4]);
							i64EndSecADT=GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+8]);
							m_i64Rsize[j][k]+=((i64EndSecADT-i64IniSecADT+1)*2048);
						}
					}
				}
				if (IniCell==l )
					m_i64Rsize[j][k]-=(IniLba*2048);

				if (EndCell==l )
					m_i64Rsize[j][k]-=((i64EndSec-i64IniSec+1-EndLba)*2048);

				if (l > EndCell || l < IniCell )
					m_i64Rsize[j][k]+=(5*2048);
			}
			else
			{
				if (l > EndCell || l < IniCell )
				{
					for (kk=0;kk<nADTCells;kk++)
					{
						if (VIDa==GetNbytes(2, &m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk]) &&
							CIDa==m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+2])
						{
							i64IniSecADT=GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+4]);
							i64EndSecADT=GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+8]);
							m_i64Rsize[j][k]+=((i64EndSecADT-i64IniSecADT+1)*2048);
						}
					}
				}
				if (IniCell==l )
					m_i64Rsize[j][k]+=(IniLba*2048);
				
				if (EndCell==l )
					m_i64Rsize[j][k]+=((i64EndSec-i64IniSec+1-EndLba)*2048);

				if (l > IniCell && l < EndCell )
					m_i64Rsize[j][k]+=(5*2048);
			}
		}
	}
}

__int64 CVobBlankerApp::CalculateMenuCellBasedSize(int nVTS, int nT)
{
	int l,n,kk;
	int same;
	int VIDa,CIDa;
	__int64 i64size;
	__int64 i64IniSecADT, i64EndSecADT;
	int nADTCells;
	CString csFile;
	struct  _stati64 statbuf;


	i64size=0;
	if (m_VTSM_C_ADT[nVTS]==0)
		nADTCells=0;
	else
		nADTCells=	(GetNbytes(4,&m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+4])-7)/12;

	for ( l=0; l< m_nMCells[nVTS][nT]; l++)
	{
		VIDa=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+4*l]);
		CIDa=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+3+4*l];

				// check if this cell has been already used
		same=0;
		if (IsReused(MENUS,nVTS,nT,l)) same=1;

// If replace or blank, count the size.
		if (m_csMCellBased[nVTS][nT][l] != 'K') same=0;

		if (same==0)
		{
			if (m_csMCellBased[nVTS][nT][l] == 'K' )
			{
				for (kk=0;kk<nADTCells;kk++)
				{
					if (VIDa==GetNbytes(2, &m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+8+12*kk]) &&
						CIDa==m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+8+12*kk+2])
					{
						i64IniSecADT=GetNbytes(4,&m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+8+12*kk+4]);
						i64EndSecADT=GetNbytes(4,&m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+8+12*kk+8]);
						i64size+=((i64EndSecADT-i64IniSecADT+1)*2048);
					}
				}
			}
			else if (m_csMCellBased[nVTS][nT][l] == 'B' )
				i64size+=(5*2048);
			else if (m_csMCellBased[nVTS][nT][l] == 'R' )
			{
				for(n=0,csFile=""; n< m_ACell_replace.GetSize(); n++)
				{
					if (m_ACell_replace[n].VID== VIDa &&
				         m_ACell_replace[n].CID== CIDa &&
						 m_ACell_replace[n].nVTS==nVTS &&
						 m_ACell_replace[n].iDomain==MENUS )
						 csFile= m_ACell_replace[n].csPath;
				}
				if (_stati64 ( csFile, &statbuf)==0)
					i64size+= statbuf.st_size;
			}
		}
	} /* for l Cells*/
	return i64size;
}


__int64 CVobBlankerApp::CalculateCellBasedSize(int nVTS, int nT)
{
	int l,kk,n;
	int same;
	int VIDa,CIDa;
	__int64 i64size;
	__int64 i64IniSecADT, i64EndSecADT;
	int nADTCells;
	CString csFile;
	struct  _stati64 statbuf;


	nADTCells=	(GetNbytes(4,&m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+4])-7)/12;
	i64size=0;

	for ( l=0; l< m_nCells[nVTS][nT]; l++)
	{
		VIDa=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+4*l]);
		CIDa=m_pIFO[nVTS][m_C_POST[nVTS][nT]+3+4*l];

				// check if this cell has been already used
		same=0;
		if (IsReused(TITLES,nVTS,nT,l)) same=1;

// If replace or blank, count the size.
		if (m_csCellBased[nVTS][nT][l] != 'K') same=0;

		if (same==0)
		{
			if (m_csCellBased[nVTS][nT][l] == 'K' )
			{
				for (kk=0;kk<nADTCells;kk++)
				{
					if (VIDa==GetNbytes(2, &m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+8+12*kk]) &&
						CIDa==m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+8+12*kk+2])
					{
						i64IniSecADT=GetNbytes(4,&m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+8+12*kk+4]);
						i64EndSecADT=GetNbytes(4,&m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+8+12*kk+8]);
						i64size+=((i64EndSecADT-i64IniSecADT+1)*2048);
					}
				}
			}
			else if (m_csCellBased[nVTS][nT][l] == 'B' )
				i64size+=(5*2048);
			else if (m_csCellBased[nVTS][nT][l] == 'R' )
			{
				for(n=0,csFile=""; n< m_ACell_replace.GetSize(); n++)
				{
					if (m_ACell_replace[n].VID== VIDa &&
				         m_ACell_replace[n].CID== CIDa &&
						 m_ACell_replace[n].nVTS==nVTS &&
						 m_ACell_replace[n].iDomain==TITLES )
						 csFile= m_ACell_replace[n].csPath;
				}
				if (_stati64 ( csFile, &statbuf)==0)
					i64size+= statbuf.st_size;
			}
		}
	} /* for l Cells*/
	return i64size;
}



void CVobBlankerApp::UpdateVideoAttr(int nVTS)
{
	int pVMG_VTS_ATRT, pVTS_ATRT;

	m_pIFO[nVTS][0x200]=m_iVideoAttr[nVTS]/256;
	m_pIFO[nVTS][0x201]=m_iVideoAttr[nVTS]%256;

	pVMG_VTS_ATRT=GetNbytes(4,&m_pIFO[0][0xd0])*2048;

	pVTS_ATRT=GetNbytes(4,&m_pIFO[0][pVMG_VTS_ATRT+8+4*(nVTS-1)])+pVMG_VTS_ATRT;

	m_pIFO[0][pVTS_ATRT+0x108]=m_iVideoAttr[nVTS]/256;
	m_pIFO[0][pVTS_ATRT+0x109]=m_iVideoAttr[nVTS]%256;

}

bool CVobBlankerApp::SaveProject(CString FilePath)
{
	CString csAux,csSection,csKey;
	int nVTS,nT;
	int n, nReplacedCells;
	bool bWrite;


	//		WritePrivateProfileString("section","key","string",ininame);
	WritePrivateProfileString("General", "InputPath", m_csInputPath, FilePath);
	WritePrivateProfileString("General", "OutputPath", m_csOutputPath, FilePath);

	csAux.Format(_T("%d"),m_nIFOs);
	WritePrivateProfileString("General", "nIFOs", csAux, FilePath);

	csAux.Format(_T("%d"),m_nTotalTitles);
	WritePrivateProfileString("General", "nTitles", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckIfof);
	WritePrivateProfileString("General", "CheckIfof", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckMenu);
	WritePrivateProfileString("General", "CheckMenu", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckVobPuops);
	WritePrivateProfileString("General", "CheckVobPuops", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckIfoPuops);
	WritePrivateProfileString("General", "CheckIfoPuops", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckTitle);
	WritePrivateProfileString("General", "CheckTitle", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckFixVobs);
	WritePrivateProfileString("General", "CheckFixVobs", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckPostPre);
	WritePrivateProfileString("General", "CheckPostPre", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckPostPreForced);
	WritePrivateProfileString("General", "CheckPostPreForced", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckElapsed);
	WritePrivateProfileString("General", "CheckElapsed", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckFolder);
	WritePrivateProfileString("General", "CheckFolder", csAux, FilePath);

	nReplacedCells=m_ACell_replace.GetSize();
	csAux.Format(_T("%d"),nReplacedCells);
	WritePrivateProfileString("Replacing Cells", "nReplacedCells", csAux, FilePath);

	for (n=0;n<nReplacedCells;n++)
	{
		csAux.Format(_T("%d"),m_ACell_replace[n].VID);
		csKey.Format(_T("Replacing_Cell_VID_%03d"),n);
		WritePrivateProfileString("Replacing Cells", csKey, csAux, FilePath);

		csAux.Format(_T("%d"),m_ACell_replace[n].CID);
		csKey.Format(_T("Replacing_Cell_CID_%03d"),n);
		WritePrivateProfileString("Replacing Cells", csKey, csAux, FilePath);

		csAux.Format(_T("%d"),m_ACell_replace[n].iDomain);
		csKey.Format(_T("Replacing_Cell_DOM_%03d"),n);
		WritePrivateProfileString("Replacing Cells", csKey, csAux, FilePath);

		csAux.Format(_T("%d"),m_ACell_replace[n].nVTS);
		csKey.Format(_T("Replacing_Cell_VTS_%03d"),n);
		WritePrivateProfileString("Replacing Cells", csKey, csAux, FilePath);

		csKey.Format(_T("Replacing_Cell_Path_%03d"),n);
		WritePrivateProfileString("Replacing Cells", csKey, m_ACell_replace[n].csPath, FilePath);
	}

	csSection="VIDEO_TS";
	csAux.Format(_T("%d"),m_nMPGCs[0]);
	WritePrivateProfileString(csSection, "nMPGCs", csAux, FilePath);

	if (m_iActionVTS[0]==PROCESS) csAux="PROCESS";
	if (m_iActionVTS[0]==SKIP) csAux="SKIP";
	WritePrivateProfileString(csSection, "ActionVTS", csAux, FilePath);	

	if ( m_iActionVTS[0]!=SKIP)
	{
		for (nT=0;nT<m_nMPGCs[0];nT++)
		{
			bWrite=false;
			csKey.Format(_T("ActionM%02d_%02d"),0,nT+1);
			if (m_iMAction[0][nT]==KEEP)   {csAux="KEEP";   bWrite=false;}
			if (m_iMAction[0][nT]==BLANK)  {csAux="BLANK";  bWrite=true;}
			if (m_iMAction[0][nT]==DELPBK) {csAux="DELPBK"; bWrite=true;}
			if (m_iMAction[0][nT]==CELLBASED) {csAux="CELLBASED"; bWrite=true;}
			if (m_iMAction[0][nT]==REUSE)
				{csAux.Format(_T("REUSE %02d"),m_iReuseLU[0][nT]+1);  bWrite=true;}
			if (bWrite)
			{
				WritePrivateProfileString(csSection, csKey, csAux, FilePath);
				if (m_iMAction[0][nT]==CELLBASED)
				{
					csKey.Format(_T("CellBased_String_Menu_%02d_%02d"),0,nT+1);
					WritePrivateProfileString(csSection, csKey, m_csMCellBased[0][nT], FilePath);
				}
			}
		}
	}
	for (nVTS=1; nVTS<m_nIFOs+1;nVTS++)
	{
		csSection.Format(_T("VTS%02d"),nVTS);

		csAux.Format(_T("%d"),m_nPGCs[nVTS]);
		WritePrivateProfileString(csSection, "nPGCs", csAux, FilePath);
		csAux.Format(_T("%d"),m_nMPGCs[nVTS]);
		WritePrivateProfileString(csSection, "nMPGCs", csAux, FilePath);

		if (m_iActionVTS[nVTS]==PROCESS) csAux="PROCESS";
		if (m_iActionVTS[nVTS]==SKIP) csAux="SKIP";
		WritePrivateProfileString(csSection, "ActionVTS", csAux, FilePath);

		csAux.Format(_T("%X"),m_iVideoAttr[nVTS]);
		WritePrivateProfileString(csSection, "VideoAttr", csAux, FilePath);
	

		if (m_iActionVTS[nVTS]!=SKIP)
		{
			for (nT=0;nT<m_nPGCs[nVTS];nT++)
			{
				bWrite=false;
				csKey.Format(_T("ActionT%02d_%02d"),nVTS,nT+1);
				if (m_iAction[nVTS][nT]==KEEP)    {csAux="KEEP";    bWrite=false;}
				if (m_iAction[nVTS][nT]==BLANK)   {csAux="BLANK";   bWrite=true;}
				if (m_iAction[nVTS][nT]==REPLACE) {csAux="REPLACE"; bWrite=true;}
				if (m_iAction[nVTS][nT]==STRIP)   {csAux="STRIP";   bWrite=true;}
				if (m_iAction[nVTS][nT]==CUT)     {csAux="CUT";     bWrite=true;}
				if (m_iAction[nVTS][nT]==SKIP)    {csAux="SKIP";    bWrite=true;}
				if (m_iAction[nVTS][nT]==CELLBASED) {csAux="CELLBASED"; bWrite=true;}
				if (bWrite)
					WritePrivateProfileString(csSection, csKey, csAux, FilePath);

				if (m_iAction[nVTS][nT]!=KEEP) 
				{
					csKey.Format(_T("Replacing Title_%02d_%02d"),nVTS,nT+1);
					WritePrivateProfileString(csSection, csKey, m_csReplace[nVTS][nT], FilePath);

					csAux.Format(_T("%I64d"),m_i64Rsize[nVTS][nT]);
					csKey.Format(_T("Replacing Size_%02d_%02d"),nVTS,nT+1);
					WritePrivateProfileString(csSection, csKey, csAux, FilePath);

					csAux.Format(_T("%d %d %d %d %d"),m_CutInfo[nVTS][nT].iAction,
						m_CutInfo[nVTS][nT].iIniCell,m_CutInfo[nVTS][nT].iIniLba,
						m_CutInfo[nVTS][nT].iEndCell,m_CutInfo[nVTS][nT].iEndLba);
					csKey.Format(_T("CutInfo_%02d_%02d"),nVTS,nT+1);
					WritePrivateProfileString(csSection,csKey, csAux, FilePath);
	
					csAux.Format(_T("%d %d %d %d %d %d %d %d"),
						m_bIdTAudioStrip[nVTS][0][nT],m_bIdTAudioStrip[nVTS][1][nT],
						m_bIdTAudioStrip[nVTS][2][nT],m_bIdTAudioStrip[nVTS][3][nT],
						m_bIdTAudioStrip[nVTS][4][nT],m_bIdTAudioStrip[nVTS][5][nT],
						m_bIdTAudioStrip[nVTS][6][nT],m_bIdTAudioStrip[nVTS][7][nT]);
					csKey.Format(_T("StripInfo_%02d_%02d"),nVTS,nT+1);
					WritePrivateProfileString(csSection, csKey, csAux, FilePath);

					if (m_iAction[nVTS][nT]==CELLBASED)
					{
						csKey.Format(_T("CellBased_String_Title_%02d_%02d"),nVTS,nT+1);
						WritePrivateProfileString(csSection, csKey, m_csCellBased[nVTS][nT], FilePath);
					}
				}
			}

			for (nT=0;nT<m_nMPGCs[nVTS];nT++)
			{
				bWrite=false;
				csKey.Format(_T("ActionM%02d_%02d"),nVTS,nT+1);
				if (m_iMAction[nVTS][nT]==KEEP)   {csAux="KEEP";   bWrite=false;}
				if (m_iMAction[nVTS][nT]==BLANK)  {csAux="BLANK";  bWrite=true;}
				if (m_iMAction[nVTS][nT]==DELPBK) {csAux="DELPBK"; bWrite=true;}
				if (m_iMAction[nVTS][nT]==CELLBASED) {csAux="CELLBASED"; bWrite=true;}
				if (m_iMAction[nVTS][nT]==REUSE)
					{csAux.Format(_T("REUSE %02d"),m_iReuseLU[nVTS][nT]+1);  bWrite=true;}
				if (bWrite)
				{
					WritePrivateProfileString(csSection, csKey, csAux, FilePath);
					if (m_iMAction[nVTS][nT]==CELLBASED)
					{
						csKey.Format(_T("CellBased_String_Menu_%02d_%02d"),nVTS,nT+1);
						WritePrivateProfileString(csSection, csKey, m_csMCellBased[nVTS][nT], FilePath);
					}
				}
			}
		}

	}
	return true;
}

bool CVobBlankerApp::LoadProject(CString FilePath)
{
	char szbuffer[1024];
	int nIFOs,nTitles;
	int nVTS,nT,nPGCs;
	int iAux;
	CString csSection,csKey,csAux;
	int n, nReplacedCells;
	CELL_REPLACE myCell_replace;

	GetPrivateProfileString("General", "InputPath","",szbuffer , 1024 , FilePath);
	m_csInputPath.Format(_T("%s"),szbuffer);
	GetPrivateProfileString("General", "OutputPath","",szbuffer , 1024 , FilePath);
	m_csOutputPath.Format(_T("%s"),szbuffer);


	if (m_csInputPath=="") 
	{
		MyErrorBox("No input path in project file");
		return false;
	}

	if (ReadIFOs(m_csInputPath+"\\"+"VIDEO_TS.IFO") <=0)
	{
		MyErrorBox("Error reading IFOs. Aborting.");
		return false;
	}
	csAux.Format(_T("%d"),m_nIFOs);

	GetPrivateProfileString("General", "nIFOs",csAux, szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &nIFOs);
	GetPrivateProfileString("General", "nTitles","0",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &nTitles);

	if (nIFOs != m_nIFOs )
	{
		MyErrorBox("Number of IFOs does not match. Aborting.");
		return false;
	}

	GetPrivateProfileString("General", "CheckIfof","1",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckIfof);
	GetPrivateProfileString("General", "CheckMenu","1",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckMenu);
	GetPrivateProfileString("General", "CheckVobPuops","1",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckVobPuops);
	GetPrivateProfileString("General", "CheckIfoPuops","1",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckIfoPuops);
	GetPrivateProfileString("General", "CheckTitle","1",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckTitle);
	GetPrivateProfileString("General", "CheckFixVobs","1",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckFixVobs);
	GetPrivateProfileString("General", "CheckPostPre","1",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckPostPre);
	GetPrivateProfileString("General", "CheckPostPreForced","1",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckPostPreForced);
	GetPrivateProfileString("General", "CheckElapsed","0",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckElapsed);
	GetPrivateProfileString("General", "CheckFolder","0",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckFolder);

	if (m_bCheckFolder)
		m_csOutputPath=m_csInputPath;

	GetPrivateProfileString("Replacing Cells", "nReplacedCells","0",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &nReplacedCells);

	m_ACell_replace.RemoveAll();

	for (n=0;n<nReplacedCells;n++)
	{
		csKey.Format(_T("Replacing_Cell_VID_%03d"),n);
		GetPrivateProfileString("Replacing Cells", csKey,"0",szbuffer , 32 , FilePath);
		sscanf (szbuffer, "%d", &myCell_replace.VID);

		csKey.Format(_T("Replacing_Cell_CID_%03d"),n);
		GetPrivateProfileString("Replacing Cells", csKey,"0",szbuffer , 32 , FilePath);
		sscanf (szbuffer, "%d", &myCell_replace.CID);

		csKey.Format(_T("Replacing_Cell_DOM_%03d"),n);
		GetPrivateProfileString("Replacing Cells", csKey,"0",szbuffer , 32 , FilePath);
		sscanf (szbuffer, "%d", &myCell_replace.iDomain);

		csKey.Format(_T("Replacing_Cell_VTS_%03d"),n);
		GetPrivateProfileString("Replacing Cells", csKey,"-1",szbuffer , 32 , FilePath);
		sscanf (szbuffer, "%d", &myCell_replace.nVTS);

		csKey.Format(_T("Replacing_Cell_Path_%03d"),n);
		GetPrivateProfileString("Replacing Cells", csKey,"",szbuffer , 1024 , FilePath);
		myCell_replace.csPath=szbuffer;

		m_ACell_replace.SetAtGrow(n,myCell_replace);
	
	}

	for (n=nReplacedCells-1;n>=0;n--)
	{
		if ( m_ACell_replace[n].VID==0 || m_ACell_replace[n].CID==0 || 
			 m_ACell_replace[n].nVTS==-1 || m_ACell_replace[n].csPath.IsEmpty() ) 
			 m_ACell_replace.RemoveAt(n,1);
	}

	csSection="VIDEO_TS";

	GetPrivateProfileString(csSection, "ActionVTS","PROCESS",szbuffer , 1024 , FilePath);
	m_iActionVTS[0]=PROCESS;
	if (strcmp(szbuffer,"SKIP")==0)
	{
		m_iActionVTS[0]=SKIP;
		for (nT=0;nT<m_nMPGCs[0];nT++)
			if (m_iMAction[0][nT]!=ZERO)
				m_iMAction[0][nT]=KEEP;
	}

	else
	{
		for (nT=0;nT<m_nMPGCs[0];nT++)
		{
			if (m_iMAction[0][nT]!=ZERO)
			{
				csKey.Format(_T("ActionM%02d_%02d"),0,nT+1);
					GetPrivateProfileString(csSection, csKey,"KEEP",szbuffer , 1024 , FilePath);
				m_iMAction[0][nT]=KEEP;
				if (strcmp(szbuffer,"BLANK")==0) m_iMAction[0][nT]=BLANK;
				if (strcmp(szbuffer,"DELPBK")==0) m_iMAction[0][nT]=DELPBK;
				if (strcmp(szbuffer,"CELLBASED")==0) m_iMAction[0][nT]=CELLBASED;
				if (strstr(szbuffer,"REUSE")!=NULL)
				{
					m_iMAction[0][nT]=REUSE;
					if ( sscanf(szbuffer+5,"%d", &m_iReuseLU[0][nT]) !=1)
						m_iMAction[0][nT]=KEEP;
					else
						m_iReuseLU[0][nT]--;
					if (m_iReuseLU[0][nT]<0 || m_iReuseLU[0][nT] > m_nLUs[0])
					{
						m_iMAction[0][nT]=KEEP;
					}
				}
				csKey.Format(_T("CellBased_String_Menu_%02d_%02d"),0,nT+1);
				GetPrivateProfileString(csSection, csKey,"",szbuffer , 1024 , FilePath);
				if (strlen(szbuffer)!=0 && strlen(szbuffer)<256 ) 
					m_csMCellBased[0][nT]=szbuffer;
			}
		}
	}
	for (nVTS=1; nVTS<m_nIFOs+1;nVTS++)
	{
		csSection.Format(_T("VTS%02d"),nVTS);

		GetPrivateProfileString(csSection, "nPGCs","0",szbuffer , 32 , FilePath);
		sscanf (szbuffer, "%d", &nPGCs);
//		if (nPGCs != m_nPGCs[nVTS] )
//		{
//			MyErrorBox("Number of PGCs does not match. Aborting.");
//			return false;
//		}
		GetPrivateProfileString(csSection, "ActionVTS","PROCESS",szbuffer , 1024 , FilePath);
		m_iActionVTS[nVTS]=PROCESS;
		if (strcmp(szbuffer,"SKIP")==0)
		{
			m_iActionVTS[nVTS]=SKIP;
			for (nT=0;nT<m_nPGCs[nVTS];nT++)
			{
				m_iAction[nVTS][nT]=SKIP;
				m_csReplace[nVTS][nT]="";
				m_i64Rsize[nVTS][nT]=0;
			}
			for (nT=0;nT<m_nMPGCs[nVTS];nT++)
				m_iMAction[nVTS][nT]=KEEP;

		}

		GetPrivateProfileString(csSection, "VideoAttr","",szbuffer , 1024 , FilePath);
		if (sscanf (szbuffer, "%X", &iAux) ==1 )
		{
			m_iVideoAttr[nVTS]=iAux;	
			theApp.UpdateVideoAttr(nVTS);
		}
		if 	(m_iActionVTS[nVTS]!=SKIP)
		{
			for (nT=0;nT<m_nPGCs[nVTS];nT++)
			{
				csKey.Format(_T("ActionT%02d_%02d"),nVTS,nT+1);
				GetPrivateProfileString(csSection, csKey,"KEEP",szbuffer , 1024 , FilePath);
				m_iAction[nVTS][nT]=KEEP;
				if (strcmp(szbuffer,"BLANK")==0) m_iAction[nVTS][nT]=BLANK;
				if (strcmp(szbuffer,"REPLACE")==0) m_iAction[nVTS][nT]=REPLACE;
				if (strcmp(szbuffer,"STRIP")==0) m_iAction[nVTS][nT]=STRIP;
				if (strcmp(szbuffer,"CUT")==0) m_iAction[nVTS][nT]=CUT;
				if (strcmp(szbuffer,"SKIP")==0) m_iAction[nVTS][nT]=SKIP;
				if (strcmp(szbuffer,"CELLBASED")==0) m_iAction[nVTS][nT]=CELLBASED;

				csKey.Format(_T("Replacing Title_%02d_%02d"),nVTS,nT+1);
				GetPrivateProfileString(csSection, csKey,"",szbuffer , 1024 , FilePath);
				m_csReplace[nVTS][nT]=szbuffer;

				csKey.Format(_T("Replacing Size_%02d_%02d"),nVTS,nT+1);
				GetPrivateProfileString(csSection, csKey,"0",szbuffer , 32 , FilePath);
				if (sscanf (szbuffer, "%I64d", &m_i64Rsize[nVTS][nT]) !=1 ) m_i64Rsize[nVTS][nT]=0;

				csKey.Format(_T("CutInfo_%02d_%02d"),nVTS,nT+1);
				GetPrivateProfileString(csSection, csKey,"0 -1 -1 -1 -1",szbuffer , 1024 , FilePath);
				sscanf(szbuffer,"%d %d %d %d %d", &m_CutInfo[nVTS][nT].iAction,
					&m_CutInfo[nVTS][nT].iIniCell,&m_CutInfo[nVTS][nT].iIniLba,
					&m_CutInfo[nVTS][nT].iEndCell,&m_CutInfo[nVTS][nT].iEndLba);

				csKey.Format(_T("StripInfo_%02d_%02d"),nVTS,nT+1);
				GetPrivateProfileString(csSection, csKey,"0 0 0 0 0 0 0 0",szbuffer , 1024 , FilePath);
				sscanf(szbuffer,"%d %d %d %d %d %d %d %d",
					&m_bIdTAudioStrip[nVTS][0][nT],&m_bIdTAudioStrip[nVTS][1][nT],
					&m_bIdTAudioStrip[nVTS][2][nT],&m_bIdTAudioStrip[nVTS][3][nT],
					&m_bIdTAudioStrip[nVTS][4][nT],&m_bIdTAudioStrip[nVTS][5][nT],
					&m_bIdTAudioStrip[nVTS][6][nT],&m_bIdTAudioStrip[nVTS][7][nT]);

				csKey.Format(_T("CellBased_String_Title_%02d_%02d"),nVTS,nT+1);
				GetPrivateProfileString(csSection, csKey,"",szbuffer , 1024 , FilePath);
				if (strlen(szbuffer)!=0 && strlen(szbuffer)<256)
					 m_csCellBased[nVTS][nT]=szbuffer;
			}

			for (nT=0;nT<m_nMPGCs[nVTS];nT++)
			{
				if (m_iMAction[nVTS][nT]!=ZERO)
				{
					csKey.Format(_T("ActionM%02d_%02d"),nVTS,nT+1);
						GetPrivateProfileString(csSection, csKey,"KEEP",szbuffer , 1024 , FilePath);
					m_iMAction[nVTS][nT]=KEEP;
					if (strcmp(szbuffer,"BLANK")==0) m_iMAction[nVTS][nT]=BLANK;
					if (strcmp(szbuffer,"DELPBK")==0) m_iMAction[nVTS][nT]=DELPBK;
					if (strcmp(szbuffer,"CELLBASED")==0) m_iMAction[nVTS][nT]=CELLBASED;
					if (strstr(szbuffer,"REUSE")!=NULL)
					{
						m_iMAction[nVTS][nT]=REUSE;
						if ( sscanf(szbuffer+5,"%d", &m_iReuseLU[nVTS][nT]) !=1)
							m_iMAction[nVTS][nT]=KEEP;
						else
							m_iReuseLU[nVTS][nT]--;
						if (m_iReuseLU[nVTS][nT]<0 || m_iReuseLU[nVTS][nT] > m_nLUs[nVTS])
						{
							m_iMAction[nVTS][nT]=KEEP;
						}
					}
					csKey.Format(_T("CellBased_String_Menu_%02d_%02d"),nVTS,nT+1);
					GetPrivateProfileString(csSection, csKey,"",szbuffer , 1024 , FilePath);
					if (strlen(szbuffer)!=0 && strlen(szbuffer)<256 ) 
						m_csMCellBased[nVTS][nT]=szbuffer;
	
				}
			}
		}
	}

	GetMenuEndSize();
	return true;
}

bool CVobBlankerApp::IsReused(int iDomain,int nVTS,int nT,int nCell)
{
	bool bReused;
	int kk,ll;
	int VIDb,CIDb;
	int VobId,CellId;


	if (iDomain==TITLES)
	{
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+4*nCell]);
		CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+3+4*nCell];

		bReused=false;

		for (kk=0; kk<nT && bReused==false ;kk++)
			for (ll=0; ll< m_nCells[nVTS][kk]; ll++)
			{
				VIDb=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][kk]+4*ll]);
				CIDb=m_pIFO[nVTS][m_C_POST[nVTS][kk]+3+4*ll];
				if (VobId==VIDb && CellId==CIDb)
					bReused=true;
			}

		for (ll=0; ll<nCell &&  bReused==false ;ll++)
		{
			VIDb=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+4*ll]);
			CIDb=m_pIFO[nVTS][m_C_POST[nVTS][nT]+3+4*ll];
			if (VobId==VIDb && CellId==CIDb)
				bReused=true;
		}
		return bReused;
	}
	else
	{
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+4*nCell]);
		CellId=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+3+4*nCell];

		bReused=false;

		for (kk=0; kk<nT && bReused==false ;kk++)
			for (ll=0; ll< m_nMCells[nVTS][kk]; ll++)
			{
				VIDb=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][kk]+4*ll]);
				CIDb=m_pIFO[nVTS][m_M_C_POST[nVTS][kk]+3+4*ll];
				if (VobId==VIDb && CellId==CIDb)
					bReused=true;
			}

		for (ll=0; ll<nCell &&  bReused==false ;ll++)
		{
			VIDb=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+4*ll]);
			CIDb=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+3+4*ll];
			if (VobId==VIDb && CellId==CIDb)
				bReused=true;
		}
		return bReused;

	}
}


void CVobBlankerApp::GetCellInfo(int iDomain, int nVTS,int nT,int nCell, 
			int * VobId, int * CellId, DWORD * dwDuration, __int64 * i64Size, bool * bReused, uchar * CellCat0, int * nButtons )
{

	__int64 i64IniSec,i64EndSec;
	int nADTCells,kk;

	*bReused=false;
	*dwDuration=0;
	*VobId= 1;
	*CellId=1;

	if (iDomain==TITLES)
	{
		*VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+4*nCell]);
		*CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+3+4*nCell];
		*dwDuration=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+4]);
		*CellCat0=m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell];
	}
	else
	{
		*VobId=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+4*nCell]);
		*CellId=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+3+4*nCell];
		*dwDuration=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+24*nCell+4]);
		*CellCat0=m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+24*nCell];
	}
	// check if this cell has been already used
				
	*bReused=IsReused(iDomain, nVTS, nT, nCell);

	*i64Size=0;
	
	if (iDomain==TITLES)
	{
		nADTCells=	(GetNbytes(4,&m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+4])-7)/12;

		for (kk=0;kk<nADTCells;kk++)
		{
			if (*VobId==GetNbytes(2, &m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+8+12*kk]) &&
				*CellId==m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+8+12*kk+2])
			{
				i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+8+12*kk+4]);
				i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+8+12*kk+8]);
				*i64Size+=((i64EndSec-i64IniSec+1)*2048);
			}
		}
	}
	else
	{
		if (m_VTSM_C_ADT[nVTS]==0)
			nADTCells=0;
		else
			nADTCells=	(GetNbytes(4,&m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+4])-7)/12;

		for (kk=0;kk<nADTCells;kk++)
		{
			if (*VobId==GetNbytes(2, &m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+8+12*kk]) &&
				*CellId==m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+8+12*kk+2])
			{
				i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+8+12*kk+4]);
				i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+8+12*kk+8]);
				*i64Size+=((i64EndSec-i64IniSec+1)*2048);
			}
		}
	}

	*nButtons=0;

	if (iDomain==MENUS)
	{
		for (kk=0;kk < m_MenuCells[nVTS].GetSize();kk++)
		{
			if (m_MenuCells[nVTS][kk].VID==*VobId &&
				m_MenuCells[nVTS][kk].CID==*CellId )
				*nButtons=m_MenuCells[nVTS][kk].nButtons;
		}
	}
}

void CVobBlankerApp::LogEnd()
{
	CString csAux;

	MyLog ("");

	csAux.Format(_T("PostCommands changed into Precommands in %d PGCs of a total of %d"),
			m_nActualPostPre,m_nPostPre);
	MyLog(csAux);

	if (m_nErrors==0)
		csAux.Format(_T("Finished. No Errors, %d Warnings"), m_nWarnings);
	else
		csAux.Format(_T("Finished with ERROR. Process Aborted and not completed"));

	MyLog ("");
	MyLog(csAux);
}

void CVobBlankerApp::ExtractCell(int iDomain, int nVTS,int nT, int nCell, CWnd* pDlg)
{
	int k;
	int CellId, VobId;
	__int64 i64sectors, i64IniSec,i64EndSec,i64;
	CString csAux,csAuxIn;
	bool bMyCell;
	struct  _stati64 statbuf;
	int nVobin;

	if (iDomain==MENUS)
	{
		CellId=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+nCell*4+3];
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+nCell*4]);
//  Locate the cell
		i64sectors=0;
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]);

		if (nVTS==0)
			csAux.Format(_T("VIDEO_TS.VOB"));
		else
			csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
	}
	else
	{
		nVobin=1;
		for (k=1; k<10; k++)
		{
			csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS,k);
			csAuxIn=m_csInputPath+'\\'+csAux;
			if (_stati64 ( csAuxIn, &statbuf)==0)
			{
				m_i64VOBsize[k]= statbuf.st_size;
			}
			else k=20;
		}

		CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4+3];
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4]);

//  Locate the cell
		i64sectors=0;
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
		for (k=1;k<10;k++)
		{
			i64sectors+=(m_i64VOBsize[k]/2048);
			if (i64IniSec<i64sectors)
			{
				i64sectors-=(m_i64VOBsize[k]/2048);
				nVobin=k;
				k=20;
			}
		}
		csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, nVobin);
	}

	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	fseek(m_Fin, (long) ((i64IniSec-i64sectors)*2048), SEEK_SET);

	m_bInProcess=true;

	for (i64=0,bMyCell=true;i64< (i64EndSec-i64IniSec+1) && m_bInProcess==true; i64++)
	{
	//readpack
		if ((i64%MODUPDATE) == 0) UpdateProgressCell(pDlg, (int)((100*i64)/(i64EndSec-i64IniSec)));
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			if (iDomain==TITLES)
			{
				fclose (m_Fin);
				nVobin++;
				csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, nVobin);
				m_csFin=m_csInputPath+ '\\' +csAux;
				m_Fin=fopen(m_csFin,"rb");
			}
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				if (m_Fin) fclose (m_Fin);
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				m_bInProcess=false;
				return;
			}
		}
		if (IsSynch(m_buffer) != true)
		{
			MyErrorLog_Box("Error reading input VOB: Unsynchronized");
			m_bInProcess=false;
			return;
		}
		if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				if (m_buffer[0x420]==(uchar)(VobId%256) &&
					m_buffer[0x41F]==(uchar)(VobId/256) &&
					m_buffer[0x422]== (uchar) CellId)
					bMyCell=true;
				else
					bMyCell=false;
				CleanILV(m_buffer);
			}
			if (bMyCell)
			{
				writebuffer(m_buffer,m_Fout);
			}
		}
	}
	m_bInProcess=false;
	UpdateProgressCell(pDlg, 100);
	if (m_Fin!=NULL) fclose (m_Fin);
	m_Fin=NULL;
//	if (m_Fout!=NULL) fclose (m_Fout);
//	m_Fout=NULL;
}

int CVobBlankerApp::FillCellInfo(int nVTS)
{
	int iACells,iANavs;
	int i,k,kk;
	__int64 i64FirstLBAFirstVOBU, i64FirstLBALastVOBU, i64LastLBALastVOBU;
	DWORD dwDuration,dwVOBUDuration;
	int CellId,VobId;
	int nNavs;
	int same;
	int iFormat;
	int nVOBIDs;

	iACells=m_ACell_list.GetSize();
	iANavs=m_ANavinfo.GetSize();
	iFormat=(m_iVideoAttr[nVTS] & 0x1000) >> 12;


///////////////////////////////////////////////////////
// Cell Info 
	nVOBIDs=0;
	for( i=0; i< iACells ; i++)
	{
		i64FirstLBAFirstVOBU=-1;
		i64FirstLBALastVOBU=0;
		i64LastLBALastVOBU=0;
		dwDuration=0x40;
		if (iFormat==NTSC) dwDuration=0xC0;
		CellId=m_ACell_list[i].CID;
		VobId=m_ACell_list[i].VID;
		for (k=0,same=0; k< i; k++)
		{
			if (VobId==m_ACell_list[k].VID )
				same=1;
		}

		if (same==0) nVOBIDs++;

		for (k=0,nNavs=0,kk=-1; k< iANavs; k++)
		{
			if (VobId==m_ANavinfo[k].VID && CellId==m_ANavinfo[k].CID)
			{
				nNavs++;
				if (i64FirstLBAFirstVOBU<0) i64FirstLBAFirstVOBU=m_ANavinfo[k].LBA;
				if (i64FirstLBALastVOBU<m_ANavinfo[k].LBA) i64FirstLBALastVOBU=m_ANavinfo[k].LBA;
				if (i64LastLBALastVOBU<m_ANavinfo[k].LastLBA) i64LastLBALastVOBU=m_ANavinfo[k].LastLBA;
				kk=k;
			}
		}
		if (i64FirstLBAFirstVOBU<0) i64FirstLBAFirstVOBU=0;
		if (kk >=0)
		{
			dwDuration=m_ANavinfo[kk].dwDuration;
			dwVOBUDuration=(m_ANavinfo[kk].iPTS1-m_ANavinfo[kk].iPTS0)/(m_ticsperframe);
			dwVOBUDuration=Dec2BCD(dwVOBUDuration);
			dwVOBUDuration=dwVOBUDuration|(dwDuration & 0xc0);
			dwDuration=AddDuration(dwDuration,dwVOBUDuration);
		}

		m_ACell_list[i].i64FirstLBAFirstVOBU=i64FirstLBAFirstVOBU;
		m_ACell_list[i].i64FirstLBALastVOBU=i64FirstLBALastVOBU;
		m_ACell_list[i].i64LastLBALastVOBU=i64LastLBALastVOBU;
		m_ACell_list[i].dwDuration=dwDuration;
		m_ACell_list[i].nNavs=nNavs;
	}
	return nVOBIDs;
}


int CVobBlankerApp::ChangePostIntoPre(int iDomain, int nVTS, int nT)
{
// returns -1: No needs to change
// returns -2: No change. There are Cell Commands 
// returns -3: No change. Post Commands have Links/Jumps/Calls to programs of this PGC 
// returns >=0: Change Post into pre. Number of commands modified

	int nCellComm, nPost, nPre, nCom;
	int iAction,PGC_COMM;
	CString csAux;
	int nCommModified;
	int nPGC,nLU,nTTN;
	bool bCommDanger;
	uchar *pCommand;


	if (iDomain==MENUS)
	{
		iAction=m_iMAction[nVTS][nT];
		PGC_COMM=m_M_PGC_COMM[nVTS][nT];
		nLU=m_nLU_MPGC[nVTS][nT];
		nPGC=nT-m_nIniPGCinLU[nVTS][nLU];
		nTTN=-1; // No sense Title number in MENUS domain
	}
	else
	{
		iAction=m_iAction[nVTS][nT];
		PGC_COMM=m_PGC_COMM[nVTS][nT];
		nPGC=nT;
		nTTN=m_nTitleInVTS[nVTS][nT];
	}

	nCellComm=	pIFO[PGC_COMM+5];
	nPre=		pIFO[PGC_COMM+1];		
	nPost=		pIFO[PGC_COMM+3];
	nCommModified=0;

	if ( iAction!=BLANK || PGC_COMM==0  ) return -1;

	if ( nPost ==0 ) return -1;


	if (iDomain==MENUS)
		csAux.Format(_T("     Changing Post into precommands: VTS %d, LU %d, PGC %d"),nVTS,nLU+1,nPGC+1);
	else
		csAux.Format(_T("     Changing Post into precommands: VTS %d, PGC %d"),nVTS,nT+1);
	MyLog(csAux);

// Explore CellCommands
	for (nCom=0,bCommDanger=false; nCom<nCellComm ; nCom++)
	{
		pCommand=&pIFO[PGC_COMM+8+8*(nCom+nPre+nPost)];
// If command different to a solid link group to the same PGC or solid link to TTN PGN or CN, abort
		if  ( (!( (pCommand[0] & 0xF0)==0x20 && (pCommand[1] == 0x81 || pCommand[1] == 01))) &&
			  (!( (pCommand[0] & 0xF0)==0x20 && (pCommand[1] & 0x7C) == 0x04 && (pCommand[1] & 0x7)!=4) ) ) 
			bCommDanger=true;
	}

	if ( nCellComm!=0 && bCommDanger && !m_bCheckPostPreForced) 
	{
		MyLog("     Quitting: There are Cell Commands in this PGC and Change always is not checked" );
		return -2;
	}

// Explore PostCommands
	for (nCom=0,bCommDanger=false; nCom<nPost ; nCom++)
	{
		pCommand=&pIFO[PGC_COMM+8+8*(nCom+nPre)];
// Look for Solid/Conditional LinkPGCN (to this PGC).
		if ( (pCommand[0] & 0xF0)==0x20 && (pCommand[1] & 0xF) == 0x04 && pCommand[7] ==(nPGC+1))
			bCommDanger=true;
// Look for JumpVTS_TT/PTT (to this Title).
		if (iDomain==TITLES && (pCommand[0] & 0xF0)==0x30 &&
			(pCommand[1] & 0x7F) >= 0x02 && (pCommand[1] & 0x7F) <= 0x05 &&
			 pCommand[5] == nTTN)
			 bCommDanger=true;
// Look for Solid/Conditional Lnk Group and Solid/Conditional LnkPGN PTTN CN
		if ( (pCommand[0] & 0xF0) == 0x20 && 
			 (  (pCommand[1] & 0x0f) == 0x01 ||
			    ((pCommand[1] & 0x0f) >= 5 && (pCommand[1] & 0x0f) <= 7) )	) 
			 bCommDanger=true;
	}
	if (bCommDanger)
	{
		MyLog("     Quitting: Post Commands with Links/Jumps/Calls to programs of this PGC");
		return -3;
	}

	pIFO[PGC_COMM + 3]=0;
	pIFO[PGC_COMM + 1]=nPost+nPre;

//	Explore precommands
	for (nCom=0;nCom<nPre;nCom++)
	{
		pCommand=&pIFO[PGC_COMM+8+8*nCom];
// Look for Solid Break
		if ((pCommand[0] & 0xE0)==0 && (pCommand[1] == 0x82 || pCommand[1] == 02))
		{
			pCommand[1]--;
			pCommand[7]=nPre+1;
			csAux.Format(_T("     Found a Solid Break. Changed into Goto command"));
			MyLog(csAux);
			nCommModified;
		}
// Look for Conditional Break
		else if ( (pCommand[0] & 0xE0) == 0  &&
			 (pCommand[1] & 0x0f) == 02 && (pCommand[1] & 0x70) != 0 )
		{
			pCommand[1]--;
			pCommand[7]=nPre+1;
			csAux.Format(_T("     Found a Conditional Break. Changed into Goto command"));
			MyLog(csAux);
			nCommModified++;
		}
// Look for Solid Lnk Group.
		else if ( (pCommand[0] & 0xF0)==0x20 && (pCommand[1] == 0x81 || pCommand[1] == 01))
		{
			pCommand[0]=0;
			pCommand[1]=(pCommand[1]&0x80)+1;
			pCommand[6]=0;
			pCommand[7]=nPre+1;
			csAux.Format(_T("     Found a Solid Lnk. Changed into Goto command"));
			MyLog(csAux);
			nCommModified++;
		}
// Look for Conditional Lnk Group.
		else if ( (pCommand[0] & 0xF0) == 0x20 && 
			 (pCommand[1] & 0x0f) == 0x01 && (pCommand[1] & 0x70) != 0 )
		{
			pCommand[0]=0;
			pCommand[1]=(pCommand[1]&0xF0)+1;
			pCommand[6]=0;
			pCommand[7]=nPre+1;
			csAux.Format(_T("     Found a Conditional Lnk. Changed into a conditional Goto command"));
			MyLog(csAux);
			nCommModified++;
		}
// LinkPGCN, with this PGC has no sense in precommands, so I'm not going to look for it
// Look for Solid LnkPTTN LinkPGN LinkCN.
		else if ( (pCommand[0] & 0xF0)==0x20 && (pCommand[1] & 0x7C) == 0x04 && (pCommand[1] & 0x7)!=4)
		{
			pCommand[0]=0;
			pCommand[1]=(pCommand[1]&0x80)+1;
			pCommand[6]=0;
			pCommand[7]=nPre+1;
			csAux.Format(_T("     Found a Solid LnkPTTN/PGN/CN. Changed into Goto command"));
			MyLog(csAux);
			nCommModified++;
		}
// Look for ConditionalLnkPTTN LinkPGN LinkCN.
		else if ( (pCommand[0] & 0xF0) == 0x20 && 
			 (pCommand[1] & 0x0C) == 0x04  && (pCommand[1] & 0x70) != 0 && (pCommand[1] & 0x7)!=4 )
		{
			pCommand[0]=0;
			pCommand[1]=(pCommand[1]&0xF0)+1;
			pCommand[6]=0;
			pCommand[7]=nPre+1;
			csAux.Format(_T("     Found a Conditional LnkPTTN/PGN/CN. Changed into Conditional Goto"));
			MyLog(csAux);
			nCommModified++;
		}

	}

	return nCommModified;
}

int CVobBlankerApp::GetProgram(int iDomain, int nVTS, int nT, int nCell)
{
	int nProgram,nP,nTotalProg;
	int C_PROG;

	nProgram=-1;

	if (iDomain==TITLES)
	{
		C_PROG=GetNbytes(2,&m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+0xE6]);
		if (C_PROG!=0  ) C_PROG+=m_VTS_PGC[nVTS][nT];

	}
	else
	{
		C_PROG=GetNbytes(2,&m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE6]);
		if (C_PROG!=0  ) C_PROG+=m_MENU_PGC[nVTS][nT];
	}
	
	if (C_PROG==0) return -1;
	
	if (iDomain==TITLES)
		nTotalProg= m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+2];
	else
		nTotalProg= m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+2];

	for (nP=0; nP<nTotalProg ; nP++)
	{
		if ( m_pIFO[nVTS][ C_PROG+nP ] == (nCell+1))
		{
			nProgram=nP+1;
			nP=nTotalProg;
		}
	}

	return nProgram;
}

int CVobBlankerApp::GetChapter(int nVTS, int nT, int nCell)
{
	int nChapter,nProgram;
	int n,nTotalTitles,nPgr;
	int iOffStart,iOffEnd;
	int nChap,nTotalPgr;

//m_nTitleInVTS

	nProgram=GetProgram(TITLES, nVTS, nT, nCell);

	if ( nProgram == -1 ) return -1;

	nChapter=-1;

	nChap=0;

	nTotalTitles=GetNbytes(2,&m_pIFO[nVTS][m_VTS_PTT_SRPT[nVTS]]);

	n= m_nTitleInVTS[nVTS][nT]-1;
	iOffStart=GetNbytes(4,&m_pIFO[nVTS][m_VTS_PTT_SRPT[nVTS]+8+4*n]);
	if (n == (nTotalTitles-1)) 
		iOffEnd=GetNbytes(4,&m_pIFO[nVTS][m_VTS_PTT_SRPT[nVTS]+4]);
	else
		iOffEnd=GetNbytes(4,&m_pIFO[nVTS][m_VTS_PTT_SRPT[nVTS]+8+4*(n+1)])-1;

	nTotalPgr=((iOffEnd-iOffStart)+1)/4;
	for (nPgr=0; nPgr < nTotalPgr ; nPgr++)
	{
		nChap++;
		if ( (nT+1)== GetNbytes(2,&m_pIFO[nVTS][m_VTS_PTT_SRPT[nVTS]+iOffStart+nPgr*4]))
		{
			if (nProgram== GetNbytes(2,&m_pIFO[nVTS][m_VTS_PTT_SRPT[nVTS]+iOffStart+nPgr*4+2]) )
			{
				nChapter=nChap;
				nPgr=nTotalPgr;
				n=nTotalTitles;
			}
		}
	}

	return nChapter;
}


/////////////////////////// NEW: MEMORY ALLOCATION ////////////

int CVobBlankerApp::MemoryNewVTSTitle(int nVTS, int nPGCs)
{
	int i;

	m_nTitle[nVTS] =		new int [nPGCs];	if (m_nTitle[nVTS] == NULL ) return 0;
	m_bEntry[nVTS] =		new bool [nPGCs];	if (m_bEntry[nVTS] == NULL ) return 0;
	m_nTitleInVTS[nVTS] =	new int [nPGCs];	if (m_nTitleInVTS[nVTS] == NULL ) return 0;
	m_bILVU[nVTS] =			new bool [nPGCs];	if (m_bILVU[nVTS] == NULL ) return 0;
	m_nAngles[nVTS] =		new int [nPGCs];	if (m_nAngles[nVTS] == NULL ) return 0;
	m_bCellReUsed[nVTS] =	new bool [nPGCs];	if (m_bCellReUsed[nVTS] == NULL ) return 0;
	m_nCells[nVTS] =		new int [nPGCs];	if (m_nCells[nVTS] == NULL ) return 0;
	m_nFirstVID[nVTS] =		new int [nPGCs];	if (m_nFirstVID[nVTS] == NULL ) return 0;
	m_dwDuration[nVTS] =	new DWORD [nPGCs];	if (m_dwDuration[nVTS] == NULL ) return 0;
	m_dwDurationOwn[nVTS] =	new DWORD [nPGCs];	if (m_dwDurationOwn[nVTS] == NULL ) return 0;
	m_i64Tisize[nVTS] =		new __int64 [nPGCs];if (m_i64Tisize[nVTS] == NULL ) return 0;
	m_i64Rsize[nVTS] =		new __int64 [nPGCs];if (m_i64Rsize[nVTS] == NULL ) return 0;
	m_iAction[nVTS] =		new int [nPGCs];	if (m_iAction[nVTS] == NULL ) return 0;
	m_VTS_PGC[nVTS] =		new int [nPGCs];	if (m_VTS_PGC[nVTS] == NULL ) return 0;
	m_C_PBKT[nVTS] =		new int [nPGCs];	if (m_C_PBKT[nVTS] == NULL ) return 0;
	m_C_POST[nVTS] =		new int [nPGCs];	if (m_C_POST[nVTS] == NULL ) return 0;
	m_PGC_COMM[nVTS] =		new int [nPGCs];	if (m_PGC_COMM[nVTS] == NULL ) return 0;
	m_i8CellComm[nVTS] =	new uchar [nPGCs];	if (m_i8CellComm[nVTS] == NULL ) return 0;
	m_i8PreComm[nVTS] =		new uchar [nPGCs];	if (m_i8PreComm[nVTS] == NULL ) return 0;
	m_i8PostComm[nVTS] =	new uchar [nPGCs];	if (m_i8PostComm[nVTS] == NULL ) return 0;
	m_CutInfo[nVTS] =	new CUTINFO [nPGCs];	if (m_CutInfo[nVTS] == NULL ) return 0;
	m_csCellBased[nVTS] =	new CString [nPGCs];if (m_csCellBased[nVTS] == NULL ) return 0;
	m_csReplace[nVTS] =		new CString [nPGCs];if (m_csReplace[nVTS] == NULL ) return 0;


	for (i=0;i<8; i++)
	{
		m_iIdTAudio[nVTS][i] =		new int [nPGCs];	if (m_iIdTAudio[nVTS][i] == NULL ) return 0;
		m_bIdTAudioStrip[nVTS][i] =		new bool [nPGCs];	if (m_bIdTAudioStrip[nVTS][i] == NULL ) return 0;
	}

	// Inicialize CStrings to empty (not sure if needed)
	for (i=0;i<nPGCs;i++)
	{
		m_csReplace[nVTS][i].Empty();
		m_csCellBased[nVTS][i].Empty();
	}
	return 1;
}

int CVobBlankerApp::MemoryNewVTSMenu(int nVTS, int nPGCs)
{
// IFO index
	m_MENU_PGC[nVTS] =		new int [nPGCs];	if (m_MENU_PGC[nVTS] == NULL ) return 0;
	m_M_C_PBKT[nVTS] =		new int [nPGCs];	if (m_M_C_PBKT[nVTS] == NULL ) return 0;
	m_M_C_POST[nVTS] =		new int [nPGCs];	if (m_M_C_POST[nVTS] == NULL ) return 0;
	m_M_PGC_COMM[nVTS] =	new int [nPGCs];	if (m_M_PGC_COMM[nVTS] == NULL ) return 0;
// Others (Menu PGCs)
	m_nLU_MPGC[nVTS] =		new int [nPGCs];	if (m_nLU_MPGC[nVTS] == NULL ) return 0;
	m_iMAction[nVTS] =		new int [nPGCs];	if (m_iMAction[nVTS] == NULL ) return 0;
	m_i64MPGCisize[nVTS] =	new __int64 [nPGCs];if (m_i64MPGCisize[nVTS] == NULL ) return 0;
	m_i64MPGCfsize[nVTS] =	new __int64 [nPGCs];if (m_i64MPGCfsize[nVTS] == NULL ) return 0;
	m_nMCells[nVTS] =		new int [nPGCs];	if (m_nMCells[nVTS] == NULL ) return 0;
	m_nMFirstVID[nVTS] =	new int [nPGCs];	if (m_nMFirstVID[nVTS] == NULL ) return 0;
	m_dwMDuration[nVTS] =	new DWORD [nPGCs];	if (m_dwMDuration[nVTS] == NULL ) return 0;
	m_bMCellReUsed[nVTS] =	new bool [nPGCs];	if (m_bMCellReUsed[nVTS] == NULL ) return 0;
	m_i8MCellComm[nVTS] =	new uchar [nPGCs];	if (m_i8MCellComm[nVTS] == NULL ) return 0;
	m_i8MPreComm[nVTS] =	new uchar [nPGCs];	if (m_i8MPreComm[nVTS] == NULL ) return 0;
	m_i8MPostComm[nVTS] =	new uchar [nPGCs];	if (m_i8MPostComm[nVTS] == NULL ) return 0;
	m_iReuseLU[nVTS] =		new int [nPGCs];	if (m_iReuseLU[nVTS] == NULL ) return 0;
	m_nButtons[nVTS] =		new int [nPGCs];	if (m_nButtons[nVTS] == NULL ) return 0;
	m_csMCellBased[nVTS] =	new CString [nPGCs];if (m_csMCellBased[nVTS] == NULL ) return 0;

	return 1;
}

void CVobBlankerApp::MemoryDeleteVTSTitle(int nVTS)
{
	int i;

	delete[] m_nTitle[nVTS];
	delete[] m_bEntry[nVTS];
	delete[] m_nTitleInVTS[nVTS];
	delete[] m_bILVU[nVTS]; 
	delete[] m_nAngles[nVTS]; 
	delete[] m_bCellReUsed[nVTS];
	delete[] m_nCells[nVTS]; 
	delete[] m_nFirstVID[nVTS]; 
	delete[] m_dwDuration[nVTS]; 
	delete[] m_dwDurationOwn[nVTS]; 
	delete[] m_i64Tisize[nVTS];
	delete[] m_i64Rsize[nVTS];
	delete[] m_iAction[nVTS];
	delete[] m_VTS_PGC[nVTS]; 
	delete[] m_C_PBKT[nVTS]; 
	delete[] m_C_POST[nVTS]; 
	delete[] m_PGC_COMM[nVTS];
	delete[] m_i8CellComm[nVTS];
	delete[] m_i8PreComm[nVTS]; 
	delete[] m_i8PostComm[nVTS]; 
	delete[] m_CutInfo[nVTS];
	delete[] m_csReplace[nVTS]; 
	delete[] m_csCellBased[nVTS];

	for (i=0;i<8; i++)
	{
		delete[] m_iIdTAudio[nVTS][i];
		delete[] m_bIdTAudioStrip[nVTS][i];
	}

}

void CVobBlankerApp::MemoryDeleteVTSMenu(int nVTS)
{

	delete[] m_MENU_PGC[nVTS];
	delete[] m_M_C_PBKT[nVTS];
	delete[] m_M_C_POST[nVTS]; 
	delete[] m_M_PGC_COMM[nVTS]; 
	delete[] m_nLU_MPGC[nVTS]; 
	delete[] m_iMAction[nVTS]; 
	delete[] m_i64MPGCisize[nVTS];
	delete[] m_i64MPGCfsize[nVTS]; 
	delete[] m_nMCells[nVTS]; 
	delete[] m_nMFirstVID[nVTS];
	delete[] m_dwMDuration[nVTS]; 
	delete[] m_bMCellReUsed[nVTS]; 
	delete[] m_i8MCellComm[nVTS]; 
	delete[] m_i8MPreComm[nVTS]; 
	delete[] m_i8MPostComm[nVTS]; 
	delete[] m_iReuseLU[nVTS];
	delete[] m_nButtons[nVTS];
	delete[] m_csMCellBased[nVTS];

}
void CVobBlankerApp::MemoryDeleteAll()
{
	int i;

	for (i=0; i<MAX_VTS; i++) 
	{
		if (m_pIFO[i]!=NULL) delete[] m_pIFO[i]; m_pIFO[i]=NULL;
		if (m_nPGCs[i]) MemoryDeleteVTSTitle (i); m_nPGCs[i]=0;
		if (m_nMPGCs[i]) MemoryDeleteVTSMenu (i); m_nMPGCs[i]=0;
	}
}

// CODE for subpictures (Not used)
/*
struct colorremap {
    int newcolors[16];
    int state,curoffs,maxlen,nextoffs,skip;
    struct colorinfo *origmap;
};
// the following code scans subtitle code in order to
// remap the colors and update the end pts
          if( buf[0] == 0 &&
                buf[1] == 0 &&
                buf[2] == 1 &&
                buf[3] == 0xba &&
                buf[14] == 0 &&
                buf[15] == 0 &&
                buf[16] == 1 &&
                buf[17] == 0xbd) 
				{
                int dptr=buf[22]+23,ml=read2(buf+18)+20;
                int st=buf[dptr];
                dptr++;
                if( (st&0xf8)==0x20 ) { // subtitle
       procremap(&crs[st&31],buf+dptr,ml-dptr,&s->audch[st].audpts[s->audch[st].numaudpts-1].pts[1]);

}

static void procremap(struct colorremap *cr,unsigned char *b,int l,int *timespan)
{
    while(l) {
        // fprintf(stderr,"INFO: state=%d, byte=%02x (%d)\n",cr->state,*b,*b);
        switch(cr->state) {
        case CR_BEGIN0: cr->curoffs=0; cr->skip=0; cr->maxlen=b[0]*256; cr->state=CR_BEGIN1; break;
        case CR_BEGIN1: cr->maxlen+=b[0]; cr->state=CR_BEGIN2; break;
        case CR_BEGIN2: cr->nextoffs=b[0]*256; cr->state=CR_BEGIN3; break;
        case CR_BEGIN3: cr->nextoffs+=b[0]; cr->state=CR_WAIT; break;

        case CR_WAIT:
            if( cr->curoffs==cr->maxlen ) {
                cr->state=CR_BEGIN0;
                continue; // execute BEGIN0 right away
            }
            if( cr->curoffs!=cr->nextoffs )
                break;
            cr->state=CR_SKIP0;
            // fall through to CR_SKIP0
        case CR_SKIP0: *timespan+=1024*b[0]*256; cr->state=CR_SKIP1; break;
        case CR_SKIP1: *timespan+=1024*b[0]; cr->state=CR_NEXTOFFS0; break;
        case CR_NEXTOFFS0: cr->nextoffs=b[0]*256; cr->state=CR_NEXTOFFS1; break;
        case CR_NEXTOFFS1: cr->nextoffs+=b[0]; cr->state=CR_CMD; break;
        case CR_SKIPWAIT:
            if( cr->skip ) {
                cr->skip--;
                break;
            }
            cr->state=CR_CMD;
            // fall through to CR_CMD
        case CR_CMD:
            switch(*b) {
            case 0: break;
            case 1: break;
            case 2: break;
            case 3: cr->state=CR_COL0; break;
            case 4: cr->skip=2; cr->state=CR_SKIPWAIT; break;
            case 5: cr->skip=6; cr->state=CR_SKIPWAIT; break;
            case 6: cr->skip=4; cr->state=CR_SKIPWAIT; break;
            case 255: cr->state=CR_WAIT; break;
            default:
                fprintf(stderr,"ERR: procremap encountered unknown subtitle command: %d\n",*b);
                exit(1);
            }
            break;

        case CR_COL0:
            remapbyte(cr,b);
            cr->state=CR_COL1;
            break;

        case CR_COL1:
            remapbyte(cr,b);
            cr->state=CR_CMD;
            break;
           
        default:
            assert(0);
        }
        cr->curoffs++;
        b++;
        l--;
    }
}
enum { CR_BEGIN0,   CR_BEGIN1,    CR_BEGIN2,    CR_BEGIN3, CR_SKIP0,
       CR_SKIP1,    CR_NEXTOFFS0, CR_NEXTOFFS1, CR_WAIT,   CR_CMD,
       CR_SKIPWAIT, CR_COL0,      CR_COL1};


static void initremap(struct colorremap *cr)
{
    int i;

    for( i=0; i<16; i++ )
        cr->newcolors[i]=i;
    cr->state=CR_BEGIN0;
    cr->origmap=0;
}

static int remapcolor(struct colorremap *cr,int idx)
{
    int i,nc;
    
    if( cr->newcolors[idx] < 16 )
        return cr->newcolors[idx];
    
    nc=cr->newcolors[idx]&0xffffff;
    for( i=0; i<16; i++ )
        if( cr->origmap->colors[i]==nc ) {
            cr->newcolors[idx]=i;
            return i;
        }
    for( i=0; i<16; i++ )
        if( cr->origmap->colors[i]==0x1000000 ) {
            cr->origmap->colors[i]=nc;
            cr->newcolors[idx]=i;
            return i;
        }
    fprintf(stderr,"ERR: color map full, unable to allocate new colors.\n");
    exit(1);
}

static void remapbyte(struct colorremap *cr,unsigned char *b)
{
    b[0]=remapcolor(cr,b[0]&15)|(remapcolor(cr,b[0]>>4)<<4);
}




int CVobBlankerApp::findspuidx(int sind,int pts0)
{
    int l,h,m;

	l=0;
	h=m_nSubsInCell[sind]-1;

	if( h<l )
		return -1;
	while(h>l)
	{
		m=(l+h+1)/2;
		if( pts0<  m_CellAudioinfo[sind][m].iPTS  )
			h=m-1;
		else
		l=m;
	}
	return l;
}

int CVobBlankerApp::FV_FindVobubysect(__int64 sect)
{
	int l,h,m;

	l=0;

    h=m_nNavsInCell-1;

	if( h<0 )
		return -1;
	if( sect<m_CellNavinfo[0].LBA )
		return -1;
    while(l<h)
	{
		m=(l+h+1)/2;
		if( sect < m_CellNavinfo[m].LBA )
			h=m-1;
		else
			l=m;
	}
	return l;
}



*/